; add model procedures here

turtles-own
[x1 y1 z1 x2 y2 z2 temp]


 globals
[ zoom xcenter  ycenter  ]


to zoom-out
  ask patches[set pcolor black ]
  set zoom ( zoom * 0.5 )
end

to zoom-in
    ask patches[set pcolor black]
    set zoom (zoom * 2)
end

to redraw
  ask patches [
  set pcolor  black
    ]
show xcenter
show ycenter
  ask turtles
  [ifelse  ( (abs( x1 * zoom ) ) >  screen-edge-x) or ((abs(y1 * zoom)) > screen-edge-y)
  [ht]  [st]
move ]
end

;;03/06/02 wooyoung


to create
  ca
  crt number
  set-current-plot "Plot1"
   auto-plot-on
   set-plot-y-range ( - screen-edge-y ) screen-edge-y
   set zoom 1
   set xcenter 0
   set ycenter 0
   create-temporary-plot-pen "pp1"
   plot-pen-reset
   set-plot-pen-color blue
   create-temporary-plot-pen "pp2"
   plot-pen-reset
   set-plot-pen-color green
   create-temporary-plot-pen "pp3"
   plot-pen-reset
   set-plot-pen-color red

 end

to colorize
  set temp (number - who)
  ;show "done with colorize temp"
  set color scale-color red temp 0 number
  pd
end

to my-setxyz  [ xc yc zc ]
  set x1 xc
  set y1 yc
  set z1 zc
end

to box
create
ask turtles
  [ my-setxyz ( init-x + (random-float((2 * radius) + 1))- radius)
           ( init-y + (random-float((2 * radius) + 1))- radius)
           ( init-z + (random-float((2 * radius) + 1))- radius)

  colorize
  move
  ]
end

to point
  create
  ask turtles
  [
     my-setxyz  init-x  init-y  init-z
      colorize
      move
  ]
end

to circle
  create
;show "done with circle"
  ask turtles
  [
  setxy init-x init-y
  fd radius
;show "done with moving"
  my-setxyz  xcor  ycor  init-z
;show "done with my-setxyz"
  colorize
 move
;show "done with move"
  ]
end

to plot-positions
      create-temporary-plot-pen "pp1"
      ask turtle 0 [plot x1]

     create-temporary-plot-pen "pp2"
      ask turtle 0 [plot y1]

      create-temporary-plot-pen "pp3"
      ask turtle 0 [plot z1]
end



to move
  if not hidden?
    [ setxy ( ( x1 - xcenter ) * zoom ) ( ( y1 - ycenter ) * zoom ) ]
end

to check-mouse
  if mouse-down?
  [
    set xcenter ( ( mouse-xcor / zoom ) + xcenter )
    set ycenter ( ( mouse-ycor / zoom ) + ycenter )
    set pcolor black
  ]
end


to check-turtles
      ifelse  ((abs((x1 - xcenter)* zoom))> screen-edge-x) or
              ((abs((y1 - ycenter)* zoom))> screen-edge-y)
      [ ht  ]  [ st ]  ;;hide turtle or show turtle
      if  (color? = true)
        [set color  z1]
      ifelse  (draw? = true)  [draw ] [ move ]
  ;plot-positions
end

to julian
  ask patches
  [   check-mouse]
ask turtles[
;check-mouse
  set x2  (  x1  +  (  (  0.01  *  delta  )  *  (  (  0  -  y1  )  -  z1  )  )  )
  set y2  (  y1  +  (  (  0.01  *  delta  )  *  (  x1  +  (  (  0.01  *  a-val  )  *  y1  )  )  )  )
  set z2  (  z1  +  (  (  0.01  *  delta  )  *  (  (  0.01  *  b-val  )  +  (  x1  *  z1  )  -  (  (  c-val  *  0.1  )  *  z1  )  )  )  )
  my-setxyz  x2  y2  z2

  check-turtles]
  plot-positions
end

to lorenz
  ask patches
  [ check-mouse  ]
  ask turtles[
;check-mouse
   set x2  (x1 + ((0.01 * delta  ) * ( (  (  -0.01  *  b-val  )  *  x1  )  +  (  z1  *  y1  )  )  )  )
   set y2  (y1 + ((0.01 * delta  ) * ( (  (  (  0.1  *  c-val  )  *  z1  )  -  y1  )  -  (  z1  *  x1  )  )  )  )
   set z2  (z1 + ((0.01 * delta  ) * ( (  0.01  *  a-val  )  *  (  y1  -  z1  )  )  )  )
   my-setxyz  x2  y2  z2
  check-turtles
]
plot-positions
end



to draw
  set heading ( towardsxy ( ( x1 - xcenter ) * zoom ) ( ( y1 - ycenter ) * zoom ) )
  fd ( distancexy ( ( x1 - xcenter ) * zoom ) ( ( y1 - ycenter ) * zoom )  )
end







; This model was created as part of the project: CONNECTED MATHEMATICS:
; MAKING SENSE OF COMPLEX PHENOMENA THROUGH BUILDING OBJECT-BASED PARALLEL
; MODELS (OBPML).
; The project gratefully acknowledges the support of the National Science
; Foundation (Applications of Advanced Technologies Program) -- grant numbers
; RED #9552950 and REC #9632612.
;
; Copyright 1996 by Uri Wilensky. All rights reserved.
;
; Permission to use, copy, or modify this software and its documentation for
; educational and research purposes only and without fee is hereby granted,
; provided that this copyright notice and the original authors' names appear
; on all copies and supporting documentation. For any other uses of this
; software, in original or modified form, including but not limited to
; distribution in whole or in part, specific prior permission must be
; obtained from Uri Wilensky. These programs shall not be used, rewritten, or
; adapted as the basis of a commercial software or hardware product without
; first obtaining appropriate licenses from Uri Wilensky. We make no
; representations about the suitability of this software for any purpose. It
; is provided "as is" without express or implied warranty.




@#$#@#$#@
GRAPHICS-WINDOW
321
10
646
356
17
17
9.0
1
10
1
1
1
0
1
1
1

CC-WINDOW
5
529
655
624
Command Center

SLIDER
22
15
114
48
delta
delta
1
10
1
1
1
NIL

SLIDER
219
10
311
43
A-val
A-val
0
1000
300
1
1
NIL

BUTTON
19
201
100
234
circle
circle
NIL
1
T
OBSERVER
T
NIL

SWITCH
219
131
309
164
draw?
draw?
1
1
-1000

SWITCH
218
170
308
203
color?
color?
1
1
-1000

SLIDER
218
49
310
82
B-val
B-val
0
1000
300
1
1
NIL

SLIDER
218
85
310
118
C-val
C-val
0
5000
300
1
1
NIL

SLIDER
19
55
111
88
init-x
init-x
-50
50
0
1
1
NIL

SLIDER
19
91
111
124
init-y
init-y
-50
50
0
1
1
NIL

SLIDER
20
128
112
161
init-z
init-z
-50
50
0
1
1
NIL

SLIDER
121
13
213
46
radius
radius
0
50
15
1
1
NIL

SLIDER
120
55
212
88
number
number
0
4096
10
1
1
NIL

BUTTON
19
244
100
277
NIL
box
NIL
1
T
OBSERVER
T
NIL

BUTTON
20
288
101
321
NIL
point
NIL
1
T
OBSERVER
T
NIL

BUTTON
109
202
190
235
NIL
julian
T
1
T
OBSERVER
T
NIL

BUTTON
110
246
191
279
NIL
lorenz
T
1
T
OBSERVER
T
NIL

BUTTON
9
343
91
376
NIL
zoom-in
NIL
1
T
OBSERVER
T
NIL

BUTTON
104
343
192
376
NIL
zoom-out
NIL
1
T
OBSERVER
T
NIL

BUTTON
205
343
286
376
NIL
redraw
NIL
1
T
OBSERVER
T
NIL

MONITOR
39
430
96
479
NIL
zoom
3
1

MONITOR
108
429
165
478
NIL
xcenter
0
1

MONITOR
181
427
238
476
NIL
ycenter
0
1

PLOT
373
365
573
515
Plot1
NIL
NIL
0.0
100.0
0.0
100.0
true
false

@#$#@#$#@
add model documentation here

WHAT IS IT?
-----------
This program allows the user to explore the concept of
stable attractors in a system of non-linear equations, using
the Lorenz and Julian equations.


HOW TO USE IT
-------------

Equations
~~~~~~~~~
These are the equations governing the movement of each
turtle.  The next position is simply based on the x, y, and
z coordinates of the turtles current position.   The "A-val",
"B-val", "C-val", and "delta" sliders can be used to change
the performance of each function.

Transformation: Xn+1 = Xn + (delta * f(Xn))
                Yn+1 = Yn + (delta * f(Yn))
                Zn+1 = Zn + (delta * f(Zn))

Lorenz:         f(X) = ZY - BX
                f(Y) = CZ - Y - ZX
                f(Z) = A * (Y - Z)

Julian:         f(X) = -Y - Z
                f(Y) =  X + AY
                f(Z) =  B + ((X - C) * Z)

Setting Up
~~~~~~~~~~
There are three different initial configurations for the
turtles.  They are accessed with the "circle", "box", and
"point" buttons.  The center point, size, and number of
turtles to use can be adjusted with the "init-x", "init-y",
"init-z", "radius", and "number" sliders.

Getting the turtles moving
~~~~~~~~~~~~~~~~~~~~~~~~~~
The "Lorenz" and "Julian" buttons will begin the turtles
moving.  The slider "draw?" when set to "1" will cause the
turtles to trace their path between points.  The slider
"plot?" when set to "1" will cause the X, Y, and Z
coordinates of turtle 0 to be displayed in the plot window.
The slider "color?" when set to "1" will cause the turtles
to dynamiclly set  their color according to their Z
coordinate rather than simply keeping their initial color.

Adjusting The Display
~~~~~~~~~~~~~~~~~~~~~
Turtles that move off the edge of the screen are no longer
displayed (unless they come back on the screen).  The
"Zoom-in" and "Zoom-out" buttons allow you  to view the part
of the pattern that you want to see.  You can also move the
center of the display region by simply clicking in the
starlogo window on the point that you wish to be the new
center.


THINGS TO TRY
-------------

Interesting Configurations
~~~~~~~~~~~~~~~~~~~~~~~~~~~
Use initial coordinates of (0,0,0) unless you are using a
the "point" initial setup.  Try some of these configurations
to get started:

           +---+-----+-----+-----+---------+-----+----+
           |del|A-val|B-val|C-val|init coor| L/J |Zoom|
           +---+-----+-----+-----+---------+-----+----+
Lorenz     | 1 | 300 | 266 | 400 | (1,1,1) | Lor | no |
Julian     | 4 |  20 |  20 |  57 | (1,1,2) | Jul |  4 |
Point      | 4 |   0 |   0 | 200 | (1,1,1) | Lor | no |
Spiral In  | 4 |  20 |  20 | 200 | (1,1,1) | Lor | no |
Spiral Out | 1 |   0 |  20 | 600 | (0,1,0) | Jul |  4 |
Circular   | 1 |  20 |  20 | 600 | (1,1,1) | Jul |  4 |
           +---+-----+-----+-----+---------+-----+----+

EXTENDING THE MODEL
-------------------

        - Try displaying all three coordinates by projecting the
          three dimensions onto the two dimensional screen.
          (See the project Membrane for an example)

        - There are other interesting systems of equations.  Find
          out what some of them are, and add them to the program.



@#$#@#$#@
default
true
0
Polygon -7566196 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7566196 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7566196 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7566196 true true 150 285 285 225 285 75 150 135
Polygon -7566196 true true 150 135 15 75 150 15 285 75
Polygon -7566196 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7566196 true true 96 182 108
Circle -7566196 true true 110 127 80
Circle -7566196 true true 110 75 80
Line -7566196 true 150 100 80 30
Line -7566196 true 150 100 220 30

butterfly
true
0
Polygon -7566196 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7566196 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7566196 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7566196 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7566196 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7566196 true true 47 195 58
Circle -7566196 true true 195 195 58

circle
false
0
Circle -7566196 true true 0 0 300

circle 2
false
0
Circle -7566196 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7566196 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7566196 true true 73 210 86 251 62 249 48 208
Polygon -7566196 true true 25 114 16 195 9 204 23 213 25 200 39 123

face happy
false
0
Circle -7566196 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7566196 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7566196 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7566196 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7566196 true true 60 15 75 300
Polygon -7566196 true true 90 150 270 90 90 30
Line -7566196 true 75 135 90 135
Line -7566196 true 75 45 90 45

flower
false
0
Polygon -11352576 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7566196 true true 85 132 38
Circle -7566196 true true 130 147 38
Circle -7566196 true true 192 85 38
Circle -7566196 true true 85 40 38
Circle -7566196 true true 177 40 38
Circle -7566196 true true 177 132 38
Circle -7566196 true true 70 85 38
Circle -7566196 true true 130 25 38
Circle -7566196 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -11352576 true false 189 233 219 188 249 173 279 188 234 218
Polygon -11352576 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7566196 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7566196 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7566196 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7566196 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7566196 true 150 0 150 300

pentagon
false
0
Polygon -7566196 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7566196 true true 110 5 80
Polygon -7566196 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7566196 true true 127 79 172 94
Polygon -7566196 true true 195 90 240 150 225 180 165 105
Polygon -7566196 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7566196 true true 135 90 165 300
Polygon -7566196 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7566196 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7566196 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7566196 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7566196 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7566196 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7566196 true true 135 90 120 45 150 15 180 45 165 90

square
false
0
Rectangle -7566196 true true 30 30 270 270

square 2
false
0
Rectangle -7566196 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7566196 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7566196 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7566196 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7566196 true true 120 120 60

tree
false
0
Circle -7566196 true true 118 3 94
Rectangle -6524078 true false 120 195 180 300
Circle -7566196 true true 65 21 108
Circle -7566196 true true 116 41 127
Circle -7566196 true true 45 90 120
Circle -7566196 true true 104 74 152

triangle
false
0
Polygon -7566196 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7566196 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7566196 true true 4 45 195 187
Polygon -7566196 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7566196 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7566196 false true 24 174 42
Circle -7566196 false true 144 174 42
Circle -7566196 false true 234 174 42

turtle
true
0
Polygon -11352576 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -11352576 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -11352576 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -11352576 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -11352576 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7566196 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7566196 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7566196 true 150 285 150 15
Line -7566196 true 15 150 285 150
Circle -7566196 true true 120 120 60
Line -7566196 true 216 40 79 269
Line -7566196 true 40 84 269 221
Line -7566196 true 40 216 269 79
Line -7566196 true 84 40 221 269

x
false
0
Polygon -7566196 true true 270 75 225 30 30 225 75 270
Polygon -7566196 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 2.2pre3
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
