
globals [
      land-color-1 land-color-2 land-color-selected lab-color silo-color
      field-selected
       land-edge lab-edge
       selected-color-1 selected-color-2
       bin-color bin-selected-color
       seed-color-1 seed-color-2 seed-color-3
       field-1 field-2 field-3 field-4 field-5 field-6 field-7 field-8]
breeds [plants plants-selected seeds seeds-selected bins bins-selected]
plants-own [
  age
  seedcolor-genotype seedshape-genotype
  eggs-list-1 eggs-list-2
  seeds-list-1 seeds-list-2
  selected?
  ear-selected]

seeds-own [
  seednumber
  seedcolor-genotype seedshape-genotype
  selected?
  harvested?
  ]

bins-own [
  seeds-list-collection
  selected?
]

patches-own [field]



to setup
  ca
  set bin-color (gray)
  set bin-selected-color (white)
  set land-color-1 (black + 2)
  set land-color-2 (black + 1)
  set land-color-selected (white)
  set lab-color (grey + 1 )
  set silo-color (grey - 1)
  set selected-color-1 (pink + 3)
  set selected-color-2  (pink + 5)
  set seed-color-1 yellow
  set seed-color-2 (blue - 3)
  set seed-color-3 (red -  2 )
  set land-edge 0
  set lab-edge ( round (screen-edge-x / 1.5))

  ask patches [set field 0]
  create-3-zones
  setup-first-harvest
  make-general-ear
  make-empty-bins
  if field-labels? [ask patches with [field != 0] [set plabel field]]

end


to make-kernal-list-for-ear
  let newlist []
  repeat 100 [set newlist fput assign-random-seedcolor newlist]
  set seeds-list-1 newlist
  set newlist []
  repeat 100 [set newlist fput assign-random-seedcolor newlist]
  set seeds-list-2 newlist

end


to create-3-zones
  create-8-fields
    ask patches with [(pxcor >  land-edge) and (pxcor <  lab-edge)] [set pcolor lab-color]
  ask patches with [pxcor >=  lab-edge] [set pcolor silo-color]
end

to create-8-fields
;;  ask patches with [pxcor <=  land-edge] [set pcolor land-color-1]
  ask patches with [pxcor <=  ( -1 * screen-edge-x / 2) and pycor >= (screen-edge-y / 2)] [set pcolor land-color-2 set field 1]
  ask patches with [pxcor >  ( -1 * screen-edge-x / 2) and pxcor <= 0 and pycor >= (screen-edge-y / 2)] [set pcolor land-color-1 set field 2]
  ask patches with [pxcor <=  ( -1 * screen-edge-x / 2) and pycor < (screen-edge-y / 2) and pycor >= 0 ] [set pcolor land-color-1 set field 3]
  ask patches with [pxcor >  ( -1 * screen-edge-x / 2) and pxcor <= 0 and pycor < (screen-edge-y / 2) and pycor >= 0] [set pcolor land-color-2 set field 4]
   ask patches with [pxcor <=  ( -1 * screen-edge-x / 2) and (pycor < 0) and pycor >= (-1 * screen-edge-y / 2)] [set pcolor land-color-2 set field 5 ]
  ask patches with [pxcor >  ( -1 * screen-edge-x / 2) and pxcor <= 0 and pycor <= 0 and (pycor < 0) and pycor >= (-1 * screen-edge-y / 2)] [set pcolor land-color-1 set field 6]
   ask patches with [pxcor <=  ( -1 * screen-edge-x / 2) and pycor < (-1 * screen-edge-y / 2)] [set pcolor land-color-1 set field 7 ]
  ask patches with [pxcor >  ( -1 * screen-edge-x / 2) and pxcor <= 0 and pycor < (-1 * screen-edge-y / 2)] [set pcolor land-color-2 set field 8]


   ;;ask patches with [pxcor <=  (land-edge / 2) and pycor <= (-1 * screen-edge-y / 2)] [set pcolor land-color-2]

end

to setup-first-harvest
 ;;repeat 50
 create-custom-plants 50 [
   setxy ( -1 * (random screen-edge-x)) (random 100)
   setup-new-plant
   ]

end

to setup-new-plant
   set age 0
   set shape "corn-seed"
   set color yellow

   set selected? false
   set ear-selected 1
   set seedcolor-genotype assign-random-seedcolor
   set seedshape-genotype assign-random-seedshape
   make-kernal-list-for-ear
end




to go

;;  show age
  ask plants [grow-corn]
 ;; ifelse field-labels? [ask patches with [field != 0] [set plabel field]]
  ;; [ask patches [set plabel ""]]
  animate-selected
  listen-select-corn
  listen-select-seeds
  listen-select-bin
end

to grow-corn
  set age (age + 10)
  if (age = 100 ) [set shape "corn-0quarter" set color green]
  if (age = 200 ) [set shape "corn-1quarter" set color green]
  if (age = 300 ) [set shape "corn-2quarter" set color green]
  if (age = 400 ) [set shape "corn-3quarter" set color green]
  if (age = 500 ) [set shape "corn-full-fruit" set color green]
  if (age = 600 ) [set shape "corn-full-fruit" set color green]
end

to animate-selected
  ask plants-selected  [
   set heading (heading + 1) ]
end

to listen-select-corn

 if mouse-down? and (any? plants with [pxcor = floor mouse-xcor and pycor = floor mouse-ycor]) [
 show "hi"
  ask plants with [selected?] [set selected? false]
  ask plants-selected [die]
  ask plants with [pxcor = floor mouse-xcor and pycor = floor mouse-ycor] [

      set selected? true
      hatch 1 [
        set color selected-color-1
        set breed plants-selected
        set size 2
        set shape "selected"
        ]

    show-ear
   ]
   ]
end



to listen-select-seeds

 if mouse-down? and (any? seeds with [pxcor = floor mouse-xcor and pycor = floor mouse-ycor]) [

  if (not multiple-seeds?) [
    ask seeds with [selected?] [set selected? false]
    ask seeds-selected [die]
    ]
  ask seeds with [xcor = floor mouse-xcor and pycor = floor mouse-ycor] [
    if (not selected?) [
      set selected? true
          hatch 1 [
          set breed seeds-selected
          set color white
          set shape "seed-selected"
          ]
        ]

    ]



  ]
end



to listen-select-bin

  if mouse-down? and (any? bins with [xcor = floor mouse-xcor and ycor = floor mouse-ycor]) [
    ask bins with [selected?] [set selected? false set color bin-color]
   ask bins-selected [die]
   ask bins with [xcor = floor mouse-xcor and ycor = floor mouse-ycor] [
     set selected? true
     set color bin-selected-color
   ]

   ]

end


to listen-transfer-seeds-to-bin
    ask bins with [selected?] [set seeds-list-collection (values-from seeds with [selected?] [seedcolor-genotype]) set color red set label length seeds-list-collection]
    ask seeds with [selected?] [set hidden? true]
    ask seeds-selected [die]
end

to listen-transfer-one-seed-to-field
   let seed-position -1
   let seed-to-transfer ""
   let size-of-collection-to-transfer 0
   let collection-to-transfer []

 ;; if (not any? plants with [field = field-selected])  [

    if field-selected != 0 [

    ask bins with [selected?] [
      set collection-to-transfer seeds-list-collection
      set size-of-collection-to-transfer length collection-to-transfer
    ]
    if size-of-collection-to-transfer > 0 and (count patches with [any? plants] > 0) [
      set seed-position position (random-one-of collection-to-transfer) collection-to-transfer
      set seed-to-transfer item seed-position collection-to-transfer

      ask random-one-of patches with [field = field-selected and not any? plants] [
         sprout 1 [
         set breed plants
         setup-new-plant
         ]
      ]
     set collection-to-transfer (remove seed-position collection-to-transfer)
     ]
  ]
end



to show-ear
  let seed-genotype ""
  let seed-number 0
  let seed-list seeds
  let n 1

  let this-seed-list seeds-list-2


  if ear-selected = 1 [set this-seed-list seeds-list-2]

  ask seeds [set shape "kernal-smooth" set color seed-color-1]

  repeat 100 [
    ask seeds with [seednumber = n] [

    set seed-genotype (item seed-number this-seed-list)

    set seed-number (seed-number + 1)

    set seedcolor-genotype seed-genotype
    set color (seedcolor-phenotype  seedcolor-genotype )

      ifelse (seed-genotype = -1)
        [set harvested? true]
        [set harvested? false
        ]
      ]
      set n (n + 1)
    ]

    ask seeds with [not harvested?] [set hidden? false ]
end


to make-general-ear
  let column 3
  let row -10
  let n 1

  repeat 20 [
    repeat 5 [
      create-custom-seeds 1 [setxy column row set hidden? true set selected? false set seednumber n]
      set column (column + 1)

    ]
    set column 3
    set row (row + 0.8)
  ]
end

to make-empty-bins
  let column 12
  let row -14
  let number 1

  repeat 8 [
    repeat 2 [
      create-custom-bins 1 [
          set size 2
           setxy column row
           set shape "bin-empty"
           set selected? false
           set color bin-color
           set label-color white
           ]
      set column (column + 4)
      set number (number + 1)
    ]
    set column 12
    set row (row + 4)
  ]
end

to listen-select-field
  if mouse-down? [
    ask patch-at mouse-xcor mouse-ycor [set field-selected field]
  ]
  if field-selected != 0 [set field-to-clear field-selected ask patches with [field = field-selected] [ set plabel "."]]
  ask patches with [field != field-selected] [set plabel ""]
end

to-report assign-random-seedcolor

   let chance (random 4)
   if chance = 0 [report "YY"]
   if chance = 1 [report "BB"]
   if chance = 2 [report "YB"]
   if chance = 3 [report "BY"]

end


to-report assign-random-seedshape
  let chance (random 4)
  if chance = 0 [report "SS"]
  if chance = 1 [report "ss"]
   if chance = 2 [report "Ss"]
  if chance = 3 [report "sS"]
end



to-report seedcolor-phenotype [genotype]
  if genotype = "YY" [report seed-color-1]
  if genotype = "BB" [report seed-color-2]
  if genotype = "YB" [report seed-color-3]
  if genotype = "BY" [report seed-color-3]
end



to-report phenotype [genotype]
  if genotype = "YY" [report seed-color-1]
  if genotype = "BB" [report seed-color-2]
  if genotype = "YB" [report seed-color-3]
  if genotype = "BY" [report seed-color-3]

end

to clear-field
  ask plants with [field = field-to-clear] [die]
  ask plants-selected with [field = field-to-clear] [die]
end
@#$#@#$#@
GRAPHICS-WINDOW
303
10
733
461
17
17
12.0
1
8
1
1
1
0
1
1
1

CC-WINDOW
5
529
742
624
Command Center
0

BUTTON
24
11
87
44
NIL
setup
NIL
1
T
OBSERVER
T
NIL

BUTTON
24
47
87
80
NIL
go
T
1
T
OBSERVER
T
NIL

BUTTON
13
408
116
441
NIL
listen-select-corn
T
1
T
OBSERVER
T
NIL

SWITCH
102
14
253
47
show-genotype?
show-genotype?
1
1
-1000

BUTTON
12
442
120
475
NIL
listen-select-seeds
T
1
T
OBSERVER
T
NIL

BUTTON
16
96
164
129
NIL
listen-transfer-seeds-to-bin
NIL
1
T
OBSERVER
T
NIL

BUTTON
11
482
130
515
NIL
listen-select-bin
T
1
T
OBSERVER
T
NIL

SWITCH
167
174
294
207
multiple-seeds?
multiple-seeds?
0
1
-1000

BUTTON
199
133
295
166
clear field
clear-field
NIL
1
T
OBSERVER
T
NIL

SWITCH
170
212
293
245
field-labels?
field-labels?
1
1
-1000

SLIDER
196
95
300
128
field-to-clear
field-to-clear
1
8
3
1
1
NIL

BUTTON
11
167
137
200
NIL
listen-select-field
T
1
T
OBSERVER
T
NIL

BUTTON
14
130
184
163
NIL
listen-transfer-one-seed-to-field
NIL
1
T
OBSERVER
T
NIL

SLIDER
53
266
225
299
seed-to-plant
seed-to-plant
1
100
50
1
1
NIL

@#$#@#$#@
WHAT IS IT?
-----------
This section could give a general understanding of what the model is trying to show or explain.


HOW IT WORKS
------------
This section could explain what rules the agents use to create the overall behavior of the model.


HOW TO USE IT
-------------
This section could explain how to use the model, including a description of each of the items in the interface tab.


THINGS TO NOTICE
----------------
This section could give some ideas of things for the user to notice while running the model.


THINGS TO TRY
-------------
This section could give some ideas of things for the user to try to do (move sliders, switches, etc.) with the model.


EXTENDING THE MODEL
-------------------
This section could give some ideas of things to add or change in the procedures tab to make the model more complicated, detailed, accurate, etc.


NETLOGO FEATURES
----------------
This section could point out any especially interesting or unusual features of NetLogo that the model makes use of, particularly in the Procedures tab.  It might also point out places where workarounds were needed because of missing features.


RELATED MODELS
--------------
This section could give the names of models in the NetLogo Models Library or elsewhere which are of related interest.


CREDITS AND REFERENCES
----------------------
This section could contain a reference to the model's URL on the web if it has one, as well as any other necessary credits or references.
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

bin-empty
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75
Polygon -16777216 true false 45 75 150 120 255 75 150 30

bin-full
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75
Polygon -2674135 true false 45 75 75 90 105 75 75 60
Polygon -1 true false 75 60 105 75 135 60 105 45

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

corn-0quarter
false
0
Polygon -7500403 true true 135 300 135 255 150 225 165 255 165 300
Rectangle -7500403 true true 135 285 165 300

corn-1quarter
false
0
Rectangle -7500403 true true 135 240 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 240 135 195 150 165 165 195 165 240

corn-2quarter
false
0
Rectangle -7500403 true true 135 165 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 195 135 150 150 120 165 150 165 195

corn-3quarter
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 135 135 90 150 60 165 90 165 135

corn-full-flower
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 120 135 75 150 45 165 75 165 120
Line -1184463 false 180 30 165 30
Line -1184463 false 150 0 150 45
Line -1184463 false 150 45 165 15
Line -1184463 false 135 15 150 45
Line -1184463 false 165 30 150 45
Line -1184463 false 120 30 135 30
Line -1184463 false 135 30 150 45

corn-full-fruit
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 120 135 75 150 45 165 75 165 120
Line -1184463 false 180 30 165 30
Line -1184463 false 150 0 150 45
Line -1184463 false 150 45 165 15
Line -1184463 false 135 15 150 45
Line -1184463 false 165 30 150 45
Line -1184463 false 120 30 135 30
Line -1184463 false 135 30 150 45

corn-seed
false
0
Polygon -7500403 true true 135 300 120 255 150 225 180 255 165 300

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

kernal-smooth
false
0
Circle -7500403 true true 15 60 90
Rectangle -7500403 true true 15 105 285 195
Circle -7500403 true true 15 150 90
Circle -7500403 true true 195 60 90
Circle -7500403 true true 195 150 90
Rectangle -7500403 true true 60 60 240 240

kernal-wrinkled
false
0
Polygon -7500403 true true 45 60 30 90 11 98 15 180 30 225 60 240 150 225
Polygon -7500403 true true 124 219 195 240 255 240 285 210 285 150 270 75 255 60
Polygon -7500403 true true 46 60 106 75 256 62 136 225
Circle -7500403 true true 11 60 67

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line-half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

seed-selected
false
0
Polygon -7500403 false true 45 45 15 60 0 90 0 210 15 240 45 255 255 255 285 240 299 211 299 89 285 60 255 45
Polygon -16777216 false false 60 60 30 75 15 105 15 195 30 225 60 240 240 240 270 225 285 195 285 105 270 75 240 60
Circle -7500403 true true 88 88 124
Circle -16777216 true false 116 116 67

selected
true
0
Circle -7500403 false true 15 15 268
Polygon -7500403 true true 285 135 225 150 285 165
Polygon -7500403 true true 135 15 150 75 165 15
Polygon -7500403 true true 135 285 150 225 165 285
Polygon -7500403 true true 15 135 75 150 15 165

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 3.0beta3
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@

