globals
[
  time
]

turtles-own
[
  disp
]

to setup
  ca
  set time 0

;;paulo says some kids dont care for the axis
; Uncomment if you disagree
;ask patches
;  [ if (pxcor = 0)
;    [ set pcolor gray - 3 ]
;    if (pycor = 0)
;    [ set pcolor gray - 3 ]
;  ]


set-default-shape turtles "circle"
  cct screen-size-x
  [
    set xcor (who - screen-edge-x)
    set color yellow
  ]
  cct screen-size-x
  [
    set xcor (who - screen-edge-x)
    set color green
  ]
  cct screen-size-x
  [
    set xcor (who - screen-edge-x)
    set color red
  ]
end

to go
  set-default-shape turtles "circle"
  set time time + 1

  ask turtles with [color = yellow]
  [
   set disp amplitude-yellow-wave * sin (frequency-yellow-wave * time + k-yellow-wave * xcor + delta-yellow-wave )
   set ycor disp
  ]

  ifelse hide-yellow-wave?
  [
     ask turtles with [color = yellow]
     [
       ht
     ]
  ]
  [
    ask turtles with [color = yellow]
     [
       st
     ]
  ]





  ifelse same-direction?
  [
   ask turtles with [color = green]
     [
       set disp amplitude-green-wave * sin (frequency-green-wave * time + k-green-wave * xcor + delta-green-wave  )
       set ycor disp
     ]
   ifelse hide-green-wave?
   [
     ask turtles with [color = green]
     [
       ht
     ]
   ]
   [
     ask turtles with [color = green]
     [
       st
     ]
   ]

   ifelse hide-red-wave?
   [
     ask turtles with [color = red]
     [
       ht
     ]
   ]
   [
    ask turtles with [color = red]
    [
      st
      set disp ( (amplitude-green-wave * sin (frequency-green-wave * time + k-green-wave * xcor + delta-green-wave  )) + (amplitude-yellow-wave * sin (frequency-yellow-wave * time + k-yellow-wave * xcor + delta-yellow-wave   )) )
      if noise?
      [
        set disp ( disp - noise-level + random ( 2 * noise-level ) )
      ]
      set ycor disp

      if high-pass-filter?
      [
        if disp < high-pass-threshold
        [
          set ycor 0
        ]
      ]

      if low-pass-filter?
      [
        if disp > low-pass-ceiling
        [
          set ycor 0
        ]
      ]
    ]
   ]
  ]




  [

    ask turtles with [color = green]
     [
       set disp amplitude-green-wave * sin (frequency-green-wave * time - k-green-wave * xcor + delta-green-wave  )
       set ycor disp
     ]
   ifelse hide-green-wave?
   [
     ask turtles with [color = green]
     [
       ht
     ]
   ]
   [
     ask turtles with [color = green]
     [
       st
     ]
   ]



   ifelse hide-red-wave?
   [
     ask turtles with [color = red]
     [
       ht
     ]
   ]
   [
    ask turtles with [color = red]
    [
      st
      set disp ( (amplitude-green-wave * sin (frequency-green-wave * time - k-green-wave * xcor + delta-green-wave  )) + (amplitude-yellow-wave * sin (frequency-yellow-wave * time + k-yellow-wave * xcor + delta-yellow-wave   )) )
      if noise?
      [
        set disp ( disp - noise-level + random ( 2 * noise-level ) )
      ]
      set ycor disp

      if high-pass-filter?
      [
        if disp < high-pass-threshold
        [
          set ycor 0
        ]
      ]

      if low-pass-filter?
      [
        if disp > low-pass-ceiling
        [
          set ycor 0
        ]
      ]

    ]
   ]
  ]
end


@#$#@#$#@
GRAPHICS-WINDOW
469
10
1081
443
150
100
2.0
1
10
1
1
1
0
1
1
1

CC-WINDOW
5
552
1090
647
Command Center
0

BUTTON
50
10
113
43
setup
setup
NIL
1
T
OBSERVER
T
NIL

BUTTON
176
12
239
45
go
go
T
1
T
OBSERVER
T
NIL

SLIDER
10
55
198
88
amplitude-yellow-wave
amplitude-yellow-wave
0
50
17
1
1
NIL

SLIDER
10
95
199
128
frequency-yellow-wave
frequency-yellow-wave
0
25
20
1
1
NIL

SLIDER
9
137
181
170
k-yellow-wave
k-yellow-wave
0
80
15
1
1
NIL

SLIDER
9
178
182
211
delta-yellow-wave
delta-yellow-wave
0
360
0
1
1
NIL

SLIDER
256
55
442
88
amplitude-green-wave
amplitude-green-wave
0
50
23
1
1
NIL

SLIDER
257
96
444
129
frequency-green-wave
frequency-green-wave
0
25
22
1
1
NIL

SLIDER
258
137
430
170
k-green-wave
k-green-wave
0
80
17
1
1
NIL

SLIDER
259
178
431
211
delta-green-wave
delta-green-wave
0
360
0
1
1
NIL

MONITOR
136
411
218
460
time elapsed
time
3
1

SWITCH
104
361
248
394
same-direction?
same-direction?
1
1
-1000

SWITCH
19
238
190
271
hide-yellow-wave?
hide-yellow-wave?
0
1
-1000

SWITCH
268
240
437
273
hide-green-wave?
hide-green-wave?
0
1
-1000

SWITCH
100
305
254
338
hide-red-wave?
hide-red-wave?
1
1
-1000

SWITCH
317
321
420
354
noise?
noise?
0
1
-1000

SLIDER
287
377
459
410
noise-level
noise-level
0
30
0
1
1
NIL

SWITCH
17
463
179
496
high-pass-filter?
high-pass-filter?
0
1
-1000

SWITCH
271
462
426
495
low-pass-filter?
low-pass-filter?
0
1
-1000

SLIDER
14
500
198
533
high-pass-threshold
high-pass-threshold
-40
50
-30
1
1
NIL

SLIDER
267
505
439
538
low-pass-ceiling
low-pass-ceiling
-40
40
23
1
1
NIL

@#$#@#$#@
WHAT IS IT?
-----------
This model simulates the interference of two waves. This can be used to simulate various interesting phenomena associated with wave interfence like beats, standing waves, oscillatory waves, constructive interference, destructive interference or anything you want. The sky is the limit. You can simulate any wave phenomena with this model.


HOW IT WORKS
------------
The user can specify the amplitudes, frequencies, wavelength (2*PI/k) and the phase factors for both the waves. Then the model displays the waves and their resultant. The resultant is calculated by the Principle of Interference which states that "each waves acts independently of others and produces it's own effect".

The first wave is painted green, the second wave is painted yellow and the resultant is painted as a red wave.

HOW TO USE IT
-------------

NOTE:- You can change the wave properties during simulation which will give you a better feel of how different properties affect the resultant.

The SETUP button creates the waves as chosen by the slider values. The GO button starts the simulation which calculates the resultant wave.

Amplitude1 and Amplitude2 sliders choose the amplitudes of the waves.
Similarly the Frequency sliders change the frequency of the respective wave.

The delta sliders change the phase of that wave.

The k sliders change the wavelength. LESSER THE K MORE THE WAVELENGTH.

The same direction switch lets you decide whether to the waves travel along the same direction of opposite.

THINGS TO NOTICE
----------------
Switch off the same-direction switch and then notice how the direction of travelling of the resultant wave changes as you change various variables. Which wave has a greater influence on the direction of the resultant? The greater frequency one? The greater wavelength one? Does the phase (delta) play any role?

Can you make the resultant wave just stand there and not move?

Notice the wavelength of the resultant. What influences it?

What has a greater influence of the resultant wave's frequency? What about resultant's amplitude? On what factors does it depend?


THINGS TO TRY
-------------
1). Keep k1=k2 and freq1=freq2. Switch ON same-direction? switch. Now try two cases:-

        a) delta1 - delta2 = 180
        (destructive interfernce) which means resultant amplitude  will be amp1-amp2

        b) delta1 - delta2 = 360
        (constructive interfernce)which means resultant amplitude  will be amp1+amp2

2). Keep k1=k2 and freq1=freq2. Switch OFF same-direction? switch. Vary the phases (deltas) and now you have standing waves.

3). Now keep k1 != k2 (not equal) and freq1=freq2.  Switch OFF same-direction? switch. Now you standing waves with in-built phase.

4). Keep k1,freq1,k2 and freq2 such that

        k1/freq1 = k2/freq2 (that is they are proportional)

Switch ON same-direction? switch.

Keep freq1 and freq2 in such a way that difference between them is smaller as compared to their values e.g. 20 and 22. A good set of k1,freq1,k2 and freq2 can be

k1=10
freq1=20
k2=11
freq2=22
Don't forget to switch ON same-direction? switch. Now you have the phenomenon of beats (also you can see the standing resultant wave changing it's amplitude in a  beautiful pattern).


EXTENDING THE MODEL
-------------------
You can increase the number of waves.

You can model the medium by specifying viscosity, friction etc.

You can put some obstacles in the path of interfernce.

You can place some slits and see the magic of polarization.

You can associate sounds with the waves through Java sound API. For example, if you have a drum as a wave 1 and guitar as wave 2 then you can really feel the beats phenomenon.

NETLOGO FEATURES
----------------
TURTLES and the mathematics functions used.

RELATED MODELS
--------------
There is a model in the library which simulate other features of waves.

CREDITS AND REFERENCES
----------------------
Made by Gagandeep Singh (gagands@cse.iitk.ac.in)
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 60 270 150 0 240 270 15 105 285 105
Polygon -7500403 true true 75 120 105 210 195 210 225 120 150 75

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 3.0pre5
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
