breeds
[ reds
  anode
  cathode
  ]

globals
[charge-flow]

to setup
  ca

foreach [ 1 2 3 4 5 6 7 8 9 10  ]
 [cct 1
 [
 pu
 set color random-one-of [red yellow green blue white orange pink]
 set breed reds
 set shape "circle"
 set label "-"
 set size 10
 set ycor (2 * ? * screen-edge-y / 10 )
 set xcor 0 + move-charge-wall
 pd
 ]]

 create-custom-cathode 1

  [set shape "ufo top"
  set color blue
  set label "+"
  set size 25
  setxy screen-edge-x - screen-edge-x / 2 0  ]


 create-custom-anode 1

  [set shape "ufo top"
  set color red
 set size 25
 set label "-"
 setxy screen-edge-x / 2 - screen-edge-x 0
  ]

 end

to go
if (mouse-down?)
  [
    cct 1
    [
      ;; Get the mouse(mass) position.
      set breed reds
      set xcor mouse-xcor
      set ycor mouse-ycor
      set size 10
      set color violet
      set shape "circle"
      st
      pd
    ]
  ]


ask anode
    [
;      hatch 1 [
;          set breed reds
;          set shape "circle"
;    set color red
;    set size 1
;    set label " "
;    set heading 0 + random 360
;
;      ]
    ask reds [ if distance-nowrap myself > 0 [ repel-anode ] ]
    ]
    ask cathode [ ask reds [       if distance-nowrap myself > 0
      [
attract ] ] ]

ask reds
  [ update-position
   ]

     end

to attract
  set heading towards-nowrap myself
  jump 0.5 * (cathode-charge / (distance-nowrap myself) ^ (0 - powerlaw ))
end
to repel-anode
  set heading towards myself
  rt 180
  jump 0.5 * (anode-charge / (distance-nowrap myself) ^ (0 - powerlaw))
  end


to update-position
 ifelse ((xcor >= (- screen-edge-x)) and (xcor <= screen-edge-x)
          and (ycor > (- screen-edge-y)) and (ycor <= screen-edge-y))

  [
    show-turtle
   ]
[ht]
     end



@#$#@#$#@
GRAPHICS-WINDOW
220
10
831
442
300
200
1.0
1
30
1
1
1
0

CC-WINDOW
5
456
840
551
Command Center

BUTTON
18
44
81
77
NIL
Setup
NIL
1
T
OBSERVER
T
NIL

BUTTON
18
77
81
110
NIL
Go
T
1
T
OBSERVER
T
NIL

SLIDER
17
116
210
149
cathode-charge
cathode-charge
0
10000
10000
100
1
NIL

SLIDER
17
148
210
181
anode-charge
anode-charge
0
10000
10000
100
1
NIL

SLIDER
19
10
192
43
move-charge-wall
move-charge-wall
-120
120
-77
1
1
NIL

CHOOSER
43
186
194
231
powerlaw
powerlaw
-2
0

TEXTBOX
82
43
192
112
Press GO and then click anywhere in the graphics window to create a test-electron\n

TEXTBOX
55
261
205
317
NOTE: THIS MODEL IS BEST OPTIMIZED IN NETLOGO 2.1 OR OLDER VERSIONS

@#$#@#$#@
What Is It?
-----------
This model simulates electric "lines of force". In physics, a force field is a way to picture the effects that electric  charges have on one another. Instead of talking about the force a positive (+) charge  exerts on an electron, we can say the charge creates a force "field" in the empty space  around it. An electron put down at any place in this force field is pulled towards the  + charge; a positive charge set down at the same place is pushed away. In this model, some electrons are created between a positive and a negative charge (e.g., a cathode and an anode, respectively) with much higher magnitude of charge than the lectron themselves. For simplicity, we have chosen the electrons to have "unit" charge. The path traced by the electrons due to the forces exerted on it due to the cathode and the anode are the "lines of force".

Since magnetic and electrostatic forces exhibit analogous behavior, you can also think of the two electrodes to be a North and a South pole, and you can treat the eletrons as very small magnets (of unit magnetic strength).


@#$#@#$#@
default
true
0
Polygon -7566196 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7566196 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7566196 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7566196 true true 150 285 285 225 285 75 150 135
Polygon -7566196 true true 150 135 15 75 150 15 285 75
Polygon -7566196 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7566196 true true 96 182 108
Circle -7566196 true true 110 127 80
Circle -7566196 true true 110 75 80
Line -7566196 true 150 100 80 30
Line -7566196 true 150 100 220 30

butterfly
true
0
Polygon -7566196 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7566196 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7566196 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7566196 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7566196 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7566196 true true 47 195 58
Circle -7566196 true true 195 195 58

circle
false
0
Circle -7566196 true true 30 30 240

circle 2
false
0
Circle -7566196 true true 16 16 270
Circle -16777216 true false 46 46 210

cow
false
0
Polygon -7566196 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7566196 true true 73 210 86 251 62 249 48 208
Polygon -7566196 true true 25 114 16 195 9 204 23 213 25 200 39 123

face happy
false
0
Circle -7566196 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7566196 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7566196 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7566196 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7566196 true true 60 15 75 300
Polygon -7566196 true true 90 150 270 90 90 30
Line -7566196 true 75 135 90 135
Line -7566196 true 75 45 90 45

flower
false
0
Polygon -11352576 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7566196 true true 85 132 38
Circle -7566196 true true 130 147 38
Circle -7566196 true true 192 85 38
Circle -7566196 true true 85 40 38
Circle -7566196 true true 177 40 38
Circle -7566196 true true 177 132 38
Circle -7566196 true true 70 85 38
Circle -7566196 true true 130 25 38
Circle -7566196 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -11352576 true false 189 233 219 188 249 173 279 188 234 218
Polygon -11352576 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7566196 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7566196 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7566196 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7566196 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7566196 true 150 0 150 300

pentagon
false
0
Polygon -7566196 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7566196 true true 110 5 80
Polygon -7566196 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7566196 true true 127 79 172 94
Polygon -7566196 true true 195 90 240 150 225 180 165 105
Polygon -7566196 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7566196 true true 135 90 165 300
Polygon -7566196 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7566196 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7566196 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7566196 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7566196 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7566196 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7566196 true true 135 90 120 45 150 15 180 45 165 90

square
false
0
Rectangle -7566196 true true 30 30 270 270

square 2
false
0
Rectangle -7566196 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7566196 true true 60 270 150 0 240 270 15 105 285 105
Polygon -7566196 true true 75 120 105 210 195 210 225 120 150 75

target
false
0
Circle -7566196 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7566196 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7566196 true true 120 120 60

tree
false
0
Circle -7566196 true true 118 3 94
Rectangle -6524078 true false 120 195 180 300
Circle -7566196 true true 65 21 108
Circle -7566196 true true 116 41 127
Circle -7566196 true true 45 90 120
Circle -7566196 true true 104 74 152

triangle
false
0
Polygon -7566196 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7566196 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7566196 true true 4 45 195 187
Polygon -7566196 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7566196 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7566196 false true 24 174 42
Circle -7566196 false true 144 174 42
Circle -7566196 false true 234 174 42

turtle
true
0
Polygon -11352576 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -11352576 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -11352576 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -11352576 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -11352576 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7566196 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

ufo top
false
0
Circle -1 true false 15 15 270
Circle -16777216 false false 15 15 270
Circle -7566196 true true 75 75 150
Circle -16777216 false false 75 75 150
Circle -7566196 true true 60 60 30
Circle -7566196 true true 135 30 30
Circle -7566196 true true 210 60 30
Circle -7566196 true true 240 135 30
Circle -7566196 true true 210 210 30
Circle -7566196 true true 135 240 30
Circle -7566196 true true 60 210 30
Circle -7566196 true true 30 135 30
Circle -16777216 false false 30 135 30
Circle -16777216 false false 60 210 30
Circle -16777216 false false 135 240 30
Circle -16777216 false false 210 210 30
Circle -16777216 false false 240 135 30
Circle -16777216 false false 210 60 30
Circle -16777216 false false 135 30 30
Circle -16777216 false false 60 60 30

wheel
false
0
Circle -7566196 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7566196 true 150 285 150 15
Line -7566196 true 15 150 285 150
Circle -7566196 true true 120 120 60
Line -7566196 true 216 40 79 269
Line -7566196 true 40 84 269 221
Line -7566196 true 40 216 269 79
Line -7566196 true 84 40 221 269

x
false
0
Polygon -7566196 true true 270 75 225 30 30 225 75 270
Polygon -7566196 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 2.1.0
@#$#@#$#@
setup
repeat 75 [ ask turtles [ go ] ]
@#$#@#$#@
@#$#@#$#@
