

globals [starting-deck
  attribute-list attribute-1 attribute-2 attribute-3 attribute-4
  cards-remaining
  card-background-color
  card-highlight-color
  sets-found
  discard-deck
  three-up-delay
  new-card
  clicked-once?
  xpos ypos
  shape-name
  clickcount
  attribute-sets
  last-card
    new-game?
    time
    counter-tick
    attempts
  attribute1-card1 attribute2-card1 attribute3-card1 attribute4-card1
  attribute1-card2 attribute2-card2 attribute3-card2 attribute4-card2
  attribute1-card3 attribute2-card3 attribute3-card3 attribute4-card3
  player-one-cards
  card-flip-delay
  simulation-speed
  ]
breeds [cards feedback players]
 cards-own [card-shape card-number card-pattern card-color ]
 players-own [user-id]

to setup
  ca
  set attempts 0
  set new-game? 1
  set player-one-cards 0
  set sets-found 0
  set attribute-sets 0
  ask patches [set pcolor white]
  set xpos -5  ;;starting position for placing the decka
  set ypos -3
  set starting-deck []; add model procedures here
  set discard-deck [];
  set clickcount 0
  set three-up-delay 1
  set clicked-once? false
  set card-background-color (white - 1)
  set card-highlight-color (white - 3)
  set time 0
  set card-flip-delay 0.05
  set counter-tick .002
  set last-card -1
  clear-match
  build-deck
end





to go
 if (new-game? = 1)
 [
 set new-game? 0
 setup-board
 ]
  detect-click-on-card
   set time (time + counter-tick)
 ;;if (cards-shown = 15 and count cards with [card-background-color] < 15) [add-new-cards]
end


to build-deck
   set attribute-1 0
   set attribute-2 0
   set attribute-3 0
   set attribute-4 0
   repeat 3 [
         repeat 3 [
               repeat 3 [

                    repeat 3 [
                      set attribute-list []
                       set attribute-list fput attribute-1 attribute-list
                       set attribute-list fput attribute-2 attribute-list
                       set attribute-list fput attribute-3 attribute-list
                       set attribute-list fput attribute-4 attribute-list
                       set starting-deck fput (sentence attribute-list) starting-deck
                       set attribute-4 (attribute-4 + 1)
                    ]
                    set attribute-4 0
                    set attribute-3 (attribute-3 + 1)
                ]
           set attribute-3 0
           set attribute-2 (attribute-2 + 1)
           ]
     set attribute-2 0
     set attribute-1 (attribute-1 + 1)
   ]
   set cards-remaining 81
end

to setup-board
  set time 0
  repeat cards-shown [
    show-card-in-deck
  ]
  create-custom-feedback 1 [set shape "face happy" set color yellow set xcor 3 set ycor 3 set hidden? true]
end



to show-card-in-deck
  set xpos (xpos + 2)
  if (xpos > 4) [set ypos (ypos + 2) set xpos -3]

  ask patch-at xpos ypos [set-display-of-card]

end

to set-display-of-card

  set new-card random-one-of starting-deck
  set starting-deck remove new-card starting-deck
  set discard-deck fput new-card discard-deck

  sprout 1 [
   ;;  set xcor xpos set ycor ypos
      set breed cards
       let c-color (item 0 new-card)
       if (c-color = 0) [set color green]   ;; read the last attributes and assign this a color for the card
       if (c-color = 1) [set color red]
       if (c-color = 2) [set color blue]
       set card-shape (item 1 new-card)
       set card-number (item 2 new-card)
       set card-pattern (item 3 new-card)
       set shape-name "square"
       wait card-flip-delay
        set shape-name (card-shape + "_" + card-number + "_" + card-pattern) ;; makes a shape name out of the numbers in the list
        set pcolor card-background-color
        set heading 0
        set shape shape-name   ;;;loads the shape name
        if labels? [set label-color black set label (shape-name + "_" + c-color)]
      ]

end



to identify-card

  if ((last-card != who) and (who != -1)) [
  set clickcount (clickcount + 1)

  if (clickcount = 1)   [
  ;;  set attribute-sets  0
    set attribute1-card1 card-shape
    set attribute2-card1 card-number
    set attribute3-card1 card-pattern
    set attribute4-card1 color
     set last-card who
   ]
  If (clickcount = 2)   [
    set attribute1-card2 card-shape
    set attribute2-card2 card-number
    set attribute3-card2 card-pattern
    set attribute4-card2 color
    set last-card who
    ]
  If (clickcount = 3)   [
    set attribute1-card3 card-shape
    set attribute2-card3 card-number
    set attribute3-card3 card-pattern
    set attribute4-card3 color
    set last-card who
  ]
  ]

end

to clear-match
    set attribute1-card3 -1
    set attribute2-card3 -1
    set attribute3-card3 -1
    set attribute4-card3 -1

end


to detect-click-on-card

 if (mouse-down? = false) [set clicked-once? false]
   if (mouse-down? and (clicked-once? = false))
   [
    set clicked-once? true
    ask cards-at mouse-xcor mouse-ycor [ set pcolor (card-highlight-color) identify-card]        ;; calls the procedure to record a global record of the card attributes]
    if ((clickcount = 3) and (attribute1-card3 != -1))
     [
      set attempts (attempts + 1)
      if ( (attribute1-card1 = attribute1-card2) and (attribute1-card2 = attribute1-card3) and (attribute1-card1 = attribute1-card3) )
        [set attribute-sets (attribute-sets + 1)  ]
      if ( (attribute1-card1 != attribute1-card2) and (attribute1-card2 != attribute1-card3) and (attribute1-card1 != attribute1-card3))
        [set attribute-sets (attribute-sets + 1)  ]

      if ( (attribute2-card1 = attribute2-card2) and (attribute2-card2 = attribute2-card3) and (attribute2-card1 = attribute2-card3))
              [set attribute-sets (attribute-sets + 1) ]
      if ( (attribute2-card1 != attribute2-card2) and (attribute2-card2 != attribute2-card3) and (attribute2-card1 != attribute2-card3))
              [set attribute-sets (attribute-sets + 1) ]

      if ( (attribute3-card1 = attribute3-card2) and (attribute3-card2 = attribute3-card3) and (attribute3-card1 = attribute3-card3))
              [set attribute-sets (attribute-sets + 1) ]

      if ( (attribute3-card1 != attribute3-card2) and (attribute3-card2 != attribute3-card3) and (attribute3-card1 != attribute3-card3))
              [set attribute-sets (attribute-sets + 1) ]

      if ( (attribute4-card1 = attribute4-card2) and (attribute4-card2 = attribute4-card3) and (attribute4-card1 = attribute4-card3))
              [set attribute-sets (attribute-sets + 1) ]

      if ((attribute4-card1 != attribute4-card2) and (attribute4-card2 != attribute4-card3) and (attribute4-card1 != attribute4-card3))
              [set attribute-sets (attribute-sets + 1) ]
            ;;  show attribute-sets
      ifelse (attribute-sets = 4)
          [ found-set ] ;;add-cards-to-my-side
          [ no-found-set]
      set clickcount 0
      set attribute-sets 0

      ifelse (cards-remaining >= 3)
        [ask patches with [pcolor = card-highlight-color] [set pcolor card-background-color]]
        [user-message "game over! you found " + sets-found + " out of + " + attempts + " tries in " + (floor time) + "time" ]

    ]
    set clicked-once? true
 ]
 end

to no-found-set
  ask feedback [set hidden? false set shape "face sad" set color (blue + 2)]
  wait three-up-delay
  ask feedback [set hidden? true]
  set last-card -1
end

to found-set
  ask feedback [set hidden? false set shape "face happy" set color yellow]
  set sets-found (sets-found + 1)
  set cards-remaining (cards-remaining - 3)
  wait three-up-delay
  ask cards with [ pcolor = card-highlight-color ] [ die ]
  repeat 3 [add-new-cards]
  ask feedback [set hidden? true]
  set last-card -1
end

to add-new-cards

  ask random-one-of patches with  [pcolor = card-highlight-color ] [set xpos pxcor set ypos pycor set-display-of-card]

end

to add-cards-to-my-side
 ;; let shift -4
  let new-color ( ( (random 14) * 10) + 3 + (random 7) )
  repeat 3 [
  ask patch-at -4 -4 [sprout 1 [set shape "card-taken" set ycor (player-one-cards - 4) set color new-color]]
 ;; set shift (shift - 0.1)
  set player-one-cards (player-one-cards + 0.1)
  ]
end


to create-feedback
 ask patch-at 0 5 [set plabel "not a set" set plabel-color black]
end




;; when a new client logs in, if there are free intersections,
;; assign one of them to that client
;; if this current-id already has an intersection, give the client that intersection.
to give-intersection-coords
  let current-id hubnet-message-source
 ;; ifelse not any? intersections with [user-id = current-id]
;;  [
      ;; the case where they tried logging in previously but there was no room for them
      ;; or they haven't logged in before
   ;;   get-free-intersection current-id
  ;;]
 ;; [
    ;; otherwise, we already have an intersection for the current-id.
    ;; all we need to do is send where the light is located at
    ask players with [user-id = current-id]
    [ hubnet-send current-id "Located At:" ("(" + 2 + "," + 3 + ")") ]
 ;; ]
end







;;1st attribute is shape 2nd number 3rd shading 4 color
@#$#@#$#@
GRAPHICS-WINDOW
378
10
883
446
5
4
45.0
1
10
1
1
1
0
1
1
1

CC-WINDOW
5
460
892
555
Command Center
0

MONITOR
210
131
287
180
Sets Found
sets-found
3
1

BUTTON
13
86
117
119
NIL
go
T
1
T
OBSERVER
T
NIL

SWITCH
126
22
229
55
labels?
labels?
1
1
-1000

MONITOR
193
346
304
395
cards selected
clickcount
0
1

BUTTON
14
23
119
56
New Game
set new-game? true\nsetup
NIL
1
T
OBSERVER
T
NIL

MONITOR
92
132
211
181
NIL
cards-remaining
0
1

MONITOR
17
132
91
181
NIL
floor time
3
1

MONITOR
287
129
359
178
NIL
attempts
0
1

TEXTBOX
88
223
291
333
Press New Game, then GO.  After the board shows the cards, click on three cards that make a SET.

CHOOSER
141
77
279
122
cards-shown
cards-shown
12 15
1

@#$#@#$#@
WHAT IS IT?
-----------
Based on the card game of SET http://www.setgame.com/set/puzzle_frame.htm


Each card has four attributes:  color, shape(s), number of shapes, and fill pattern

An attribute is considered SET, when three cards EITHER share all the same value for the attribute OR share none of the same values for the attribute.

You are trying to find three cards which have each of their four attributes SET.

An example of a set would be:
   Card 1:   green, diamond, 1, empty
   Card 2:   green, diamond, 2, hatched lines
   Card 3:   green, diamond, 3, filled

Another example of a set would be:
   Card 1:   red, circle, 3, empty
   Card 2:   red, diamond, 3, empty
   Card 3:   red, squiggle, 3, empty

An example of 3 cards that would NOT be a set would be:
   Card 1:   green, circle, 3, empty
   Card 2:   red, diamond, 3, empty
   Card 3:   red, squiggle, 3, empty

Another example of 3 cards that would NOT be a set would be:
   Card 1:   green, diamond, 2, empty
   Card 2:   green, diamond, 2, empty
   Card 3:   blue, circle, 3, filled



HOW IT WORKS
------------
Press SETUP to build the deck, and then GO to deal out 15 cards and begin selecting SETS.

After three cards are selected, you are told whether this was a set or not.  If it was, it is removed from the board, three new cards are added and your total sets found and cards remaining is updated.

HOW TO USE IT
-------------
This section could explain how to use the model, including a description of each of the items in the interface tab.


THINGS TO NOTICE
----------------
This section could give some ideas of things for the user to notice while running the model.


THINGS TO TRY
-------------
This section could give some ideas of things for the user to try to do (move sliders, switches, etc.) with the model.


EXTENDING THE MODEL
-------------------
A HubNet version of the model would capture how the game is played with a real card deck.  Player speed in finding SETS in the common board area are what drive the competitive fun of the game.


NETLOGO FEATURES
----------------
This section could point out any especially interesting or unusual features of NetLogo that the model makes use of, particularly in the Procedures tab.  It might also point out places where workarounds were needed because of missing features.


RELATED MODELS
--------------
This section could give the names of models in the NetLogo Models Library or elsewhere which are of related interest.


CREDITS AND REFERENCES
----------------------
Developed partially by a student of M. Novak's.  Waiting to see if he will post the modified file to user community web page.
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

0_0_0
true
6
Circle -13840069 false true 116 116 67

0_0_1
true
6
Circle -13840069 false true 118 118 62
Line -13840069 true 180 150 150 180
Line -13840069 true 134 176 176 134
Line -13840069 true 123 166 165 124
Line -13840069 true 150 120 120 150

0_0_2
true
6
Circle -13840069 true true 120 120 60

0_1_0
true
6
Circle -13840069 false true 56 116 67
Circle -13840069 false true 176 116 67

0_1_1
true
6
Circle -13840069 false true 58 118 62
Circle -13840069 false true 178 118 62
Line -13840069 true 90 120 60 150
Line -13840069 true 120 150 90 180
Line -13840069 true 63 166 105 124
Line -13840069 true 74 176 116 134
Line -13840069 true 240 150 210 180
Line -13840069 true 194 176 236 134
Line -13840069 true 183 166 225 124
Line -13840069 true 210 120 180 150

0_1_2
true
6
Circle -13840069 true true 180 120 60
Circle -13840069 true true 60 120 60

0_2_0
true
6
Circle -13840069 false true 13 118 62
Circle -13840069 false true 223 118 62
Circle -13840069 false true 118 118 62

0_2_1
true
6
Circle -13840069 false true 13 118 62
Circle -13840069 false true 223 118 62
Circle -13840069 false true 118 118 62
Line -13840069 true 45 120 15 150
Line -13840069 true 75 150 45 180
Line -13840069 true 18 166 60 124
Line -13840069 true 29 176 71 134
Line -13840069 true 180 150 150 180
Line -13840069 true 134 176 176 134
Line -13840069 true 123 166 165 124
Line -13840069 true 150 120 120 150
Line -13840069 true 285 150 255 180
Line -13840069 true 239 176 281 134
Line -13840069 true 228 166 270 124
Line -13840069 true 255 120 225 150

0_2_2
true
6
Circle -13840069 true true 225 120 60
Circle -13840069 true true 15 120 60
Circle -13840069 true true 120 120 60

1_0_0
true
6
Polygon -13840069 false true 120 150 150 75 180 150 150 225

1_0_1
true
6
Line -13840069 true 137 194 180 150
Polygon -13840069 false true 120 150 150 75 180 150 150 225
Line -13840069 true 166 185 144 208
Line -13840069 true 175 136 133 178
Line -13840069 true 125 164 167 122
Line -13840069 true 163 106 120 150
Line -13840069 true 134 115 156 92

1_0_2
true
6
Polygon -13840069 true true 150 75 120 150 150 225 180 150

1_1_0
true
6
Polygon -13840069 false true 60 150 90 75 120 150 90 225
Polygon -13840069 false true 180 150 210 75 240 150 210 225

1_1_1
true
6
Line -13840069 true 74 115 96 92
Line -13840069 true 103 106 60 150
Line -13840069 true 65 164 107 122
Line -13840069 true 115 136 73 178
Line -13840069 true 77 194 120 150
Line -13840069 true 106 185 84 208
Polygon -13840069 false true 60 150 90 75 120 150 90 225
Line -13840069 true 194 115 216 92
Line -13840069 true 223 106 180 150
Line -13840069 true 185 164 227 122
Line -13840069 true 235 136 193 178
Line -13840069 true 197 194 240 150
Line -13840069 true 226 185 204 208
Polygon -13840069 false true 180 150 210 75 240 150 210 225

1_1_2
true
6
Polygon -13840069 true true 90 75 60 150 90 225 120 150
Polygon -13840069 true true 210 75 180 150 210 225 240 150

1_2_0
true
6
Polygon -13840069 false true 120 150 150 75 180 150 150 225
Polygon -13840069 false true 30 150 60 75 90 150 60 225
Polygon -13840069 false true 210 150 240 75 270 150 240 225

1_2_1
true
6
Line -13840069 true 137 194 180 150
Polygon -13840069 false true 120 150 150 75 180 150 150 225
Line -13840069 true 166 185 144 208
Line -13840069 true 175 136 133 178
Line -13840069 true 125 164 167 122
Line -13840069 true 163 106 120 150
Line -13840069 true 134 115 156 92
Line -13840069 true 44 115 66 92
Line -13840069 true 73 106 30 150
Line -13840069 true 35 164 77 122
Line -13840069 true 85 136 43 178
Line -13840069 true 47 194 90 150
Line -13840069 true 76 185 54 208
Polygon -13840069 false true 30 150 60 75 90 150 60 225
Line -13840069 true 224 115 246 92
Line -13840069 true 253 106 210 150
Line -13840069 true 215 164 257 122
Line -13840069 true 265 136 223 178
Line -13840069 true 227 194 270 150
Line -13840069 true 256 185 234 208
Polygon -13840069 false true 210 150 240 75 270 150 240 225

1_2_2
true
6
Polygon -13840069 true true 60 75 30 150 60 225 90 150
Polygon -13840069 true true 150 75 120 150 150 225 180 150
Polygon -13840069 true true 240 75 210 150 240 225 270 150

2_0_0
true
6
Polygon -13840069 false true 150 75 135 75 120 90 120 120 135 150 150 195 135 210 150 225 165 225 180 210 180 180 165 150 150 105 165 90

2_0_1
true
6
Line -13840069 true 160 85 122 123
Line -13840069 true 129 138 153 114
Line -13840069 true 158 131 135 153
Polygon -13840069 false true 150 75 135 75 120 90 120 120 135 150 150 195 135 210 150 225 165 225 180 210 180 180 165 150 150 105 165 90
Line -13840069 true 148 75 119 104
Line -13840069 true 142 169 165 147
Line -13840069 true 171 162 147 186
Line -13840069 true 140 215 178 177
Line -13840069 true 152 225 181 196

2_0_2
true
6
Polygon -13840069 true true 150 75 135 75 120 90 120 120 135 150 150 195 135 210 150 225 165 225 180 210 180 180 165 150 150 105 165 90 150 75

2_1_0
true
6
Polygon -13840069 false true 195 75 180 75 165 90 165 120 180 150 195 195 180 210 195 225 210 225 225 210 225 180 210 150 195 105 210 90
Polygon -13840069 false true 105 75 90 75 75 90 75 120 90 150 105 195 90 210 105 225 120 225 135 210 135 180 120 150 105 105 120 90

2_1_1
true
6
Polygon -13840069 false true 195 75 180 75 165 90 165 120 180 150 195 195 180 210 195 225 210 225 225 210 225 180 210 150 195 105 210 90
Line -13840069 true 197 225 226 196
Line -13840069 true 185 215 223 177
Line -13840069 true 216 162 192 186
Line -13840069 true 187 169 210 147
Line -13840069 true 203 131 180 153
Line -13840069 true 174 138 198 114
Line -13840069 true 205 85 167 123
Line -13840069 true 193 75 164 104
Line -13840069 true 103 75 74 104
Line -13840069 true 115 85 77 123
Line -13840069 true 84 138 108 114
Line -13840069 true 113 131 90 153
Line -13840069 true 97 169 120 147
Line -13840069 true 126 162 102 186
Line -13840069 true 95 215 133 177
Line -13840069 true 107 225 136 196
Polygon -13840069 false true 105 75 90 75 75 90 75 120 90 150 105 195 90 210 105 225 120 225 135 210 135 180 120 150 105 105 120 90

2_1_2
true
6
Polygon -13840069 true true 195 75 180 75 165 90 165 120 180 150 195 195 180 210 195 225 210 225 225 210 225 180 210 150 195 105 210 90 195 75
Polygon -13840069 true true 105 75 90 75 75 90 75 120 90 150 105 195 90 210 105 225 120 225 135 210 135 180 120 150 105 105 120 90 105 75

2_2_0
true
6
Polygon -13840069 false true 150 75 135 75 120 90 120 120 135 150 150 195 135 210 150 225 165 225 180 210 180 180 165 150 150 105 165 90
Polygon -13840069 false true 225 75 210 75 195 90 195 120 210 150 225 195 210 210 225 225 240 225 255 210 255 180 240 150 225 105 240 90
Polygon -13840069 false true 75 75 60 75 45 90 45 120 60 150 75 195 60 210 75 225 90 225 105 210 105 180 90 150 75 105 90 90

2_2_1
true
6
Line -13840069 true 160 85 122 123
Line -13840069 true 129 138 153 114
Line -13840069 true 158 131 135 153
Polygon -13840069 false true 150 75 135 75 120 90 120 120 135 150 150 195 135 210 150 225 165 225 180 210 180 180 165 150 150 105 165 90
Line -13840069 true 148 75 119 104
Line -13840069 true 142 169 165 147
Line -13840069 true 171 162 147 186
Line -13840069 true 140 215 178 177
Line -13840069 true 152 225 181 196
Polygon -13840069 false true 225 75 210 75 195 90 195 120 210 150 225 195 210 210 225 225 240 225 255 210 255 180 240 150 225 105 240 90
Line -13840069 true 227 225 256 196
Line -13840069 true 215 215 253 177
Line -13840069 true 246 162 222 186
Line -13840069 true 217 169 240 147
Line -13840069 true 233 131 210 153
Line -13840069 true 204 138 228 114
Line -13840069 true 235 85 197 123
Line -13840069 true 223 75 194 104
Line -13840069 true 73 75 44 104
Line -13840069 true 85 85 47 123
Line -13840069 true 54 138 78 114
Line -13840069 true 83 131 60 153
Line -13840069 true 67 169 90 147
Line -13840069 true 96 162 72 186
Line -13840069 true 65 215 103 177
Line -13840069 true 77 225 106 196
Polygon -13840069 false true 75 75 60 75 45 90 45 120 60 150 75 195 60 210 75 225 90 225 105 210 105 180 90 150 75 105 90 90

2_2_2
true
6
Polygon -13840069 true true 150 75 135 75 120 90 120 120 135 150 150 195 135 210 150 225 165 225 180 210 180 180 165 150 150 105 165 90 150 75
Polygon -13840069 true true 225 75 210 75 195 90 195 120 210 150 225 195 210 210 225 225 240 225 255 210 255 180 240 150 225 105 240 90 225 75
Polygon -13840069 true true 75 75 60 75 45 90 45 120 60 150 75 195 60 210 75 225 90 225 105 210 105 180 90 150 75 105 90 90 75 75

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

card-taken
false
0
Rectangle -16777216 true false 30 30 293 292
Rectangle -7500403 true true 15 15 285 285

circle
false
0
Circle -7500403 true true 30 30 240

circle 2
false
0
Circle -7500403 true true 16 16 270
Circle -16777216 true false 46 46 210

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

square
false
0
Rectangle -7500403 true true 0 0 300 300
Rectangle -16777216 true false 30 45 75 60
Rectangle -16777216 true false 30 45 45 90
Rectangle -16777216 true false 30 75 75 90
Rectangle -16777216 true false 60 75 75 120
Rectangle -16777216 true false 30 105 75 120
Rectangle -16777216 true false 120 180 165 195
Rectangle -16777216 true false 120 150 165 165
Rectangle -16777216 true false 120 120 165 135
Rectangle -16777216 true false 120 120 135 195
Rectangle -16777216 true false 210 195 255 210
Rectangle -16777216 true false 225 195 240 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 60 270 150 0 240 270 15 105 285 105
Polygon -7500403 true true 75 120 105 210 195 210 225 120 150 75

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 3.0beta2
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@

