__extensions [ "sound.jar" ]

globals
[ selected
  dragged
  ticks
  K
  ;; for sound
  pitches
]

breeds
[ levers
]

levers-own
[ free1?
  free2?
  stretch
  cx cy
  x1 x2 y1 y2
  hook1
  hook2
  xv yv av
  fixed?
  spin?
  armlen

      from-h1 to-h2
      h1x2 h1y2
      h2x1 h2y1
      h1cx h1cy
      h2cx h2cy
      ideal-dist
      ideal-angl
      ratio1
      ratio2
  ;; for sound
  pitch
  instrument
]

to setup
    stop-music
    ca
    clear-output
    set k 1
    set-default-shape levers "lever"
    set ticks 0
    ; set population screen-edge-x * .5
    create-levers population
    ask levers
    [ set spin? false
      set armlen .5
      set size scale
      set cx screen-size-x - scale * armlen
      set cy ( (who / population) * screen-size-y - screen-edge-y ) * -.8
      set fixed? false
      setxy cx cy
      set cx xcor
      set cy ycor
      ifelse who = 0
      [ set free1? false
        set hook1 self
        set label "1"
        set fixed? true
      ]
      [ set free1? true
        set hook1 turtle ( who - 1 )
      ]
      ifelse who = population - 1
      [ set free2? false
        set hook2 self
        set label "2"
        set fixed? false
      ]
      [ set free2? true
        set hook2 turtle ( who + 1 )
      ]
      set stretch 1.0
      set heading random 360
      set x1 xcor - dx * scale * armlen
      set y1 ycor - dy * scale * armlen
      set x2 xcor + dx * scale * armlen
      set y2 ycor + dy * scale * armlen
    ]
    set selected turtle 0
    setup-music
end

to-report mean-heading [ a b ]
      report atan (( sin a + sin b) * .5)
                  (( cos a + cos b) * .5)
end

to-report mean-heading-w [ a b c w]
     locals [ w/2 ]
      set w/2 (1 - w) * .5
      report atan ( w/2 * sin a + w/2 * sin b + w * sin c )
                  ( w/2 * cos a + w/2 * cos b + w * cos c )
end

to-report xangle-diff-sin [ a b ]
    locals [ diff ]
    set diff sin a - cos b
    ifelse diff < -180
    [ set diff diff + 360 ]
    [ if diff > 180 [ set diff diff - 360 ]
    ]

    report sin (diff) - cos (diff)
end

to go
  set ticks ticks + 1
  ask levers
  [ if mouse-on?
    [ monitor-mouse ]
    lever-display
  ]
  ask levers
  [ calc-arm-coords
    calc-hook-coords
  ]
  ask levers
  [ lever! ]
  ;ask random-one-of levers [ without-interruption
  ;[ lever!2 ] ]
  chorus
end

to-report sign [ a ]
    ifelse a = 0
    [ report 0 ]
    [  report a / abs a ]
end

to monitor-mouse
    locals [ mouse-here? ]
    set mouse-here? abs (mouse-xcor - xcor)  < scale / 2 and abs ( mouse-ycor - ycor) < scale / 2
    ifelse mouse-here?
    [ if color != white [ set color white ] ]
    [ if color = white [ set color (5 + (10 * (who mod 14 ))) ] ]
    ifelse mouse-down?
    [ if dragged = nobody and mouse-here?
      [ set dragged self
        set selected self
      ]
    ]
    [ set dragged nobody ]
end

to lever-display
    locals [ shape-name ]
    if size != armlen * 2 * scale
    [ set size scale * 2 * armlen ]
    set shape-name "lever"
    if fixed?
    [ set shape-name word shape-name "-f" ]
    if spin?
    [ set shape-name word shape-name "-r" ]
    ifelse selected = self
    [ set shape-name word shape-name "-s"
      if label != (word who "-" armlen "    " ) [ set label (word who "-" armlen "    ") ]
    ]
    [ if label != no-label
    [ set label no-label ]
    ]
    if shape != shape-name
    [ set shape shape-name ]
end

to calc-arm-coords
    set x1 cx - dx * scale * armlen
    set y1 cy - dy * scale * armlen
    set x2 cx + dx * scale * armlen
    set y2 cy + dy * scale * armlen
end

to calc-hook-coords
    ifelse hook1 = self
    [ set h1x2 x1
      set h1y2 y1
      set h1cx cx - dx * scale * armlen
      set h1cy cy - dy * scale * armlen
    ]
    [ set h1x2 x2-of hook1
      set h1y2 y2-of hook1
      set h1cx cx-of hook1
      set h1cy cy-of hook1
    ]
    ifelse hook2 = self
    [ set h2x1 x2
      set h2y1 y2
      set h2cx cx + scale * dx * armlen
      set h2cy cy + scale * dy * armlen
    ]
    [ set h2x1 x1-of hook2
      set h2y1 y1-of hook2
      set h2cx cx-of hook2
      set h2cy cy-of hook2
    ]
    set ratio1 armlen / armlen-of hook1
    set ratio2 armlen / armlen-of hook2
end

to lever!
    locals
    [ ]
    ifelse dragged = self
    [ set cx mouse-xcor
      set cy mouse-ycor
    ]
    [
      if not fixed?
      [ set xv ( xv * f ) + ( ( h1x2 - x1 ) + ( h2x1 - x2 ) ) * .5 * k
        set yv ( yv * f ) + ( ( h1y2 - y1 ) + ( h2y1 - y2 ) ) * .5 * k - g * armlen

        set cx cx + xv
        set cy cy + yv

        if abs cx > screen-edge-x [ set xv xv * -.9 set cx screen-edge-x * sign cx + xv
        drum 1 (1.5 * (ycor + screen-edge-y + 30))


        ]
        if abs cy > screen-edge-y [ set yv yv * -.9 set cy screen-edge-y * sign cy + yv

        drum 2 (1.5 * (xcor + screen-edge-x + 30))
        ]
      ]
    ]
    ifelse stiff?
    [ new-heading-2 ]
    [ new-heading-1 ]

    if spin? = true [ set heading heading + spin-speed ]
    setxy cx cy
end

to new-heading-1
    ; calculate new heading of lever
    ; if node2 of hook1 is overlapping center, keep same heading
    ; other wise, find heading to node2 of hook1
    ifelse ( distancexy-nowrap h1x2 h1y2 = 0 )
    [ set from-h1 180 + heading ]
    [ set from-h1 180 + towardsxy-nowrap h1x2 h1y2 ]
    ; likewise node1 of hook2
    ifelse ( distancexy-nowrap h2x1 h2y1 = 0 )
    [ set to-h2 heading ]
    [ set to-h2 towardsxy-nowrap h2x1 h2y1 ]
    ; calc heading
    ;;; using "angular velocity"
    ;;set av av * f + k2 * (subtract-headings ( mean-heading from-h1 to-h2 ) heading )
    ;;set heading heading + av + dt
    set heading mean-heading from-h1 to-h2
end

to new-heading-2
    ; calculate new heading of lever
    ; if center of hook1 is overlapping center, keep same heading
    ; other wise, find heading to center of hook1
    ifelse ( distancexy-nowrap h1cx h1cy = 0 )
    [ set from-h1 180 + heading ]
    [ set from-h1 180 + towardsxy-nowrap h1cx h1cy ]
    ; likewise node1 of hook2
    ifelse ( distancexy-nowrap h2cx h2cy = 0 )
    [ set to-h2 heading ]
    [ set to-h2 towardsxy-nowrap h2cx h2cy ]
    ; calc heading
    set heading mean-heading from-h1 to-h2
end

to lever!2
    ; randomly snaps lever to one or the other hook
    ; an attempt to make the hooks NOT stretch.
    locals [ which-hook? a b c real-dist real-angl ]
    calc-hook-coords
    ifelse hook1 = self
    [ set which-hook? 2 ]
    [ ifelse hook2 = self
      [ set which-hook? 1 ]
      [ set which-hook? 1 + random 2 ]
    ]
    ifelse which-hook? = 1
    [ set a h1x2
      set b h1y2
      set c 180
    ]
    [ set a h2x1
      set b h2y1
      set c 0

    ]
    set real-angl heading
    set real-dist distancexy a b
    if real-dist > 0
    [ set ideal-angl c + towardsxy a b
      set heading ideal-angl
    ]
    if fixed? = false
    [
    set ideal-dist armlen * scale
    if real-dist != ideal-dist
    [ jump abs ( real-dist - ideal-dist )
    ]
    ; set av av + subtract-headings real-angl ideal-angl
    set cx xcor
    set cy ycor
    ]
    calc-arm-coords


end

to crazy-machine
  without-interruption
  [ ask levers
  [ set cx random-float 1 * screen-edge-x * (random 2 * 2 - 1 ) * .8
    set cy random-float 1 * screen-edge-y * .8
    set xv 0
    set yv 0
    setxy cx cy
    set fixed? ( who mod 2 = 0 and random 5 = 0 )
    ifelse fixed? [ set spin? (random 3 = 0) ]
    [ set spin? ( random 8 = 0) ]
    set armlen precision ( .5 + .5 * random-float 2 ) 2
  ]
  ]
end


to reset
  ask turtles
  [ set fixed? false
    set armlen .5
    set spin? false
  ]
  ask turtle 0
  [ set fixed? true
    set cx 0
    set cy (screen-edge-y * .9 )
    setxy cx cy
  ]
end

;;; sound procedures

to setup-music
  locals [cdega offset]
  set pitches []
  set offset 0
  set cdega [0 2 4 7 9]
  while [length pitches < 50]
   [ set pitches sentence pitches map [? + offset] cdega
     set offset offset + 12 ]
  ask levers
    [ set instrument item (who * 3 / count levers)
                       ["ocarina" "drawbar organ" "clavi"] ]
end

to-report nearby [p]
  report first filter [? >= p] pitches
end

to chorus
  every 0.05
    [ ask levers
        [ sing ] ]
end

to sing  ;; lever procedure
  ifelse fixed?
    [ stop-note instrument pitch ]
    [ let new-pitch nearby (xcor + screen-edge-x + 30)
      if pitch != new-pitch
        [ stop-note instrument pitch
          set pitch new-pitch
          start-note instrument pitch size * 50 ] ]
end

to drum [num p]
  ;; note: num is ignored for now
  play-drum item (p mod length drums) drums (100 + random 20)
end
@#$#@#$#@
GRAPHICS-WINDOW
211
10
578
398
25
25
7.0
1
10
1
1
1
0

CC-WINDOW
5
530
588
625
Command Center

BUTTON
10
10
65
43
NIL
setup
NIL
1
T
OBSERVER
T
NIL

SLIDER
10
48
182
81
f
f
0.9
0.9999
0.9872
1.0E-4
1
NIL

BUTTON
69
10
124
43
NIL
go
T
1
T
OBSERVER
T
NIL

SWITCH
105
189
206
222
mouse-on?
mouse-on?
0
1
-1000

SLIDER
10
83
182
116
population
population
3
100
7
1
1
NIL

SLIDER
11
153
183
186
scale
scale
0.5
15
5.0
0.5
1
NIL

SLIDER
10
117
182
150
g
g
0
0.095
0.0381
1.0E-4
1
NIL

BUTTON
13
252
68
285
fix/free
ask selected [ set fixed? not fixed? ]
NIL
1
T
OBSERVER
T
NIL

BUTTON
14
288
69
321
arm +++
ask selected [ set armlen precision ( armlen + .1 ) 3 ]
NIL
1
T
OBSERVER
T
NIL

BUTTON
72
288
127
321
arm ---
ask selected [ if armlen > .1 [ set armlen precision ( armlen - .1 ) 3 ] ]
NIL
1
T
OBSERVER
T
NIL

BUTTON
56
376
111
409
reset-all
reset
NIL
1
T
OBSERVER
T
NIL

BUTTON
130
288
185
321
arm reset
ask selected [ set armlen .5 ]
NIL
1
T
OBSERVER
T
NIL

BUTTON
131
252
186
285
next
set selected turtle ( ( (who-of selected) + 1 ) mod population )
NIL
1
T
OBSERVER
T
NIL

SLIDER
11
331
131
364
spin-speed
spin-speed
-100
100
3.09
0.01
1
NIL

BUTTON
72
252
127
285
spin?
ask selected [ set spin? not spin? ]
NIL
1
T
OBSERVER
T
NIL

MONITOR
5
467
62
516
NIL
ticks
0
1

BUTTON
10
420
182
453
build-crazy-machine
crazy-machine
NIL
1
T
OBSERVER
T
NIL

SWITCH
11
189
101
222
stiff?
stiff?
1
1
-1000

BUTTON
133
331
188
364
spd=0
set spin-speed 0
NIL
1
T
OBSERVER
T
NIL

TEXTBOX
13
234
149
252
Selected Lever Properties

BUTTON
242
400
579
452
STOP!!!
stop-music
NIL
1
T
OBSERVER
T
NIL

@#$#@#$#@
This is derived from James Steiner's "Machines" model that he posted to netlogo-users on or around March 26, 2004.  It uses Andrei's sound extension.

@#$#@#$#@
default
true
0
Polygon -7566196 true true 150 5 40 250 150 205 260 250

ball
true
10
Circle -16776961 true true 15 15 270

lever
true
10
Circle -16776961 true true 120 -30 60
Circle -16776961 true true 121 270 58
Line -16776961 true 150 30 150 269
Polygon -16776961 true true 150 90 195 105 149 30 105 105

lever-f
true
10
Circle -16776961 true true 120 -30 60
Circle -16776961 true true 121 270 58
Line -16776961 true 150 30 150 269
Polygon -16776961 true true 150 90 195 105 149 30 105 105
Rectangle -16776961 true true 135 135 166 166

lever-f-r
true
10
Circle -16776961 true true 120 -30 60
Circle -16776961 true true 121 270 58
Line -16776961 true 150 30 150 269
Polygon -16776961 true true 150 90 195 105 149 30 105 105
Line -16776961 true 61 30 240 30
Line -16776961 true 240 30 195 44
Line -16776961 true 238 29 193 15
Line -16776961 true 239 269 61 270
Line -16776961 true 61 270 106 255
Line -16776961 true 104 285 61 271
Rectangle -16776961 true true 135 135 165 165

lever-f-r-s
true
10
Circle -16776961 true true 120 -30 60
Circle -16776961 true true 121 270 58
Line -16776961 true 150 30 150 269
Polygon -16776961 true true 150 90 195 105 149 30 105 105
Line -16776961 true 61 30 240 30
Line -16776961 true 240 30 195 44
Line -16776961 true 238 29 193 15
Line -16776961 true 239 269 61 270
Line -16776961 true 61 270 106 255
Line -16776961 true 104 285 61 271
Rectangle -16776961 true true 135 135 165 165
Circle -16776961 false true 29 30 240

lever-f-s
true
10
Circle -16776961 true true 120 -30 60
Circle -16776961 true true 121 270 58
Line -16776961 true 150 30 150 269
Polygon -16776961 true true 150 90 195 105 149 30 105 105
Circle -16776961 false true 30 30 240
Rectangle -16776961 true true 135 135 165 165

lever-r
true
10
Circle -16776961 true true 120 -30 60
Circle -16776961 true true 121 270 58
Line -16776961 true 150 30 150 269
Polygon -16776961 true true 150 90 195 105 149 30 105 105
Line -16776961 true 61 30 240 30
Line -16776961 true 240 30 195 44
Line -16776961 true 238 29 193 15
Line -16776961 true 239 269 61 270
Line -16776961 true 61 270 106 255
Line -16776961 true 104 285 61 271

lever-r-s
true
10
Circle -16776961 true true 120 -30 60
Circle -16776961 true true 121 270 58
Line -16776961 true 150 30 150 269
Polygon -16776961 true true 150 90 195 105 149 30 105 105
Line -16776961 true 61 30 240 30
Line -16776961 true 240 30 195 44
Line -16776961 true 238 29 193 15
Line -16776961 true 239 269 61 270
Line -16776961 true 61 270 106 255
Line -16776961 true 104 285 61 271
Circle -16776961 false true 29 29 242

lever-s
true
10
Circle -16776961 true true 120 -30 60
Circle -16776961 true true 121 270 58
Line -16776961 true 150 30 150 269
Polygon -16776961 true true 150 90 195 105 149 30 105 105
Circle -16776961 false true 30 30 240

@#$#@#$#@
NetLogo 2.2pre2
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
