globals [
  widow-vertical-distance widow-horizontal-distance
  xcor-nw ycor-nw xcor-se ycor-se
  mouse-sequence
  width height
  color-stationary
  color-selected
  color-dragging
  ]

breeds [ edge-north edge-west edge-east edge-south objects]

objects-own [selected? xcor-relative ycor-relative]

to setup
  ca
  set color-stationary (blue)
  set color-selected (red)
  set color-dragging  (blue + 2)
  create-custom-objects number [set color color-stationary set selected? false]
  setup-positions
  setup-plots
  set mouse-sequence "ready"
end


to go
  if mouse-inside? [
    make-window
    hide-window
    select-anchor
    drag-turtles
    release-anchor
    do-plots
    ;;show mouse-sequence
  ]
end



to setup-positions
   ask objects [setxy (random (2 * screen-edge-x)) (random (2 * screen-edge-y)) ]
end


to make-window

  if ((mouse-down?) and (not any? edge-north) and (mouse-sequence = "ready")) [
     set xcor-nw mouse-xcor
     set ycor-nw mouse-ycor
     create-custom-edge-east 1 [set shape "edge-vertical" setxy xcor-nw ycor-nw]
     create-custom-edge-west 1  [set shape "edge-vertical"  setxy xcor-nw ycor-nw]
     create-custom-edge-north 1 [set shape "edge-horizontal"  setxy xcor-nw ycor-nw]
     create-custom-edge-south 1 [set shape "edge-horizontal" setxy xcor-nw ycor-nw]
  ]

  if ((mouse-down?) and (any? edge-north) ) [
     set xcor-se mouse-xcor
     set ycor-se mouse-ycor
     set widow-horizontal-distance ((2.0 * (xcor-se - xcor-nw)))
     set widow-vertical-distance ((2.0 * (ycor-se - ycor-nw)))
     ifelse widow-horizontal-distance < 0 [ask edge-north [set heading -180] ask edge-south [set heading -180]]
       [ask edge-north [set heading 0] ask edge-south [set heading 0]]
     ifelse widow-vertical-distance > 0 [ask edge-east [set heading -180] ask edge-west [set heading -180]]
       [ask edge-east [set heading 0] ask edge-west [set heading 0]]

     set width (abs widow-horizontal-distance)
     set height (abs widow-vertical-distance)
     ask edge-north [set size width]
     ask edge-south [set size width set ycor ycor-se]
     ask edge-east [set size height set xcor xcor-se]
     ask edge-west [set size height]
     set mouse-sequence "size"
      ]
end


to hide-window
  if ((not mouse-down?) and (mouse-sequence = "size")) [

    if  (widow-horizontal-distance > 0 and widow-vertical-distance < 0)
      [ask objects with [xcor < xcor-se and ycor > ycor-se and xcor > xcor-nw and ycor < ycor-nw]  [set color color-selected set selected? true] ]
    if (widow-horizontal-distance < 0 and widow-vertical-distance < 0)
      [ask objects with [xcor > xcor-se and ycor > ycor-se and xcor < xcor-nw and ycor < ycor-nw] [set color color-selected set selected? true]]

    if  (widow-horizontal-distance > 0 and widow-vertical-distance > 0)
      [ask objects with [xcor < xcor-se and ycor < ycor-se and xcor > xcor-nw and ycor > ycor-nw] [set color color-selected set selected? true]]
    if (widow-horizontal-distance < 0 and widow-vertical-distance > 0)
      [ask objects with [xcor > xcor-se and ycor < ycor-se and xcor < xcor-nw and ycor > ycor-nw] [set color color-selected set selected? true]]

     ask edge-north [die]
     ask edge-south [die]
     ask edge-east [die]
     ask edge-west [die]

    ifelse drag?
       [set mouse-sequence "hidden"]
       [set mouse-sequence "ready"]
  ]
end


to select-anchor
;;show mouse-sequence
   if mouse-down? and (mouse-sequence = "hidden")
   [
     ifelse (any? objects-at mouse-xcor mouse-ycor)
     [
         ask objects with [ selected?]
         [
           set color color-selected
           set xcor-relative (xcor - mouse-xcor)
           set ycor-relative (ycor - mouse-ycor)
         ]
          set mouse-sequence "selected"
     ]
     [clear-mouse-sequence]
   ]


end


to drag-turtles
   if mouse-down? and (mouse-sequence = "selected") [
      ask objects with [selected?] [setxy (xcor-relative + mouse-xcor) (ycor-relative + mouse-ycor) set color color-dragging]
   ]
   if (not mouse-down?) and (mouse-sequence = "selected") [
      set mouse-sequence "dragging"
   ]
  ;;set mouse-sequence "dragging"
end


to release-anchor
   if (not mouse-down?) and (mouse-sequence = "dragging") [
   ask objects [set selected? false set color color-stationary]
     set mouse-sequence "ready"
  ]

end


to deselect-all
  ask objects  [set selected? false set color color-stationary]
  do-plots
end


to do-plots
  set-current-plot "histogram of xcor"
  if plot-all? [
    set-current-plot-pen "all"
    set-plot-pen-interval 1
    set-plot-pen-color color-stationary
    set-histogram-num-bars ((2 * screen-edge-x) + 1)
    histogram-from (objects) [xcor]
  ]
  set-current-plot-pen "selected"
  set-plot-pen-interval 1
  set-plot-pen-color color-selected
  set-histogram-num-bars ((2 * screen-edge-x) + 1)
  histogram-from (objects with [selected?]) [xcor]
end


to setup-plots
  set-current-plot "histogram of xcor"
  set-plot-pen-interval 1
  set-plot-x-range (-1 * screen-edge-x) (screen-edge-x)
end



to clear-mouse-sequence

   ask objects [set selected? false set color color-stationary]
     set mouse-sequence "ready"
end
@#$#@#$#@
GRAPHICS-WINDOW
293
10
723
461
17
17
12.0
1
10
1
1
1
0
1
1
1

CC-WINDOW
5
475
732
570
Command Center
0

BUTTON
126
12
189
45
NIL
go
T
1
T
OBSERVER
T
NIL

BUTTON
60
13
123
46
NIL
setup
NIL
1
T
OBSERVER
T
NIL

PLOT
11
89
284
270
histogram of xcor
xcor
number
-10.0
10.0
0.0
10.0
true
false
PENS
"default" 1.0 1 -16777216 true
"all" 1.0 1 -13345367 true
"selected" 1.0 1 -2674135 true

SWITCH
193
12
290
45
drag?
drag?
0
1
-1000

SLIDER
60
50
190
83
number
number
0
500
200
1
1
NIL

BUTTON
195
51
289
84
deselect all
deselect-all
NIL
1
T
OBSERVER
T
NIL

SWITCH
119
314
222
347
plot-all?
plot-all?
0
1
-1000

@#$#@#$#@
WHAT IS IT?
-----------
A statistical model that uses a draggable selection window in the graphics window to select samples from a population

The model demos a useful new way to interact with agents on in
the graphics window.  It emulates the drag and select features in other
programs.  This drag and select feature in other NetLogo models
would be extermely useful to sample and perform an action on a portion of
the agents in the world, especially within a local terrority or region of
the screen.

This example just shows one interesting way that selecting some of the
screen and comparing the histogram that is made to the the histogram of
the xcoordinates of all the turtles can give you insight into how
histograms are built.


HOW IT WORKS
------------
Objects are randomly distributed in the graphics window.  The x-coordinates of the objects in the graphics window are plotted in the "histogram of xcor".  When the user presses GO, objects can be selected in the graphics window by clicking and dragging (holding down the mouse button and moving the mouse) a "selection window".  This selection window looks similar to clicking and dragging effects in many computer programs.


HOW TO USE IT
-------------
NUMBER determines the number of objects distributed around the graphics window on SETUP

DRAG? when turned on will allow the user to drag the objects that are selected by clicking and dragging (holding down the mouse button and moving the mouse) to a new location.  When turned off, the user can keep repeating the selection window.  To deselect multiple areas of selected objects, use the DESELECT ALL button.

PLOT-ALL? when turned on will plot a histogram of the x-coordinates of the complete set of objects on the same graph as the selected set of objects.  When turned off, only the x-coordinates of the selected set of objects are graphed.


THINGS TO NOTICE
----------------
With DRAG? turned off, you can select multiple sections of objects to sample any territory in the graphics window.

With DRAG? turned on, you can select and then move objects to new locations in the graphics window.


THINGS TO TRY
-------------
Select a thin horizontal window of objects that runs the width of the graphics window.  Notice the shape of the histogram.

Select a thin vertical window of objects that runs the height of the graphics window.  Notice the shape of the histogram.



EXTENDING THE MODEL
-------------------
Any attribute could be sampled in a model using this model as an example.  Number of "heads up" coins, animals in a forest that have been sampled before, number of particles above a certain energy threshold, etc...

Hide the turtles at first and ask students to make predictions about the

Selective sampling serves as a useful bridge in understanding many phenomena in statistics.


NETLOGO FEATURES
----------------
This section could point out any especially interesting or unusual features of NetLogo that the model makes use of, particularly in the Procedures tab.  It might also point out places where workarounds were needed because of missing features.


RELATED MODELS
--------------
This section could give the names of models in the NetLogo Models Library or elsewhere which are of related interest.


CREDITS AND REFERENCES
----------------------
This section could contain a reference to the model's URL on the web if it has one, as well as any other necessary credits or references.
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

edge-horizontal
true
0
Line -7500403 true 150 150 300 150

edge-vertical
true
0
Line -7500403 true 150 150 150 300

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line-half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 3.0beta2
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@

