; add model procedures here

globals
[
  ;; quick start instructions variables
  quick-start  ;; current quickstart instruction displayed in the quickstart monitor
  qs-item      ;; index of the current quickstart instruction
  qs-items1     ;; list of quickstart instructions
  qs-items2     ;; list of quickstart instructions
  text
  questnum     ;; the field number of the question
  questlist    ;; the list of questions
  quest-item   ;; the item number in the list of questions (not the field number)
]




to setup
  ca
  set qs-item 0
  set quest-item 0
  set questnum quest_start_field

  set questlist
  [
    "  A. demonstrate introductory knowledge, skills, and understanding of concepts related to technology (as described in the ISTE National Education Technology Standards for Students)."
    "  B. demonstrate continual growth in technology knowledge and skills to stay abreast of current and emerging technologies."
    "  A. design developmentally appropriate learning opportunities that apply technology-enhanced instructional strategies to support the diverse needs of learners."
    "  B. apply current research on teaching and learning with technology when planning learning environments and experiences."
    "  C. identify and locate technology resources and evaluate them for accuracy and suitability."
    "  D. plan for the management of technology resources within the context of learning activities."
    "  E. plan strategies to manage student learning in a technology-enhanced environment."
    "  A. facilitate technology-enhanced experiences that address content standards and student technology standards."
    "  B. use technology to support learner-centered strategies that address the diverse needs of students."
    "  C. apply technology to develop students' higher order skills and creativity."
    "  D. manage student learning activities in a technology-enhanced environment."
    "  A. apply technology in assessing student learning of subject matter using a variety of assessment techniques."
    "  B. use technology resources to collect and analyze data, interpret results, and communicate findings to improve instructional practice and maximize student learning."
    "  C. apply multiple methods of evaluation to determine students' appropriate use of technology resources for learning,communication,and productivity."
    "  A. use technology resources to engage in ongoing professional development and lifelong learning."
    "  B. continually evaluate and reflect on professional practice to make informed decisions regarding the use of technology in support of student learning."
    "  C. apply technology to increase productivity."
    "  D. use technology to communicate and collaborate with peers, parents, and the larger community in order to nurture student learning."
    "  A. model and teach legal and ethical practice related to technology use."
    "  B. apply technology resources to enable and empower learners with diverse backgrounds, characteristics, and abilities."
    "  C. identify and use technology resources that affirm diversity"
    "  D. promote safe and healthy use of technology resources."
    "  E. facilitate equitable access to technology resources for all students."
    "  1. demonstrate a sound understanding of the nature an operation of technology systems. (I)*"
    "  2. demonstrate proficiency in the use of common input and output devices; solve routine hardware and software problems; and make informed choices about technology systems, resources, and services. (I)* "
    "  3. use technology tools and information resources to increase productivity, promote creativity, and facilitate academic learning. (I, III, IV, V)"
    "  4. use content-specific tools (e.g., software, simulation, environmental robes, graphing calculators, exploratory environments, Web tools) to support learning and research. (I, III, V)* "
    "  5. use technology resources to facilitate higher order and complex thinking skills, including problem solving, critical thinking, informed decision making, knowledge construction, and creativity. (I, III, V)*"
    "  6. collaborate in constructing technology-enhanced models, preparing publications, and producing other creative works using productivity tools. (I, V)* "
    "  7. use technology to locate, evaluate, and collect information from a variety of sources. (I, IV, V)* "
    "  8. use technology tools to process data and report results. (I, III, IV, V)* "
    "  9. use technology in the development of strategies for solving problems in the real world. (I, III, V)* "
    " 10. observe and experience the use of technology in their major field of study. (III, V) "
    " 11. use technology tools and resources for managing and communicating information (e.g., finances, schedules, addresses, purchases, correspondence). (I, V)"
    " 12. evaluate and select new information resources and technological innovations based on their appropriateness to specific tasks. (I, III, IV, V)* "
    " 13. use a variety of media and formats, including telecommunications, to collaborate, publish, and interact with peers, experts, and other audiences. (I, V)* "
    " 14. demonstrate an understanding of the legal, ethical, cultural, and societal issues related to technology. (VI)* "
    " 15. exhibit positive attitudes toward technology uses that support lifelong learning, collaboration, personal pursuits, and productivity. (V, VI)*"
    " 16. discuss diversity issues related to electronic media. (I, VI)"
    " 17. discuss the health and safety issues related to technology use. (VI)"
    "  1. identify the benefits of technology to maximize student learning and facilitate higher order thinking skills. (I, II) "
    "  2. differentiate between appropriate and inappropriate uses of technology for teaching and learning while using electronic resources to design and implement learning activities. (II, III, V, VI) "
    "  3. identify technology resources available in schools and analyze how accessibility to those resources affects planning for instruction. (I, II) "
    "  4. identify, select, and use hardware and software technology resources specially designed for use by PK-12 students to meet specific teaching and learning objectives. (I, II) "
    "  5. plan for the management of electronic instructional resources within a lesson design by identifying potential problems and planning for solutions. (II) "
    "  6. identify specific technology applications and resources that maximize student learning, address learner needs, and affirm diversity. (III, VI)  "
    "  7. design and teach technology-enriched learning activities that connect content standards with student technology standards and meet the diverse needs of students. (II, III, IV, VI) "
    "  8. design and peer teach a lesson that meets content area standards and reflects the current best practices in teaching and learning with technology. (II, III) "
    "  9. plan and teach student-centered learning activities and lessons in which students apply technology tools and resources. (II, III) "
    " 10. research and evaluate the accuracy, relevance, appropriateness, comprehensiveness, and bias of electronic information resources to be used by students. (II, IV, V, VI) "
    " 11. discuss technology-based assessment and evaluation strategies. (IV) "
    " 12. examine multiple strategies for evaluating technology-based student products and the processes used to create those products. (IV) "
    " 13. examine technology tools used to collect, analyze, interpret, represent, and communicate student performance data.(I, IV) "
    " 14. integrate technology-based assessment strategies and tools into plans for evaluating specific learning activities. (IV) "
    " 15. develop a portfolio of technology-based products from coursework, including the related assessment tools. (IV, V) "
    " 16. identify and engage in technology-based opportunities for professional education and lifelong learning, including the use of distance education. (V) "
    " 17. apply online and other technology resources to support problem solving and related decision making for maximizing student learning. (III, V) "
    " 18. participate in online professional collaborations with peers and experts. (III, V) "
    " 19. use technology productivity tools to complete required professional tasks. (V) "
    " 20. identify technology-related legal and ethical issues, including copyright, privacy, and security of technology systems, data, and information. (VI) "
    " 21. examine acceptable use policies for the use of technology in schools, including strategies for addressing threats to security of technology systems, data, and information. (VI) "
    " 22. identify issues related to equitable access to technology in school, community, and home environments. (VI) "
    " 23. identify safety and health issues related to technology use in schools. (VI) "
    " 24. identify and use assistive technologies to meet the special physical needs of students. (VI) "  ]

  set qs-items1
  [
    "  <P><INPUT TYPE=radio NAME=Field"
    "  <INPUT TYPE=radio NAME=Field"
    "  <INPUT TYPE=radio NAME=Field"
    "  <INPUT TYPE=radio NAME=Field"
    "  <INPUT TYPE=radio NAME=Field"  ]

  set qs-items2
  [
    " VALUE=1>1-Strongly Disagree"
    " VALUE=2>2-Disagree"
    " VALUE=3>3-Neutral"
    " VALUE=4>4-Agree"
    " VALUE=5>5-Strongly Agree</P>"  ]
end

to go
  repeat (length questlist)
  [
  set text " <P>" + item quest-item questlist
  set text text + " </P>"
  print text
  repeat length qs-items1
    [set text item qs-item qs-items1
     set text text + questnum
     set text text + (item qs-item qs-items2)
     print text
     set qs-item qs-item + 1
    ]
  print "<P></P>"
  set qs-item 0
  set questnum questnum + 1
  set quest-item quest-item + 1
  ]


end



@#$#@#$#@
GRAPHICS-WINDOW
208
10
393
216
17
17
5.0
1
10
1
1
1
0

CC-WINDOW
2
726
981
822
Command Center

SLIDER
15
10
160
43
quest_start_field
quest_start_field
1
100
50
1
1
NIL

BUTTON
105
51
186
84
go
go
NIL
1
T
OBSERVER
T

BUTTON
15
51
96
84
setup
setup
NIL
1
T
OBSERVER
T

@#$#@#$#@
add model documentation here

Created by Walter M. Stroup
@#$#@#$#@
default
true
0
Polygon -7566196 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7566196 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7566196 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7566196 true true 150 285 285 225 285 75 150 135
Polygon -7566196 true true 150 135 15 75 150 15 285 75
Polygon -7566196 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7566196 true true 96 182 108
Circle -7566196 true true 110 127 80
Circle -7566196 true true 110 75 80
Line -7566196 true 150 100 80 30
Line -7566196 true 150 100 220 30

butterfly
true
0
Polygon -7566196 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7566196 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7566196 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7566196 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7566196 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7566196 true true 47 195 58
Circle -7566196 true true 195 195 58

circle
false
0
Circle -7566196 true true 0 0 300

circle 2
false
0
Circle -7566196 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7566196 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7566196 true true 73 210 86 251 62 249 48 208
Polygon -7566196 true true 25 114 16 195 9 204 23 213 25 200 39 123

face happy
false
0
Circle -7566196 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7566196 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7566196 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7566196 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7566196 true true 60 15 75 300
Polygon -7566196 true true 90 150 270 90 90 30
Line -7566196 true 75 135 90 135
Line -7566196 true 75 45 90 45

flower
false
0
Polygon -11352576 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7566196 true true 85 132 38
Circle -7566196 true true 130 147 38
Circle -7566196 true true 192 85 38
Circle -7566196 true true 85 40 38
Circle -7566196 true true 177 40 38
Circle -7566196 true true 177 132 38
Circle -7566196 true true 70 85 38
Circle -7566196 true true 130 25 38
Circle -7566196 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -11352576 true false 189 233 219 188 249 173 279 188 234 218
Polygon -11352576 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7566196 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7566196 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7566196 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7566196 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7566196 true 150 0 150 300

pentagon
false
0
Polygon -7566196 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7566196 true true 110 5 80
Polygon -7566196 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7566196 true true 127 79 172 94
Polygon -7566196 true true 195 90 240 150 225 180 165 105
Polygon -7566196 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7566196 true true 135 90 165 300
Polygon -7566196 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7566196 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7566196 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7566196 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7566196 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7566196 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7566196 true true 135 90 120 45 150 15 180 45 165 90

square
false
0
Rectangle -7566196 true true 30 30 270 270

square 2
false
0
Rectangle -7566196 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7566196 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7566196 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7566196 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7566196 true true 120 120 60

tree
false
0
Circle -7566196 true true 118 3 94
Rectangle -6524078 true false 120 195 180 300
Circle -7566196 true true 65 21 108
Circle -7566196 true true 116 41 127
Circle -7566196 true true 45 90 120
Circle -7566196 true true 104 74 152

triangle
false
0
Polygon -7566196 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7566196 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7566196 true true 4 45 195 187
Polygon -7566196 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7566196 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7566196 false true 24 174 42
Circle -7566196 false true 144 174 42
Circle -7566196 false true 234 174 42

turtle
true
0
Polygon -11352576 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -11352576 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -11352576 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -11352576 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -11352576 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7566196 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7566196 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7566196 true 150 285 150 15
Line -7566196 true 15 150 285 150
Circle -7566196 true true 120 120 60
Line -7566196 true 216 40 79 269
Line -7566196 true 40 84 269 221
Line -7566196 true 40 216 269 79
Line -7566196 true 84 40 221 269

x
false
0
Polygon -7566196 true true 270 75 225 30 30 225 75 270
Polygon -7566196 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 2.1pre2
@#$#@#$#@
; let preview be all-black
@#$#@#$#@
@#$#@#$#@
