breeds [
  flowers
  birds
]

to setup
  ca
  draw-landscape
  make-birds
  make-flowers
end

; draw the grass, sky, and sun
to draw-landscape
  ask patches [ set pcolor (green + 2) ]
  ask patches with [ pycor > -5 ]
  [ set pcolor (blue - 1.5) ]
  ask patch 12 12
  [ ask patches in-radius 3
    [ set pcolor yellow ] ]
end

to make-birds
  ask random-n-of 20 (patches with [ pcolor = (blue - 1.5) ])
  [ sprout 1
    [ set breed birds
      set shape ("bird" + (1 + random 3))
      set size (2 + random 3) ]
  ]
end

to make-flowers
  ask random-n-of 20 (patches with [ pcolor = (green + 2) ])
  [ sprout 1
    [ set breed flowers
      set shape ("flower" + (1 + random 6))
      set size (random 8) ] ]
end

to go
  ask birds
  [ set heading (heading - random 15)
    stay-in-sky
    fd 1 ]
  rotate-flowers
end

to rotate-flowers
  if any? flowers
  [ ask random-n-of 1 flowers [ die ] ]
  make-more-flowers
end

; keeps the birds from flying into the ground
to stay-in-sky
  if (pcolor-of patch-ahead 2 = (green + 2))
  [ set heading (heading + 180) ]
end

; re-grow flowers
to make-more-flowers
  ask random-n-of 3 (patches with [ pcolor = (green + 2) ])
  [ sprout 1
    [ set breed flowers
      set shape ("flower" + (1 + random 6))
      set size (random 8) ] ]
end

@#$#@#$#@
GRAPHICS-WINDOW
113
10
438
356
17
17
9.0
1
10
1
1
1
0

CC-WINDOW
2
403
676
499
Command Center

BUTTON
19
97
82
130
go
go
T
1
T
OBSERVER
T

BUTTON
19
44
82
77
setup
setup
NIL
1
T
OBSERVER
T

@#$#@#$#@
WHAT IS IT?
-----------
This model displays the shapes created by the test subjects during Shapes editor testing.

HOW IT WORKS
------------
This section could explain what rules the agents use to create the overall behavior of the model.


HOW TO USE IT
-------------
This section could explain how to use the model, including a description of each of the items in the interface tab.


THINGS TO NOTICE
----------------
This section could give some ideas of things for the user to notice while running the model.


THINGS TO TRY
-------------
This section could give some ideas of things for the user to try to do (move sliders, switches, etc.) with the model.


EXTENDING THE MODEL
-------------------
This section could give some ideas of things to add or change in the procedures tab to make the model more complicated, detailed, accurate, etc.


NETLOGO FEATURES
----------------
This section could point out any especially interesting or unusual features of NetLogo that the model makes use of, particularly in the Procedures tab.  It might also point out places where workarounds were needed because of missing features.


RELATED MODELS
--------------
This section could give the names of models in the NetLogo Models Library or elsewhere which are of related interest.


CREDITS AND REFERENCES
----------------------
This section could contain a reference to the model's URL on the web if it has one, as well as any other necessary credits or references.
@#$#@#$#@
default
true
0
Polygon -7566196 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7566196 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7566196 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7566196 true true 150 285 285 225 285 75 150 135
Polygon -7566196 true true 150 135 15 75 150 15 285 75
Polygon -7566196 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7566196 true true 96 182 108
Circle -7566196 true true 110 127 80
Circle -7566196 true true 110 75 80
Line -7566196 true 150 100 80 30
Line -7566196 true 150 100 220 30

butterfly
true
0
Polygon -7566196 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7566196 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7566196 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7566196 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7566196 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7566196 true true 47 195 58
Circle -7566196 true true 195 195 58

circle
false
0
Circle -7566196 true true 0 0 300

circle 2
false
0
Circle -7566196 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7566196 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7566196 true true 73 210 86 251 62 249 48 208
Polygon -7566196 true true 25 114 16 195 9 204 23 213 25 200 39 123

face happy
false
0
Circle -7566196 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7566196 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7566196 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7566196 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7566196 true true 60 15 75 300
Polygon -7566196 true true 90 150 270 90 90 30
Line -7566196 true 75 135 90 135
Line -7566196 true 75 45 90 45

flower
false
0
Polygon -11352576 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7566196 true true 85 132 38
Circle -7566196 true true 130 147 38
Circle -7566196 true true 192 85 38
Circle -7566196 true true 85 40 38
Circle -7566196 true true 177 40 38
Circle -7566196 true true 177 132 38
Circle -7566196 true true 70 85 38
Circle -7566196 true true 130 25 38
Circle -7566196 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -11352576 true false 189 233 219 188 249 173 279 188 234 218
Polygon -11352576 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7566196 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7566196 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7566196 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7566196 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7566196 true 150 0 150 300

pentagon
false
0
Polygon -7566196 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7566196 true true 110 5 80
Polygon -7566196 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7566196 true true 127 79 172 94
Polygon -7566196 true true 195 90 240 150 225 180 165 105
Polygon -7566196 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7566196 true true 135 90 165 300
Polygon -7566196 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7566196 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7566196 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7566196 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7566196 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7566196 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7566196 true true 135 90 120 45 150 15 180 45 165 90

square
false
0
Rectangle -7566196 true true 30 30 270 270

square 2
false
0
Rectangle -7566196 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7566196 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7566196 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7566196 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7566196 true true 120 120 60

tree
false
0
Circle -7566196 true true 118 3 94
Rectangle -6524078 true false 120 195 180 300
Circle -7566196 true true 65 21 108
Circle -7566196 true true 116 41 127
Circle -7566196 true true 45 90 120
Circle -7566196 true true 104 74 152

triangle
false
0
Polygon -7566196 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7566196 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7566196 true true 4 45 195 187
Polygon -7566196 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7566196 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7566196 false true 24 174 42
Circle -7566196 false true 144 174 42
Circle -7566196 false true 234 174 42

turtle
true
0
Polygon -11352576 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -11352576 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -11352576 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -11352576 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -11352576 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7566196 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7566196 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7566196 true 150 285 150 15
Line -7566196 true 15 150 285 150
Circle -7566196 true true 120 120 60
Line -7566196 true 216 40 79 269
Line -7566196 true 40 84 269 221
Line -7566196 true 40 216 269 79
Line -7566196 true 84 40 221 269

x
false
0
Polygon -7566196 true true 270 75 225 30 30 225 75 270
Polygon -7566196 true true 30 75 75 30 270 225 225 270

bird1
true
0
Circle -65536 true false 68 84 110
Polygon -44544 true false 97 129 59 124 59 124
Polygon -44544 true false 53 109 53 109 85 124 84 124 84 124 52 157
Rectangle -44544 true false 106 177 115 227
Rectangle -44544 true false 132 177 140 225
Polygon -256 true false 151 118 150 154 211 113
Circle -16776961 true false 91 103 11

bird2
true
0
Circle -11352576 true false 60 38 78
Circle -1 true false 78 49 30
Circle -16711936 true false 85 90 176
Line -256 false 71 105 70 105
Polygon -256 true false 66 74 2 112 76 106 74 101
Polygon -8716033 true false 213 203 265 243 222 197 215 202
Polygon -16745473 true false 212 203 206 210 271 245
Polygon -16776961 true false 191 231 204 210 268 242
Circle -8716033 true false 89 57 8
Circle -8716033 true false 85 55 16
Polygon -11352576 true false 98 149 153 288 168 231 140 133 124 138

bird3
true
0
Polygon -256 true false 150 30 135 60 165 60
Circle -7566196 true true 123 50 54
Polygon -7566196 true true 120 105 60 165 45 195 75 180 75 195 105 180 105 210 135 180 135 195 125 225 120 240 150 225 180 240 165 195 165 180 195 210 195 180 225 195 225 180 255 195 240 165 180 105 150 90
Circle -16777216 true false 135 60 10
Circle -16777216 true false 154 60 10

bird4
true
13
Polygon -1 true false 45 195 90 105 135 105 135 75 120 75 105 60 120 45 165 45 165 105 210 105 255 195
Polygon -1 true false 135 180 135 240 120 270 180 270 165 240 165 180
Polygon -65413 true true 60 210 90 165 105 165 75 210
Polygon -65413 true true 90 210 120 165 135 165 105 210 90 210 90 210
Polygon -65413 true true 195 210 165 165 180 165 210 210
Polygon -65413 true true 225 210 195 165 210 165 240 210
Polygon -65413 true true 105 105 90 120 135 120 135 105
Polygon -65413 true true 165 105 165 120 210 120 195 105

flower1
false
0
Polygon -11352576 true false 163 286 164 233 161 201 150 182 132 169 106 162 88 163 75 171 67 187 82 191 91 173 111 174 137 189 148 212 152 244 150 272 148 289
Polygon -7566196 true true 76 187 92 222 70 222 76 187 122 201 121 187 76 187 122 171 122 156 122 156 107 156 76 187 92 141 77 141 76 187 54 142 41 162 76 187 31 185 42 205
Circle -256 true false 65 169 29

flower2
true
0
Circle -256 true false 150 60 0
Circle -44544 true false 120 15 90
Circle -256 true false 135 75 0
Circle -256 true false 165 60 0
Circle -44544 true false 165 60 90
Circle -65413 true false 146 131 67
Circle -65536 true false 85 135 72
Circle -44544 true false 53 97 74
Circle -65281 true false 66 52 70
Circle -256 true false 120 90 60
Polygon -11352576 true false 144 162 143 299 160 298 155 161 145 163
Circle -6524078 false false 136 103 6
Circle -6524078 false false 150 108 8
Circle -6524078 false false 150 99 4
Circle -6524078 false false 142 95 6
Circle -6524078 false false 135 114 6
Circle -6524078 false false 134 123 15
Circle -6524078 false false 158 124 8
Circle -6524078 false false 145 114 12
Circle -6524078 false false 152 136 2
Circle -6524078 false false 144 137 8
Circle -6524078 false false 164 115 8
Circle -6524078 false false 160 111 4
Circle -6524078 false false 158 104 6
Circle -6524078 false false 156 97 6
Circle -6524078 false false 156 133 7
Circle -6524078 false false 126 123 6
Circle -6524078 false false 123 116 6
Circle -6524078 false false 126 108 4
Circle -6524078 false false 129 104 4
Circle -6524078 false false 133 98 4
Circle -6524078 false false 131 132 4
Circle -6524078 false false 141 128 2
Polygon -11352576 true false 154 216 214 206 156 243
Polygon -11352576 true false 149 255 86 228 151 237

flower3
false
0
Circle -8716033 true false 92 106 43
Rectangle -16711936 false false 105 150 120 225
Circle -256 false false 115 83 34
Circle -16711738 false false 84 138 32
Circle -16776961 false false 116 137 32
Circle -44544 false false 135 115 28
Circle -8716033 false false 75 80 38
Circle -65536 false false 61 116 36

flower4
false
0
Polygon -11352576 true false 140 292 140 247 143 178 140 157 140 142 145 130 143 117 155 112 155 142 155 157 151 202 148 250 151 276 154 292
Polygon -7566196 true true 149 119 149 119 179 164 198 155 149 119 200 146 209 134 149 119 209 119 209 104 149 119 207 90 186 73 149 119 168 64 149 62 149 119 134 59 121 70 149 119 112 78 104 89 149 119 102 107 105 126 149 119 104 149 111 158 149 119 119 164 134 164 149 119 149 164 164 164 149 119
Circle -65536 true false 133 103 33

flower5
false
0
Polygon -11352576 true false 140 292 140 247 143 178 140 157 140 142 145 130 143 117 155 112 155 142 155 157 151 202 148 250 151 276 154 292
Polygon -7566196 true true 150 120 120 45 195 45 150 120 225 150 180 195 150 120 105 180 75 120
Polygon -6524078 true false 150 120 90 105 120 75 150 120 180 90 195 120 150 120 135 165 165 165

flower6
false
0
Circle -256 true false 150 75 0
Circle -256 true false 103 58 95
Polygon -11352576 true false 143 150 128 210 143 255 128 300 143 300 158 255 143 210 158 150
Polygon -7566196 true true 135 60 120 15 165 15 150 60
Polygon -7566196 true true 179 65 196 23 223 50 185 71
Polygon -7566196 true true 196 94 237 77 232 118 199 104
Polygon -7566196 true true 196 126 230 133 210 158 189 130
Polygon -7566196 true true 120 146 108 174 87 154 119 139
Polygon -7566196 true true 117 71 106 34 77 56 110 77
Polygon -7566196 true true 105 94 62 79 65 117 105 105
Polygon -7566196 true true 102 120 63 128 81 143
Polygon -7566196 true true 167 148 163 183 190 169 170 142
Polygon -16711936 true false 129 195 91 185 64 202 93 212
Polygon -16711936 true false 150 229 184 217 211 231 177 240
Line -16777216 false 123 87 135 90
Line -16777216 false 135 105 118 112
Line -16777216 false 167 103 177 94
Line -16777216 false 162 122 166 129
Line -16777216 false 142 70 147 78

flower7
false
0
Polygon -65413 true false 101 112 116 164 180 166 199 105 160 124 136 107 121 126 101 111
Rectangle -16711936 true false 141 159 150 282
Rectangle -8716033 true false 116 136 127 150
Rectangle -8716033 true false 140 121 150 137
Rectangle -8716033 true false 156 153 166 160
Rectangle -8716033 true false 168 126 178 140
Polygon -16711936 true false 146 215 179 194 146 198
Polygon -16711936 true false 151 211 116 200 143 228

@#$#@#$#@
NetLogo 2.1pre2
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
