

globals [ horde-released? clock]

to setup
  Ca
  set clock 0
   cct num-oranges
  [set color green set size 2 set shape "circle" set heading random 360]
  cct num-blues
  [ set color blue set heading random 360]

 ask patches
 [ if abs pxcor >= 10 and abs pxcor <= 13 and
      abs pycor >= 10 and abs pycor <= 13 [ set pcolor white ]  ]
  ask patches
  [if pxcor = 17 [ set pcolor orange]
  if pxcor = -17 [set pcolor orange]
  if pycor = 17 [set pcolor orange]
  if pycor = -17 [set pcolor orange] ]
  set horde-released? false
end

to go
  set clock clock + 1
  ask turtles
  [
  if shape = "circle" [move-circle]
  if shape = "default" [move-default]
  if shape = "horde" [move-default]
    bounce
  ]
  if not any? turtles with [ color = orange or color = blue or color = green ]
  [ if not horde-released? [ horde-release ]

  ask patch 4 0 [set plabel "unleash the horde"]

  ask patch 16 0 [set plabel "unleash the horde"]

  ask patch -7 0 [set plabel "unleash the horde"]

  ask patch -7 6 [set plabel "unleash the horde"]

  ask patch 4 6 [set plabel "unleash the horde"]

  ask patch 16 6 [set plabel "unleash the horde"]

  ask patch -7 -6 [set plabel "unleash the horde"]

  ask patch 4 -6 [set plabel "unleash the horde"]

  ask patch 16 -6 [set plabel "unleash the horde"]
  ]
  if ((count turtles) = 1) [wait 1 cp ct stop ]
end

to move-default ;; turtle procedure
  fd 0.8
  if ( pcolor = white ) and ( color != red )
    [set color white set size 4]
     if color = blue and any? other-turtles-here with [ color = white ] [ set color white set size 4]
     if color = blue and any? other-turtles-here with [ color = orange ] [set color orange set shape "circle" set size 2]
     if color = orange and any? other-turtles-here with [ color = white] [set color white set size 4 ]
     if color = white and any? other-turtles-here with [ color = red ]  [die]
    if not any? turtles with [ color != red ] [
    if color = red and any? other-turtles-here with [ color = red ]
    [ without-interruption  [set size size + sum values-from other-turtles-here [size] ask other-turtles-here [die] ] ] ]

    end

to move-circle ;; turtle procedure
   fd 1
  if color = orange and any? other-turtles-here with [ color = white ] [set color white set size 4 ]
  if color = white and any? other-turtles-here with [ color = red] [die]
end

to bounce
   if ( round xcor = -1 * screen-edge-x ) or ( round xcor = screen-edge-x )
    [ set heading ( 360 - heading )
    if color = green [set color orange] ]
   if ( round ycor = -1 * screen-edge-y ) or ( round ycor = screen-edge-y )
    [ set heading (180 - heading ) if color = green [set color orange] ]
end

to horde-release
  set horde-released? true
  ask patches with [pcolor = white]
   [sprout num-the-horde [set color red set size 1 set shape "horde" set heading random 360] ]
   ask turtles
   [bounce]
end

@#$#@#$#@
GRAPHICS-WINDOW
333
17
658
363
17
17
9.0
1
10
1
1
1
0
1
1
1

CC-WINDOW
5
390
667
485
Command Center
0

BUTTON
0
10
70
43
SETUP
setup
NIL
1
T
OBSERVER
T
NIL

BUTTON
2
47
65
80
GO
go
T
1
T
OBSERVER
T
NIL

MONITOR
2
210
59
259
blues
count turtles with [color = blue]
3
1

SLIDER
3
130
175
163
num-blues
num-blues
1
200
100
1
1
NIL

MONITOR
64
210
128
259
oranges
count turtles with [color = orange]
3
1

SLIDER
3
167
175
200
num-oranges
num-oranges
1
200
100
1
1
NIL

MONITOR
3
270
60
319
whites
count turtles with [color = white]
3
1

MONITOR
70
269
127
318
greens
count turtles with [ color = green]
3
1

SLIDER
3
94
175
127
num-THE-HORDE
num-THE-HORDE
1
35
4
1
1
NIL

MONITOR
4
326
61
375
HORDE
count turtles with [ color = red]
3
1

MONITOR
71
327
128
376
NIL
clock
3
1

@#$#@#$#@
Greg Lucas Lehrer
NetLogo Workshop 2004


WHAT IS IT?
-----------
This model shows how a simple breed of the "HORDE" can dominate every other breed of turtles. note (this model is sick and has no logic if do not appreciate the sick and twisted humor please don't sue the creator just dont watch it...)

HOW IT WORKS
------------
The starting breeds of turtles will assimilate each other until each turtle is the same breed then the "HORDE" steps in and wipes everyone out. Note ( please don't try this at home with real living things if you are thinking of such things please go and get some help).


HOW TO USE IT
-------------
Use the slider to determin how much of one breed can be on the screen at once.
Note ( if u take joy in mass devastation, such as the person who created this model, please keep in mind no triangles, circles, or "HORDE" were hurt in the making of this model).

THINGS TO NOTICE
----------------
Things to notice are the cool fact that when the "HORDE" are realeased and decimate everything on screen they eat each other and use the eaten(s) as a form of energy to grow to enormous sizes.  Note (this can be highly amusing).

THINGS TO TRY
-------------
Putting all the sliders at the max to enjoy the assimilating decimating and not to mention the eating of each one of the breeds of turtles. Note ( if u do this you are a very sick person).

EXTENDING THE MODEL
-------------------
When all the "HORDE" have eaten each other, make the one that is left explode into many different breeds of "HORDE".  Note (this could cause some serious lag problems. If your eyes cannot follow the movements, please step away from the screen before bad things happen)

NETLOGO FEATURES
----------------
Nothing incredibly special. Note ( don't pick on me about not making the model incredibly special).

ANY MODELS SIMILAR

Find that one model that has them eating each other to increase their own size.
Note ( the creator would like to mention if u like the other model more... u are a traitor).


CREDITS AND REFERENCES
----------------------
It does'nt have one so there... Note ( don't ask ).
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
true
0
Polygon -7500403 true true 45 255 255 255 255 45 45 45

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

horde
true
1
Polygon -2674135 true true 91 16 90 166 137 166 136 102 179 102 180 165 226 165 226 15 179 15 179 61 135 61 135 13
Rectangle -2674135 true true 135 79 135 115
Rectangle -2674135 true true 130 93 190 120

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

oranges
true
2
Circle -955883 false true 58 57 187
Circle -955883 false true 96 92 111

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 3.0pre5
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
