turtles-own [accuracy evaluate capture correction harm benefit chance-to-harm chance-to-benefit]
Globals [Times number-inaccurate Captured Resulting-harm Resulting-benefit]

to setup
  ca
  setup-turtles
  set Times 0
  do-plotting
  ask patches [set pcolor 0]
end

to setup-turtles
  crt 100
  ask turtles [
      set shape "person"
      set size 3.5
      set harm 0
      set chance-to-harm (random 100)
      set chance-to-benefit (random 100)
      set heading random-float 360
      fd (random screen-edge-x)
      ;set pxcor [screen-edge x = 17]
      ;set pxcor [screen-edge x = -17]
      ;set pycor [screen-edge y = 17]
      ;set pycor [screen-edge y = -17]
      ifelse random 100 < %accuracy
       [set color 95 set accuracy true]
       [  set accuracy false
         set color red
         fd 1
         if inaccurate-trail? [ pd] ]
     set evaluate false
     if (random 100 < %evaluate)
     [
       set evaluate true
     ]
     set correction false
     if random 100 < %correction
     [
     set correction true
     ]
    ]
end

to go
ask turtles [
    fd (random screen-edge-x)
    if (color = red)
    [
      ask other-turtles-here with [color = 95]
      [
        set color red
      ]
    ]
    if (color = red)
    [
       set accuracy false
         if inaccurate-trail? [ pd]
    ]
     if capture? [if (correction = true and accuracy = true and evaluate = true)
     [ask other-turtles-here with [color = red] [set capture true set color yellow pu]
     ]

     if (color = yellow)
     [
       set accuracy true
     ]
     if (color = 95)
     [
       set accuracy true
     ]
   ]
        ]
If Errors? [
 ask turtles
   [  calculate-harm
      calculate-benefit
        check-patients
   ]]

   Set Times (Times + 1)
If Times > Times-stopper [stop]
  set number-inaccurate count turtles with [accuracy = false]
  set Captured count turtles with [capture = true]
  set Resulting-harm count patches with [pcolor = 17]
  set Resulting-benefit count patches with [pcolor = 66]
  do-plotting

end

to check-patients ;;turtle procedure
  if random 100 < %act-likelihood [
    if color = red
      [calculate-harm
      if harm = true [set pcolor 17]]

    if color = 95 or color = yellow
    [calculate-benefit
    if benefit = true [set pcolor 66]]]
end

to calculate-harm

  Ifelse Error-margin?
  [set harm false
     if random 100 < %margin-of-error
     [
     set harm true
     ]]

  [set harm false
     if random 100 < chance-to-harm
     [
     set harm true
     ]]


end

to calculate-benefit

Ifelse Benefit-margin?
  [set benefit false
     if random 100 < %margin-of-benefit
     [
     set benefit true
     ]]
     [set benefit false
     if random 100 < chance-to-benefit
     [
     set benefit true
     ]]

end
to do-plotting
  set-current-plot "Accuracy of Information"
  plot count turtles with [accuracy = true]
  set-current-plot "Error Related Harm"
  plot count patches with [pcolor = 17]
end
@#$#@#$#@
GRAPHICS-WINDOW
415
10
791
407
17
17
10.46
1
10
1
1
1
0

CC-WINDOW
5
530
800
625
Command Center

BUTTON
22
10
88
43
NIL
Setup
NIL
1
T
OBSERVER
T
NIL

BUTTON
93
10
156
43
NIL
Go
T
1
T
OBSERVER
T
NIL

SLIDER
19
47
191
80
%accuracy
%accuracy
0
100
92
1
1
NIL

SLIDER
19
86
191
119
%evaluate
%evaluate
0
100
50
1
1
NIL

PLOT
2
195
206
345
Accuracy of Information
Time
Information
0.0
100.0
0.0
100.0
true
false

SLIDER
19
122
191
155
%correction
%correction
0
100
50
1
1
NIL

SWITCH
209
11
352
44
inaccurate-trail?
inaccurate-trail?
1
1
-1000

MONITOR
208
140
270
189
NIL
Times
3
1

SLIDER
20
159
192
192
Times-stopper
Times-stopper
0
2000
497
1
1
NIL

MONITOR
5
351
118
400
NIL
number-inaccurate
3
1

MONITOR
128
352
190
401
NIL
Captured
3
1

SWITCH
209
52
305
85
Capture?
Capture?
0
1
-1000

SLIDER
6
406
178
439
%act-likelihood
%act-likelihood
0
100
24
1
1
NIL

SLIDER
7
444
179
477
%Margin-of-error
%Margin-of-error
0
100
61
1
1
NIL

SLIDER
6
483
179
516
%Margin-of-benefit
%Margin-of-benefit
0
100
77
1
1
NIL

SWITCH
181
447
312
480
Error-margin?
Error-margin?
0
1
-1000

SWITCH
181
482
314
515
Benefit-margin?
Benefit-margin?
0
1
-1000

SWITCH
182
409
272
442
act?
act?
0
1
-1000

SWITCH
208
94
311
127
Errors?
Errors?
0
1
-1000

PLOT
210
195
410
345
Error Related Harm
Times
Harm
0.0
100.0
0.0
100.0
true
false
PENS
"default" 1.0 1 -16777216 true

MONITOR
302
350
412
399
NIL
Resulting-harm
3
1

MONITOR
193
351
298
400
NIL
Resulting-benefit
3
1

@#$#@#$#@
Donna Woods
NetLogo Workshop 2004

WHAT IS IT?
-----------
This model shows the dynamics of the transfer of inaccurate information and dynamics of error occurrence based on the dynamics of use the inaccurate information.


HOW IT WORKS
------------
The agents are clinicians with inaccurate information = red, accurate information = blue, clinicians who had inaccrate information but were corrected = yellow. Blue clinicians spread inaccurate information to red turtle who are not in a position to correct the information. The ability to correct the information is set by the sliders %evaluate (the proportion of clinicians in a position to evaluate the information) and %corrected (the proportion of clinicians willing or able to correct the inaccurate information)
This model starts out looking at the transfer  of inaccurate information. The model tracks the spread of the inaccurate information and looks at factors that buffer or facilitate its spread.
The monitors track the number of transfer times, the clinicians with inaccurate information, the number of clinicians corrected, or in other words, inaccurate messages captured. there is a plot associated with information transfer tracking over time the number of clinicians carrying accurate information.

The model then tracks the impact of acting based on the inaccurate information. One can set the proportion of clinicans who will act on information (either accurate or inaccurate) on a slider (%act-likelihood). Then the proportion of actions that can cause harm can be varied by first turning error-margin switch off and the liklihood that an action will cause harm is set randomly for each clinician, or secondly with the switch on, this will set an overall likelihood that an error will cause harm. Using the same procedure for the benefit-margin switch. Then depending on the values of %accuracy, %evaluate, %corrected, %act-likelihood, Margin-of-Errorand Margin of Benefit sliders and the whether the Capture switch is on or off one can watch the dynamics of error and harm. This can be run in a cascade mode or in a context inwhich inaccurate information is corrected. One can approximate differn situations through vaying the values in the sliders and switches.
Examples:

HOW TO USE IT
-------------
1) Set the setting of the %accuracy slider and set the Capture switch to off and the Errors switch to off.
This shows information cascade. Look at the Accuracy of Information plot and monotors for times and number-inaccurate. Vary %accuracy and see what happens
2) Set the setting of the %accuracy, %evaluate, %corrected and set the Capture switch to on and the Errors switch to off. This shows the impact of the copture of inaccurate information in a system. Look at the increase in yellow clinicians, the Accuracy of Information plot and the monitors for number-inaccurate and Capture. Vary the values of  %accuracy, %evaluate, %corrected and see what happens.
3) Set the values of the %accuracy, %evaluate, %corrected, %act-likelihood, Margin-of-Errorand Margin of Benefit sliders and set the Capture switch to off and the Errors switch to on.  This shows the impact of inaccurate information on error and the resulting harm in a cascading system with no opportunity to capture the inaccuracy informatin or the error. Look at number-inaccurate, Resulting Harm monitors. Accuracy of Information and Error related Harm plots. Vary the values of the %accuracy, %evaluate, %corrected, %act-likelihood, Margin-of-Errorand Margin of Benefit sliders and see what happens.
4) Set the values of the %accuracy, %evaluate, %corrected, %act-likelihood, Margin-of-Errorand Margin of Benefit sliders and set the Capture switch to on and the Errors switch to on.  This shows the impact of inaccurate information on error and the resulting harm when there is a varying ability to cpature and correct the inacurrate information thus preventing the potential resulting error and harm. *** Look at number-inaccurate, Resulting Harm monitors. Accuracy of Information and Error related Harm plots. Vary the values of the %accuracy, %evaluate, %corrected, %act-likelihood, Margin-of-Errorand Margin of Benefit sliders and see what happens.

THINGS TO NOTICE
----------------
See above.

THINGS TO TRY
-------------
See above.

EXTENDING THE MODEL
-------------------
One could extend this model by elaborating the nature of the harm by creating severity of harm from the error.
One could create gradients in the environment that make inaccurate information transfer or error more or less likely.
One could add variable such as incomplete information.One could create breeds of clinicians with different featrues that impact the accuracy of the information, its transfer, the ability to correct the inaccurate information, or the ability to act or the likelihood of creating an error.
One could try to extend this model by developing information trees of successive information from the initial peice of accccurate or inaccurate information.
One could create sets of teams from the turtles much like departments, units or floors and create different conditions for communication of information within the team and for across the teams.



@#$#@#$#@
default
true
0
Polygon -7566196 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7566196 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7566196 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7566196 true true 150 285 285 225 285 75 150 135
Polygon -7566196 true true 150 135 15 75 150 15 285 75
Polygon -7566196 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7566196 true true 96 182 108
Circle -7566196 true true 110 127 80
Circle -7566196 true true 110 75 80
Line -7566196 true 150 100 80 30
Line -7566196 true 150 100 220 30

butterfly
true
0
Polygon -7566196 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7566196 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7566196 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7566196 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7566196 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7566196 true true 47 195 58
Circle -7566196 true true 195 195 58

circle
false
0
Circle -7566196 true true 0 0 300

circle 2
false
0
Circle -7566196 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7566196 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7566196 true true 73 210 86 251 62 249 48 208
Polygon -7566196 true true 25 114 16 195 9 204 23 213 25 200 39 123

face happy
false
0
Circle -7566196 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7566196 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7566196 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7566196 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7566196 true true 60 15 75 300
Polygon -7566196 true true 90 150 270 90 90 30
Line -7566196 true 75 135 90 135
Line -7566196 true 75 45 90 45

flower
false
0
Polygon -11352576 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7566196 true true 85 132 38
Circle -7566196 true true 130 147 38
Circle -7566196 true true 192 85 38
Circle -7566196 true true 85 40 38
Circle -7566196 true true 177 40 38
Circle -7566196 true true 177 132 38
Circle -7566196 true true 70 85 38
Circle -7566196 true true 130 25 38
Circle -7566196 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -11352576 true false 189 233 219 188 249 173 279 188 234 218
Polygon -11352576 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7566196 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7566196 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7566196 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7566196 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7566196 true 150 0 150 300

pentagon
false
0
Polygon -7566196 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7566196 true true 110 5 80
Polygon -7566196 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7566196 true true 127 79 172 94
Polygon -7566196 true true 195 90 240 150 225 180 165 105
Polygon -7566196 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7566196 true true 135 90 165 300
Polygon -7566196 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7566196 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7566196 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7566196 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7566196 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7566196 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7566196 true true 135 90 120 45 150 15 180 45 165 90

square
false
0
Rectangle -7566196 true true 30 30 270 270

square 2
false
0
Rectangle -7566196 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7566196 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7566196 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7566196 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7566196 true true 120 120 60

tree
false
0
Circle -7566196 true true 118 3 94
Rectangle -6524078 true false 120 195 180 300
Circle -7566196 true true 65 21 108
Circle -7566196 true true 116 41 127
Circle -7566196 true true 45 90 120
Circle -7566196 true true 104 74 152

triangle
false
0
Polygon -7566196 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7566196 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7566196 true true 4 45 195 187
Polygon -7566196 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7566196 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7566196 false true 24 174 42
Circle -7566196 false true 144 174 42
Circle -7566196 false true 234 174 42

turtle
true
0
Polygon -11352576 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -11352576 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -11352576 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -11352576 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -11352576 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7566196 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7566196 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7566196 true 150 285 150 15
Line -7566196 true 15 150 285 150
Circle -7566196 true true 120 120 60
Line -7566196 true 216 40 79 269
Line -7566196 true 40 84 269 221
Line -7566196 true 40 216 269 79
Line -7566196 true 84 40 221 269

x
false
0
Polygon -7566196 true true 270 75 225 30 30 225 75 270
Polygon -7566196 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 2.1beta4
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
