patches-own [ground pheromone visited]
turtles-own [cost path pathdir]
globals [n-of-turtles latest-cost currentmin currentmax pathlengths]

to setup
ask turtles [die]
ask patches [set ground rand-from-to -3 4]
repeat 10 [diffuse ground 0.3]
ask patches [
    set ground crude ground 0 1]
clear
clear
end


to clear
ask patches with [ground = 0] [set pcolor blue - 1]
ask patches with [ground = 1] [set pcolor brown]
ask patches with [ground = 2] [set pcolor green - 2]
ask patches [set pheromone [1 1 1 1]]
ask patch-at screen-edge-x ((-1) * screen-edge-y) [set pcolor red]
ask patch-at ((-1) * screen-edge-x) screen-edge-y [set pcolor green]
ask patches with [pxcor = ((-1) * screen-edge-x)] [set pheromone nullify pheromone 3]
ask patches with [pxcor = (screen-edge-x)] [set pheromone nullify pheromone 1]
ask patches with [pycor = ((-1) * screen-edge-y)] [set pheromone nullify pheromone 2]
ask patches with [pycor = (screen-edge-y)] [set pheromone nullify pheromone 0]
ask patches [if (value-from patch-at 0 1 [ground]) = 0 [set pheromone nullify pheromone 0]]
ask patches [if (value-from patch-at 1 0 [ground]) = 0 [set pheromone nullify pheromone 1]]
ask patches [if (value-from patch-at 0 -1 [ground]) = 0 [set pheromone nullify pheromone 2]]
ask patches [if (value-from patch-at -1 0 [ground]) = 0 [set pheromone nullify pheromone 3]]
set n-of-turtles 0
set latest-cost 1000000
set currentmin 1000000
set currentmax 0
ask turtles [die]
set pathlengths []
setup-plot
do-plot
end


to recolor
ask patches with [ground = 0] [set pcolor blue - 1]
ask patches with [ground = 1] [set pcolor brown]
ask patches with [ground = 2] [set pcolor green - 2]
ask patch-at screen-edge-x ((-1) * screen-edge-y) [set pcolor red]
ask patch-at ((-1) * screen-edge-x) screen-edge-y [set pcolor green]
end

to-report crude [val lo hi]
if val < lo [report 0]
if val > hi [report 2]
report 1
end


to turtle-step
locals [rdir dirvec]
;set dirvec value-from patch-here [pheromone]
;show dirvec
;if (value-from patch-at 0 1 [visited]) [set dirvec nullify dirvec 0]
;if (value-from patch-at 1 0 [visited]) [set dirvec nullify dirvec 1]
;if (value-from patch-at 0 -1 [visited]) [set dirvec nullify dirvec 2]
;if (value-from patch-at -1 0 [visited]) [set dirvec nullify dirvec 3]
;set heading random-dir dirvec

set heading random-dir value-from patch-here [pheromone]
set pathdir fput (int (heading / 90)) pathdir
forward 1
set cost (cost + value-from patch-here [ground])
set path fput (list xcor ycor) path
ask patch-here [ifelse ground = 1 [set pcolor turquoise - 1] [set pcolor turquoise - 2]]
ask patch-here [set visited true]
end

to-report arrived?
report (xcor >= (screen-edge-x - 0.1)) and (ycor <= (-1) * (screen-edge-y) + 0.1)
end


to walk
set n-of-turtles n-of-turtles + 1
set path fput (list ((-1) * screen-edge-x) screen-edge-y) []
set pathdir []
setxy ((-1) * screen-edge-x) screen-edge-y
while [not arrived?] [turtle-step]
end

to single-walk
crt 1
;ask patches [set visited false]
ask turtles [walk]
do-plot
end

to retrace
locals [currind currcost localpathdir localpath]
;show length path
if remove-loops?
    [
    set localpath remove-loops path
    set localpathdir stepdirs localpath
    set path localpath
    set pathdir localpathdir
    ]
set path butfirst path
set currcost cost

set latest-cost cost
set currentmin min list latest-cost currentmin
set currentmax max list latest-cost currentmax
set pathlengths fput cost pathlengths
;show length path
while [not empty? path] [
        setxy first first path last first path
        set currind first pathdir
;        set currind first localpathdir
        ask patch-here [
                ifelse ground = 1 [set pcolor yellow - 1] [set pcolor yellow - 2]
                set pheromone replace-item currind pheromone
                        ((item currind pheromone) + (increment currcost))]
        set pathdir butfirst pathdir
;        set localpathdir butfirst localpathdir
        set path butfirst path
      ]
end

to-report random-dir [weightvec]
locals [randnum probvec]
set probvec cumsum normalize weightvec
set randnum random-int-or-float 1.0
if randnum < (item 0 probvec) [report 0]
if randnum < (item 1 probvec) [report 90]
if randnum < (item 2 probvec) [report 180]
report 270
end

to-report nullify [l index]
if empty? l [report l]
if index = 0 [report fput 0 butfirst l]
report fput first l nullify butfirst l (index - 1)
end

to-report addlists [l1 l2]
if empty? l1 [report l2]
if empty? l2 [report l1]
report fput ((first l1) + (first l2)) (addlists (butfirst l1) (butfirst l2))
end

to-report normalize [l]
report scalmult (1 / (sum l))   l
end

to-report scalmult [factor l]
if empty? l [report l]
output fput (factor * first l) scalmult factor butfirst l
end

to-report scaladd [scalar l]
if empty? l [report l]
output fput (scalar + first l) scaladd scalar butfirst l
end


to-report vecadd [vec1 vec2]
if empty? vec1 [report vec2]
if empty? vec2 [report vec1]
report fput ((first vec1) + (first vec2)) vecadd butfirst vec1 butfirst vec2
end

to-report cumsum [l]
if empty? l [report l]
report fput (first l) scaladd (first l) (cumsum butfirst l)
end

to runs
repeat n-of-runs [
    full-turtle-run]
end

to full-turtle-run
single-walk
wait delay / 10
recolor
ask turtles [retrace]
ask turtles [show cost]
wait delay / 10
ask turtles [die]
recolor
end

to-report rand-from-to [a b]
report (random-int-or-float (b - a + 0.0)) + a
end

to-report increment [x]
report (2000 ^ 3) / (x ^ 3)
end


to-report second [l]
report first butfirst l
end

to-report stepdirs [coordlist]
if (length coordlist = 1) [report []]
output fput dir-from-step (list ((first first coordlist) - (first second coordlist))
                  ((second first coordlist) - (second second coordlist)))
            stepdirs butfirst coordlist
end

to-report dir-from-step [step]
if ((first step) = 0) and ((second step) = 1) [report 0]
if ((first step) = 1) and ((second step) = 0) [report 1]
if ((first step) = 0) and ((second step) = -1) [report 2]
if ((first step) = -1) and ((second step) = 0) [report 3]
end


to-report remove-loops [p]
if (length p) < 2 [report p]
ifelse (member? first p butfirst p)
    [report remove-loops remove-startloop p]
    [report fput first p remove-loops butfirst p]
end

to-report remove-startloop [p]
report cut-head p (1 + position first p butfirst p)
end

to-report cut-head [p num]
if (num < 1) [report p]
report cut-head butfirst p (num - 1)
end


to setup-plot
  set-current-plot "Path length"
  set-plot-x-range  0 10 * (screen-edge-x * screen-edge-y)
  set-plot-y-range 0 10
  set-histogram-num-bars 10
end

to do-plot
  set-histogram-num-bars 10
;  set-plot-x-range  0 50 * (screen-edge-x * screen-edge-y)
  set-plot-x-range  0 histwidth
  set-plot-y-range  0 max list 10 n-of-turtles
  set-histogram-num-bars 20
  histogram-list pathlengths          ; using the default plot pen
end



@#$#@#$#@
GRAPHICS-WINDOW
321
10
672
228
15
8
11.0
1
10
1
1
1

CC-WINDOW
364
352
679
472
Command Center

BUTTON
34
66
115
99
NIL
setup
NIL
1
T
OBSERVER
T

BUTTON
34
156
115
189
NIL
runs
NIL
1
T
OBSERVER
T

SLIDER
127
155
299
188
n-of-runs
n-of-runs
1
100
7
1
1
NIL

SWITCH
34
112
184
145
remove-loops?
remove-loops?
1
1
-1000

BUTTON
127
66
208
99
NIL
clear
NIL
1
T
OBSERVER
T

MONITOR
32
249
112
298
ants so far
n-of-turtles
3
1

MONITOR
220
248
299
297
NIL
latest-cost
3
1

MONITOR
125
248
210
297
NIL
currentmin
3
1

SLIDER
34
205
206
238
delay
delay
0
100
0
1
1
NIL

PLOT
31
306
300
454
Path length
NIL
NIL
0.0
100.0
0.0
100.0
true
false
PENS
"default" 1.0 1 -16777216 true

MONITOR
311
248
394
297
NIL
currentmax
3
1

SLIDER
30
459
202
492
histwidth
histwidth
0
20000
750
10
1
NIL

BUTTON
216
459
297
492
replot
do-plot
NIL
1
T
OBSERVER
T

@#$#@#$#@
In this model ants try to find a short path from the
left upper corner to the right lower corner of the area.

There are pools and lakes (blue) which the ants cannot enter.
And there is normal soil (brown) and wood (green).
Ants are only half as fast in wood than on normal soil.

The ants "communicate" by dropping pheromone on the ground.
The purpose of the pheromone is to indicate "preferable directions"
to go on.
When an ant decides which directions to go
it does so randomly, with probabilities proportional
to the pheromone values for the different directions.

In the beginning, on any spot all legal directions have the same
pheromone value.
So the first ant takes a completely random path.
When an ant arrives, it traces its path back and drops pheromone
on all the spots, in the directions it has taken.
It drops only a little pheromone if the path was long, and it drops
more pheromone if the path was short. So pheromone "piles up"
on spots belonging to a short path.

Turtles starting later already get hints on which directions
to take, and so the paths becomes shorter and shorter for some time.

The setup button creates a new map of an area.
Not all maps work. If the start or the goal is completely blocked
by water, start and goal cannot be connected.

The clear button resets the pheromone values to the initial state.
The remove-loops switch allows you to play with "smart ants".
When the switch is on, the ants remove all the loops the have
walked before retracing there paths backward.

The run button starts a number of ants (one after the other),
and the slider next to it controls the number of ants to be started.

The delay slider allows you to stop the ants for some time before they start
retracing so you can see the pattern of the paths better.
The ant path is turqoise on the way to the goal, and yellow when the ant
goes back dropping the pheromone.

The monitors should be self explaining.

The histogram at the bottom displays the lengths of all paths so far.
You can change the width with the slider, and after a change you can replot
with the button.

@#$#@#$#@
default
true
0
Polygon -7566196 true true 150 5 40 250 150 205 260 250

ant
true
0
Polygon -7566196 true true 136 61 129 46 144 30 119 45 124 60 114 82 97 37 132 10 93 36 111 84 127 105 172 105 189 84 208 35 171 11 202 35 204 37 186 82 177 60 180 44 159 32 170 44 165 60
Polygon -7566196 true true 150 95 135 103 139 117 125 149 137 180 135 196 150 204 166 195 161 180 174 150 158 116 164 102
Polygon -7566196 true true 149 186 128 197 114 232 134 270 149 282 166 270 185 232 171 195 149 186 149 186
Polygon -7566196 true true 225 66 230 107 159 122 161 127 234 111 236 106
Polygon -7566196 true true 78 58 99 116 139 123 137 128 95 119
Polygon -7566196 true true 48 103 90 147 129 147 130 151 86 151
Polygon -7566196 true true 65 224 92 171 134 160 135 164 95 175
Polygon -7566196 true true 235 222 210 170 163 162 161 166 208 174
Polygon -7566196 true true 249 107 211 147 168 147 168 150 213 150

arrow
true
0
Polygon -7566196 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

bee
true
0
Polygon -256 true false 152 149 77 163 67 195 67 211 74 234 85 252 100 264 116 276 134 286 151 300 167 285 182 278 206 260 220 242 226 218 226 195 222 166
Polygon -16777216 true false 150 149 128 151 114 151 98 145 80 122 80 103 81 83 95 67 117 58 141 54 151 53 177 55 195 66 207 82 211 94 211 116 204 139 189 149 171 152
Polygon -7566196 true true 151 54 119 59 96 60 81 50 78 39 87 25 103 18 115 23 121 13 150 1 180 14 189 23 197 17 210 19 222 30 222 44 212 57 192 58
Polygon -16777216 true false 70 185 74 171 223 172 224 186
Polygon -16777216 true false 67 211 71 226 224 226 225 211 67 211
Polygon -16777216 true false 91 257 106 269 195 269 211 255
Line -1 false 144 100 70 87
Line -1 false 70 87 45 87
Line -1 false 45 86 26 97
Line -1 false 26 96 22 115
Line -1 false 22 115 25 130
Line -1 false 26 131 37 141
Line -1 false 37 141 55 144
Line -1 false 55 143 143 101
Line -1 false 141 100 227 138
Line -1 false 227 138 241 137
Line -1 false 241 137 249 129
Line -1 false 249 129 254 110
Line -1 false 253 108 248 97
Line -1 false 249 95 235 82
Line -1 false 235 82 144 100

bird1
false
0
Polygon -7566196 true true 2 6 2 39 270 298 297 298 299 271 187 160 279 75 276 22 100 67 31 0

bird2
false
0
Polygon -7566196 true true 2 4 33 4 298 270 298 298 272 298 155 184 117 289 61 295 61 105 0 43

boat1
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6524078 true false 150 32 157 162
Polygon -16776961 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7566196 true true 158 33 230 157 182 150 169 151 157 156
Polygon -7566196 true true 149 55 88 143 103 139 111 136 117 139 126 145 130 147 139 147 146 146 149 55

boat2
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6524078 true false 150 32 157 162
Polygon -16776961 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7566196 true true 157 54 175 79 174 96 185 102 178 112 194 124 196 131 190 139 192 146 211 151 216 154 157 154
Polygon -7566196 true true 150 74 146 91 139 99 143 114 141 123 137 126 131 129 132 139 142 136 126 142 119 147 148 147

boat3
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6524078 true false 150 32 157 162
Polygon -16776961 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7566196 true true 158 37 172 45 188 59 202 79 217 109 220 130 218 147 204 156 158 156 161 142 170 123 170 102 169 88 165 62
Polygon -7566196 true true 149 66 142 78 139 96 141 111 146 139 148 147 110 147 113 131 118 106 126 71

box
true
0
Polygon -7566196 true true 45 255 255 255 255 45 45 45

butterfly1
true
0
Polygon -16777216 true false 151 76 138 91 138 284 150 296 162 286 162 91
Polygon -7566196 true true 164 106 184 79 205 61 236 48 259 53 279 86 287 119 289 158 278 177 256 182 164 181
Polygon -7566196 true true 136 110 119 82 110 71 85 61 59 48 36 56 17 88 6 115 2 147 15 178 134 178
Polygon -7566196 true true 46 181 28 227 50 255 77 273 112 283 135 274 135 180
Polygon -7566196 true true 165 185 254 184 272 224 255 251 236 267 191 283 164 276
Line -7566196 true 167 47 159 82
Line -7566196 true 136 47 145 81
Circle -7566196 true true 165 45 8
Circle -7566196 true true 134 45 6
Circle -7566196 true true 133 44 7
Circle -7566196 true true 133 43 8

circle
false
0
Circle -7566196 true true 35 35 230

person
false
0
Circle -7566196 true true 155 20 63
Rectangle -7566196 true true 158 79 217 164
Polygon -7566196 true true 158 81 110 129 131 143 158 109 165 110
Polygon -7566196 true true 216 83 267 123 248 143 215 107
Polygon -7566196 true true 167 163 145 234 183 234 183 163
Polygon -7566196 true true 195 163 195 233 227 233 206 159

spacecraft
true
0
Polygon -7566196 true true 150 0 180 135 255 255 225 240 150 180 75 240 45 255 120 135

thin-arrow
true
0
Polygon -7566196 true true 150 0 0 150 120 150 120 293 180 293 180 150 300 150

truck-down
false
0
Polygon -7566196 true true 225 30 225 270 120 270 105 210 60 180 45 30 105 60 105 30
Polygon -8716033 true false 195 75 195 120 240 120 240 75
Polygon -8716033 true false 195 225 195 180 240 180 240 225

truck-left
false
0
Polygon -7566196 true true 120 135 225 135 225 210 75 210 75 165 105 165
Polygon -8716033 true false 90 210 105 225 120 210
Polygon -8716033 true false 180 210 195 225 210 210

truck-right
false
0
Polygon -7566196 true true 180 135 75 135 75 210 225 210 225 165 195 165
Polygon -8716033 true false 210 210 195 225 180 210
Polygon -8716033 true false 120 210 105 225 90 210

turtle
true
0
Polygon -7566196 true true 138 75 162 75 165 105 225 105 225 142 195 135 195 187 225 195 225 225 195 217 195 202 105 202 105 217 75 225 75 195 105 187 105 135 75 142 75 105 135 105

wolf-left
false
3
Polygon -6524078 true true 117 97 91 74 66 74 60 85 36 85 38 92 44 97 62 97 81 117 84 134 92 147 109 152 136 144 174 144 174 103 143 103 134 97
Polygon -6524078 true true 87 80 79 55 76 79
Polygon -6524078 true true 81 75 70 58 73 82
Polygon -6524078 true true 99 131 76 152 76 163 96 182 104 182 109 173 102 167 99 173 87 159 104 140
Polygon -6524078 true true 107 138 107 186 98 190 99 196 112 196 115 190
Polygon -6524078 true true 116 140 114 189 105 137
Rectangle -6524078 true true 109 150 114 192
Rectangle -6524078 true true 111 143 116 191
Polygon -6524078 true true 168 106 184 98 205 98 218 115 218 137 186 164 196 176 195 194 178 195 178 183 188 183 169 164 173 144
Polygon -6524078 true true 207 140 200 163 206 175 207 192 193 189 192 177 198 176 185 150
Polygon -6524078 true true 214 134 203 168 192 148
Polygon -6524078 true true 204 151 203 176 193 148
Polygon -6524078 true true 207 103 221 98 236 101 243 115 243 128 256 142 239 143 233 133 225 115 214 114

wolf-right
false
3
Polygon -6524078 true true 170 127 200 93 231 93 237 103 262 103 261 113 253 119 231 119 215 143 213 160 208 173 189 187 169 190 154 190 126 180 106 171 72 171 73 126 122 126 144 123 159 123
Polygon -6524078 true true 201 99 214 69 215 99
Polygon -6524078 true true 207 98 223 71 220 101
Polygon -6524078 true true 184 172 189 234 203 238 203 246 187 247 180 239 171 180
Polygon -6524078 true true 197 174 204 220 218 224 219 234 201 232 195 225 179 179
Polygon -6524078 true true 78 167 95 187 95 208 79 220 92 234 98 235 100 249 81 246 76 241 61 212 65 195 52 170 45 150 44 128 55 121 69 121 81 135
Polygon -6524078 true true 48 143 58 141
Polygon -6524078 true true 46 136 68 137
Polygon -6524078 true true 45 129 35 142 37 159 53 192 47 210 62 238 80 237
Line -16777216 false 74 237 59 213
Line -16777216 false 59 213 59 212
Line -16777216 false 58 211 67 192
Polygon -6524078 true true 38 138 66 149
Polygon -6524078 true true 46 128 33 120 21 118 11 123 3 138 5 160 13 178 9 192 0 199 20 196 25 179 24 161 25 148 45 140
Polygon -6524078 true true 67 122 96 126 63 144

@#$#@#$#@
NetLogo 2.0beta5
@#$#@#$#@
setup
@#$#@#$#@
@#$#@#$#@
