breeds [shuffler player] ;;creates two turtles, shuffler disperses one numnber per patch, player will collect them one at a time
shuffler-own [numbers];;shuffler owns a list of numbers from 1 to 100
patches-own [values];; values are received by patches from shuffler
player-own [rewards mylist standard exceed reward]; player owns these variables
globals [moves average med hundreds];; moves = number of steps taken by player before accepting a value
;;average = average points gained per run, med = median of all rewards
;;hundreds = how often 100 (top prize) appears in rewards list


to setup
ca
set moves 0

ask patches [set values 0]
create-shuffler 1
ask shuffler [set color green rt 90 fd 51];;shuffler is green, moves to  first patch

ask shuffler [ set numbers [
1 2 3 4 5 6 7 8 9 10
11 12 13 14 15 16 17 18 19 20
21 22 23 24 25 26 27 28 29 30
31 32 33 34 35 36 37 38 39 40
41 42 43 44 45 46 47 48 49 50
51 52 53 54 55 56 57 58 59 60
61 62 63 64 65 66 67 68 69 70
71 72 73 74 75 76 77 78 79 80
81 82 83 84 85 86 87 88 89 90
91 92 93 94 95 96 97 98 99 100
]] ;;;shuffler has numbers 1 to 100

ask shuffler [
ifelse new-shuffle?
[set numbers new-shuffle numbers]
[ set numbers old-shuffle numbers]
] ;;;shuffler shuffles numbers


 repeat 100 [ask shuffler  [fd 1
  set values-of patch-here first numbers ;;shuffler gives first number in list to patch
  set  numbers but-first numbers;; shuffler removes first number from his list, does this 100 times
  set pcolor scale-color yellow values 10 90]];; color coding: top and bottom 10 numbers are white or black, respectively;
  ;;could be changed to make the patch with 100 stand out


create-player 1
ask player [set shape "bee"] ;;player has form of bee
ask player [ rt 90 fd 51];;to to starting point
ask player [set mylist []];;set mylist and rewards at 0
ask player [set rewards []]
ask player [set hundreds 0];; initially no hundreds
end

to go
repeat cycles ;;cycles is a slider, how many times does the player run?
[set-standard
exceed-standard
reset]
end

to set-standard
repeat steps [ask player  [fd 1 set mylist fput values-of patch-here mylist]]
;; player goes forward, one step at a time, slider 'steps' controls number of steps, adds value of patch to list
ask player [set standard max mylist];;after a number of steps, places highest value found in standard
ask player [set moves moves + steps];; add number of initial survey to number of moves taken
end

to exceed-standard
ask player [set exceed 0]
ask player [while [exceed <= standard and pxcor < 50];; continues until a newly found value is higher than standard
;;or, until the end of the line is reached (last patch)
  [fd 1 set exceed values-of patch-here set moves moves + 1]];;; each step add one to moves
end

to reset
ask player [set reward exceed];;exceed is labelled reward
ask player [if reward = 100  [set hundreds hundreds + 1]]
ask player [set rewards fput reward rewards];;reward is added to rewards list
ask player [set average mean rewards];;;determines average of rewards, placed in average monitor
ask player [set med median rewards];; determines median of  rewards, placed in med monitor
ask player [set exceed 0 set standard 0 set mylist []];; these lists are emptied again for next run
ask player [jump (51 - xcor)];; player moves to first patch

ask shuffler [ set numbers [
1 2 3 4 5 6 7 8 9 10
11 12 13 14 15 16 17 18 19 20
21 22 23 24 25 26 27 28 29 30
31 32 33 34 35 36 37 38 39 40
41 42 43 44 45 46 47 48 49 50
51 52 53 54 55 56 57 58 59 60
61 62 63 64 65 66 67 68 69 70
71 72 73 74 75 76 77 78 79 80
81 82 83 84 85 86 87 88 89 90
91 92 93 94 95 96 97 98 99 100
]]
;;;shuffler owns numbers 1 to 100

ask shuffler [
ifelse new-shuffle?
[set numbers new-shuffle numbers]
[ set numbers old-shuffle numbers]
] ;;;shuffler shuffles numbers

ask shuffler [fd 1]
 repeat 100 [ask shuffler  [fd 1
  set values-of patch-here first numbers ;;shuffler gives first number in list to patch
  set  numbers but-first numbers;; shuffler removes first number from his list, does this 100 times
  set pcolor scale-color yellow values 10 90]];; color coding, top and bottom 10 numbers are white or black, respectively
end

to-report old-shuffle [input-list]
report sort-by [random-int-or-float 2 = 0] input-list
end

to-report new-shuffle [input-list]
report map [item 1 ?]
           sort-by [first ?1 < first ?2]
                   map [list random-int-or-float 1.0 ?]
                       input-list
                       end


;; shuffler shuffles numbers



@#$#@#$#@
GRAPHICS-WINDOW
38
28
755
66
50
0
7.0
1
10
1
1
1

CC-WINDOW
321
357
646
476
Command Center

BUTTON
39
105
105
138
NIL
setup
NIL
1
T
OBSERVER
T

BUTTON
40
157
103
190
NIL
go
NIL
1
T
OBSERVER
T

SLIDER
37
259
130
292
steps
steps
1
99
1
1
1
NIL

SLIDER
35
313
127
346
cycles
cycles
0
1000
78
1
1
NIL

MONITOR
217
106
274
155
NIL
Moves
3
1

MONITOR
216
172
274
221
NIL
average
3
1

MONITOR
307
175
364
224
NIL
med
3
1

MONITOR
308
108
382
157
hundreds
hundreds
3
1

SWITCH
524
178
653
211
new-shuffle?
new-shuffle?
0
1
-1000

@#$#@#$#@
WHAT IS IT?
-----------
The Dowry Problem
(Felix Baerlocher, Biology, Mt. Allison  Unversity, Sackville, N.B., Canada; fbaerlocher@mta.ca)

This is a well-known puzzle from statistics (e.g., Mosteller 1965). A sultan wishes to test the intelligence of his advisor, who is seeking a wife. The sultan provides a choice of 100 women, each with a different dowry. The advisor has to choose the woman with the largest dowry. He is introduced to one woman at a time, who will tell him how much dowry she will be provided with, and he can either accept them or reject her. However, once he rejects a woman there is no going back, and he has to move on to the next candidate. Which strategy is most likely to provide him with the highest dowry?
The puzzle is also known as 'the secretary problem': an employer sequentially interviews a number of applicants trying to find the best. Rejection of an applicant is final (they might have accepted another job). Or, it could represent foraging animals: they encounter food patches containing variable amounts of food. Once they reject a patch, there is no turning back (another consumer might have found the food).
As it turns out,  the highest probability of finding the top prize is the following strategy: examine the first 37 choices (or, more generally, n/e, where n = number of choices; Mosteller 1965). With this strategy, one finds the top choice in 37% of all cases.
Investigations of search or decision strategies, where options are encountered in a temporal sequence, have attracted the attention of statisticians, economists and biologists.
Statisticians in general have concentrated on finding the solution that is most likely to yield the top price (n/e rule).
Economists, in the context of job search (best salaries) and consumer choice (lowest prices), take into account search costs. They do not assume that only the 'best' solution is acceptable. They may set a 'reservation price' where the marginal cost of further search equals marginal expected improvement over the best prospect seen so far (these models generally assume that previously seen options are still available).
Biologists tend to emphasize empirical testability of their models. They  are generally more aware of search and opportunity costs (moving from one place to the next takes time, during which no feeding takes place), and handling costs (how much energy has to be invested to subdue, handle, digest the prey). One popular model has been a 'reservation price' rule: by sampling the environment, the animal constructs an expectation of what might reasonably be expected. As soon as this value is reached, the reward (food, mate) is accepted. Simon (1990) calls this a 'satisficing' model. It is a form of 'bounded rationality', useful in situations where the entire set of possible options is not known.


HOW IT WORKS
------------
The graphics window is changed to show a racetrack, with Xcor between -50 and +50, for a total of 101 patches.
There are two turtles, a shuffler and a player. The shuffler has numbers from 1 to 100, which he randomly distributes on patches -49 to +50 (one number per patch).
The player moves forward, one patch at a time, and makes a list of all numbers he encounters. After a number of steps (can be modified by slider), he determines the highest values found so far (standard). He then continues to move forward until he finds a patch with a higher number,  or until he runs out of options (last patch). One of these values is the reward, which is placed in the rewards list. The process is repeated a number of times (set by cycles slider).
The program keeps track of 100s (number of times that the maximum is chosen), average (average payoff) and med (median of payoffs). It also keeps track of moves (number of steps; this combines the initial search steps and steps taken until a reward is accepted).


HOW TO USE IT
-------------
Setup: prepares the model for the first run (shuffler distributes 100 values; player at end of lane).
Go: initiates search behaviour
Steps: slider, how many patches are examined to set a standard
Cycles: slider, how many times does the playe run through the lane and decide on a reward
moves: how many moves does the player make before he accepts a reward. Dividing moves by cycles gives average moves per decision
hundreds: how many times has the top reward been found?
average: what is the average reward?
med: what is the median reward?
new-shuffle?: redistributes awards with each new cycle


THINGS TO NOTICE
----------------
Running averages, med and number of 100s shown.


THINGS TO TRY
-------------
Check  if the 37 rule is indeed true. Vary the number of steps and determine Average, Med, 100s.Try Behavior space to observe changes in Average, Med, 100s as a function of steps.


EXTENDING THE MODEL
-------------------
For a more realistic approach to optimal search strategies, quantify costs for search behavior and benefits for the reward. Differentiate between costs of simply inspecting a patch (initial phase) and exploiting a patch (in biology, this could include costs of overpowering a prey, eating and digesting the food).
If the model represents mate choice, modify it so that both mates have a choice.
How does the payoff (optimal choice) change if the player can choose previously encountered patches?
What if the energy level of player is limited, and your primary objective is to prevent starvation? Is the optimal strategy the same as the one that gives the highest average payoff?
Or, the primary objective can be to be reproductively as successful as possible (highest numbers of offspring per unit time, Darwinian fitness). It is always best to maximize life-span?
Food is usually distributed randomly. This could be simulated by using standard square arrangement of patches, and randomly distribute 100 patches with values of 1 to 100. Or, some of the numbers between 1 and 100 could be replaced by 0. What would the optimal search strategy be now?
Adding more players: this would introduce an element of competition.
Some patches might be provided with a very high return, but may also be dangerous (predators). Might it be more advantageous to avoid these high-yield patches? In Biology, the concept of 'enemy-free' space plays a large role when discussing optimal foraging.


NETLOGO FEATURES
----------------
The model is still preliminary; I'm not entirely convinced that all steps work as they should. I also think it can probably be simplified.


RELATED MODELS
--------------
Anything related to consumers, herbivores, predator-prey interactions


CREDITS AND REFERENCES
----------------------
References
Mosteller, F. (1965) Fifty challenging problems in probability with solutions. Dover, New York.

Simon, H.A. (1990) Invariants of human behaviour. Annual Review of Psychology 41, 1-19.

Todd, P.M. & Miller, G.F. (1999) From pride and prejudice to persuasion - satisficing in mate search. Pp. 287 - 308 in Gigerenzer, G., Todd, P.M. and the ABC Research Group (eds.), Simple heuristics that make us smart. Oxford University Press.


Acknowledgments
I benefitted greatly from attending the Workshop (Mesa State College &  CCL, July 2003, by Dr. Michael Gizzi and colleagues). I also received numerous tips from Seth Tisue and other members of the netlogo user group, for which I'm extremely grateful.
@#$#@#$#@
default
true
0
Polygon -7566196 true true 150 5 40 250 150 205 260 250

ant
true
0
Polygon -7566196 true true 136 61 129 46 144 30 119 45 124 60 114 82 97 37 132 10 93 36 111 84 127 105 172 105 189 84 208 35 171 11 202 35 204 37 186 82 177 60 180 44 159 32 170 44 165 60
Polygon -7566196 true true 150 95 135 103 139 117 125 149 137 180 135 196 150 204 166 195 161 180 174 150 158 116 164 102
Polygon -7566196 true true 149 186 128 197 114 232 134 270 149 282 166 270 185 232 171 195 149 186 149 186
Polygon -7566196 true true 225 66 230 107 159 122 161 127 234 111 236 106
Polygon -7566196 true true 78 58 99 116 139 123 137 128 95 119
Polygon -7566196 true true 48 103 90 147 129 147 130 151 86 151
Polygon -7566196 true true 65 224 92 171 134 160 135 164 95 175
Polygon -7566196 true true 235 222 210 170 163 162 161 166 208 174
Polygon -7566196 true true 249 107 211 147 168 147 168 150 213 150

arrow
true
0
Polygon -7566196 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

bee
true
0
Polygon -256 true false 152 149 77 163 67 195 67 211 74 234 85 252 100 264 116 276 134 286 151 300 167 285 182 278 206 260 220 242 226 218 226 195 222 166
Polygon -16777216 true false 150 149 128 151 114 151 98 145 80 122 80 103 81 83 95 67 117 58 141 54 151 53 177 55 195 66 207 82 211 94 211 116 204 139 189 149 171 152
Polygon -7566196 true true 151 54 119 59 96 60 81 50 78 39 87 25 103 18 115 23 121 13 150 1 180 14 189 23 197 17 210 19 222 30 222 44 212 57 192 58
Polygon -16777216 true false 70 185 74 171 223 172 224 186
Polygon -16777216 true false 67 211 71 226 224 226 225 211 67 211
Polygon -16777216 true false 91 257 106 269 195 269 211 255
Line -1 false 144 100 70 87
Line -1 false 70 87 45 87
Line -1 false 45 86 26 97
Line -1 false 26 96 22 115
Line -1 false 22 115 25 130
Line -1 false 26 131 37 141
Line -1 false 37 141 55 144
Line -1 false 55 143 143 101
Line -1 false 141 100 227 138
Line -1 false 227 138 241 137
Line -1 false 241 137 249 129
Line -1 false 249 129 254 110
Line -1 false 253 108 248 97
Line -1 false 249 95 235 82
Line -1 false 235 82 144 100

bird1
false
0
Polygon -7566196 true true 2 6 2 39 270 298 297 298 299 271 187 160 279 75 276 22 100 67 31 0

bird2
false
0
Polygon -7566196 true true 2 4 33 4 298 270 298 298 272 298 155 184 117 289 61 295 61 105 0 43

boat1
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6524078 true false 150 32 157 162
Polygon -16776961 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7566196 true true 158 33 230 157 182 150 169 151 157 156
Polygon -7566196 true true 149 55 88 143 103 139 111 136 117 139 126 145 130 147 139 147 146 146 149 55

boat2
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6524078 true false 150 32 157 162
Polygon -16776961 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7566196 true true 157 54 175 79 174 96 185 102 178 112 194 124 196 131 190 139 192 146 211 151 216 154 157 154
Polygon -7566196 true true 150 74 146 91 139 99 143 114 141 123 137 126 131 129 132 139 142 136 126 142 119 147 148 147

boat3
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6524078 true false 150 32 157 162
Polygon -16776961 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7566196 true true 158 37 172 45 188 59 202 79 217 109 220 130 218 147 204 156 158 156 161 142 170 123 170 102 169 88 165 62
Polygon -7566196 true true 149 66 142 78 139 96 141 111 146 139 148 147 110 147 113 131 118 106 126 71

box
true
0
Polygon -7566196 true true 45 255 255 255 255 45 45 45

butterfly1
true
0
Polygon -16777216 true false 151 76 138 91 138 284 150 296 162 286 162 91
Polygon -7566196 true true 164 106 184 79 205 61 236 48 259 53 279 86 287 119 289 158 278 177 256 182 164 181
Polygon -7566196 true true 136 110 119 82 110 71 85 61 59 48 36 56 17 88 6 115 2 147 15 178 134 178
Polygon -7566196 true true 46 181 28 227 50 255 77 273 112 283 135 274 135 180
Polygon -7566196 true true 165 185 254 184 272 224 255 251 236 267 191 283 164 276
Line -7566196 true 167 47 159 82
Line -7566196 true 136 47 145 81
Circle -7566196 true true 165 45 8
Circle -7566196 true true 134 45 6
Circle -7566196 true true 133 44 7
Circle -7566196 true true 133 43 8

circle
false
0
Circle -7566196 true true 35 35 230

person
false
0
Circle -7566196 true true 155 20 63
Rectangle -7566196 true true 158 79 217 164
Polygon -7566196 true true 158 81 110 129 131 143 158 109 165 110
Polygon -7566196 true true 216 83 267 123 248 143 215 107
Polygon -7566196 true true 167 163 145 234 183 234 183 163
Polygon -7566196 true true 195 163 195 233 227 233 206 159

sheep
false
15
Rectangle -1 true true 90 75 270 225
Circle -1 true true 15 75 150
Rectangle -16777216 true false 81 225 134 286
Rectangle -16777216 true false 180 225 238 285
Circle -16777216 true false 1 88 92

spacecraft
true
0
Polygon -7566196 true true 150 0 180 135 255 255 225 240 150 180 75 240 45 255 120 135

thin-arrow
true
0
Polygon -7566196 true true 150 0 0 150 120 150 120 293 180 293 180 150 300 150

truck-down
false
0
Polygon -7566196 true true 225 30 225 270 120 270 105 210 60 180 45 30 105 60 105 30
Polygon -8716033 true false 195 75 195 120 240 120 240 75
Polygon -8716033 true false 195 225 195 180 240 180 240 225

truck-left
false
0
Polygon -7566196 true true 120 135 225 135 225 210 75 210 75 165 105 165
Polygon -8716033 true false 90 210 105 225 120 210
Polygon -8716033 true false 180 210 195 225 210 210

truck-right
false
0
Polygon -7566196 true true 180 135 75 135 75 210 225 210 225 165 195 165
Polygon -8716033 true false 210 210 195 225 180 210
Polygon -8716033 true false 120 210 105 225 90 210

turtle
true
0
Polygon -7566196 true true 138 75 162 75 165 105 225 105 225 142 195 135 195 187 225 195 225 225 195 217 195 202 105 202 105 217 75 225 75 195 105 187 105 135 75 142 75 105 135 105

wolf
false
0
Rectangle -7566196 true true 15 105 105 165
Rectangle -7566196 true true 45 90 105 105
Polygon -7566196 true true 60 90 83 44 104 90
Polygon -16777216 true false 67 90 82 59 97 89
Rectangle -1 true false 48 93 59 105
Rectangle -16777216 true false 51 96 55 101
Rectangle -16777216 true false 0 121 15 135
Rectangle -16777216 true false 15 136 60 151
Polygon -1 true false 15 136 23 149 31 136
Polygon -1 true false 30 151 37 136 43 151
Rectangle -7566196 true true 105 120 263 195
Rectangle -7566196 true true 108 195 259 201
Rectangle -7566196 true true 114 201 252 210
Rectangle -7566196 true true 120 210 243 214
Rectangle -7566196 true true 115 114 255 120
Rectangle -7566196 true true 128 108 248 114
Rectangle -7566196 true true 150 105 225 108
Rectangle -7566196 true true 132 214 155 270
Rectangle -7566196 true true 110 260 132 270
Rectangle -7566196 true true 210 214 232 270
Rectangle -7566196 true true 189 260 210 270
Line -7566196 true 263 127 281 155
Line -7566196 true 281 155 281 192

wolf-left
false
3
Polygon -6524078 true true 117 97 91 74 66 74 60 85 36 85 38 92 44 97 62 97 81 117 84 134 92 147 109 152 136 144 174 144 174 103 143 103 134 97
Polygon -6524078 true true 87 80 79 55 76 79
Polygon -6524078 true true 81 75 70 58 73 82
Polygon -6524078 true true 99 131 76 152 76 163 96 182 104 182 109 173 102 167 99 173 87 159 104 140
Polygon -6524078 true true 107 138 107 186 98 190 99 196 112 196 115 190
Polygon -6524078 true true 116 140 114 189 105 137
Rectangle -6524078 true true 109 150 114 192
Rectangle -6524078 true true 111 143 116 191
Polygon -6524078 true true 168 106 184 98 205 98 218 115 218 137 186 164 196 176 195 194 178 195 178 183 188 183 169 164 173 144
Polygon -6524078 true true 207 140 200 163 206 175 207 192 193 189 192 177 198 176 185 150
Polygon -6524078 true true 214 134 203 168 192 148
Polygon -6524078 true true 204 151 203 176 193 148
Polygon -6524078 true true 207 103 221 98 236 101 243 115 243 128 256 142 239 143 233 133 225 115 214 114

wolf-right
false
3
Polygon -6524078 true true 170 127 200 93 231 93 237 103 262 103 261 113 253 119 231 119 215 143 213 160 208 173 189 187 169 190 154 190 126 180 106 171 72 171 73 126 122 126 144 123 159 123
Polygon -6524078 true true 201 99 214 69 215 99
Polygon -6524078 true true 207 98 223 71 220 101
Polygon -6524078 true true 184 172 189 234 203 238 203 246 187 247 180 239 171 180
Polygon -6524078 true true 197 174 204 220 218 224 219 234 201 232 195 225 179 179
Polygon -6524078 true true 78 167 95 187 95 208 79 220 92 234 98 235 100 249 81 246 76 241 61 212 65 195 52 170 45 150 44 128 55 121 69 121 81 135
Polygon -6524078 true true 48 143 58 141
Polygon -6524078 true true 46 136 68 137
Polygon -6524078 true true 45 129 35 142 37 159 53 192 47 210 62 238 80 237
Line -16777216 false 74 237 59 213
Line -16777216 false 59 213 59 212
Line -16777216 false 58 211 67 192
Polygon -6524078 true true 38 138 66 149
Polygon -6524078 true true 46 128 33 120 21 118 11 123 3 138 5 160 13 178 9 192 0 199 20 196 25 179 24 161 25 148 45 140
Polygon -6524078 true true 67 122 96 126 63 144

@#$#@#$#@
NetLogo 2.0beta5
@#$#@#$#@
setup go
@#$#@#$#@
@#$#@#$#@
