globals [ Mon     ; the initial motivation
          Mon+1   ; the next term in the time series
          Em      ; the strength of emotion as it varies 0 < Em <= 1 with time
          t       ; time
        ]

to run-plot
   ca
   set Mon 0.5
   set t 0
   repeat 115[                                 ; the strength of emotion as it varies with time
   ifelse t < 5[set Em 0.5][                   ;                    ditto
   ifelse t < 7[set Em 0.85][                  ;                    ditto
   ifelse t < 10[set Em 0.5][                  ;                    ditto
   ifelse t < 20[set Em Em + 0.0125][          ;                    ditto
   ifelse t < 30[set Em Em - 0.025][           ;                    ditto
   ifelse t < 35[set Em Em][                   ;                    ditto
   ifelse t < 60[set Em Em + 0.025][           ;                    ditto
   ifelse t < 80[set Em Em][                   ;                    ditto
   ifelse t < 97[set Em Em - 0.04][            ;                    ditto
   ifelse t < 105[set Em Em][                  ;                    ditto
   ifelse t < 110[set Em Em + 0.04][           ;                    ditto
   if t < 115[set Em Em]]]]]]]]]]]]            ; the strength of emotion as it varies with time
   set Mon+1 Em * 4 * Mon * (1 - Mon)          ; the expression to be iterated (Verhulst's model)
   set Mon Mon+1 set t t + 1                   ; the iteration, time steps
   plot-run                                    ; the plot
   wait 0.5]                                   ; to slow the display of the plot
end

to plot-run
   set-current-plot "Emotion X 4 & Motivation X 4"
   set-current-plot-pen "Emo"
   plot Em * 4                                 ; Emotion X 4 is plotted to enable relating values
   set-current-plot-pen "Motiv"                ; to Verhulst's model
   plot Mon+1 * 4                              ; Motivation X 4 is plotted to enable relating values
end                                            ; to Verhulst's model

;;The author Derek Rush may be contacted at:  <derekrush@beeb.net>      March 2005.










@#$#@#$#@
GRAPHICS-WINDOW
610
96
696
203
0
0
76.0
0
0
0
0
0
0

CC-WINDOW
5
461
770
556
Command Center

BUTTON
705
330
760
363
NIL
run-plot
NIL
1
T
OBSERVER
T
NIL

PLOT
7
10
761
267
Emotion X 4 & Motivation X 4
time
depression   motivation   mania
0.0
115.0
0.0
4.0
false
true
PENS
"Emo" 1.0 0 -65536 true
"Motiv" 1.0 1 -16777216 true

TEXTBOX
8
271
685
447
This is the final model in a series and follows SELF-AWARENESS and IMAGINATION. Emotion is multifarious but all are words that describe a condition that motivates the brain; and Emotion uses chemical messengers and neuronal links between body and brain to bring both to a state of readiness in response to an input to the brain. The plot above shows a typical human relationship between Emotion and Motivation. It depicts the immediate high level of motivation for a rapid instinctive survival condition. It shows motivation closely following gentle changes of emotion and a progressive separation as emotion increases greatly, leading eventually to large swings of motivation  between depression and mania, plus motivation lagging behind as emotion makes a rapid dive followed by recovery to quieter conditions. A self-organising living thing with feedbacks for regulation could show these characteristics. The plot was obtained with a SIMPLE, as befits nature, iterative procedure (Verhulst's model)*. This study is extended on the INFORMATION page to include PERCEPTION, PERCEPTS, MEMORIES, DISPLAY & COMMUNICATION and CONSCIOUSNESS; also the conclusion that a creature or human is what its brain makes it.                   *see Further Reading 12, and are mood swings phase transitions?

TEXTBOX
59
27
116
59
instinctive response

TEXTBOX
449
34
527
52
mood swings

TEXTBOX
18
10
215
28
Please hide the Command Center

@#$#@#$#@

EMOTION & MOTIVATION is the third and final model of a series that began with SELF-AWARENESS and continued with IMAGINATION.
     "Even insects express anger, terror, jealousy, and love by their stridulation."
        The Expression Of The Emotions In Man and Animals by Charles Darwin.1872
EMOTION
A brain is subject to the long term changes of evolution and the lottery of conception, also it grows, learns responses and is reconfigured many times during its lifetime. Life is essentially a copying process in which evolution, the optimistic empiricist, proceeds by copying whatever survives. This includes instinctive reponses to enable a
creature's survival. Part of a response is the setting of the emotional condition of a creature and thereby its MOTIVATION. Similarly and most importantly, a ceature's brain records emotional data in learned responses and memories throughout life.
Emotion is multifarious with Anger, Fear, Sadness and Enjoyment, considered as primary
and frustration, elation, guilt, jealousy, excitement, confusion, nervousness, hatred, distress, envy, affection, sympathy, joy, infatuation, resentment, generosity, pride, anxiousness and many more variations or mixtures of the primaries; but all are words that describe a condition leading to a degree of arousal, the motivation of the brain. A creature's body and brain are interdependent with communication by neuronal links and chemical messengers. Emotion uses messengers to bring the body's heartbeat, muscles and breathing, also the brain's cells and sensors, to a readiness for whatever response, including physical action, display and communication is likely to be required. This state of readiness produces the emotional 'feelings' in the body; and only a few messengers, in combination, are required to cover the range of emotions.

PERCEPTION
Apart from body maintenance some of the inputs to a brain are: body motion, impacts
and pain, plus sights, sounds, smells, and tastes. Automatically, inputs are first compared with instinctive response templets in case a survival type rapid response is required and if not responses will be arrived at by comparing inputs with memories plus some degree of processing. To compare requires a brain to have the ability to PERCEIVE the salient characteristics at least of the information presented and this fundamental ability is shown by creatures known not to possess the processing capability of humans. It can be that PERCEPTION in all creatures works with less than perfect representations not unlike the memories of human experience. It may be further concluded that MEMORIES are stored PERCEPTS and thinking by a human brain is a process similar to the ability shown by other creatures but extended in scale and content by additional processing power. If PERCEPTION enables a human brain's thinking process, then thoughts are a "desktop" of PERCEPTS, a muted rehearsal for what might be an action, whilst EMOTION data stored with the PERCEPTS sets the MOTIVATION for the thinking and the action if any. Also a brain does not need inputs from outside or inside the body to motivate thinking, if not in coma, it will be sufficiently stimulated by urges. Day or night dreaming are examples, from many.
                                                                                        DISPLAY & COMMUNICATION
Creatures evolved with urges that assist survival and these include DISPLAY and COMMUNICATION. Instinctive responses often include emotional DISPLAY by a creature, audible as well as visible, both being very useful in courting and conflict. Also it makes possible deliberate COMMUNICATION a distinguishing sign of self-awareness and a necessity for the practice of family, group and community life. Human beings have the physiology for spoken language plus the manipulative skills for writing which through shared human knowledge have extended their abilities far beyond the apparent potential of their brain's processing power.
                                                                                        CONSCIOUSNESS & 'I'
Philosophers and others have debated human 'consciousness' and sought a location for the human I. Some of their conjectures placed the seat of 'consciousness' and the location of I away from the brain in a mind that had no physical form. However, this model and analysis of human experience suggests that consciousness is the brain perceiving whatever is being sensed, recalled or processed, and is or could be acted upon or communicated about the emotion that is motivating the brain; and 'feel' of a conscious experince results from the brain and body state produced by the messengers of emotion. It is common experience that humans are not always conscious of their brain's perceptions, decision taking and action initiation, the quick response required for survival responses is an example; also tests with humans are reported as showing that electrical activity in a brains physical action area can begin 1/4 second before the person is aware of their intention to act.

This leads to the conclusions, that environment and fortune aside A CREATURE OR HUMAN IS WHAT ITS BRAIN MAKES IT; there is NO SEPARATE MYSTERIOUS MIND, NOR AN 'I', AND CONSCIOUSNESS IS THE BRAIN'S PERCEPTION OF ITS MOTIVATION.

FURTHER READING        (The two previous NetLogo Models in this series were entitled SELF-AWARENESS and IMAGINATION)
FR. 1 The Expression Of The Emotions In Man and Animals by Charles Darwin.1872.
      (The quotation given above is from Chapter 14, Concluding Remarks and Summary.)
FR. 2 The Living Brain by W.Grey Walter. Duckworth, London, 1953.
FR. 3 Mapping The Mind by Rita Carter. Weidenfeld & Nicolson, London, 1998.
FR. 4 Emotional Intelligence, Daniel Goleman. Bloomsbury Publishing, London, 1996.
FR. 5 The Emotional Brain, Joseph LeDoux. Simon and Schuster, New York, 1998.
FR. 6 Phantoms In The Brain-Human Nature And The Architecture Of The Mind by V.S.             Ramachandran and Sandra Blakeslee. Fourth Estate, London 1998.
FR. 7 The Human Computer by Mark Jeffery. Little, Brown and Company, London, 1999.
FR. 8 Conciousness-How Matter Becomes Imagination by Gerald M. Edelman and G.Tononi.
      Penguin London, 2000.(In the USA as A Universe of Conciousness. Perseus.)
FR. 9 How The Mind Works by Steven Pinker. Penguin, London.
                                             (Also in the USA, W.W.Norton 1997)
FR.10 An Anatomy of Thought, The origin and machinery of the mind by Ian Glynn.                                                       Weidenfeld & Nicolson, London, 1999.
FR.11 The Private Life Of The Brain by Susan Greenfield. Penguin, 2000.
FR.12 For information on Verhulst's model.FRACTALS Images of Chaos, by Hans Lauwerier.                                                Penguin & Princeton Univ'Press 1991.

The author Derek Rush may be contacted at:  <derekrush@beeb.net>      March 2005.
























@#$#@#$#@
default
true
0
Polygon -7566196 true true 150 5 40 250 150 205 260 250

ant
true
0
Polygon -7566196 true true 136 61 129 46 144 30 119 45 124 60 114 82 97 37 132 10 93 36 111 84 127 105 172 105 189 84 208 35 171 11 202 35 204 37 186 82 177 60 180 44 159 32 170 44 165 60
Polygon -7566196 true true 150 95 135 103 139 117 125 149 137 180 135 196 150 204 166 195 161 180 174 150 158 116 164 102
Polygon -7566196 true true 149 186 128 197 114 232 134 270 149 282 166 270 185 232 171 195 149 186
Polygon -7566196 true true 225 66 230 107 159 122 161 127 234 111 236 106
Polygon -7566196 true true 78 58 99 116 139 123 137 128 95 119
Polygon -7566196 true true 48 103 90 147 129 147 130 151 86 151
Polygon -7566196 true true 65 224 92 171 134 160 135 164 95 175
Polygon -7566196 true true 235 222 210 170 163 162 161 166 208 174
Polygon -7566196 true true 249 107 211 147 168 147 168 150 213 150

arrow
true
0
Polygon -7566196 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

bee
true
0
Polygon -256 true false 151 152 137 77 105 67 89 67 66 74 48 85 36 100 24 116 14 134 0 151 15 167 22 182 40 206 58 220 82 226 105 226 134 222
Polygon -16777216 true false 151 150 149 128 149 114 155 98 178 80 197 80 217 81 233 95 242 117 246 141 247 151 245 177 234 195 218 207 206 211 184 211 161 204 151 189 148 171
Polygon -7566196 true true 246 151 241 119 240 96 250 81 261 78 275 87 282 103 277 115 287 121 299 150 286 180 277 189 283 197 281 210 270 222 256 222 243 212 242 192
Polygon -16777216 true false 115 70 129 74 128 223 114 224
Polygon -16777216 true false 89 67 74 71 74 224 89 225 89 67
Polygon -16777216 true false 43 91 31 106 31 195 45 211
Line -1 false 200 144 213 70
Line -1 false 213 70 213 45
Line -1 false 214 45 203 26
Line -1 false 204 26 185 22
Line -1 false 185 22 170 25
Line -1 false 169 26 159 37
Line -1 false 159 37 156 55
Line -1 false 157 55 199 143
Line -1 false 200 141 162 227
Line -1 false 162 227 163 241
Line -1 false 163 241 171 249
Line -1 false 171 249 190 254
Line -1 false 192 253 203 248
Line -1 false 205 249 218 235
Line -1 false 218 235 200 144

bird1
false
0
Polygon -7566196 true true 2 6 2 39 270 298 297 298 299 271 187 160 279 75 276 22 100 67 31 0

bird2
false
0
Polygon -7566196 true true 2 4 33 4 298 270 298 298 272 298 155 184 117 289 61 295 61 105 0 43

boat1
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6524078 true false 150 32 157 162
Polygon -16776961 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7566196 true true 158 33 230 157 182 150 169 151 157 156
Polygon -7566196 true true 149 55 88 143 103 139 111 136 117 139 126 145 130 147 139 147 146 146 149 55

boat2
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6524078 true false 150 32 157 162
Polygon -16776961 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7566196 true true 157 54 175 79 174 96 185 102 178 112 194 124 196 131 190 139 192 146 211 151 216 154 157 154
Polygon -7566196 true true 150 74 146 91 139 99 143 114 141 123 137 126 131 129 132 139 142 136 126 142 119 147 148 147

boat3
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6524078 true false 150 32 157 162
Polygon -16776961 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7566196 true true 158 37 172 45 188 59 202 79 217 109 220 130 218 147 204 156 158 156 161 142 170 123 170 102 169 88 165 62
Polygon -7566196 true true 149 66 142 78 139 96 141 111 146 139 148 147 110 147 113 131 118 106 126 71

box
true
0
Polygon -7566196 true true 45 255 255 255 255 45 45 45

butterfly1
true
0
Polygon -16777216 true false 151 76 138 91 138 284 150 296 162 286 162 91
Polygon -7566196 true true 164 106 184 79 205 61 236 48 259 53 279 86 287 119 289 158 278 177 256 182 164 181
Polygon -7566196 true true 136 110 119 82 110 71 85 61 59 48 36 56 17 88 6 115 2 147 15 178 134 178
Polygon -7566196 true true 46 181 28 227 50 255 77 273 112 283 135 274 135 180
Polygon -7566196 true true 165 185 254 184 272 224 255 251 236 267 191 283 164 276
Line -7566196 true 167 47 159 82
Line -7566196 true 136 47 145 81
Circle -7566196 true true 165 45 8
Circle -7566196 true true 134 45 6
Circle -7566196 true true 133 44 7
Circle -7566196 true true 133 43 8

circle
false
0
Circle -7566196 true true 34 34 230

person
false
0
Circle -7566196 true true 155 20 63
Rectangle -7566196 true true 158 79 217 164
Polygon -7566196 true true 158 81 110 129 131 143 158 109 165 110
Polygon -7566196 true true 216 83 267 123 248 143 215 107
Polygon -7566196 true true 167 163 145 234 183 234 183 163
Polygon -7566196 true true 195 163 195 233 227 233 206 159

spacecraft
true
0
Polygon -7566196 true true 150 0 180 135 255 255 225 240 150 180 75 240 45 255 120 135

thin-arrow
true
0
Polygon -7566196 true true 150 0 0 150 120 150 120 293 180 293 180 150 300 150

truck-down
false
0
Polygon -7566196 true true 225 30 225 270 120 270 105 210 60 180 45 30 105 60 105 30
Polygon -8716033 true false 195 75 195 120 240 120 240 75
Polygon -8716033 true false 195 225 195 180 240 180 240 225

truck-left
false
0
Polygon -7566196 true true 120 135 225 135 225 210 75 210 75 165 105 165
Polygon -8716033 true false 90 210 105 225 120 210
Polygon -8716033 true false 180 210 195 225 210 210

truck-right
false
0
Polygon -7566196 true true 180 135 75 135 75 210 225 210 225 165 195 165
Polygon -8716033 true false 210 210 195 225 180 210
Polygon -8716033 true false 120 210 105 225 90 210

turtle
true
0
Polygon -7566196 true true 138 75 162 75 165 105 225 105 225 142 195 135 195 187 225 195 225 225 195 217 195 202 105 202 105 217 75 225 75 195 105 187 105 135 75 142 75 105 135 105

wolf-left
false
3
Polygon -6524078 true true 117 97 91 74 66 74 60 85 36 85 38 92 44 97 62 97 81 117 84 134 92 147 109 152 136 144 174 144 174 103 143 103 134 97
Polygon -6524078 true true 87 80 79 55 76 79
Polygon -6524078 true true 81 75 70 58 73 82
Polygon -6524078 true true 99 131 76 152 76 163 96 182 104 182 109 173 102 167 99 173 87 159 104 140
Polygon -6524078 true true 107 138 107 186 98 190 99 196 112 196 115 190
Polygon -6524078 true true 116 140 114 189 105 137
Rectangle -6524078 true true 109 150 114 192
Rectangle -6524078 true true 111 143 116 191
Polygon -6524078 true true 168 106 184 98 205 98 218 115 218 137 186 164 196 176 195 194 178 195 178 183 188 183 169 164 173 144
Polygon -6524078 true true 207 140 200 163 206 175 207 192 193 189 192 177 198 176 185 150
Polygon -6524078 true true 214 134 203 168 192 148
Polygon -6524078 true true 204 151 203 176 193 148
Polygon -6524078 true true 207 103 221 98 236 101 243 115 243 128 256 142 239 143 233 133 225 115 214 114

wolf-right
false
3
Polygon -6524078 true true 170 127 200 93 231 93 237 103 262 103 261 113 253 119 231 119 215 143 213 160 208 173 189 187 169 190 154 190 126 180 106 171 72 171 73 126 122 126 144 123 159 123
Polygon -6524078 true true 201 99 214 69 215 99
Polygon -6524078 true true 207 98 223 71 220 101
Polygon -6524078 true true 184 172 189 234 203 238 203 246 187 247 180 239 171 180
Polygon -6524078 true true 197 174 204 220 218 224 219 234 201 232 195 225 179 179
Polygon -6524078 true true 78 167 95 187 95 208 79 220 92 234 98 235 100 249 81 246 76 241 61 212 65 195 52 170 45 150 44 128 55 121 69 121 81 135
Polygon -6524078 true true 48 143 58 141
Polygon -6524078 true true 46 136 68 137
Polygon -6524078 true true 45 129 35 142 37 159 53 192 47 210 62 238 80 237
Line -16777216 false 74 237 59 213
Line -16777216 false 59 213 59 212
Line -16777216 false 58 211 67 192
Polygon -6524078 true true 38 138 66 149
Polygon -6524078 true true 46 128 33 120 21 118 11 123 3 138 5 160 13 178 9 192 0 199 20 196 25 179 24 161 25 148 45 140
Polygon -6524078 true true 67 122 96 126 63 144

@#$#@#$#@
NetLogo 2.1.0
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
