;;IMAGINATION

globals [iteration]
turtles-own [stick bore thick]

to text-1
   crt 1
   ask turtles [setxy 133 90 plc set plabel
   "IMAGINATION can surprise human beings with IDEAS or CREATIONS both unexpected and apparently from nowhere."]
   ask turtles [setxy 140 84 plc set plabel
   "The model shows memories of two computer drawn trees, recalled, associated and modelled here. These gave the author"]
   ask turtles [setxy 143 78 plc set plabel
   "a strong desire to create a more solid looking tree which was satisfied when IMAGINATION showed how this could be done."]
    ask turtles [setxy 2 72 plc set plabel
   "But it was 'a strong desire', EMOTION, that was the motivation."]
end

to text-2
   crt 1
   ask turtles [setxy 29 -9 plc set plabel
   "Memories recalled and associated to produce a procedure for a sticks tree."]
end

to text-3
   crt 1
   ask turtles [setxy 28 -9 plc set plabel
   "Memories recalled and associated to produce a procedure for a tubes tree"]
end

to text-4
   ask turtles [setxy -31 60 plc set plabel
   "How to model a solid limb was suggested by this"]
   ask turtles [setxy -23 42 plc set plabel
   "using these memories, presented by IMAGINATION."]
end

to text-5
   ask turtles [setxy 30 -9 plc set plabel
   "Memories recalled and associated to produce a procedure for a limbs tree."]
end

to text-6
   ask turtles [setxy 54 -24 plc set plabel
   "NOW THAT'S A TREE! This modelling took several sittings, so there was time for the"]
   ask turtles [setxy 63 -30 plc set plabel
   "imagination searches to take place unperceived and then to be arranged and presented."]
   ask turtles [setxy 54 -36 plc set plabel
   "Imagination showed a memory of painting surfaces with long brush strokes and this it"]
   ask turtles [setxy 44 -42 plc set plabel
   "associated with a turtles pen leaving a trace; also it found a memory of making a"]
   ask turtles [setxy 17 -48 plc set plabel
   "picket fence and this it associated with the procedure for a sticks tree."]
   ask turtles [setxy 49 -54 plc set plabel
   "Later these recalled memories contributed to a perceived animation similar to that"]
   ask turtles [setxy 33 -60 plc set plabel
   "reproduced above and from which the procedure for limbs tree was derived."];
   ask turtles [setxy 135 -72 plc set plabel
   "A brain may be CREATIVE by being active in rearranging the inputs it has received during life, also by communicating"]
   ask turtles [setxy 132 -76 plc set plabel
   "and thereby obtaining new inputs. But what motivates this activity?.......It is emotion and that deserves another model."]
end

to plc
   ht set plabel-color 9.999                    ; sets text color
end

to go
   ca
   text-1 wait 15
   memory-m0 memory-m1 memory-m2 memory-m3 text-2 recall-m2 recall-m3
   setup-sticks step-sticks wait 5 ca text-1
   memory-m0 memory-m1 memory-m2 memory-m3 text-3 recall-m1 recall-m0 recall-m3
   setup-tubes step-tubes wait 5 ca text-1 text-4 wait 5
   repeat 2 [memory-m0 flash-m0] slow-limb wait 5 text-5
   memory-m1 memory-m2 memory-m3 recall-m0 recall-m3 recall-m1 recall-m2
   setup-limbs step-limbs text-6
end

to memory-m0
   ask turtle 0[ht ifelse (random-int-or-float 2 = 1)[set color 3][set color 8] set ycor 57 code-m]
end

to memory-m1
   crt 1
   ask turtle 1[ht ifelse (random-int-or-float 2 = 1)[set color 3][set color 8] set ycor 40 code-m]
end

to memory-m2
   crt 1
   ask turtle 2[ht ifelse (random-int-or-float 2 = 1)[set color 3][set color 8] set ycor 23 code-m]
end

to memory-m3
   crt 1
   ask turtle 3[ht ifelse (random-int-or-float 2 = 1)[set color 3][set color 8] set ycor 6 code-m]
end

to code-m
   ht set heading 360 bk 4 rt 90 set xcor -145 repeat 2 [
   repeat 30 [fd 3 ifelse (random-int-or-float 5 > 2) [pd] [pu] fd 1 wait 0.05 pu]
   bk 120 lt 90 bk 4 rt 90]
end

to flash-m0
   ask patches with [pycor < 57 and pycor > 40 and pcolor > 2][
   set pcolor 9 wait 1 set pcolor 2 wait 1 set pcolor 9 wait 1]
end

to lightup
   set pcolor 9 ask patches at-points [[1 0] [0 1] [-1 0] [0 -1]][
   set pcolor 9 wait 2 set pcolor 2 wait 2 set pcolor 9]
end

to recall-m0
   ask patches with [pycor < 57 and pycor > 40 and pcolor > 2][
   repeat 2 [lightup]]
end

to recall-m1
   ask patches with [pycor < 40 and pycor > 23 and pcolor > 2][
   repeat 2 [lightup]]
end

to recall-m2
   ask patches with [pycor < 23 and pycor > 6 and pcolor > 2][
   repeat 2 [lightup]]
end

to recall-m3
   ask patches with [pycor < 6 and pycor > -11 and pcolor > 2][
   repeat 2 [lightup]]
end

to setup-sticks                                 ; draws a stick trunk
   crt 1
   ask turtles
   [
   set heading 360
   setxy 60 -50
   set stick 40
   pd hue fd stick
   ]
   set iteration 1
end

to hue                                          ; colours the sticks, tubes, limbs and leaves
   ifelse (iteration > 6)[set color 53 + (10 * random-int-or-float 3) ][set color 33]
end

to step-sticks                                  ; draws stick branches, twigs and leaves
   if (iteration = 10)[stop]
   repeat 10[
   ask turtles
   [
   stick-less
   hatch 1 [lt 30 hue fd stick]                 ; bifurcates to two shorter sticks
   pu rt 60 pd hue fd stick                     ; and will lean right
   ]wait 1
   set iteration iteration + 1]
end

to stick-less
   set stick stick / sqrt 2                     ;reduces stick length
end

to setup-tubes                                  ; draws a tube trunk
   crt 1
   ask turtles
   [
   set heading 360
   setxy 54 -55
   set stick 40
   set bore 10
   tube
   ]
   set iteration 1

end

to tube                                         ; draws a tube of length stick and bore bore
   repeat 2
   [
   pd hue fd stick pu rt 90 fd bore rt 90 fd 1
   ]
   fd stick
end

to step-tubes                                   ; draws tube branches, twigs and leaves
   if (iteration = 10)[stop]
   repeat 10[
   ask turtles
   [
   stick-less
   bore-less
   hatch 1 [lt 30 tube]                         ; bifurcates to two shorter, thinner tubes
   pu rt 60 fd bore tube                        ; and will lean right
   ]wait 1
   set iteration iteration + 1]
end

to bore-less
   set bore bore / sqrt 2                       ; reduces bore size
end

to slow-limb                                    ; illustrates the "solid" limb procedure slowly
   ask turtles
   [
   setxy -27 58
   set heading 360
   set color 34
   repeat 6 [flash-m0 pd fd 10 rt 90 fd 1 lt 90 pu bk 10 wait 1]
   fd 1 pu
   ]
end

to setup-limbs                                  ; draws a "solid" trunk
   crt 1
   ask turtles
   [
   set heading 360
   setxy 64 -50
   set stick 40
   set thick 10
   limb
   ]
   set iteration 1
end

to limb                                         ; makes a "solid" limb of a number(thick) of sticks
   repeat (thick)
   [pd hue fd stick rt 90 fd 1 lt 90 pu bk stick]
   fd stick lt 90 fd (10 - iteration) rt 90
end

to step-limbs                                   ; draws "solid" branches, twigs and leaves
   if (iteration = 10)[stop]
   repeat 10[
   ask turtles
   [
   thick-less
   stick-less
   hatch 1 [lt 30 limb]                         ; bifurcates to two shorter, thinner limbs
   rt 60 limb                                   ; one shorter than other and will lean right
   ]wait 1
   set iteration iteration + 1]
end

to thick-less                                   ; reduces limb thickness
   set thick thick - 1
end













@#$#@#$#@
GRAPHICS-WINDOW
179
10
791
443
150
100
2.0
0
10
1
1
1

CC-WINDOW
6
383
168
444
Command Center

BUTTON
44
106
122
139
NIL
clear-all
NIL
1
T
OBSERVER
T

BUTTON
44
54
122
87
run
go
NIL
1
T
OBSERVER
T

@#$#@#$#@

IMAGINATION is the second model of a series that began with SELF-AWARENESS.

IMAGINATION can surprise human beings with IDEAS or CREATIONS both unexpected and apparently from nowhere.
This model illustrates the process of imagination by relating, with some animation, the events experienced
by the author in making the procedure for a model to show trees in NetLogo.

For this activity a brain uses memories that have associations with the current subject and it finds
recently ignored or long forgotten associations; also a conscious brain does not perceive the detailed operations of all of its processes, hence an element of surprise, but more surprise comes from new and unexpected material, which can arrive when a motivating emotion is strong.
For the modelling being described the outlines of computer generated trees had already been seen in FR 3
but that computer modelling programme was not NetLogo. Most of the work required little if any imagination
and used only recent memories, some faint some strong, with expected associations; but the desire to
produce something more aesthetically pleasing became really strong after a 'sticks tree' and a 'tubes tree' were completed.

At this point imagination took over, motivated by emotion from the desire to make something more pleasing.
The modelling took several sittings, so there was time for the imagination searches to take place
unperceived and the results to be subject to at least the processing involved in associating memories. Imagination showed a memory of painting surfaces with long brush strokes and this it associated with a
turtle's pen leaving a trace; also it found a memory of making a picket fence and this it associated with
the procedure for a sticks tree. Later these recalled memories contributed to a perceived animation
similar to that reproduced in this model and from which the procedure for limbs tree was derived.

A brain may be creative by being active in rearranging the inputs it has received during life, also by communicating and thereby obtaining new inputs, (see FR 5).But what motivates this activity?.......It is emotion. Emotion is the accelerator pedal of a brain, for survival it has to be; also it must be able to override other activity decisions, hence in a brain it is the nearest thing to a homunculus (see FR 5).
A brain is part of a living thing and living things have the characteristics of a self-organising system
with feedbacks providing regulation; but this can generate oscillations or chaos, (see FR 2 & 6), thereby adding the unexpected which is good for ideas, creativity and surprising predators, (see FR 2 p.95).
Since emotion is involved in controlling actions within a brain it is possible that extreme emotion can
result in oscillation or chaos; but emotion is a big subject that deserves a separate model.

FURTHER READING
FR. 1 The Human Computer by Mark Jeffery. Little, Brown and Company, London, 1999. ISBN 0 7515 2847 1
FR. 2 The New Scientist Guide To Chaos, edited by Nina Hall, Penguin Books, 1991.
FR. 3 Fractals by Hans Lauwerier, published by Princeton University Press.
FR. 4 Mapping The Mind by Rita Carter. Weidenfeld & Nicolson, London, 1998. ISBN 0 297 62330 2
FR. 5 NetLogo Model SELF-AWARENESS
FR. 6 NetLogo Model POPEQ

The Author Derek Rush may be contacted by Email at derekrush@beeb.net.    February 2003.


































@#$#@#$#@
default
true
0
Polygon -7566196 true true 150 5 40 250 150 205 260 250

ant
true
0
Polygon -7566196 true true 136 61 129 46 144 30 119 45 124 60 114 82 97 37 132 10 93 36 111 84 127 105 172 105 189 84 208 35 171 11 202 35 204 37 186 82 177 60 180 44 159 32 170 44 165 60
Polygon -7566196 true true 150 95 135 103 139 117 125 149 137 180 135 196 150 204 166 195 161 180 174 150 158 116 164 102
Polygon -7566196 true true 149 186 128 197 114 232 134 270 149 282 166 270 185 232 171 195 149 186 149 186
Polygon -7566196 true true 225 66 230 107 159 122 161 127 234 111 236 106
Polygon -7566196 true true 78 58 99 116 139 123 137 128 95 119
Polygon -7566196 true true 48 103 90 147 129 147 130 151 86 151
Polygon -7566196 true true 65 224 92 171 134 160 135 164 95 175
Polygon -7566196 true true 235 222 210 170 163 162 161 166 208 174
Polygon -7566196 true true 249 107 211 147 168 147 168 150 213 150

arrow
true
0
Polygon -7566196 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

bee
true
0
Polygon -256 true false 152 149 77 163 67 195 67 211 74 234 85 252 100 264 116 276 134 286 151 300 167 285 182 278 206 260 220 242 226 218 226 195 222 166
Polygon -16777216 true false 150 149 128 151 114 151 98 145 80 122 80 103 81 83 95 67 117 58 141 54 151 53 177 55 195 66 207 82 211 94 211 116 204 139 189 149 171 152
Polygon -7566196 true true 151 54 119 59 96 60 81 50 78 39 87 25 103 18 115 23 121 13 150 1 180 14 189 23 197 17 210 19 222 30 222 44 212 57 192 58
Polygon -16777216 true false 70 185 74 171 223 172 224 186
Polygon -16777216 true false 67 211 71 226 224 226 225 211 67 211
Polygon -16777216 true false 91 257 106 269 195 269 211 255
Line -1 false 144 100 70 87
Line -1 false 70 87 45 87
Line -1 false 45 86 26 97
Line -1 false 26 96 22 115
Line -1 false 22 115 25 130
Line -1 false 26 131 37 141
Line -1 false 37 141 55 144
Line -1 false 55 143 143 101
Line -1 false 141 100 227 138
Line -1 false 227 138 241 137
Line -1 false 241 137 249 129
Line -1 false 249 129 254 110
Line -1 false 253 108 248 97
Line -1 false 249 95 235 82
Line -1 false 235 82 144 100

bird1
false
0
Polygon -7566196 true true 2 6 2 39 270 298 297 298 299 271 187 160 279 75 276 22 100 67 31 0

bird2
false
0
Polygon -7566196 true true 2 4 33 4 298 270 298 298 272 298 155 184 117 289 61 295 61 105 0 43

boat1
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6524078 true false 150 32 157 162
Polygon -16776961 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7566196 true true 158 33 230 157 182 150 169 151 157 156
Polygon -7566196 true true 149 55 88 143 103 139 111 136 117 139 126 145 130 147 139 147 146 146 149 55

boat2
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6524078 true false 150 32 157 162
Polygon -16776961 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7566196 true true 157 54 175 79 174 96 185 102 178 112 194 124 196 131 190 139 192 146 211 151 216 154 157 154
Polygon -7566196 true true 150 74 146 91 139 99 143 114 141 123 137 126 131 129 132 139 142 136 126 142 119 147 148 147

boat3
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6524078 true false 150 32 157 162
Polygon -16776961 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7566196 true true 158 37 172 45 188 59 202 79 217 109 220 130 218 147 204 156 158 156 161 142 170 123 170 102 169 88 165 62
Polygon -7566196 true true 149 66 142 78 139 96 141 111 146 139 148 147 110 147 113 131 118 106 126 71

box
true
0
Polygon -7566196 true true 45 255 255 255 255 45 45 45

butterfly1
true
0
Polygon -16777216 true false 151 76 138 91 138 284 150 296 162 286 162 91
Polygon -7566196 true true 164 106 184 79 205 61 236 48 259 53 279 86 287 119 289 158 278 177 256 182 164 181
Polygon -7566196 true true 136 110 119 82 110 71 85 61 59 48 36 56 17 88 6 115 2 147 15 178 134 178
Polygon -7566196 true true 46 181 28 227 50 255 77 273 112 283 135 274 135 180
Polygon -7566196 true true 165 185 254 184 272 224 255 251 236 267 191 283 164 276
Line -7566196 true 167 47 159 82
Line -7566196 true 136 47 145 81
Circle -7566196 true true 165 45 8
Circle -7566196 true true 134 45 6
Circle -7566196 true true 133 44 7
Circle -7566196 true true 133 43 8

circle
false
0
Circle -7566196 true true 35 35 230

person
false
0
Circle -7566196 true true 155 20 63
Rectangle -7566196 true true 158 79 217 164
Polygon -7566196 true true 158 81 110 129 131 143 158 109 165 110
Polygon -7566196 true true 216 83 267 123 248 143 215 107
Polygon -7566196 true true 167 163 145 234 183 234 183 163
Polygon -7566196 true true 195 163 195 233 227 233 206 159

spacecraft
true
0
Polygon -7566196 true true 150 0 180 135 255 255 225 240 150 180 75 240 45 255 120 135

thin-arrow
true
0
Polygon -7566196 true true 150 0 0 150 120 150 120 293 180 293 180 150 300 150

truck-down
false
0
Polygon -7566196 true true 225 30 225 270 120 270 105 210 60 180 45 30 105 60 105 30
Polygon -8716033 true false 195 75 195 120 240 120 240 75
Polygon -8716033 true false 195 225 195 180 240 180 240 225

truck-left
false
0
Polygon -7566196 true true 120 135 225 135 225 210 75 210 75 165 105 165
Polygon -8716033 true false 90 210 105 225 120 210
Polygon -8716033 true false 180 210 195 225 210 210

truck-right
false
0
Polygon -7566196 true true 180 135 75 135 75 210 225 210 225 165 195 165
Polygon -8716033 true false 210 210 195 225 180 210
Polygon -8716033 true false 120 210 105 225 90 210

turtle
true
0
Polygon -7566196 true true 138 75 162 75 165 105 225 105 225 142 195 135 195 187 225 195 225 225 195 217 195 202 105 202 105 217 75 225 75 195 105 187 105 135 75 142 75 105 135 105

wolf-left
false
3
Polygon -6524078 true true 117 97 91 74 66 74 60 85 36 85 38 92 44 97 62 97 81 117 84 134 92 147 109 152 136 144 174 144 174 103 143 103 134 97
Polygon -6524078 true true 87 80 79 55 76 79
Polygon -6524078 true true 81 75 70 58 73 82
Polygon -6524078 true true 99 131 76 152 76 163 96 182 104 182 109 173 102 167 99 173 87 159 104 140
Polygon -6524078 true true 107 138 107 186 98 190 99 196 112 196 115 190
Polygon -6524078 true true 116 140 114 189 105 137
Rectangle -6524078 true true 109 150 114 192
Rectangle -6524078 true true 111 143 116 191
Polygon -6524078 true true 168 106 184 98 205 98 218 115 218 137 186 164 196 176 195 194 178 195 178 183 188 183 169 164 173 144
Polygon -6524078 true true 207 140 200 163 206 175 207 192 193 189 192 177 198 176 185 150
Polygon -6524078 true true 214 134 203 168 192 148
Polygon -6524078 true true 204 151 203 176 193 148
Polygon -6524078 true true 207 103 221 98 236 101 243 115 243 128 256 142 239 143 233 133 225 115 214 114

wolf-right
false
3
Polygon -6524078 true true 170 127 200 93 231 93 237 103 262 103 261 113 253 119 231 119 215 143 213 160 208 173 189 187 169 190 154 190 126 180 106 171 72 171 73 126 122 126 144 123 159 123
Polygon -6524078 true true 201 99 214 69 215 99
Polygon -6524078 true true 207 98 223 71 220 101
Polygon -6524078 true true 184 172 189 234 203 238 203 246 187 247 180 239 171 180
Polygon -6524078 true true 197 174 204 220 218 224 219 234 201 232 195 225 179 179
Polygon -6524078 true true 78 167 95 187 95 208 79 220 92 234 98 235 100 249 81 246 76 241 61 212 65 195 52 170 45 150 44 128 55 121 69 121 81 135
Polygon -6524078 true true 48 143 58 141
Polygon -6524078 true true 46 136 68 137
Polygon -6524078 true true 45 129 35 142 37 159 53 192 47 210 62 238 80 237
Line -16777216 false 74 237 59 213
Line -16777216 false 59 213 59 212
Line -16777216 false 58 211 67 192
Polygon -6524078 true true 38 138 66 149
Polygon -6524078 true true 46 128 33 120 21 118 11 123 3 138 5 160 13 178 9 192 0 199 20 196 25 179 24 161 25 148 45 140
Polygon -6524078 true true 67 122 96 126 63 144

@#$#@#$#@
NetLogo 2.0beta5
@#$#@#$#@
text-1 setup-sticks setup-tubes setup-limbs
@#$#@#$#@
@#$#@#$#@
