; OPTIMISM AISB2
; Annerieke Heuvelink, Daniel Nettle, and Dylan Evans, 11 March 2003

breeds [
        emotional
        optimistic
        rational
       ]

patches-own [
             p
             cost
             benefit
             ]

turtles-own [
             energy
             guessp
             guessb
             guessc
             player
             ]

globals [
         clicks
         average-energyemotional
         average-energyoptimistic
         average-energyrational
         ]

to setup
    clear-all-plots
    cp ct
    setup-turtles
    setup-globals
    setup-patches
    set clicks 1
end

to setup-globals
    ifelse (display? = true)
        [display]
        [no-display]
    set average-energyemotional  ((sum values-from (emotional) [energy]) / (count emotional))
    set average-energyoptimistic ((sum values-from (optimistic)[energy]) / (count optimistic))
    set average-energyrational   ((sum values-from (rational)  [energy]) / (count rational))
end

to setup-turtles
    create-emotional 50
    create-optimistic 50
    create-rational 50
    ask turtles [
        set energy 0
        set player 0
        set guessp 0
        set guessc 0
        set guessb 0
        if (breed = emotional)  [set color red]
        if (breed = optimistic) [set color green]
        if (breed = rational)   [set color blue]
        set heading random-int-or-float 360
        jump random-int-or-float 100
        ]
end

to setup-patches
    ask patches [
        set cost random-int-or-float 10
        set benefit random-int-or-float 10
        if benefit <= 0 [set benefit 0.0001]
        if cost <= 0 [set cost 0.0001]
        set p random-int-or-float 1.0
        set pcolor (p * 5) + 95
        ]
end

to fullrun
    locals [counter]
    set counter 0
    print " "
    print "ErrorCB, ErrorP, Emotional, Optimistic, Rational, 10 times,"
    repeat 11 [
        set errorcb counter
        runerrorp
        set counter counter + 1
        ]
end

to runerrorp
locals [counter]
    set counter 0
    print " "
    repeat 11 [
        set errorp counter
        type errorcb
        type ","
        type errorp
        type ","
        repeat 10 [
            setup
            repeat 500 [go]
            type average-energyemotional / clicks
            type ", "
            type average-energyoptimistic / clicks
            type ", "
            type average-energyrational / clicks
            type ", "
            ]
        print ""
        set counter counter + 1
        ]
end

to go
    setup-patches
    setup-globals
    guess
    decide
    play
    do-plot
    set clicks clicks + 1
    if (clicks > 500) [stop]
end


to guess
    ask turtles [
        guessofb
        guessofc
        guessofp
        ]
end

to guessofb
    set guessb random-normal (value-from (patch-here) [benefit]) (errorcb)
    if guessb <= 0 [guessofb]
    if guessb > 10 [guessofb]
end

to guessofc
    set guessc random-normal (value-from (patch-here) [cost]) (errorcb)
    if guessc <= 0 [guessofc]
    if guessc > 10 [guessofc]
end

to guessofp
    set guessp random-normal (value-from (patch-here) [p]) (errorp / 10)
    if guessp >= 1 [guessofp]
    if guessp <= 0 [guessofp]
end

to decide
    ask turtles [

        if (breed = emotional) [
            ifelse ((guessc / guessb) > 2) [set player 0]
                [ifelse ((guessc / guessb) < 0.5) [set player 1]
                    [if (random-int-or-float 1.00 < guessp) [set player 1]
                    ]
                ]
            ]

        if (breed = optimistic) [
            if (guessb * (guessp * (guessb / guessc)) > (1 - (guessp * (guessb / guessc))) * guessc) [set player 1]
            ]

        if (breed = rational) [
            if (guessb * guessp > (1 - guessp) * guessc) [set player 1]
            ]

        ]
end

to play
    ask turtles [
        if player = 1 [
            ifelse (random-int-or-float 1.00 <= (value-from (patch-here) [p]))
                [set energy energy + (value-from (patch-here) [benefit])]
                [set energy energy - (value-from (patch-here) [cost])]
            ]
        set player 0
        ]
end

to do-plot
    set-current-plot "Average energy"
    set-current-plot-pen "emotional"
    plot average-energyemotional / clicks
    set-current-plot-pen "optimistic"
    plot average-energyoptimistic / clicks
    set-current-plot-pen "rational"
    plot average-energyrational / clicks
    set-current-plot-pen "zero"
    plot 0
end

@#$#@#$#@
GRAPHICS-WINDOW
5
10
372
398
10
10
17.0
1
10
1
1
1
0
1
1
1

CC-WINDOW
5
611
843
706
Command Center
0

BUTTON
12
432
93
465
Setup
setup
NIL
1
T
OBSERVER
T
NIL

BUTTON
107
432
188
465
Go
go
T
1
T
OBSERVER
T
NIL

BUTTON
201
432
290
465
One step
Go
NIL
1
T
OBSERVER
T
NIL

MONITOR
473
429
600
478
av-energy-rational
average-energyrational / clicks
3
1

SLIDER
13
480
289
513
errorp
errorp
0
10
10
1
1
NIL

SLIDER
12
525
290
558
errorcb
errorcb
0
10
4
1
1
NIL

MONITOR
476
548
601
597
av-energy-emotional
average-energyemotional / clicks
3
1

MONITOR
389
430
459
479
rational
count rational
0
1

MONITOR
389
548
462
597
emotional
count emotional
0
1

PLOT
388
73
834
417
Average energy
time
energy / time
0.0
500.0
-0.5
2.0
true
true
PENS
"rational" 1.0 0 -13345367 true
"emotional" 1.0 0 -2674135 true
"optimistic" 1.0 0 -10899396 true
"zero" 1.0 0 -16777216 true

MONITOR
389
488
461
537
optimistic
count optimistic
0
1

MONITOR
475
487
601
536
av-energy-optimistic
average-energyoptimistic / clicks
3
1

SWITCH
15
562
123
595
display?
display?
0
1
-1000

BUTTON
137
563
218
596
Fullrun
fullrun
NIL
1
T
OBSERVER
T
NIL

@#$#@#$#@
WHAT IS IT?
-----------
This project is inspired by the phenomenon of 'motivational bias'.  It shows how the principle of maximum expected utility (MEU), can - in certain types of environment - be outperformed by 'biased' decision rules.

In this model, three types of agent live in a 2D gridworld consisting of 441 (21 x 21) patches, each of which represents an 'opportunity'.  Each opportunity has a probability of success (p, ranging from 0-1), a benefit for success (b, ranging from 0.0001 to 10 energy points) and a cost of failure (c, ranging from 0.0001 to 10 energy points).The colour of the patch is determined by the probability of success, with darker patches representing more difficult opportunities.

Agents have only one goal - to maximise their energy points.  In other words, their utility function is a linear function of their energy level.  Agents have some knowledge of the probability of success (p), the benefit for success (b), and the cost of failure (c), for each opportunity they face. Those c, b and p are properties of the patch they are on an that moment. The level of noise affecting the agents' knowledge of these values can be set by means of the sliders on the interface.

The error can vary from 0 (perfect information) to 10 (great uncertainty). This error determines the standard deviation used for the normal distribution of which the mean is the true value of c, b or p of the patch. A random number drawn from this distribution determines the agents' guesses about the values of c, b and p. There are two error sliders, one affects knowledge of p, the other affects the agents' knowledge of c and b.

Agents do not move, but since each patch is updated each turn, each agent is presented with a different opportunity at every time step.  Each turn, every agent must decide whether or not to 'play' that opportunity or not.  This decision is made according to the agent's 'decision rule'. There are three types of agent, each with a different decision rule:

  - The RATIONAL agent (BLUE) uses the principle of maximum expected utility.  I.e. it only plays when the expected utility of playing is greater than that of not playing.
  - The OPTIMISTIC agent (YELLOW) also uses the principle of maximum expected utility, but uses a biased estimate of p (its estimate of p is multiplied by its estimate of b divided by its estimate of c).
  - The EMOTIONAL agent (RED) plays whenever it estimates b to be more than twice c, and does not play whenever it estimates b to be less than half c.  When it estimates that b and c are similar, its chance of playing is proportional to its estimate of p.

If an agent decides to play an opportunity, its chance of success is determined by the probability of success associated with that opportunity.  If it plays and succeeds, its energy level is increased by the benefit for success associated with the opportunity.  If it plays and fails, its energy level is decreased by the cost of failure associated with that opportunity.  If an agent does not play, its energy level remains the same for that turn.  Agents start with zero energy. Agents never die, and there is no reproduction


HOW TO USE IT
-------------
Click the SETUP button to set up a collection of 50 agents of each type.

Click the GO button to start the simulation.  The simulation then runs for 500 time clicks and stops.

The ONE-STEP button allows you to step through the simulation one turn at a time.

The ERRORP slider controls the amount of noise that affects the agents' knowledge of p.  When ERRORP is set to zero, agents have perfect information about p.

The ERRORCB slider controls the amount of noise that affects the agent's knowledge of c and b.  When ERRORCB is set to zero, agents have perfect information about c and b.

The DISPLAY switch allows you to turn off the graphics screen, which makes the model run faster.  This is useful when using the FULLRUN button.

The FULLRUN button gives you data of the performances of all the agents under all conditions. It steps by increments of 1 through all the different values of ERRORCB (set by the ERRORCB slider) and the range of ERRORP values. The  ERRORCB starts at 0 and gradually changes to 10. For the given level of ERRORCB it also gradually varies the ERRORP slider, starting at zero and then increasing ERRORP by increments of 1 till this also reached 10.  For every combination of values of ERRORCB and ERRORP, 10 runs of 500 time steps each are performed.  For each run, the final average energy of all the agents is printed in the command centre.

When the FULLRUN procedure terminates, the results may be saved in a text file by selecting 'Export Output' from the FILE menu.  This text file can then be imported into an EXCEL spreadsheet and graphed.


THINGS TO NOTICE
----------------
With a low levels of ERRORP and ERRORCB, the rational agents do best.  This is precisely what you would expect from game theory;  the principle of maximum expected utility is designed to give optimal performance in a world of perfect information.

With high levels of ERRORP and ERRORCB, all the agents do poorly. The rational agents are slightly better, but this is not a significant difference.

With a high level of ERRORP and a small level of ERRORCB, the emotional agents and the optimistic agents outperform the rational agents.  Can you work out WHY this happens?


THINGS TO TRY
-------------
Try different values for the ERRORP and ERRORCB sliders. What are the critical thresholds at which rational agents are no longer the best?


EXTENDING THE MODEL
-------------------
Try creating more types of agent with different decision rules.  Can you find any decision rules that do better than the rational agents (ie. the principle of maximum expected utility)?  Under what conditions does the new decision rule outperform the rational agents?

Can you find a decision rule that does better than the rational agent if and only if ERRORP is low but ERRORCB is high?


CREDITS AND REFERENCES
----------------------
This model was created by Annerieke Heuvelink, Daniel Nettle and Dylan Evans.

For a paper discussing this model in more detail, visit http://www.dylan.org.uk/optimismAISB.html
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

ant
true
0
Polygon -7500403 true true 136 61 129 46 144 30 119 45 124 60 114 82 97 37 132 10 93 36 111 84 127 105 172 105 189 84 208 35 171 11 202 35 204 37 186 82 177 60 180 44 159 32 170 44 165 60
Polygon -7500403 true true 150 95 135 103 139 117 125 149 137 180 135 196 150 204 166 195 161 180 174 150 158 116 164 102
Polygon -7500403 true true 149 186 128 197 114 232 134 270 149 282 166 270 185 232 171 195 149 186
Polygon -7500403 true true 225 66 230 107 159 122 161 127 234 111 236 106
Polygon -7500403 true true 78 58 99 116 139 123 137 128 95 119
Polygon -7500403 true true 48 103 90 147 129 147 130 151 86 151
Polygon -7500403 true true 65 224 92 171 134 160 135 164 95 175
Polygon -7500403 true true 235 222 210 170 163 162 161 166 208 174
Polygon -7500403 true true 249 107 211 147 168 147 168 150 213 150

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

bee
true
0
Polygon -1184463 true false 152 149 77 163 67 195 67 211 74 234 85 252 100 264 116 276 134 286 151 300 167 285 182 278 206 260 220 242 226 218 226 195 222 166
Polygon -16777216 true false 150 149 128 151 114 151 98 145 80 122 80 103 81 83 95 67 117 58 141 54 151 53 177 55 195 66 207 82 211 94 211 116 204 139 189 149 171 152
Polygon -7500403 true true 151 54 119 59 96 60 81 50 78 39 87 25 103 18 115 23 121 13 150 1 180 14 189 23 197 17 210 19 222 30 222 44 212 57 192 58
Polygon -16777216 true false 70 185 74 171 223 172 224 186
Polygon -16777216 true false 67 211 71 226 224 226 225 211 67 211
Polygon -16777216 true false 91 257 106 269 195 269 211 255
Line -1 false 144 100 70 87
Line -1 false 70 87 45 87
Line -1 false 45 86 26 97
Line -1 false 26 96 22 115
Line -1 false 22 115 25 130
Line -1 false 26 131 37 141
Line -1 false 37 141 55 144
Line -1 false 55 143 143 101
Line -1 false 141 100 227 138
Line -1 false 227 138 241 137
Line -1 false 241 137 249 129
Line -1 false 249 129 254 110
Line -1 false 253 108 248 97
Line -1 false 249 95 235 82
Line -1 false 235 82 144 100

bird1
false
0
Polygon -7500403 true true 2 6 2 39 270 298 297 298 299 271 187 160 279 75 276 22 100 67 31 0

bird2
false
0
Polygon -7500403 true true 2 4 33 4 298 270 298 298 272 298 155 184 117 289 61 295 61 105 0 43

boat1
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6459832 true false 150 32 157 162
Polygon -13345367 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7500403 true true 158 33 230 157 182 150 169 151 157 156
Polygon -7500403 true true 149 55 88 143 103 139 111 136 117 139 126 145 130 147 139 147 146 146 149 55

boat2
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6459832 true false 150 32 157 162
Polygon -13345367 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7500403 true true 157 54 175 79 174 96 185 102 178 112 194 124 196 131 190 139 192 146 211 151 216 154 157 154
Polygon -7500403 true true 150 74 146 91 139 99 143 114 141 123 137 126 131 129 132 139 142 136 126 142 119 147 148 147

boat3
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6459832 true false 150 32 157 162
Polygon -13345367 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7500403 true true 158 37 172 45 188 59 202 79 217 109 220 130 218 147 204 156 158 156 161 142 170 123 170 102 169 88 165 62
Polygon -7500403 true true 149 66 142 78 139 96 141 111 146 139 148 147 110 147 113 131 118 106 126 71

box
true
0
Polygon -7500403 true true 45 255 255 255 255 45 45 45

butterfly1
true
0
Polygon -16777216 true false 151 76 138 91 138 284 150 296 162 286 162 91
Polygon -7500403 true true 164 106 184 79 205 61 236 48 259 53 279 86 287 119 289 158 278 177 256 182 164 181
Polygon -7500403 true true 136 110 119 82 110 71 85 61 59 48 36 56 17 88 6 115 2 147 15 178 134 178
Polygon -7500403 true true 46 181 28 227 50 255 77 273 112 283 135 274 135 180
Polygon -7500403 true true 165 185 254 184 272 224 255 251 236 267 191 283 164 276
Line -7500403 true 167 47 159 82
Line -7500403 true 136 47 145 81
Circle -7500403 true true 165 45 8
Circle -7500403 true true 134 45 6
Circle -7500403 true true 133 44 7
Circle -7500403 true true 133 43 8

circle
false
0
Circle -7500403 true true 35 35 230

person
false
0
Circle -7500403 true true 155 20 63
Rectangle -7500403 true true 158 79 217 164
Polygon -7500403 true true 158 81 110 129 131 143 158 109 165 110
Polygon -7500403 true true 216 83 267 123 248 143 215 107
Polygon -7500403 true true 167 163 145 234 183 234 183 163
Polygon -7500403 true true 195 163 195 233 227 233 206 159

sheep
false
15
Rectangle -1 true true 90 75 270 225
Circle -1 true true 15 75 150
Rectangle -16777216 true false 81 225 134 286
Rectangle -16777216 true false 180 225 238 285
Circle -16777216 true false 1 88 92

spacecraft
true
0
Polygon -7500403 true true 150 0 180 135 255 255 225 240 150 180 75 240 45 255 120 135

thin-arrow
true
0
Polygon -7500403 true true 150 0 0 150 120 150 120 293 180 293 180 150 300 150

truck-down
false
0
Polygon -7500403 true true 225 30 225 270 120 270 105 210 60 180 45 30 105 60 105 30
Polygon -8630108 true false 195 75 195 120 240 120 240 75
Polygon -8630108 true false 195 225 195 180 240 180 240 225

truck-left
false
0
Polygon -7500403 true true 120 135 225 135 225 210 75 210 75 165 105 165
Polygon -8630108 true false 90 210 105 225 120 210
Polygon -8630108 true false 180 210 195 225 210 210

truck-right
false
0
Polygon -7500403 true true 180 135 75 135 75 210 225 210 225 165 195 165
Polygon -8630108 true false 210 210 195 225 180 210
Polygon -8630108 true false 120 210 105 225 90 210

turtle
true
0
Polygon -7500403 true true 138 75 162 75 165 105 225 105 225 142 195 135 195 187 225 195 225 225 195 217 195 202 105 202 105 217 75 225 75 195 105 187 105 135 75 142 75 105 135 105

wolf
false
0
Rectangle -7500403 true true 15 105 105 165
Rectangle -7500403 true true 45 90 105 105
Polygon -7500403 true true 60 90 83 44 104 90
Polygon -16777216 true false 67 90 82 59 97 89
Rectangle -1 true false 48 93 59 105
Rectangle -16777216 true false 51 96 55 101
Rectangle -16777216 true false 0 121 15 135
Rectangle -16777216 true false 15 136 60 151
Polygon -1 true false 15 136 23 149 31 136
Polygon -1 true false 30 151 37 136 43 151
Rectangle -7500403 true true 105 120 263 195
Rectangle -7500403 true true 108 195 259 201
Rectangle -7500403 true true 114 201 252 210
Rectangle -7500403 true true 120 210 243 214
Rectangle -7500403 true true 115 114 255 120
Rectangle -7500403 true true 128 108 248 114
Rectangle -7500403 true true 150 105 225 108
Rectangle -7500403 true true 132 214 155 270
Rectangle -7500403 true true 110 260 132 270
Rectangle -7500403 true true 210 214 232 270
Rectangle -7500403 true true 189 260 210 270
Line -7500403 true 263 127 281 155
Line -7500403 true 281 155 281 192

wolf-left
false
3
Polygon -6459832 true true 117 97 91 74 66 74 60 85 36 85 38 92 44 97 62 97 81 117 84 134 92 147 109 152 136 144 174 144 174 103 143 103 134 97
Polygon -6459832 true true 87 80 79 55 76 79
Polygon -6459832 true true 81 75 70 58 73 82
Polygon -6459832 true true 99 131 76 152 76 163 96 182 104 182 109 173 102 167 99 173 87 159 104 140
Polygon -6459832 true true 107 138 107 186 98 190 99 196 112 196 115 190
Polygon -6459832 true true 116 140 114 189 105 137
Rectangle -6459832 true true 109 150 114 192
Rectangle -6459832 true true 111 143 116 191
Polygon -6459832 true true 168 106 184 98 205 98 218 115 218 137 186 164 196 176 195 194 178 195 178 183 188 183 169 164 173 144
Polygon -6459832 true true 207 140 200 163 206 175 207 192 193 189 192 177 198 176 185 150
Polygon -6459832 true true 214 134 203 168 192 148
Polygon -6459832 true true 204 151 203 176 193 148
Polygon -6459832 true true 207 103 221 98 236 101 243 115 243 128 256 142 239 143 233 133 225 115 214 114

wolf-right
false
3
Polygon -6459832 true true 170 127 200 93 231 93 237 103 262 103 261 113 253 119 231 119 215 143 213 160 208 173 189 187 169 190 154 190 126 180 106 171 72 171 73 126 122 126 144 123 159 123
Polygon -6459832 true true 201 99 214 69 215 99
Polygon -6459832 true true 207 98 223 71 220 101
Polygon -6459832 true true 184 172 189 234 203 238 203 246 187 247 180 239 171 180
Polygon -6459832 true true 197 174 204 220 218 224 219 234 201 232 195 225 179 179
Polygon -6459832 true true 78 167 95 187 95 208 79 220 92 234 98 235 100 249 81 246 76 241 61 212 65 195 52 170 45 150 44 128 55 121 69 121 81 135
Polygon -6459832 true true 48 143 58 141
Polygon -6459832 true true 46 136 68 137
Polygon -6459832 true true 45 129 35 142 37 159 53 192 47 210 62 238 80 237
Line -16777216 false 74 237 59 213
Line -16777216 false 59 213 59 212
Line -16777216 false 58 211 67 192
Polygon -6459832 true true 38 138 66 149
Polygon -6459832 true true 46 128 33 120 21 118 11 123 3 138 5 160 13 178 9 192 0 199 20 196 25 179 24 161 25 148 45 140
Polygon -6459832 true true 67 122 96 126 63 144

@#$#@#$#@
NetLogo 3.0pre5
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
