breeds [winner loser predator] ;; three species
turtles-own [energy age];;turtles have energy and age
globals [time]

to setup
ca
set time 0
ask patches [set pcolor blue] ;;all patches are colored blue, water

create-loser nloser
ask loser [set color green set shape "tetra"]
ask loser [fd (random 21)]

create-winner nwinner
ask winner [set color red set shape "heli"]
ask winner [fd (random 21)]

create-predator npredator
ask predator [set shape "gamm"]
ask predator [set color yellow]
ask predator [fd (random 21)]
ask turtles [set energy 10];;initial energy is 10
ask winner [set age 10];;initial age is 10
ask loser [set age 10]
ask predator [set age 50];;except for predator whose age is 50


repeat npatch ;;a certain number of patches colored brown, leaves
[ set pcolor-of random-one-of patches with [pcolor != brown] brown]

end

to go

set time time + 1

ask turtles [set age age - 1] ;;deducts one year with each turn
ask turtles [if (age = 0) [die]]

ask loser [if (pcolor != brown) [rt random 360 fd random 41]]
ask loser [if (pcolor != brown) [set energy energy - 1]]
ask loser [if (pcolor = brown) and (count winner-here != 0) [die]] ;;if heli on brown patch, tetra dies
ask loser [if (pcolor = brown) [set energy energy + 1]]
ask loser [if (pcolor = brown) and (energy > 10) and (count loser-here < 10) [hatch lrepro [rt random 360 fd random ljmp set energy 5 set age 20]]];; reproduce only if less than 10 losers on patch
ask loser [if (energy = 0) [die]]

ask winner [if (pcolor != brown) [rt random 360 fd 1]]
ask winner [if (pcolor != brown) [set energy energy - 1]]
ask winner [if (pcolor = brown) [set energy energy + 1]]
ask winner [if (pcolor = brown) and (energy > 10) and (count winner-here < 10) [hatch wrepro [rt random 360 fd wjmp set energy 5 set age 20]]]
ask winner [if (pcolor = brown and count loser-here != 0) [ask loser-here [die]]];; winner kills loser here
ask winner [if (energy = 0) [die]]

ask predator [if (pcolor != brown) [rt random 360 fd random pjmp set energy energy - 1]]
ask predator [if (pcolor = brown and count winner-here = 0 and count loser-here = 0) [set energy energy - 1]] ;;no winner, no losers, predator loses energy
ask predator [if (pcolor = brown and count winner-here = 0 and count loser-here = 0) [rt random 360 fd random pjmp]];if no fungi,  move on
ask predator [if (pcolor = brown and count winner-here != 0) [set energy energy + 2]] ;; predator gains energy if winner here
ask predator [if (pcolor = brown and count winner-here != 0) [ask winner-here [die]]];; predator kills winner here
ask predator [if (pcolor = brown and count loser-here != 0) [set energy energy + 2]];; predator gains energy if loser here
ask predator [if (pcolor = brown and count loser-here != 0) [ask loser-here [die]]];; predator kills loser here
ask predator [if (energy = 0) [die]]
ask predator [if (energy > 15) and (count predator < pmax )[hatch prepro [rt random 360 fd random 40 set energy 5 set age 50]]];;if energy > 10, produce number of new predator, grows older than winner or loser



if (count loser = 0) [stop] ;;program stops when all tetra dead
if (count winner = 0) [stop] ;;program stops when all heli dead
do-plots

end; add model procedures here

to do-plots
set-current-plot "Numbers"
set-current-plot-pen "Loser"
plot count loser
set-current-plot-pen "Predator"
plot count predator
set-current-plot-pen "Winner"
plot count winner
end

@#$#@#$#@
GRAPHICS-WINDOW
313
10
743
461
17
17
12.0
1
10
1
1
1

CC-WINDOW
315
462
630
582
Command Center

BUTTON
22
192
77
225
NIL
setup
NIL
1
T
OBSERVER

BUTTON
94
191
157
224
NIL
go
T
1
T
OBSERVER

MONITOR
101
261
158
310
Loser
count loser
3
1

MONITOR
179
260
229
309
Winner
count winner
3
1

MONITOR
25
258
87
307
Predator
count predator
3
1

SLIDER
17
374
109
407
nloser
nloser
0
1000
400
1
1
NIL

SLIDER
14
327
106
360
nwinner
nwinner
0
1000
400
1
1
NIL

SLIDER
16
425
108
458
npredator
npredator
0
1000
0
1
1
NIL

SLIDER
148
472
248
505
npatch
npatch
0
1000
500
1
1
NIL

PLOT
72
36
272
186
Numbers
NIL
NIL
0.0
100.0
0.0
100.0
true
true
PENS
"Loser" 1.0 0 -11352576 true
"Winner" 1.0 0 -65536 true
"Predator" 1.0 0 -256 true

SLIDER
146
378
238
411
prepro
prepro
0
10
1
1
1
NIL

SLIDER
147
329
239
362
wrepro
wrepro
0
100
5
1
1
NIL

SLIDER
147
426
239
459
lrepro
lrepro
0
20
5
1
1
NIL

SLIDER
767
334
859
367
ljmp
ljmp
0
20
20
1
1
NIL

SLIDER
761
377
853
410
pmax
pmax
0
1000
250
1
1
NIL

SLIDER
765
288
857
321
pjmp
pjmp
0
20
20
1
1
NIL

SLIDER
761
243
853
276
wjmp
wjmp
0
20
1
1
1
NIL

MONITOR
242
263
292
312
Time
time
3
1

@#$#@#$#@
PREDATOR-MEDIATED COEXISTENCE (Felix Baerlocher, fbaerlocher@mta.ca)

WHAT IS IT?
This model is based on Caswell (1978). It examines the effect of a predator on the coexistence of two competitors. The graphics window contains a variable number of brown resource patches and blue non-resource patches. Brown patches allow survival and reproduction of the two competitors, called "winner" and "loser", respectively. A third agent, "predator" preys on both winners and losers present on a brown patch. Blue patches do not contain any food, they  may represent barriers between food patches. When a winner and a loser land on the same brown patch, the loser gets killed. Once a winner is established on a brown patch, it cannot be displaced, except by a predator. When a predator arrives on a brown  patch, it will kill both winners and losers, and, in the process, gain energy.
Newly hatched offspring wander randomly until they find a brown patch. If the patch is empty, it can be colonized by either winner and loser; if it already contains a winner, losers cannot colonize it. Predators can colonize (and will empty) any patch with losers, winners, or both.
When the model is run with only winners and losers, winners almost always win, except when there are very few brown patches and the migration parameters are set very low.
When a predator is added, the length of time that winner and loser can coexist, increases. By emptying patches occupied by the superior competitor, the predator creates new opportunities for the inferior competitor.
Important concepts that can be illustrated are the difference between open and closed systems, equilibrium vs. nonequilibrium systems, trade-offs between rapid reproduction and wide dispersal vs. superior competitiveness, etc.
An advantage of this model over Caswell's original model is that spatial arrangement of resource patches is explicit. Their numbers and arrangements,combined with mobility of the agents, can greatly influence the final outcome. In the current setup, they are distributed randomly; this could easily be modified by producing clumps of patches, separated by variable distances.
The predator can be generalized to a disturbance (which would no longer allow its extinction). The model could then provide a simple illustration of the intermediate disturbance hypothesis (Connell 1978)

Caswell, H. (1978) Predator-mediated coexistence: a nonequilibrium model. American Naturalist 112, 127-154.
Connell, J.H.(1978) Diversity in tropical rainforests and coral reefs. Science 199, 1302-1310.

HOW TO USE IT?
Click the SETUP button to set up the the two competitors (winner, loser), the predator (predator) and the resources patches.
Click the GO button to start the simulation.
There are 11 sliders. nwinner, nloser and npredator control the initial numbers of the three species, npatches controls the initial number of brown resource patches.
nrepro, wrepro, and prepro control the number of offspring released during hatching.
wjmp, ljmp, pjmp controls the maximum number of fd steps that might be taken during random movement.
pmax controls the upper limit where reproduction by the predator is no longer possible.
(Note: Changes in the DENSITY slider do not take effect until the next SETUP.)

THINGS TO NOTICE
Begin with the following settings: nwinner = nwloser = 400. npredator = 0;wrepro = 5, lrepro = 5, prepro = 1, npatch = 500. pmax = 250. wjmp = 1, pjmp = 20, ljmp = 20. pmax = 250. The loser generally goes extinct within 20 - 50 turns.
Now add 250 predators. Winner usually goes extinct after a few 100 turns.
Now begin with 500 patches. Coexistence of all 3 species is extended.


EXTENDING THE MODEL
Try arranging brown patches in a certain order (e.g., a large contiguous block in the center, with a few smaller blocks distributed randomly. Replace predator by an physical/chemical disturbance (no need to reproduce).
@#$#@#$#@
default
true
0
Polygon -7566196 true true 150 5 40 250 150 205 260 250

ant
true
0
Polygon -7566196 true true 136 61 129 46 144 30 119 45 124 60 114 82 97 37 132 10 93 36 111 84 127 105 172 105 189 84 208 35 171 11 202 35 204 37 186 82 177 60 180 44 159 32 170 44 165 60
Polygon -7566196 true true 150 95 135 103 139 117 125 149 137 180 135 196 150 204 166 195 161 180 174 150 158 116 164 102
Polygon -7566196 true true 149 186 128 197 114 232 134 270 149 282 166 270 185 232 171 195 149 186 149 186
Polygon -7566196 true true 225 66 230 107 159 122 161 127 234 111 236 106
Polygon -7566196 true true 78 58 99 116 139 123 137 128 95 119
Polygon -7566196 true true 48 103 90 147 129 147 130 151 86 151
Polygon -7566196 true true 65 224 92 171 134 160 135 164 95 175
Polygon -7566196 true true 235 222 210 170 163 162 161 166 208 174
Polygon -7566196 true true 249 107 211 147 168 147 168 150 213 150

arrow
true
0
Polygon -7566196 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

bee
true
0
Polygon -256 true false 151 152 137 77 105 67 89 67 66 74 48 85 36 100 24 116 14 134 0 151 15 167 22 182 40 206 58 220 82 226 105 226 134 222
Polygon -16777216 true false 151 150 149 128 149 114 155 98 178 80 197 80 217 81 233 95 242 117 246 141 247 151 245 177 234 195 218 207 206 211 184 211 161 204 151 189 148 171
Polygon -7566196 true true 246 151 241 119 240 96 250 81 261 78 275 87 282 103 277 115 287 121 299 150 286 180 277 189 283 197 281 210 270 222 256 222 243 212 242 192
Polygon -16777216 true false 115 70 129 74 128 223 114 224
Polygon -16777216 true false 89 67 74 71 74 224 89 225 89 67
Polygon -16777216 true false 43 91 31 106 31 195 45 211
Line -1 false 200 144 213 70
Line -1 false 213 70 213 45
Line -1 false 214 45 203 26
Line -1 false 204 26 185 22
Line -1 false 185 22 170 25
Line -1 false 169 26 159 37
Line -1 false 159 37 156 55
Line -1 false 157 55 199 143
Line -1 false 200 141 162 227
Line -1 false 162 227 163 241
Line -1 false 163 241 171 249
Line -1 false 171 249 190 254
Line -1 false 192 253 203 248
Line -1 false 205 249 218 235
Line -1 false 218 235 200 144

bird1
false
0
Polygon -7566196 true true 2 6 2 39 270 298 297 298 299 271 187 160 279 75 276 22 100 67 31 0

bird2
false
0
Polygon -7566196 true true 2 4 33 4 298 270 298 298 272 298 155 184 117 289 61 295 61 105 0 43

boat1
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6524078 true false 150 32 157 162
Polygon -16776961 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7566196 true true 158 33 230 157 182 150 169 151 157 156
Polygon -7566196 true true 149 55 88 143 103 139 111 136 117 139 126 145 130 147 139 147 146 146 149 55

boat2
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6524078 true false 150 32 157 162
Polygon -16776961 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7566196 true true 157 54 175 79 174 96 185 102 178 112 194 124 196 131 190 139 192 146 211 151 216 154 157 154
Polygon -7566196 true true 150 74 146 91 139 99 143 114 141 123 137 126 131 129 132 139 142 136 126 142 119 147 148 147

boat3
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6524078 true false 150 32 157 162
Polygon -16776961 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7566196 true true 158 37 172 45 188 59 202 79 217 109 220 130 218 147 204 156 158 156 161 142 170 123 170 102 169 88 165 62
Polygon -7566196 true true 149 66 142 78 139 96 141 111 146 139 148 147 110 147 113 131 118 106 126 71

box
true
0
Polygon -7566196 true true 45 255 255 255 255 45 45 45

butterfly1
true
0
Polygon -16777216 true false 151 76 138 91 138 284 150 296 162 286 162 91
Polygon -7566196 true true 164 106 184 79 205 61 236 48 259 53 279 86 287 119 289 158 278 177 256 182 164 181
Polygon -7566196 true true 136 110 119 82 110 71 85 61 59 48 36 56 17 88 6 115 2 147 15 178 134 178
Polygon -7566196 true true 46 181 28 227 50 255 77 273 112 283 135 274 135 180
Polygon -7566196 true true 165 185 254 184 272 224 255 251 236 267 191 283 164 276
Line -7566196 true 167 47 159 82
Line -7566196 true 136 47 145 81
Circle -7566196 true true 165 45 8
Circle -7566196 true true 134 45 6
Circle -7566196 true true 133 44 7
Circle -7566196 true true 133 43 8

circle
false
0
Circle -7566196 true true 34 34 230

clav
true
0
Polygon -65536 true false 131 280 149 297
Polygon -65536 true false 150 298 121 265 97 121 151 96 201 129 180 271
Polygon -65536 true false 100 135 32 74 39 49 64 49 115 111 149 107 138 102 125 16 149 1 178 22 160 113 193 125 237 60 266 64 274 93 180 166

gamm
true
0
Polygon -256 true false 41 227 23 213 30 139 71 49 133 17 187 19 254 53 276 89 283 107 290 122 216 130 285 139 185 146 169 161 281 165 162 174 137 184 265 185 124 193 100 198 207 214 89 204 81 211 106 234 78 231 84 249

heli
true
0
Polygon -65536 true false 150 241 128 218 117 94 92 75 130 83 150 58 157 81 198 77 171 96 172 216

person
false
0
Circle -7566196 true true 155 20 63
Rectangle -7566196 true true 158 79 217 164
Polygon -7566196 true true 158 81 110 129 131 143 158 109 165 110
Polygon -7566196 true true 216 83 267 123 248 143 215 107
Polygon -7566196 true true 167 163 145 234 183 234 183 163
Polygon -7566196 true true 195 163 195 233 227 233 206 159

spacecraft
true
0
Polygon -7566196 true true 150 0 180 135 255 255 225 240 150 180 75 240 45 255 120 135

tetra
true
0
Polygon -11352576 true false 149 295 123 271 122 151 45 63 55 38 76 50 142 128 129 96 152 81 180 87 183 97 164 124 158 131 250 77 275 78 278 95 167 150 268 201 268 216 245 219 161 170

thin-arrow
true
0
Polygon -7566196 true true 150 0 0 150 120 150 120 293 180 293 180 150 300 150

truck-down
false
0
Polygon -7566196 true true 225 30 225 270 120 270 105 210 60 180 45 30 105 60 105 30
Polygon -8716033 true false 195 75 195 120 240 120 240 75
Polygon -8716033 true false 195 225 195 180 240 180 240 225

truck-left
false
0
Polygon -7566196 true true 120 135 225 135 225 210 75 210 75 165 105 165
Polygon -8716033 true false 90 210 105 225 120 210
Polygon -8716033 true false 180 210 195 225 210 210

truck-right
false
0
Polygon -7566196 true true 180 135 75 135 75 210 225 210 225 165 195 165
Polygon -8716033 true false 210 210 195 225 180 210
Polygon -8716033 true false 120 210 105 225 90 210

turtle
true
0
Polygon -7566196 true true 138 75 162 75 165 105 225 105 225 142 195 135 195 187 225 195 225 225 195 217 195 202 105 202 105 217 75 225 75 195 105 187 105 135 75 142 75 105 135 105

wolf-left
false
3
Polygon -6524078 true true 117 97 91 74 66 74 60 85 36 85 38 92 44 97 62 97 81 117 84 134 92 147 109 152 136 144 174 144 174 103 143 103 134 97
Polygon -6524078 true true 87 80 79 55 76 79
Polygon -6524078 true true 81 75 70 58 73 82
Polygon -6524078 true true 99 131 76 152 76 163 96 182 104 182 109 173 102 167 99 173 87 159 104 140
Polygon -6524078 true true 107 138 107 186 98 190 99 196 112 196 115 190
Polygon -6524078 true true 116 140 114 189 105 137
Rectangle -6524078 true true 109 150 114 192
Rectangle -6524078 true true 111 143 116 191
Polygon -6524078 true true 168 106 184 98 205 98 218 115 218 137 186 164 196 176 195 194 178 195 178 183 188 183 169 164 173 144
Polygon -6524078 true true 207 140 200 163 206 175 207 192 193 189 192 177 198 176 185 150
Polygon -6524078 true true 214 134 203 168 192 148
Polygon -6524078 true true 204 151 203 176 193 148
Polygon -6524078 true true 207 103 221 98 236 101 243 115 243 128 256 142 239 143 233 133 225 115 214 114

wolf-right
false
3
Polygon -6524078 true true 170 127 200 93 231 93 237 103 262 103 261 113 253 119 231 119 215 143 213 160 208 173 189 187 169 190 154 190 126 180 106 171 72 171 73 126 122 126 144 123 159 123
Polygon -6524078 true true 201 99 214 69 215 99
Polygon -6524078 true true 207 98 223 71 220 101
Polygon -6524078 true true 184 172 189 234 203 238 203 246 187 247 180 239 171 180
Polygon -6524078 true true 197 174 204 220 218 224 219 234 201 232 195 225 179 179
Polygon -6524078 true true 78 167 95 187 95 208 79 220 92 234 98 235 100 249 81 246 76 241 61 212 65 195 52 170 45 150 44 128 55 121 69 121 81 135
Polygon -6524078 true true 48 143 58 141
Polygon -6524078 true true 46 136 68 137
Polygon -6524078 true true 45 129 35 142 37 159 53 192 47 210 62 238 80 237
Line -16777216 false 74 237 59 213
Line -16777216 false 59 213 59 212
Line -16777216 false 58 211 67 192
Polygon -6524078 true true 38 138 66 149
Polygon -6524078 true true 46 128 33 120 21 118 11 123 3 138 5 160 13 178 9 192 0 199 20 196 25 179 24 161 25 148 45 140
Polygon -6524078 true true 67 122 96 126 63 144

@#$#@#$#@
NetLogo 2.0alpha1 (Rev B)
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
