globals [ph w]

to open                             ;summary and instructions
   ifelse (w = 1 or w = 2)[stop][
   cp ct ca crt 1 text-1]
end

to setup-rock&shadow
   ca
   set w 1                          ;controls wave procedure
   set ph 0                         ;moves the sea along the shore
   ask patches with [(pxcor <= -11) and (pycor <= -17)][set pcolor 7]                 ;sets rock color
   ask patches with [(pxcor = -10) and (pycor = -19)][set pcolor 7]
   ask patches with [((pxcor = -10) or (pxcor = -9)) and (pycor = -20)][set pcolor 1] ;sets shade color
   ask patches with [((pxcor = -9) or (pxcor = -8)) and (pycor = -19)][set pcolor 1]
   ask patches with [(pxcor >= -12) and (pxcor <= -8) and (pycor = -18)][set pcolor 1]
   ask patches with [(pxcor >= -15) and (pxcor <= -10) and (pycor = -17)][set pcolor 1]
   ask patches with [(pxcor >= -30) and (pxcor <= -14) and (pycor = -16)][set pcolor 1]
end

to setup-nest-and-run-hatchlings
   if (w = 2)[
   crt 1
   ask turtle 0[set color 49 setxy 28 -5]                                                    ;setup predator
   crt 8
   ask turtles with [color != 49][set color 39 setxy 0 -18 set shape "turtle" set size 2     ;turtle nest
   repeat 10[set color color - 0.5 ask turtle 5[set color 39] fd 0.1 wait 1.25]set heading 0];hatching
   ask turtle 0[set heading 240 repeat 29[bird]]ask turtle 4[die]                            ;predator
   ask turtle 0[set heading 200 repeat 1[bird]ht setxy 0 -20]
   ask turtle 1[rt 5] ask turtle 2[rt 20] ask turtle 3[rt 30]                                ;heading turtles
   ask turtle 6[lt 84] ask turtle 7[rt 30]
   ask turtles with [color = 34][wait 2.5 repeat 35[walk]]                                   ;walk turtles
   ask turtle 0[st set heading 0 repeat 10[bird]] ask turtle 8[die]                          ;predator
   ask turtle 0[set heading 200 repeat 11[bird]ht setxy 28 -5]
   ask turtles with [color = 34][repeat 17[ifelse (color-ahead = 79)[fd 2 die][walk]]]       ;walk turtles
   ask turtle 0[st set heading 260 repeat 22[bird]] ask turtle 3[die]                        ;predator
   ask turtle 0[set heading 180 repeat 10[bird]ht die]
   ask turtles with [color = 34][repeat 20[ifelse (color-ahead = 79)[fd 2 die][walk]]]       ;walk turtles
   ask turtle 5[set color 33 repeat 15[walk]]                                                ;hatch eighth
   ask turtle 6[set color 33 set heading 0 repeat 5[walk]]                                   ;position T6
   ask turtle 5[repeat 100[ifelse (color-farahead = 49)[set color 34                         ;detect sea edge
   ask turtles with [color = 34][repeat 100[                                                 ;walk turtles
   ifelse (color-ahead = 79)[fd 2 die][walk]]]][wait 0.25]]]                                 ;detect sea                                                             ;walk turtles
   ask turtle 6 [set plabel-color 45 set plabel "T6 waits for sea to be furthest      "repeat 100[ ;walk T6
   ifelse (color-farahead = 49)[repeat 100[ifelse (color-ahead = 79)[               ;detect sea edge and sea
   set plabel-color 0 set plabel "'I' made it!" wait 2 die][walk]]][wait 0.25]]]    ;walk T6 into sea
   set w 3
   crt 1
   text-2 stop]
end

to run-waves
   every 0.26 [                                              ;"every 0.26" controls wave period
   ifelse (w = 3)[stop][set w 2 ask patches[
   ifelse (pcolor = 7)[set pcolor 7][                        ;retains rock color
   ifelse (pcolor = 1)[set pcolor 1][                        ;retains shade color
   ifelse ((pycor + 6 * sin(3 * pxcor + ph)) > random-int-or-float 5)[
   ifelse (random-int-or-float 50 = 0)[set pcolor 9.999][
   ifelse (pcolor = 49)[set pcolor 9.999][set pcolor 79]]][  ;sets sea colors
   set pcolor 49]]]]]                                        ;sets sands color
   set ph ph + 3]                                            ;to progress the sea along the shore
end

to walk
   fd 0.2 wait 0.25                                                      ;turtles walk
end

to bird
   set shape "bird-1" set color 6 set size 7 fd 0.5 wait 0.05             ;half of a flapping bird
   set shape "bird-2" set color 9.9 set size 6 fd 0.5 wait 0.05           ;the other half
end

to-report color-ahead
   report pcolor-of patch-at dx dy                                       ;detects sea
end

to-report color-farahead
   report pcolor-of patch-at (24 * dx) (24 * dy)                         ;detects distant sea edge
end

to text-1
   ask turtles[setxy 27 20 plcw set plabel
   "SELF-AWARENESS is for human beings that feeling of existing, it is the stuff of survival, it has an evolutionary advantage.       "]
   ask turtles[setxy 30 19 plcw set plabel
   "When spiced with emotion, meaning is added giving 'I', the subject of much philosophical and scientific debate; but how common is "]
   ask turtles[setxy 30 18 plcw set plabel
   "self-awareness and is it a simple property of conscious brain activity. This model will examine how self-awareness can be expected to"]
   ask turtles[setxy 22 17 plcw set plabel
   "arise in a conscious brain.                   NEXT go to Information for BACKGROUND plus notes on THE ANIMATION.  "]
   ask turtles[setxy 3 15 plcw set plabel
   "For THE ANIMATION Press SETUP ROCK, then SETUP NEST, then RUN."]
end

to text-2
   ask turtles[setxy -23 20 plcy set plabel
   "CONCLUSIONS "]
   ask turtles[setxy 29 19 plcy set plabel
   "On two occasions T6 observed, deliberated, decided and acted. That should qualify as conscious action, but could self-awareness  "]
   ask turtles[setxy 30 18 plcy set plabel
   "have been detected? Yes, if there was an interpretable act of communication, even if it was as little as an emotional wag of the tail. "]
   ask turtles[setxy 29 17 plcy set plabel
   "In the absence of language self-awareness can be so easily missed, it has no physical manifestation but it can be detected in other"]
   ask turtles[setxy 29 16 plcy set plabel
   "communications as described in BACKGROUND. There have been attempts to explain the source of self-awareness with inventions"]
   ask turtles[setxy 29 15 plcy set plabel
   "such as mind separate from the brain, or a homunculus or a single point of awareness or a special section or special activity, within"]
   ask turtles[setxy 29 14 plcy set plabel
   "the brain. Whereas, given that the brain is the creature, human or otherwise and the brain is aware of its own activity, like seeing,   "]
   ask turtles[setxy 16 13 plcy set plabel
   "like preparing something to be communicated, no more should be needed to explain self-awareness.  "]
   ask turtles[setxy 28 12 plcy set plabel
   "Self-awareness can be understood without recourse to special effects. It can be seen as the inevitable result of evolution giving   "]
   ask turtles[setxy 28 11 plcy set plabel
   "creatures the combination of some processing power together with a drive to communicate and the means to communicate. This"]
   ask turtles[setxy 30 10 plcy set plabel
   "drive to communicate is probably recognisable in all creatures with the mammalian brain, especially in those that form social groups."]
   ask turtles[setxy 30 9 plcy set plabel
   "The evolving brain of humans provided a lot of processing power and a drive to communicate as strong as that for procreation, also   "]
   ask turtles[setxy 30 8 plcy set plabel
   "the physiology for spoken language, the latter providing the brain of a human with outstanding opportunities for shared experience   "]
   ask turtles[setxy 28 7 plcy set plabel
   "and knowledge. When creatures communicate there is a need for identification and for those forming social groups identities are"]
   ask turtles[setxy 29 6 plcy set plabel
   "evident even when the means of communication are limited. So it must have been for early human beings but, when spoken         "]
   ask turtles[setxy 15 5 plcy set plabel
   "language arrived, identification by 'I' would have become essential to the communication process.  "]
   ask turtles[setxy -16 4 plcy set plabel
   "Thus everything was in place:   "]
   ask turtles[setxy 23 3 plcy set plabel
           "*the processing power coming from a huge number of neurons and an even larger number of interconnections"]
   ask turtles[setxy 10 2 plcy set plabel
           "*the cleverness coming from a genetic program and through nurture and culture   "]
   ask turtles[setxy 25 1 plcy set plabel
   "for a brain to imagine 'I' and self-awareness as transcendental phenomena; but, that can now be considered an illusion.   "]
   ask turtles[setxy 7 0 plcy set plabel
   "Yes, but what is it 'to imagine'?.........Good question, that requires another model. "]
end

to plcw
   ht set plabel-color 9.999
end

to plcy
   ht set plabel-color 15
end






@#$#@#$#@
GRAPHICS-WINDOW
155
10
792
462
30
20
10.28
1
10
1
1
1
0
1
1
1

CC-WINDOW
5
476
801
571
Command Center
0

BUTTON
24
96
121
129
setup rock
setup-rock&shadow
NIL
1
T
OBSERVER
T
NIL

BUTTON
22
193
118
226
run
run-waves
T
1
T
OBSERVER
T
NIL

BUTTON
22
145
120
178
setup nest
setup-nest-and-run-hatchlings
T
1
T
OBSERVER
T
NIL

BUTTON
24
48
121
81
NIL
open
NIL
1
T
OBSERVER
T
NIL

@#$#@#$#@
SELF-AWARENESS is for human beings that feeling of existing, it is the stuff of survival, it has an evolutionary advantage. When spiced with emotion, meaning is added giving 'I', the subject of much philosophical and scientific debate; but how common is self-awareness and is it a simple property of
conscious brain activity. This model will examine how self-awareness can be expected to arise in
a conscious brain.
BACKGROUND
Creatures have a brain that provides automatic responses for several important requirements of its body, including body regulation, mobility plus survival actions and the initial processing of sensor inputs.
This limited brain is without consciousness and is sometimes called the reptilian brain. Mammals have
the reptilian brain providing the automatic responses but with some additions. First improved general abilities, then consciousness with anything from tiny to vast information processing power. After a
learning phase, a mammalian brain is able to deal with matters tolerant of some time delay and requiring individual consideration. A conscious brain gains greatly from language and communication with other
brains, but without these, offers much less evolutionary advantage. Self-awareness is easily made
evident through language but it should be detectable from other forms of communication. To display intentionally is to be self-aware. A creature will have a reason for deliberately communicating and to
have a reason is to be self-aware. Therefore if creatures with a mammalian brain communicate what is
clearly not a reflex, automatic gesture or display by the unconscious brain, it is very likely that the creatures are being self-aware.
THE ANIMATION
   [Disclaimer: Turtles as reptiles have the unconscious reptilian brain, but the author felt
                obliged to choose them for the animation because of the origins of Logo turtles,
                that is from studies of the brain, see FR 1 & 2 below]
         Press OPEN for an introduction, then SETUP ROCK, then SETUP NEST, then RUN.                          The model opens on a sandy beach, with the outline of a turtles nest adjacent to a rock, which is making
a shadow. Seven of eight turtles hatch but a predator appears, a silver-wing gull, and takes a hatchling.
Five make for the water but turtle 6 (T6) has noticed that things are less distinct in shadow and moves
to the shadow of the nearby rock. Two more hatchlings are lost and three continue to the sea; also the
last turtle hatches and makes for the water. T6 watches them all and in particular the last to hatch.
>From this T6 concludes that the walk to the sea will be shortest if started when the sea is at its
furthest from its position. The ('I' made it!) label is what T6 might have said given the power of
speech; alternatively, emotion might have wagged its tail. Finally CONCLUSIONS appear on the display.

CONCLUSIONS
On two occasions T6 observed, deliberated, decided and acted. That should qualify as conscious action,
but could self-awareness have been detected? Yes, if there was an interpretable act of communication,
even if it was as little as an emotional wag of the tail. In the absence of language self-awareness can
be so easily missed, it has no physical manifestation but it can be detected in other communications
as described in BACKGROUND. There have been attempts to explain the source of self-awareness with
inventions such as mind separate from the brain, or a homunculus or a single point of awareness or a
special section or special activity, within the brain. Whereas, given that the brain is the creature,
human or otherwise and the brain is aware of its own activity, like seeing, like preparing something
to be communicated, no more should be needed to explain self-awareness. Self-awareness can be under-
stood without recourse to special effects. It can be seen as the inevitable result of evolution giving
creatures the combination of some processing power together with a drive to communicate and the means
to communicate. This drive to communicate is probably recognisable in all creatures with the mammalian
brain, especially in those that form social groups. The evolving brain of humans provided a lot of
processing power and a drive to communicate as strong as that for procreation, also the physiology for
spoken language, the latter providing the brain with outstanding opportunities for shared experience
and knowledge. When creatures communicate there is a need for identification and for those forming
social groups identities are evident even when the means of communication are limited. So it must have
been for early human beings but, when spoken language arrived, identification by 'I' would have become
essential to the communication process.
Thus everything was in place:
 *the processing power coming from a huge number of neurons and an even larger number of interconnections
 *the cleverness coming from a genetic program and through nurture and culture
for a brain to imagine 'I' and SELF-AWARENESS as transcendental phenomena; but, that can now be considered
                                                                                              an illusion.
Yes, but what is it "to imagine"?........Good question, that requires another model.

FURTHER READING
FR. 1 http://lcs.www.media.mit.edu/groups/el/projects/circles/turtles.html
FR. 2 The Living Brain by W.Grey Walter. Duckworth, London, 1953.
FR. 3 Mapping The Mind by Rita Carter. Weidenfeld & Nicolson, London, 1998. ISBN 0 297 62330 2
FR. 4 Conciousness-How Matter Becomes Imagination by Gerald M. Edelman and Giulio Tononi.
       Penguin, London, 2000, also in the USA as A Universe of Conciousness, Perseus Books, 2000.
FR. 5 Phantoms In The Brain-Human Nature And The Architecture Of The Mind by V.S. Ramachandran
       and Sandra Blakeslee. Fourth Estate, London 1998. ISBN 1 85702 895 3
FR. 6 The Human Computer by Mark Jeffery. Little, Brown and Company, London, 1999. ISBN 0 7515 2847 1


































@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

ant
true
0
Polygon -7500403 true true 136 61 129 46 144 30 119 45 124 60 114 82 97 37 132 10 93 36 111 84 127 105 172 105 189 84 208 35 171 11 202 35 204 37 186 82 177 60 180 44 159 32 170 44 165 60
Polygon -7500403 true true 150 95 135 103 139 117 125 149 137 180 135 196 150 204 166 195 161 180 174 150 158 116 164 102
Polygon -7500403 true true 149 186 128 197 114 232 134 270 149 282 166 270 185 232 171 195 149 186
Polygon -7500403 true true 225 66 230 107 159 122 161 127 234 111 236 106
Polygon -7500403 true true 78 58 99 116 139 123 137 128 95 119
Polygon -7500403 true true 48 103 90 147 129 147 130 151 86 151
Polygon -7500403 true true 65 224 92 171 134 160 135 164 95 175
Polygon -7500403 true true 235 222 210 170 163 162 161 166 208 174
Polygon -7500403 true true 249 107 211 147 168 147 168 150 213 150

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

bee
true
0
Polygon -1184463 true false 152 149 77 163 67 195 67 211 74 234 85 252 100 264 116 276 134 286 151 300 167 285 182 278 206 260 220 242 226 218 226 195 222 166
Polygon -16777216 true false 150 149 128 151 114 151 98 145 80 122 80 103 81 83 95 67 117 58 141 54 151 53 177 55 195 66 207 82 211 94 211 116 204 139 189 149 171 152
Polygon -7500403 true true 151 54 119 59 96 60 81 50 78 39 87 25 103 18 115 23 121 13 150 1 180 14 189 23 197 17 210 19 222 30 222 44 212 57 192 58
Polygon -16777216 true false 70 185 74 171 223 172 224 186
Polygon -16777216 true false 67 211 71 226 224 226 225 211 67 211
Polygon -16777216 true false 91 257 106 269 195 269 211 255
Line -1 false 144 100 70 87
Line -1 false 70 87 45 87
Line -1 false 45 86 26 97
Line -1 false 26 96 22 115
Line -1 false 22 115 25 130
Line -1 false 26 131 37 141
Line -1 false 37 141 55 144
Line -1 false 55 143 143 101
Line -1 false 141 100 227 138
Line -1 false 227 138 241 137
Line -1 false 241 137 249 129
Line -1 false 249 129 254 110
Line -1 false 253 108 248 97
Line -1 false 249 95 235 82
Line -1 false 235 82 144 100

bird-1
false
0
Polygon -7500403 true true 2 6 2 39 270 298 297 298 299 271 187 160 279 75 276 22 100 67 31 0

bird-2
false
0
Polygon -7500403 true true 2 4 33 4 298 270 298 298 272 298 155 184 117 289 61 295 61 105 0 43

boat1
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6459832 true false 150 32 157 162
Polygon -13345367 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7500403 true true 158 33 230 157 182 150 169 151 157 156
Polygon -7500403 true true 149 55 88 143 103 139 111 136 117 139 126 145 130 147 139 147 146 146 149 55

boat2
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6459832 true false 150 32 157 162
Polygon -13345367 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7500403 true true 157 54 175 79 174 96 185 102 178 112 194 124 196 131 190 139 192 146 211 151 216 154 157 154
Polygon -7500403 true true 150 74 146 91 139 99 143 114 141 123 137 126 131 129 132 139 142 136 126 142 119 147 148 147

boat3
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6459832 true false 150 32 157 162
Polygon -13345367 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7500403 true true 158 37 172 45 188 59 202 79 217 109 220 130 218 147 204 156 158 156 161 142 170 123 170 102 169 88 165 62
Polygon -7500403 true true 149 66 142 78 139 96 141 111 146 139 148 147 110 147 113 131 118 106 126 71

box
true
0
Polygon -7500403 true true 45 255 255 255 255 45 45 45

butterfly1
true
0
Polygon -16777216 true false 151 76 138 91 138 284 150 296 162 286 162 91
Polygon -7500403 true true 164 106 184 79 205 61 236 48 259 53 279 86 287 119 289 158 278 177 256 182 164 181
Polygon -7500403 true true 136 110 119 82 110 71 85 61 59 48 36 56 17 88 6 115 2 147 15 178 134 178
Polygon -7500403 true true 46 181 28 227 50 255 77 273 112 283 135 274 135 180
Polygon -7500403 true true 165 185 254 184 272 224 255 251 236 267 191 283 164 276
Line -7500403 true 167 47 159 82
Line -7500403 true 136 47 145 81
Circle -7500403 true true 165 45 8
Circle -7500403 true true 134 45 6
Circle -7500403 true true 133 44 7
Circle -7500403 true true 133 43 8

circle
true
0
Circle -7500403 true true 11 12 277

person
false
0
Circle -7500403 true true 155 20 63
Rectangle -7500403 true true 158 79 217 164
Polygon -7500403 true true 158 81 110 129 131 143 158 109 165 110
Polygon -7500403 true true 216 83 267 123 248 143 215 107
Polygon -7500403 true true 167 163 145 234 183 234 183 163
Polygon -7500403 true true 195 163 195 233 227 233 206 159

spacecraft
true
0
Polygon -7500403 true true 150 0 180 135 255 255 225 240 150 180 75 240 45 255 120 135

thin-arrow
true
0
Polygon -7500403 true true 150 0 0 150 120 150 120 293 180 293 180 150 300 150

truck-down
false
0
Polygon -7500403 true true 225 30 225 270 120 270 105 210 60 180 45 30 105 60 105 30
Polygon -8630108 true false 195 75 195 120 240 120 240 75
Polygon -8630108 true false 195 225 195 180 240 180 240 225

truck-left
false
0
Polygon -7500403 true true 120 135 225 135 225 210 75 210 75 165 105 165
Polygon -8630108 true false 90 210 105 225 120 210
Polygon -8630108 true false 180 210 195 225 210 210

truck-right
false
0
Polygon -7500403 true true 180 135 75 135 75 210 225 210 225 165 195 165
Polygon -8630108 true false 210 210 195 225 180 210
Polygon -8630108 true false 120 210 105 225 90 210

turtle
true
0
Polygon -7500403 true true 138 75 162 75 165 105 225 105 225 142 195 135 195 187 225 195 225 225 195 217 195 202 105 202 105 217 75 225 75 195 105 187 105 135 75 142 75 105 135 105

wolf-left
false
3
Polygon -6459832 true true 117 97 91 74 66 74 60 85 36 85 38 92 44 97 62 97 81 117 84 134 92 147 109 152 136 144 174 144 174 103 143 103 134 97
Polygon -6459832 true true 87 80 79 55 76 79
Polygon -6459832 true true 81 75 70 58 73 82
Polygon -6459832 true true 99 131 76 152 76 163 96 182 104 182 109 173 102 167 99 173 87 159 104 140
Polygon -6459832 true true 107 138 107 186 98 190 99 196 112 196 115 190
Polygon -6459832 true true 116 140 114 189 105 137
Rectangle -6459832 true true 109 150 114 192
Rectangle -6459832 true true 111 143 116 191
Polygon -6459832 true true 168 106 184 98 205 98 218 115 218 137 186 164 196 176 195 194 178 195 178 183 188 183 169 164 173 144
Polygon -6459832 true true 207 140 200 163 206 175 207 192 193 189 192 177 198 176 185 150
Polygon -6459832 true true 214 134 203 168 192 148
Polygon -6459832 true true 204 151 203 176 193 148
Polygon -6459832 true true 207 103 221 98 236 101 243 115 243 128 256 142 239 143 233 133 225 115 214 114

wolf-right
false
3
Polygon -6459832 true true 170 127 200 93 231 93 237 103 262 103 261 113 253 119 231 119 215 143 213 160 208 173 189 187 169 190 154 190 126 180 106 171 72 171 73 126 122 126 144 123 159 123
Polygon -6459832 true true 201 99 214 69 215 99
Polygon -6459832 true true 207 98 223 71 220 101
Polygon -6459832 true true 184 172 189 234 203 238 203 246 187 247 180 239 171 180
Polygon -6459832 true true 197 174 204 220 218 224 219 234 201 232 195 225 179 179
Polygon -6459832 true true 78 167 95 187 95 208 79 220 92 234 98 235 100 249 81 246 76 241 61 212 65 195 52 170 45 150 44 128 55 121 69 121 81 135
Polygon -6459832 true true 48 143 58 141
Polygon -6459832 true true 46 136 68 137
Polygon -6459832 true true 45 129 35 142 37 159 53 192 47 210 62 238 80 237
Line -16777216 false 74 237 59 213
Line -16777216 false 59 213 59 212
Line -16777216 false 58 211 67 192
Polygon -6459832 true true 38 138 66 149
Polygon -6459832 true true 46 128 33 120 21 118 11 123 3 138 5 160 13 178 9 192 0 199 20 196 25 179 24 161 25 148 45 140
Polygon -6459832 true true 67 122 96 126 63 144
Rectangle -13840069 true false 223 105 227 109

@#$#@#$#@
NetLogo 3.0pre5
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
