globals     [it's-r/phi        ;iterations of the r/phi calculation
             it's-lt/fd        ;     "      "  "  lt/fd       "
             it's-sh/lt/fd     ;     "      "  "  sh/lt/fd    "
             phi               ;polar coordinate angle of rotation
             B-1 & B-2         ;angles in the pair of triangles for calculation of 'lt' and 'fd'
            ]

to setup
   cp cp ct ct
   crt 1
   set it's-r/phi 0
   set it's-lt/fd 0
   set it's-sh/lt/fd 0
   set phi 0
end

to go-r/phi                                              ;converts from polar coordinates 'r' 'phi'
   ask turtles[                                          ;to cartesian for the display
   setxy 0 0 set heading 0
   repeat 10000[
   ifelse ((xcor >= 199) or (xcor <= -199) or            ;stops calculation with trace
   (ycor >= 199) or (ycor <= -199))[stop]                ;at edge of display
   [set phi 0 + (0.5 * it's-r/phi)                       ;sets angle increments of 0.5 degree
   set xcor r * cos phi                                  ;calculates Cartesian
   set ycor r * sin phi                                  ;coordinates
   set pcolor 45                                              ;colours trace
   if it's-r/phi = 2[type"r/phi xcor"print xcor
   type"r/phi ycor"print ycor type"heading"print heading];see comment in INFORMATION
   if plots = true[plot-run-r/phi]
   set it's-r/phi it's-r/phi + 1]]]
end

to-report r                                              ;polar radius formulae
   ifelse spirals = 1
   [report s * 1 * (2 * pi * phi / 360)]                 ;Archimedes
   [ifelse spirals = 2
   [report s * 10 * sqrt(1 + (2 * pi * phi / 360) ^ 2)]  ;evolute
   [ifelse spirals = 3
   [report exp(s / 10 * (2 * pi * phi / 360))]           ;logarithmic
   [report 0]]]
end

                 ;the lt/fd caculation uses the cosine formula etc and two triangles with a common side
to go-lt/fd      ;which are made from 3 consecutive values of the polar radius 'r', see INFORMATION PAGE
   ask turtles[
   set heading 0 set color 15 pd
   ifelse spirals = 1[setxy 0 (s * -0.0001525) rt 90][   ;sets start conditions
   ifelse spirals = 2[setxy (s * 10) 0][                 ;  "     "       "
   if spirals = 3[setxy 1 0 rt(s * 5.35)]]]              ;  "      "       " (also see comment in INFORMATION)
   repeat 10000[
   ifelse ((xcor >= 199) or (xcor <= -199) or            ;stops calculation with trace
   (ycor >= 199) or (ycor <= -199))[stop][               ;at edge of display
   set B-1 asin (b1 * sin 0.5 / a1)                      ;the angle opposite the side b1
   set B-2 asin (b2 * sin 0.5 / a2)                      ;the angle opposite the side b2
   lt (B-2 - B-1)                                        ;display requires lt 'angle'
   fd a2                                                 ;display requires fd 'step'
   if it's-lt/fd = 1[type"lt/fd xcor"print xcor
   type"lt/fd ycor"print ycor type"heading"print heading];see comment in INFORMATION
   if plots = true[plot-run-lt/fd]
   set it's-lt/fd it's-lt/fd + 1]]]
end

to-report b1                                             ;a side of one of the triangles
   set phi 0.5 * it's-lt/fd                              ;and the radius 'r' at the previous iteration
   report r
end

to-report c                                              ;the common side of the two triangles
   set phi 0.5 * (it's-lt/fd + 1)                        ;and the radius 'r' at the iteration now
   report r
end

to-report b2                                             ;a side of one the triangles
   set phi 0.5 * (it's-lt/fd + 2)                        ;and the radius 'r' at the next iteration
   report r
end

to-report a1                                                 ;a side of one of the triangles and the
   report sqrt((b1 ^ 2) + (c ^ 2) - (2 * b1 * c * cos 0.5))  ;step forward made at the previous iteration
end

to-report a2                                                 ;a side of one of the triangles and the
   report sqrt((b2 ^ 2) + (c ^ 2) - (2 * b2 * c * cos 0.5))  ;step forward at this iteration
end
                       ;The sh/lt/fd procedure is a shorter, approximate lt/fd code, derived by
to go-sh/lt/fd         ;matching sh/lt/fd plots of lt and fd with those of the lt/fd procedure
   ask turtles[
   set heading 0 set color 65 pd
   ifelse spirals = 1[setxy 0 -0.0001525 rt 90][         ;sets start conditions
   ifelse spirals = 2[setxy (s * 10) 0][                 ; "      "       "
   if spirals = 3[setxy 1 0 rt (s * 5.8)]]]              ; "      "       "
   repeat 10000[
   ifelse ((xcor >= 199) or (xcor <= -199) or            ;stops calculation with trace
   (ycor >= 199) or (ycor <= -199))[stop][               ;at edge of display
   set phi 0.5 + (0.5 * it's-sh/lt/fd)
   lt beta                                               ;see derived code below
   fd delta                                              ;see derived code below
   if plots = true[plot-run-sh/lt/fd]
   set it's-sh/lt/fd it's-sh/lt/fd + 1]]]
end

to-report beta
    ifelse spirals = 1
   [report  0.5 + (0.5 / (1 + (0.007 * it's-sh/lt/fd) ^ 3))]        ;Archimedes
   [ifelse spirals = 2
   [report 0.55 - (0.5 / (1 + (0.024 * it's-sh/lt/fd) ^ 2))]        ;evolute
   [if spirals = 3
   [report 0.5]]]                                                   ;logarithmic
end

to-report delta
    ifelse spirals = 1
   [report (s * it's-sh/lt/fd * 0.000076)]                            ;Archimedes
   [ifelse spirals = 2
   [report (s * (0.125 + (0.85 / 1157 * (it's-sh/lt/fd - 100))))]     ;evolute
   [if spirals = 3
   [report s * ((it's-sh/lt/fd / 3250) ^ 3.9)]]]                      ;logarithmic
end

to plot-run-r/phi
   set-current-plot "spirals using r/phi, lt/fd and sh/lt/fd code"
   set-current-plot-pen "r"
   plot r / 100
   set-current-plot-pen "phi"
   plot phi / 5000
end

to plot-run-lt/fd
   set-current-plot "spirals using r/phi, lt/fd and sh/lt/fd code"
   set-current-plot-pen "lt"
   plot (B-2 - B-1)
   set-current-plot-pen "fd"
   plot a2
end

to plot-run-sh/lt/fd
   set-current-plot "spirals using r/phi, lt/fd and sh/lt/fd code"
   set-current-plot-pen "sh/lt"
   plot beta
   set-current-plot-pen "sh/fd"
   plot delta
end












@#$#@#$#@
GRAPHICS-WINDOW
367
10
778
442
200
200
1.0
1
10
1
1
1
0
1
1
1

CC-WINDOW
5
457
787
552
Command Center
0

MONITOR
77
134
138
183
NIL
it's-r/phi
0
1

BUTTON
2
144
70
177
run r/phi
go-r/phi
NIL
1
T
OBSERVER
T
NIL

BUTTON
141
207
209
282
NIL
setup
NIL
1
T
OBSERVER
T
NIL

SLIDER
146
170
358
203
s
s
1
5
5.0
0.1
1
NIL

CHOOSER
5
10
122
55
spirals
spirals
1 2 3
0

TEXTBOX
43
60
134
108
1 Archimedes\n2 evolute\n3 logarithmic\n

BUTTON
3
192
72
225
run lt/fd
go-lt/fd
NIL
1
T
OBSERVER
T
NIL

MONITOR
76
184
138
233
NIL
it's-lt/fd
0
1

BUTTON
3
240
71
273
run sh/lt/fd
go-sh/lt/fd
NIL
1
T
OBSERVER
T
NIL

MONITOR
75
234
138
283
NIL
it's-sh/lt/fd
0
1

BUTTON
271
209
361
242
clear plots
clear-plot
NIL
1
T
OBSERVER
T
NIL

MONITOR
211
220
268
269
NIL
phi
2
1

SWITCH
272
248
362
281
plots
plots
1
1
-1000

PLOT
6
285
364
443
spirals using r/phi, lt/fd and sh/lt/fd code
it's-r/phi or it's-lt/fd or it's-sh/lt/fd
r,phi,lt,fd,sh/lt,sh/fd
0.0
1000.0
0.0
1.0
true
true
PENS
"r" 1.0 0 -16777216 true
"phi" 1.0 0 -955883 true
"lt" 1.0 0 -13345367 true
"fd" 1.0 0 -10899396 true
"sh/lt" 1.0 0 -6459832 true
"sh/fd" 1.0 0 -5825686 true

@#$#@#$#@
Model SPIRALS & CURVE MATCHING

BACKGROUND
-------------
Alternative procedures for displaying spirals are examined and a procedure for matching equations
to curves is developed, which may have other applications.
Anyone of three well known spirals can be displayed by selection at the CHOICE widget.
The Archimedes spiral is generated by a rotation plus a constant velocity crossways displacement
as in the case of a gramophone record, giving an equidistance spacing between the lines.
Both the evolute and the logarithmic spirals are growth spirals in which the spacing between the
lines increases.

The original spirals were generated with the polar, r/phi procedure, the more natural from a
mathematical point of view; but to display conversion to cartesian coordinates was used.

The scale factor 's' can be adjusted to alter the spacing between the lines and therefore the
"length" of the spirals displayed.

Following a comment made by Seth Tisue at CCL, June 2003, lt/fd procedures were explored and added
as follows:
Using from the r/phi procedure, the cartesian coordinates of calculations of 3 iterations, previous,
now and next was a possibility. However completing the right-angled triangles between these and solving
for lt and fd was somewhat clumsy; so a similar method using the polar radii of iterations, previous 'b1',
now 'c' and next 'b2', was chosen:
                                  where A is the constant 0.5 angular step of the polar r/phi code
        ___a2__ ___a1__           hence 'a1' becomes the previous step forward or 'fd' of the lt/fd code
        \C2  B2|B1  C1/           also  'a2'    "     "    next     "     "     "   "   "  "    "    "
         \     |     /            and 'B2' - 'B1' becomes the angular step or 'lt' of the lt/fd code.
        b2\   c|c   /b1
           \   |   /              And the cosine formula  a = sqroot[bxb + cxc - 2xbxcxcosA]
            \  |  /                             also a/sinA = b/sinB = c/sinC are available.
             \A|A/
              \|/                 Overlaying the displays of the r/phi and lt/fd procedures shows that
               |                  the match is very good, including over the range of 's'.

It is possible to obtain an approximate match with a shorter procedure,identified as sh/lt/fd, by
comparing the PLOTS of the sh/lt/fd equations with those of the lt/fd equations and modifying the
sh/lt/fd equations to obtain a close fit. The results for the Archimedes spiral, (the simplest), are acceptable. The other equations have been left half finished for the amusement of model viewers who
wish to try their hand at "fitting an equation to a curve techniques" and then overlaying the spiral
that is generated to see if the match of sh/lt/fd against r/phi is good.

USING THE MODEL TO DISPLAY THE SPIRALS
--------------------------------------
First CHOOSE a spiral, select a value for 's' and press SETUP. Then RUN one procedure followed by another
if observing the match by overlaying; otherwise press SETUP in between RUNNING procedures.
It runs quicker with PLOTS switched OFF.
The overlay with close matching is difficult to see, so r/phi writes in yellow, lt/fd writes in red and
sh/lt/fd writes in lime.
It may be instructive to run the r/phi procedure with PLOTS switched ON but not when fitting an equation
to a curve, when it could be confusing.

USING THE MODEL TO FIT AN EQUATION TO A CURVE
---------------------------------------------
First CHOOSE a spiral, select a value for 's' and press SETUP.
With PLOTS switched ON the lt/fd procedure should be RUN  to plot the curves of 'lt' and 'fd'; followed
directly by the sh/lt/fd procedure to examine how closely its 'lt' and 'fd' plots follow those of lt/fd.
The fit of these curves may suggest a change to the sh/lt/fd equations for 'lt'(beta) and 'fd'(delta) to
obtain a better match when overlaying the spiral that is generated.
If all else fails there is always the START conditions to give that last tweek to the match.

COMMENT
-------
The START conditions, 'xcor', 'ycor' and 'heading' are important in acheiving a good match between the
spirals generated by the r/phi procedure and by the lt/fd procedures. To assist this process code has been included to print these values in the COMMAND CENTER. The heading value can change the xcor&ycor figures.
Over a 5 : 1 range of values of 's' it does appear possible to obtain a near perfect match of the spirals
drawn by procedure r/phi and procedure lt/fd. Perhaps a perfect match of the displayed spirals is not
possible because steps in the display result from finite pixel size.

The Author Derek Rush may be contacted by Email at derekrush@beeb.net           October 2002 and July 2003.




@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

ant
true
0
Polygon -7500403 true true 136 61 129 46 144 30 119 45 124 60 114 82 97 37 132 10 93 36 111 84 127 105 172 105 189 84 208 35 171 11 202 35 204 37 186 82 177 60 180 44 159 32 170 44 165 60
Polygon -7500403 true true 150 95 135 103 139 117 125 149 137 180 135 196 150 204 166 195 161 180 174 150 158 116 164 102
Polygon -7500403 true true 149 186 128 197 114 232 134 270 149 282 166 270 185 232 171 195 149 186
Polygon -7500403 true true 225 66 230 107 159 122 161 127 234 111 236 106
Polygon -7500403 true true 78 58 99 116 139 123 137 128 95 119
Polygon -7500403 true true 48 103 90 147 129 147 130 151 86 151
Polygon -7500403 true true 65 224 92 171 134 160 135 164 95 175
Polygon -7500403 true true 235 222 210 170 163 162 161 166 208 174
Polygon -7500403 true true 249 107 211 147 168 147 168 150 213 150

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

bee
true
0
Polygon -1184463 true false 152 149 77 163 67 195 67 211 74 234 85 252 100 264 116 276 134 286 151 300 167 285 182 278 206 260 220 242 226 218 226 195 222 166
Polygon -16777216 true false 150 149 128 151 114 151 98 145 80 122 80 103 81 83 95 67 117 58 141 54 151 53 177 55 195 66 207 82 211 94 211 116 204 139 189 149 171 152
Polygon -7500403 true true 151 54 119 59 96 60 81 50 78 39 87 25 103 18 115 23 121 13 150 1 180 14 189 23 197 17 210 19 222 30 222 44 212 57 192 58
Polygon -16777216 true false 70 185 74 171 223 172 224 186
Polygon -16777216 true false 67 211 71 226 224 226 225 211 67 211
Polygon -16777216 true false 91 257 106 269 195 269 211 255
Line -1 false 144 100 70 87
Line -1 false 70 87 45 87
Line -1 false 45 86 26 97
Line -1 false 26 96 22 115
Line -1 false 22 115 25 130
Line -1 false 26 131 37 141
Line -1 false 37 141 55 144
Line -1 false 55 143 143 101
Line -1 false 141 100 227 138
Line -1 false 227 138 241 137
Line -1 false 241 137 249 129
Line -1 false 249 129 254 110
Line -1 false 253 108 248 97
Line -1 false 249 95 235 82
Line -1 false 235 82 144 100

bird1
false
0
Polygon -7500403 true true 2 6 2 39 270 298 297 298 299 271 187 160 279 75 276 22 100 67 31 0

bird2
false
0
Polygon -7500403 true true 2 4 33 4 298 270 298 298 272 298 155 184 117 289 61 295 61 105 0 43

boat1
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6459832 true false 150 32 157 162
Polygon -13345367 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7500403 true true 158 33 230 157 182 150 169 151 157 156
Polygon -7500403 true true 149 55 88 143 103 139 111 136 117 139 126 145 130 147 139 147 146 146 149 55

boat2
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6459832 true false 150 32 157 162
Polygon -13345367 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7500403 true true 157 54 175 79 174 96 185 102 178 112 194 124 196 131 190 139 192 146 211 151 216 154 157 154
Polygon -7500403 true true 150 74 146 91 139 99 143 114 141 123 137 126 131 129 132 139 142 136 126 142 119 147 148 147

boat3
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6459832 true false 150 32 157 162
Polygon -13345367 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7500403 true true 158 37 172 45 188 59 202 79 217 109 220 130 218 147 204 156 158 156 161 142 170 123 170 102 169 88 165 62
Polygon -7500403 true true 149 66 142 78 139 96 141 111 146 139 148 147 110 147 113 131 118 106 126 71

box
true
0
Polygon -7500403 true true 45 255 255 255 255 45 45 45

butterfly1
true
0
Polygon -16777216 true false 151 76 138 91 138 284 150 296 162 286 162 91
Polygon -7500403 true true 164 106 184 79 205 61 236 48 259 53 279 86 287 119 289 158 278 177 256 182 164 181
Polygon -7500403 true true 136 110 119 82 110 71 85 61 59 48 36 56 17 88 6 115 2 147 15 178 134 178
Polygon -7500403 true true 46 181 28 227 50 255 77 273 112 283 135 274 135 180
Polygon -7500403 true true 165 185 254 184 272 224 255 251 236 267 191 283 164 276
Line -7500403 true 167 47 159 82
Line -7500403 true 136 47 145 81
Circle -7500403 true true 165 45 8
Circle -7500403 true true 134 45 6
Circle -7500403 true true 133 44 7
Circle -7500403 true true 133 43 8

circle
false
0
Circle -7500403 true true 35 35 230

person
false
0
Circle -7500403 true true 155 20 63
Rectangle -7500403 true true 158 79 217 164
Polygon -7500403 true true 158 81 110 129 131 143 158 109 165 110
Polygon -7500403 true true 216 83 267 123 248 143 215 107
Polygon -7500403 true true 167 163 145 234 183 234 183 163
Polygon -7500403 true true 195 163 195 233 227 233 206 159

spacecraft
true
0
Polygon -7500403 true true 150 0 180 135 255 255 225 240 150 180 75 240 45 255 120 135

thin-arrow
true
0
Polygon -7500403 true true 150 0 0 150 120 150 120 293 180 293 180 150 300 150

truck-down
false
0
Polygon -7500403 true true 225 30 225 270 120 270 105 210 60 180 45 30 105 60 105 30
Polygon -8630108 true false 195 75 195 120 240 120 240 75
Polygon -8630108 true false 195 225 195 180 240 180 240 225

truck-left
false
0
Polygon -7500403 true true 120 135 225 135 225 210 75 210 75 165 105 165
Polygon -8630108 true false 90 210 105 225 120 210
Polygon -8630108 true false 180 210 195 225 210 210

truck-right
false
0
Polygon -7500403 true true 180 135 75 135 75 210 225 210 225 165 195 165
Polygon -8630108 true false 210 210 195 225 180 210
Polygon -8630108 true false 120 210 105 225 90 210

turtle
true
0
Polygon -7500403 true true 138 75 162 75 165 105 225 105 225 142 195 135 195 187 225 195 225 225 195 217 195 202 105 202 105 217 75 225 75 195 105 187 105 135 75 142 75 105 135 105

wolf-left
false
3
Polygon -6459832 true true 117 97 91 74 66 74 60 85 36 85 38 92 44 97 62 97 81 117 84 134 92 147 109 152 136 144 174 144 174 103 143 103 134 97
Polygon -6459832 true true 87 80 79 55 76 79
Polygon -6459832 true true 81 75 70 58 73 82
Polygon -6459832 true true 99 131 76 152 76 163 96 182 104 182 109 173 102 167 99 173 87 159 104 140
Polygon -6459832 true true 107 138 107 186 98 190 99 196 112 196 115 190
Polygon -6459832 true true 116 140 114 189 105 137
Rectangle -6459832 true true 109 150 114 192
Rectangle -6459832 true true 111 143 116 191
Polygon -6459832 true true 168 106 184 98 205 98 218 115 218 137 186 164 196 176 195 194 178 195 178 183 188 183 169 164 173 144
Polygon -6459832 true true 207 140 200 163 206 175 207 192 193 189 192 177 198 176 185 150
Polygon -6459832 true true 214 134 203 168 192 148
Polygon -6459832 true true 204 151 203 176 193 148
Polygon -6459832 true true 207 103 221 98 236 101 243 115 243 128 256 142 239 143 233 133 225 115 214 114

wolf-right
false
3
Polygon -6459832 true true 170 127 200 93 231 93 237 103 262 103 261 113 253 119 231 119 215 143 213 160 208 173 189 187 169 190 154 190 126 180 106 171 72 171 73 126 122 126 144 123 159 123
Polygon -6459832 true true 201 99 214 69 215 99
Polygon -6459832 true true 207 98 223 71 220 101
Polygon -6459832 true true 184 172 189 234 203 238 203 246 187 247 180 239 171 180
Polygon -6459832 true true 197 174 204 220 218 224 219 234 201 232 195 225 179 179
Polygon -6459832 true true 78 167 95 187 95 208 79 220 92 234 98 235 100 249 81 246 76 241 61 212 65 195 52 170 45 150 44 128 55 121 69 121 81 135
Polygon -6459832 true true 48 143 58 141
Polygon -6459832 true true 46 136 68 137
Polygon -6459832 true true 45 129 35 142 37 159 53 192 47 210 62 238 80 237
Line -16777216 false 74 237 59 213
Line -16777216 false 59 213 59 212
Line -16777216 false 58 211 67 192
Polygon -6459832 true true 38 138 66 149
Polygon -6459832 true true 46 128 33 120 21 118 11 123 3 138 5 160 13 178 9 192 0 199 20 196 25 179 24 161 25 148 45 140
Polygon -6459832 true true 67 122 96 126 63 144

@#$#@#$#@
NetLogo 3.0pre5
@#$#@#$#@
setup
go-r/phi
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
