globals [
          init        ;; peut on lancer le programme
          modeaffich  ;;la derniere chose afficher entre piste et phero
          ptdepartx    ;;coord du point de depart des fourmis
          ptdeparty
          ptciblex      ;;idem pour la cible, sert  donner l'orientation de dpart
          ptcibley
          nbfourmis    ;; on peut faireevoluer le nombre de fourmis, et on controle leur depart (pas plus d'une par cycle)
          bords        ;; on ne doit pas avoir de pheromones qui circulent par diffusion entre les bords opposs

          hautm
          basm
          hautr
          basr        ;; pour adapter l'echelle des degrade
        ]

patches-own[
            surface    ;; paramtre qui dfinit si le terrain est vide ou un morceau de chemin
            depart?   ;; la surface est-elle une partie du point de dpart
            cible?    ;; idem pour la cible
            phero-rentrer  ;;valeur des phromones permettant le retour au nid
            phero-miam  ;;valeur des phromones permettant d'aller  la source de nourriture
         ]

turtles-own[
            transport?  ;; vrai si la fourmis ramne de la nourriture (donc rentre  la fourmilire)
            stock-phero-miam ;; plus on s'eloigne de la source, moins on depose
            stock-phero-rentrer ;;idem pour la maison
            ]

;;;;; le monde va de -32  +32 en x et y


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; PHASE D'INITIALISATION
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to initialiser
locals [agent vitrech vitret]
ifelse( not (is-boolean? init) )
[
;; 1ere utilisation, tout part defaut
ca
regenerer-carte
generer-agent
set modeaffich 0
set graphisme-fourmis "fourmis"
set init true
]
[

set init false
set agent nombre-fourmis
set vitrech evaporation-recherche
set vitret evaporation-retour
wait 0.5
cp ct
clear-output
clear-all-plots
regenerer-carte
set nombre-fourmis agent
set evaporation-recherche vitrech
set evaporation-retour vitret
generer-agent
set modeaffich 0
set graphisme-fourmis "fourmis"
set init true
]

end

to regenerer-carte
import-world "upload/essaim/pistefourmis2.csv"
set nbfourmis 0
set ptdepartx (- screen-edge-x + 1 )
set ptdeparty 0
set ptciblex (screen-edge-x - 1)
set ptcibley 0
set bords patches with [abs pxcor = screen-edge-x]

ask patches[
  set phero-rentrer 0
  set phero-miam 0
  if surface = 3 [set depart? true]
  if surface = 2 [set cible? true]

  ]
end


to generer-agent
  set-default-shape turtles "fourmi"

end

to naissance
set color blue
  ifelse (graphisme-fourmis = "point")
  [set size 0.8
   set shape "circle"
  ]
  [set size 2.5
  set shape "fourmi"
  ]
  set xcor ptdepartx
  set ycor ptdeparty
  set heading towards-nowrap patch ptciblex ptcibley
  set transport? false
  set stock-phero-miam 200
  set stock-phero-rentrer 200

end







to init2                      ;; ce bout de code permet de generer un monde  partir d'un fichier texte contenant une piste
locals [liste i j]
ca
set i (- screen-edge-x)
set j screen-edge-x
file-open "piste2.txt"

while[not file-at-end?]
      [
      set liste file-read-line
      set i (- screen-edge-x)
      while[i <= screen-edge-x][

            ifelse (item (i + screen-edge-x) liste = "0")
             [set surface-of patch i j 0
             ]
             [
               ifelse (item (i + screen-edge-x) liste = "1")
               [set surface-of patch i j 1
               ]
               [
               ifelse (item (i + screen-edge-x) liste = "2")
                 [set surface-of patch i j 2
                 ]
                 [set surface-of patch i j 3
                 ]
               ]
             ]
          set i (i + 1)
      ]
     set j (j - 1)
]
file-close
ask patches [
  if (surface = 1 and pycor > 0 and pxcor > -23 and pxcor < 23 )[set pcolor brown]
  if (surface = 1 and pycor = 0)[set pcolor red]
  if (surface = 1 and pycor < 0 and pxcor > -23 and pxcor < 23)[set pcolor pink]
  if (surface = 1 and (pxcor <= -23 or pxcor >= 23 ))[set pcolor red]
  if (surface >= 2 )[set pcolor yellow]
  if (surface = 0 )[set pcolor grey]

  ]

end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; PHASE D'EXECUTION
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to lancer

  ifelse( is-boolean? init )
  [
  if (init)[
  ask patch ptdepartx ptdeparty [ controle-nb-fourmis]
  ask turtles [bouger]
  ask patches [evaporer]
  ask bords [nettoyer ]

  if ((afficher-pheromones = "retour") or (afficher-pheromones = "recherche"))
  [
  set hautm (max values-from  patches [phero-miam] ) + 1
  set basm (min values-from  patches [phero-miam] )
  set hautr (max values-from patches [phero-rentrer] ) + 1
  set basr (min values-from patches [phero-rentrer] )

  set modeaffich 1
   ifelse (afficher-pheromones = "retour")
    [
      ask patches [afficher 0  ]
    ]
    [
      ask patches [afficher 1  ]
    ]
    ]
  if ((modeaffich = 1) and (afficher-pheromones = "piste seule"))
  [
  set modeaffich 0
  ask patches [piste]
  ]



  tracer-graphe
  ]
  ]
  [ ;; 1ere utilisation, on init tout
   initialiser
  ]
end



to bouger

  ifelse (graphisme-fourmis = "point")
  [set size 0.8
   set shape "circle"
  ]
  [set size 2.5

    ifelse(transport?)[set shape "fourmiam"][set shape "fourmi"]
  ]


  ifelse transport?
  [    rentrer ]
  [   chercher ]
  if ((surface-of patch-ahead 1) != 0)
  [fd 1
  ]

  if (xcor = (- screen-edge-x) ) [set heading towards-nowrap patch ptciblex ptcibley]
  if (xcor = screen-edge-x ) [set heading towards-nowrap patch ptdepartx ptdeparty]

end

to rentrer
locals [phero]
  ifelse (surface-of patch-here = 3)
  [ set transport? false
    set stock-phero-rentrer  100


    set color (blue - 2)
  ifelse (graphisme-fourmis = "point")
  [set size 0.8
   set shape "circle"
  ]
  [set size 2.5
  set shape "fourmi"
  ]
    rt 180
  ]
  [
  set phero stock-phero-miam
    set phero-miam (phero-miam + phero)
    ask neighbors[
      if (surface != 0)[set phero-miam (phero-miam + 0.25 * phero )]
      ]
    set stock-phero-miam (stock-phero-miam - 1)
    if (stock-phero-miam < 1) [set stock-phero-miam 1]


          remonter-piste-rentrer        ;; on ne recherche la piste que si elle n'est pas "vidente" sinon, on fonce devant, on n'a pas de raison de se retourner

  ]



end

to chercher
locals [phero]
ifelse (surface-of patch-here = 2)
  [

    set transport? true
    set stock-phero-miam  100

    set color (blue + 2)
  ifelse (graphisme-fourmis = "point")
  [set size 0.8
   set shape "circle"
  ]
  [set size 2.5
  set shape "fourmiam"
  ]
    rt 180
  ]
  [
    set phero stock-phero-rentrer
    set phero-rentrer (phero-rentrer + phero)
    ask neighbors[
      if (surface != 0)[set phero-rentrer (phero-rentrer + 0.25 * phero )]
      ]
    set stock-phero-rentrer (stock-phero-rentrer - 1)
    if (stock-phero-rentrer < 1) [set stock-phero-rentrer 1]


     ;; if (phero-miam-of patch-ahead 1 < 20 and xcor < -19 )[
        remonter-piste-miam                      ;; on ne recherche la piste que si elle n'est pas "vidente" sinon, on fonce devant, on n'a pas de raison de se retourner
    ;;]
  ]


end

to remonter-piste-rentrer

locals [devant devant-gauche devant-droit gauche droit vrai?]
  no-display
    diriger
    ;;ancienne formule ifelse (phero-miam-of patch-ahead 1 < 5000 and xcor < -19) [set vrai? true][set vrai? false]
   ifelse (xcor > 19) [set vrai? true][set vrai? false]
    ;;  si on est proche d'un croisement, on cherche la meilleure route avec precision
    ;;sinon, on fonce et on evite d'aller dans le trou

  ifelse(surface-of patch-ahead 1 = 0) [set devant -1][ifelse (vrai?) [set devant phero-rentrer-of patch-ahead 1 ][set devant 1]]
  ifelse(surface-of patch-left-and-ahead 45 1 = 0) [set devant-gauche -1][ifelse (vrai?) [set devant-gauche phero-rentrer-of patch-left-and-ahead 45 1][set devant-gauche 1]]
  ifelse(surface-of patch-right-and-ahead 45 1 = 0 )[set devant-droit -1][ifelse (vrai?) [set devant-droit phero-rentrer-of patch-right-and-ahead 45 1][set devant-droit 1]]
  ifelse(surface-of patch-left-and-ahead 90 1 = 0) [set gauche -1][ifelse (vrai?) [set gauche phero-rentrer-of patch-left-and-ahead 90 1][set gauche 1]]
  ifelse(surface-of patch-right-and-ahead 90 1 = 0 )[set droit -1][ifelse (vrai?) [set droit phero-rentrer-of patch-right-and-ahead 90 1][set droit 1]]


 if ((devant-gauche > devant) or (devant-droit > devant) or (gauche > devant) or (droit > devant) ) ;;si il vaut mieut tourner
      [
      ;;si pb devant, on est a un croisement? si oui, on choisit une branche
      ifelse ((devant-gauche = devant-droit) and (gauche = droit))[ifelse ((random 2) = 0)[lt 40][rt 40]  ]
      [
      if (devant-gauche > devant-droit or devant-gauche > droit or gauche > devant-droit or gauche > droit) ;; si la piste est interessante sur les cots
      [ lt 45
      if(gauche > devant-gauche ) [lt 45] ;; on regarde s'il elle ne l'ai pas encore plus un peu plus loin
      ]
      if (devant-droit > devant-gauche or devant-droit > gauche or droit > gauche or droit > devant-gauche)
      [ rt 45
      if(droit > devant-droit) [rt 45]
      ]
  ]]
  if (devant < 0 and devant-gauche < 0 and devant-droit < 0 and gauche < 0 and droit < 0) ;; on est pas l o il faut...
  [fd ( -1) set heading 90 ];; on cherche a faire demi tour
display
end


to remonter-piste-miam

locals [devant devant-gauche devant-droit gauche droit vrai?]
no-display
   diriger
   ;;ancienne formule ifelse (phero-miam-of patch-ahead 1 < 5000 and xcor < -19) [set vrai? true][set vrai? false]
   ifelse (xcor < -19) [set vrai? true][set vrai? false]

    ;; si on est proche d'un croisement, on cherche la meilleure route avec precision
    ;;sinon, on fonce et on evite d'aller dans le trou
  ifelse(surface-of patch-ahead 1 = 0) [set devant -1][ifelse (vrai?) [ set devant phero-miam-of patch-ahead 1 ][set devant 1]]
  ifelse(surface-of patch-left-and-ahead 45 1 = 0) [set devant-gauche -1][ifelse (vrai?) [set devant-gauche phero-miam-of patch-left-and-ahead 45 1][set devant-gauche 1]]
  ifelse(surface-of patch-right-and-ahead 45 1 = 0 )[set devant-droit -1][ifelse (vrai?) [set devant-droit phero-miam-of patch-right-and-ahead 45 1][set devant-droit 1]]
  ifelse(surface-of patch-left-and-ahead 90 1 = 0) [set gauche -1][ifelse (vrai?) [set gauche phero-miam-of patch-left-and-ahead 90 1][set gauche 1]]
  ifelse(surface-of patch-right-and-ahead 90 1 = 0 )[set droit -1][ifelse (vrai?) [set droit phero-miam-of patch-right-and-ahead 90 1][set droit 1]]



 if ((devant-gauche > devant) or (devant-droit > devant) or (gauche > devant) or (droit > devant) ) ;;si il vaut mieut tourner
      [

      ;;si pb devant, on est a un croisement? si oui, on choisit une branche
      ifelse ((devant-gauche = devant-droit) and (gauche = droit))[ifelse ((random 2) = 0)[lt 40][rt 40]  ]
      [
      if (devant-gauche > devant-droit or devant-gauche > droit or gauche > devant-droit or gauche > droit) ;; si la piste est interessante sur les cots
      [ lt 45
      if(gauche > devant-gauche ) [lt 45] ;; on regarde s'il elle ne l'ai pas encore plus un peu plus loin
      ]
      if (devant-droit > devant-gauche or devant-droit > gauche or droit > gauche or droit > devant-gauche)
      [ rt 45
      if(droit > devant-droit) [rt 45]
      ]
  ]]

 if (devant < 0 and devant-gauche < 0 and devant-droit < 0 and gauche < 0 and droit < 0)  ;; on est pas l o il faut...
  [fd ( -1) set heading 270 ] ;; on cherche a faire demi tour

  display
end

to agiter

  lt random 30
  rt random 30


end

to diriger
agiter
ifelse transport?
[
  if ( ( heading > 0 and heading < 180 ) )
    [


     if ( xcor < 0 and ycor > 0)[set heading 225]
     if ( xcor > 0 and ycor > 0)[set heading 315]
     if ( xcor < 0 and ycor < 0)[set heading 315]
     if ( xcor > 0 and ycor < 0)[set heading 225]

      agiter
    ]
]
[
  if ( (  heading > 180 and heading < 360 )  )
    [
     if ( xcor < 0 and ycor > 0)[set heading 45]
     if ( xcor > 0 and ycor > 0)[set heading 135]
     if ( xcor < 0 and ycor < 0)[set heading 135]
     if ( xcor > 0 and ycor < 0)[set heading 45]
      agiter
    ]
]


end

to evaporer

set phero-miam (phero-miam * (1 - (evaporation-recherche / 100) ) )
set phero-rentrer (phero-rentrer * (1 - (evaporation-retour / 100) ) )
if phero-miam < 0.01 [set phero-miam 0]
if phero-rentrer < 0.01 [set phero-rentrer 0]
end

to nettoyer
set phero-miam 0
set phero-rentrer 0

end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; PHASE DE PARAMETRAGE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to controle-nb-fourmis                    ;; on controle ici le nombre de fourmis dans la simulation
ifelse (nbfourmis < nombre-fourmis)       ;; on ne provoque pas plus d'une naissance par cycle, tous les individus
  [                                       ;; ne partent plus en mme temps
    sprout 1 [naissance]
    set nbfourmis (nbfourmis + 1)
  ]
  [
    if (nbfourmis > nombre-fourmis)
      [
        ask turtles with [who >= nombre-fourmis] [die]
        set nbfourmis count turtles
      ]
  ]

end

to afficher [val]
  no-display

  ifelse (val = 1)
  [



    if (surface != 0)
    [set pcolor scale-color green phero-miam basm hautm]
  ]
  [
    if (surface != 0)
     [set pcolor scale-color red phero-rentrer basr hautr  ]
  ]
  display


end

to piste

no-display

  if (surface = 1 and pycor > 0 and pxcor > -23 and pxcor < 23 )[set pcolor brown]
  if (surface = 1 and pycor = 0)[set pcolor red]
  if (surface = 1 and pycor < 0 and pxcor > -23 and pxcor < 23)[set pcolor pink]
  if (surface = 1 and (pxcor <= -23 or pxcor >= 23 ))[set pcolor red]
  if (surface >= 2 )[set pcolor yellow]
  if (surface = 0 )[set pcolor grey]

  display
end

to tracer-graphe
set-current-plot "individus par branche"
set-current-plot-pen "chemin haut"
plot ((count turtles with
     [ ycor > (0) ] ) / nbfourmis) * 100

set-current-plot-pen "chemin bas"
plot ((count turtles with
     [ ycor < (0) ] ) / nbfourmis) * 100

end

@#$#@#$#@
GRAPHICS-WINDOW
288
14
797
544
32
32
7.68
1
10
1
1
1
0
1
1
1

CC-WINDOW
5
605
806
700
Command Center
0

BUTTON
2
80
121
126
nouvelle simulation
initialiser
NIL
1
T
OBSERVER
T
NIL

BUTTON
2
14
121
70
action/pause
lancer
T
1
T
OBSERVER
T
NIL

SLIDER
123
14
285
47
nombre-fourmis
nombre-fourmis
10
1200
350
10
1
NIL

PLOT
1
404
285
591
individus par branche
temps (s)
pourcentage
0.0
100.0
0.0
100.0
true
true
PENS
"chemin bas" 1.0 0 -2064490 true
"chemin haut" 1.0 0 -6459832 true

SLIDER
123
58
285
91
evaporation-recherche
evaporation-recherche
0
100
5
1
1
%

SLIDER
123
93
285
126
evaporation-retour
evaporation-retour
0
100
5
1
1
%

CHOOSER
427
546
569
591
afficher-pheromones
afficher-pheromones
"piste seule" "recherche" "retour"
0

TEXTBOX
6
131
277
399
Mode d'emploi:\n1. Cliquez sur action/pause, une simulation de base se lance.\n2. Vous pouvez modifier interactivement le nombre de fourmis presentes dans la simulation en jouant sur le curseur nombre-fourmis.\n3. Vous pouvez initialiser une nouvelle simulation en cliquant sur nouvelle simulation. \n4. Avec les curseurs evaporation, vous pouvez choisir la vitesse d'evaporation des pheromones.\n5. Le bouton afficher-pheromones permet de visualiser les traces chimiques des fourmis ou d'afficher la piste.\n6. Le bouton graphisme-fourmis permet de simplifier la representation des fourmis (avec un gain de vitesse possible).

TEXTBOX
193
405
283
423
courbes

CHOOSER
287
546
425
591
graphisme-fourmis
graphisme-fourmis
"fourmis" "point"
0

TEXTBOX
294
18
793
38
      Simulation de la recherche de nourriture par les fourmis

@#$#@#$#@
DE QUOI S'AGIT IL ?
-------------------

Cette applet illustre la dcouverte du plus court chemin entre une fourmillire et une source de nourriture. Des fourmis sortant  gauche vont essayer d'attendre la nourriture  droite, en passant par l'un des deux chemins, puis devra rentrer dposer la nourriture acquise. Aprs un certain nombre de passage des fourmis, l'une des branches deviendra trs frquente : la plus courte entre la fourmillire et la nourriture.


QUEL EST LE PRINCIPE ?
----------------------

Les fourmis ne savent pas par o passer pour trouver de la nourriture. Elle vont donc explorer le terrain  sa recherche. Afin de ne pas se perdre, les fourmis vont dposer des phromones au fur et  mesure de leur exploration. Quand elles dcouvriront une source de nourriture, les fourmis vont ramener de la nourriture  la fourmillire. Elles vont pouvoir la retrouver en suivant la piste de phromones qu'elles ont dpose en venant. (Les fourmis deviennent alors bleues claires)

Afin que d'autres fourmis puissent trouver la source de nourriture convoite, les fourmis sur le retour vont dposer une seconde phromone (dite de ralliement) indiquant la prsence de nourriture. A leur tour, les fourmis qui cherchaient de la nourriture vont suivre cette nouvelle piste, et accderont plus rapidement  la source de nourriture.

Dans le cadre de cette simulation, les fourmis vont d'abord explorer alatoirement les deux chemins, et les fourmis ayant emprunt le chemin le plus court seront les premires satisfaites.
Elles emprunteront alors le chemin de l'aller en remontant la piste de phromones leur permettant de rentrer, et dposeront une nouvelle piste de phromones de ralliement.
En arrivant  proximit du nid, les fourmis sortantes vont tre directement attires par la piste de ralliement, et ne choisiront donc plus le chemin au hasard.

De ce fait, deux phnomnes vont se produire :
* Une amplification de la piste des phromones de retour, dpose par les fourmis en qute de nourriture
* Une amplification de la piste de ralliement vers la nourriture, dpose par les fourmis ramenant de la nourriture suivant la premire piste.

Ceci fera qu'aux intersections, une piste sera plus concentre en phromones dans les deux sens que l'autre, et donc attirera un grand nombre de fourmis.
Comme la piste la plus courte donne gnralement satisfaction en premier, elle sera donc rapidement la plus frquente.

Cependant, les phromones s'vaporent avec le temps, ce qui permet de ne plus rallier les sources de nourriture vides.

Remarque : plus les fourmis s'loignent de la source ou du nid, et moins elles dposent de phromones. Ainsi, dans le cas de chemins complexes ou peu frquents, les fourmis peuvent suivrent la piste dans le bon sens, en cherchant  aller vers l'endroit o il y a plus de phromones.


COMMENT AGIR SUR LE PROGRAMME ?
-------------------------------

L'emploi de cette application est relativement simple.

* Pour commencer, il suffit de cliquer sur le bouton "lancer", qui dmarrera la simulation avec des paramtres par dfaut. Pour le moment, il vous suffit de regarder et d'observer la dcouverte du plus court chemin.

* Pour interrompre la simulation, il suffit de cliquer de nouveau sur "lancer"; ou alors de cliquer sur "nouvelle simulation" pour en lancer une nouvelle.

* Les fourmis sortent de la fourmillire rgulirement au cours du temps, et partent en exploration.
Grce au curseur nombre-fourmis, il est possible de changer  tout instant le nombre de fourmis souhait dans la simulation. Si vous rduisez fortement le nombre de fourmis, celles qui sont en trop mourront alors. Au contraire, tant que le nombre de fourmis se promenant n'a pas atteint le nombre souhait, de nouvelles sortiront de la fourmillire (Les fourmis sortantes sont bleues, les fourmis sur le retour sont bleues claires, et celles retournant  nouveau chercher de la nourriture sont bleues sombres).

* Un graphique permet de visualiser le pourcentage de fourmis sur chaque branche en fonction du temps. Vous pourrez y voir que mme si la branche la plus longue est parfois plus frquente au tout dbut, c'est trs rapidement la plus courte qui devient la piste favorite.

* Deux curseurs "evaporation-recherche" et "evaporation-retour" permettent de dfinir  quelle vitesse les phromones s'vaporent une fois dposes.
"evaporation-recherche" correspond  la vitesse d'vaporation de la phromone de ralliement, celle qui est suivit quand les fourmis sont en recherche de nourriture.
"evaporation-retour" correspond  la vitesse d'vaporation de la phromone de retour  la fourmillire.
Le pourcentage indiqu par les curseurs donne le pourcentage de phromone qui disparatra  chaque seconde.


Concernant l'affichage :

Il est tout d'abord possible de visualiser les traces chimiques des phromones.
En cliquant sur "afficher-pheromones" un menu apparat proposant:
* piste seule : n'affiche que la piste sous les fourmis.
* recherche : affiche un dgrad de couleur verte correspondant aux phromones de ralliement .
* retour : affiche un dgrad de couleur rouge correspondant aux phromones permettant le retour au nid.
Plus la couleur est claire, et plus la quantit de phromones est concentre.

Enfin, le bouton "graphisme-fourmis" offre deux choix entre "point" et "fourmis". Le mode point permet de symboliser les fourmis par des petits cercles, plus simple  afficher, cel permet d'avoir une simulation plus rapide sur certain ordinateur, surtout quand il y a beaucoup de fourmis  l'cran.
le mode fourmis quant  lui affiche les fourmis normalement, mais demande une machine plus puissante, pour que le programme ne ralentisse pas de trop.

POINT A NOTER
-------------

La simulation a t faite pour aider les fourmis  trouver plus rapidement leur chemin (elle ne peuvent pas faire demi-tour pour changer de branche par exemple). Elles n'en ont pas besoin en pratique, mais ceci permet de constater plus rapidement du rsultat, les simulation pouvant devenir beaucoup plus longue sans l'aide. Les fourmis ont donc pour indication : la nourriture est vers l'Est par rapport  la fourmillire (mais ne savent pas o).


QUELQUES TRUCS A ESSAYER
------------------------

Vous pouvez jouer sur les curseurs d'vaporation pour observer  quel moment les fourmis ne peuvent plus retrouver facilement le plus court chemin. Voir mme, quelles valeurs font que les fourmis, si elles ont commenc  visiter majoritairement la branche la plus longue, vont rester dessus, et "viter" la plus courte.

Vous pourrez aussi jouer sur le nombre de fourmis et observer s'il y a un nombre minimum de fourmis ncessaire pour avoir une branche favorite.


CREDITS ET REFERENCES
----------------------
Cette applet a t dveloppe avec NetLogo par Aurlien SAINT-DIZIER pour le site www.interstices.info
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

ant
true
0
Polygon -7500403 true true 136 61 129 46 144 30 119 45 124 60 114 82 97 37 132 10 93 36 111 84 127 105 172 105 189 84 208 35 171 11 202 35 204 37 186 82 177 60 180 44 159 32 170 44 165 60
Polygon -7500403 true true 150 95 135 103 139 117 125 149 137 180 135 196 150 204 166 195 161 180 174 150 158 116 164 102
Polygon -7500403 true true 149 186 128 197 114 232 134 270 149 282 166 270 185 232 171 195 149 186

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

bee
true
0
Polygon -1184463 true false 152 149 77 163 67 195 67 211 74 234 85 252 100 264 116 276 134 286 151 300 167 285 182 278 206 260 220 242 226 218 226 195 222 166
Polygon -16777216 true false 150 149 128 151 114 151 98 145 80 122 80 103 81 83 95 67 117 58 141 54 151 53 177 55 195 66 207 82 211 94 211 116 204 139 189 149 171 152
Polygon -7500403 true true 151 54 119 59 96 60 81 50 78 39 87 25 103 18 115 23 121 13 150 1 180 14 189 23 197 17 210 19 222 30 222 44 212 57 192 58
Polygon -16777216 true false 70 185 74 171 223 172 224 186
Polygon -16777216 true false 67 211 71 226 224 226 225 211 67 211
Polygon -16777216 true false 91 257 106 269 195 269 211 255
Line -1 false 144 100 70 87
Line -1 false 70 87 45 87
Line -1 false 45 86 26 97
Line -1 false 26 96 22 115
Line -1 false 22 115 25 130
Line -1 false 26 131 37 141
Line -1 false 37 141 55 144
Line -1 false 55 143 143 101
Line -1 false 141 100 227 138
Line -1 false 227 138 241 137
Line -1 false 241 137 249 129
Line -1 false 249 129 254 110
Line -1 false 253 108 248 97
Line -1 false 249 95 235 82
Line -1 false 235 82 144 100

bird1
false
0
Polygon -7500403 true true 2 6 2 39 270 298 297 298 299 271 187 160 279 75 276 22 100 67 31 0

bird2
false
0
Polygon -7500403 true true 2 4 33 4 298 270 298 298 272 298 155 184 117 289 61 295 61 105 0 43

boat1
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6459832 true false 150 32 157 162
Polygon -13345367 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7500403 true true 158 33 230 157 182 150 169 151 157 156
Polygon -7500403 true true 149 55 88 143 103 139 111 136 117 139 126 145 130 147 139 147 146 146 149 55

boat2
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6459832 true false 150 32 157 162
Polygon -13345367 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7500403 true true 157 54 175 79 174 96 185 102 178 112 194 124 196 131 190 139 192 146 211 151 216 154 157 154
Polygon -7500403 true true 150 74 146 91 139 99 143 114 141 123 137 126 131 129 132 139 142 136 126 142 119 147 148 147

boat3
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6459832 true false 150 32 157 162
Polygon -13345367 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7500403 true true 158 37 172 45 188 59 202 79 217 109 220 130 218 147 204 156 158 156 161 142 170 123 170 102 169 88 165 62
Polygon -7500403 true true 149 66 142 78 139 96 141 111 146 139 148 147 110 147 113 131 118 106 126 71

box
true
0
Polygon -7500403 true true 45 255 255 255 255 45 45 45

butterfly1
true
0
Polygon -16777216 true false 151 76 138 91 138 284 150 296 162 286 162 91
Polygon -7500403 true true 164 106 184 79 205 61 236 48 259 53 279 86 287 119 289 158 278 177 256 182 164 181
Polygon -7500403 true true 136 110 119 82 110 71 85 61 59 48 36 56 17 88 6 115 2 147 15 178 134 178
Polygon -7500403 true true 46 181 28 227 50 255 77 273 112 283 135 274 135 180
Polygon -7500403 true true 165 185 254 184 272 224 255 251 236 267 191 283 164 276
Line -7500403 true 167 47 159 82
Line -7500403 true 136 47 145 81
Circle -7500403 true true 165 45 8
Circle -7500403 true true 134 45 6
Circle -7500403 true true 133 44 7
Circle -7500403 true true 133 43 8

circle
false
0
Circle -7500403 true true 35 35 230

fourmi
true
0
Polygon -7500403 true true 135 31 166 31 181 46 167 60 136 60 122 45
Polygon -7500403 true true 151 75 167 92 168 120 151 136 136 120 135 90 151 75
Polygon -7500403 true true 151 135 125 165 125 224 151 242 177 225 177 164 151 135
Rectangle -7500403 true true 147 128 154 146
Rectangle -7500403 true true 144 58 157 68
Rectangle -7500403 true true 147 64 153 86
Polygon -1 true false 135 43 111 23 117 21
Polygon -1 true false 121 6 111 23 117 21 121 6
Polygon -1 true false 168 42 182 18 189 20
Polygon -1 true false 177 3 187 19 182 19

fourmiam
true
0
Polygon -7500403 true true 135 31 166 31 181 46 167 60 136 60 122 45
Polygon -7500403 true true 151 75 167 92 168 120 151 136 136 120 135 90 151 75
Polygon -7500403 true true 151 135 125 165 125 224 151 242 177 225 177 164 151 135
Rectangle -7500403 true true 147 128 154 146
Rectangle -7500403 true true 144 58 157 68
Rectangle -7500403 true true 147 64 153 86
Polygon -1 true false 135 43 111 23 117 21
Polygon -1 true false 121 6 111 23 117 21 121 6
Polygon -1 true false 168 42 182 18 189 20
Polygon -1 true false 177 3 187 19 182 19
Circle -11221820 true false 119 -4 23
Circle -11221820 true false 133 -5 25
Circle -11221820 true false 152 -5 27

person
false
0
Circle -7500403 true true 155 20 63
Rectangle -7500403 true true 158 79 217 164
Polygon -7500403 true true 158 81 110 129 131 143 158 109 165 110
Polygon -7500403 true true 216 83 267 123 248 143 215 107
Polygon -7500403 true true 167 163 145 234 183 234 183 163
Polygon -7500403 true true 195 163 195 233 227 233 206 159

sheep
false
15
Rectangle -1 true true 90 75 270 225
Circle -1 true true 15 75 150
Rectangle -16777216 true false 81 225 134 286
Rectangle -16777216 true false 180 225 238 285
Circle -16777216 true false 1 88 92

spacecraft
true
0
Polygon -7500403 true true 150 0 180 135 255 255 225 240 150 180 75 240 45 255 120 135

thin-arrow
true
0
Polygon -7500403 true true 150 0 0 150 120 150 120 293 180 293 180 150 300 150

truck-down
false
0
Polygon -7500403 true true 225 30 225 270 120 270 105 210 60 180 45 30 105 60 105 30
Polygon -8630108 true false 195 75 195 120 240 120 240 75
Polygon -8630108 true false 195 225 195 180 240 180 240 225

truck-left
false
0
Polygon -7500403 true true 120 135 225 135 225 210 75 210 75 165 105 165
Polygon -8630108 true false 90 210 105 225 120 210
Polygon -8630108 true false 180 210 195 225 210 210

truck-right
false
0
Polygon -7500403 true true 180 135 75 135 75 210 225 210 225 165 195 165
Polygon -8630108 true false 210 210 195 225 180 210
Polygon -8630108 true false 120 210 105 225 90 210

turtle
true
0
Polygon -7500403 true true 138 75 162 75 165 105 225 105 225 142 195 135 195 187 225 195 225 225 195 217 195 202 105 202 105 217 75 225 75 195 105 187 105 135 75 142 75 105 135 105

wolf
false
0
Rectangle -7500403 true true 15 105 105 165
Rectangle -7500403 true true 45 90 105 105
Polygon -7500403 true true 60 90 83 44 104 90
Polygon -16777216 true false 67 90 82 59 97 89
Rectangle -1 true false 48 93 59 105
Rectangle -16777216 true false 51 96 55 101
Rectangle -16777216 true false 0 121 15 135
Rectangle -16777216 true false 15 136 60 151
Polygon -1 true false 15 136 23 149 31 136
Polygon -1 true false 30 151 37 136 43 151
Rectangle -7500403 true true 105 120 263 195
Rectangle -7500403 true true 108 195 259 201
Rectangle -7500403 true true 114 201 252 210
Rectangle -7500403 true true 120 210 243 214
Rectangle -7500403 true true 115 114 255 120
Rectangle -7500403 true true 128 108 248 114
Rectangle -7500403 true true 150 105 225 108
Rectangle -7500403 true true 132 214 155 270
Rectangle -7500403 true true 110 260 132 270
Rectangle -7500403 true true 210 214 232 270
Rectangle -7500403 true true 189 260 210 270
Line -7500403 true 263 127 281 155
Line -7500403 true 281 155 281 192

wolf-left
false
3
Polygon -6459832 true true 117 97 91 74 66 74 60 85 36 85 38 92 44 97 62 97 81 117 84 134 92 147 109 152 136 144 174 144 174 103 143 103 134 97
Polygon -6459832 true true 87 80 79 55 76 79
Polygon -6459832 true true 81 75 70 58 73 82
Polygon -6459832 true true 99 131 76 152 76 163 96 182 104 182 109 173 102 167 99 173 87 159 104 140
Polygon -6459832 true true 107 138 107 186 98 190 99 196 112 196 115 190
Polygon -6459832 true true 116 140 114 189 105 137
Rectangle -6459832 true true 109 150 114 192
Rectangle -6459832 true true 111 143 116 191
Polygon -6459832 true true 168 106 184 98 205 98 218 115 218 137 186 164 196 176 195 194 178 195 178 183 188 183 169 164 173 144
Polygon -6459832 true true 207 140 200 163 206 175 207 192 193 189 192 177 198 176 185 150
Polygon -6459832 true true 214 134 203 168 192 148
Polygon -6459832 true true 204 151 203 176 193 148
Polygon -6459832 true true 207 103 221 98 236 101 243 115 243 128 256 142 239 143 233 133 225 115 214 114

wolf-right
false
3
Polygon -6459832 true true 170 127 200 93 231 93 237 103 262 103 261 113 253 119 231 119 215 143 213 160 208 173 189 187 169 190 154 190 126 180 106 171 72 171 73 126 122 126 144 123 159 123
Polygon -6459832 true true 201 99 214 69 215 99
Polygon -6459832 true true 207 98 223 71 220 101
Polygon -6459832 true true 184 172 189 234 203 238 203 246 187 247 180 239 171 180
Polygon -6459832 true true 197 174 204 220 218 224 219 234 201 232 195 225 179 179
Polygon -6459832 true true 78 167 95 187 95 208 79 220 92 234 98 235 100 249 81 246 76 241 61 212 65 195 52 170 45 150 44 128 55 121 69 121 81 135
Polygon -6459832 true true 48 143 58 141
Polygon -6459832 true true 46 136 68 137
Polygon -6459832 true true 45 129 35 142 37 159 53 192 47 210 62 238 80 237
Line -16777216 false 74 237 59 213
Line -16777216 false 59 213 59 212
Line -16777216 false 58 211 67 192
Polygon -6459832 true true 38 138 66 149
Polygon -6459832 true true 46 128 33 120 21 118 11 123 3 138 5 160 13 178 9 192 0 199 20 196 25 179 24 161 25 148 45 140
Polygon -6459832 true true 67 122 96 126 63 144

@#$#@#$#@
NetLogo 3.0pre5
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
