globals [crashed scrashed won destroyed colors]
breeds [balloon island birds sun]

to setup
  ca
  set colors [red orange yellow green lime green cyan violet pink magenta black white grey]
  ask patches
    [ifelse pycor > -11
      [set pcolor sky]
      [set pcolor blue]]
  create-custom-balloon 1
    [set shape "balloon"
    set size 10
    set xcor -15
    set ycor 13
    if Balloon.Color = "red"
      [set color red]
    if Balloon.Color = "orange"
      [set color orange]
    if Balloon.Color = "green"
      [set color green]
    if balloon.color = "lime"
      [set color lime]
    if Balloon.Color = "cyan"
      [set color cyan]
    if Balloon.Color = "white"
      [set color white]
    if balloon.color = "purple"
      [set color violet]
    if balloon.color = "pink"
      [set color pink]
    if balloon.color = "magenta"
      [set color magenta]
    if balloon.color = "grey"
      [set color grey]]
  if level = "very easy"
    [create-birds 3
    ask birds
      [fd 5]]
  if level = "easy"
    [create-birds 5
    ask birds
      [fd 7]]
  if level = "medium"
    [create-birds 7
    ask birds
      [fd 7]]
  if level = "hard"
    [create-birds 9
    ask birds
      [fd 7]]
  if level = "very hard"
    [create-birds 11
    ask birds
      [fd 7]]
  if level = "iNsAnE"
    [create-birds 15
    ask birds
      [fd 7]]
  ask birds
    [set shape "bird side"
    set size 5
    set heading 270
    set color random-one-of colors]
  create-custom-island 1
    [set shape "island"
    set size 15
    set ycor -9
    set heading 90]
  create-custom-sun 1
    [set shape "sun"
    set color yellow
    set size 10
    set xcor 13
    set ycor 13]
end

to go
  ask birds
    [fd random 2
    wait .001]
  ask island
    [fd random 4
    wait .001]
  ask balloon
    [bk 1
    set xcor xcor + 2
    wait .001]
  ask birds
    [if distance turtle 0 < 3
      [set destroyed "true"]]
  ask sun
    [if distance turtle 0 < 3
      [set scrashed "true"]]
  ask island
    [if distance turtle 0 < 3
      [set won "true"]]
  ask balloon
    [if ycor < -8
      [set crashed "true"]]
  if destroyed = "true"
    [user-message "A bird ripped open your balloon..."
    stop]
  if scrashed = "true"
    [user-message "You crashed into the sun..."
    stop]
  if won = "true"
    [cow]
  if crashed = "true"
    [user-message "You MISSED and CRASHED into the ocean..."
    stop]
end

to flare
  ask balloon
    [set ycor ycor + 5]
end

to cow
  user-message "You WIN!...although what you are going to do on this deserted landing pad, I'll never know..."
  ifelse level = "very easy"
    [user-message "..yay..you beat the game on very easy...so what? make it harder!!"]
    [ifelse level = "easy"
      [user-message "...okay look on the bright side, you didn't beat it on very easy..."
      user-message "but this is easy, for goodness' sake! could you do any better?"]
      [ifelse level = "medium"
        [user-message "Okay, now we're impressed. You have now officially done better at this game than the creator."
        user-message "The creator now challenges you to to hard...just to test you, of course.."]
        [ifelse level = "hard"
          [user-message "We are very impressed. You have beaten the game two levels higher than the creator has."
          user-message "Try very hard...see if you can beat it..."]
          [ifelse level = "very hard"
            [user-message "Okay, now we are getting suspicious...You aren't cheating, are you?"
            user-message "<Oh, well, it is of no matter...Try iNsAnE...we are confident in our programming ability.."]
            [user-message "D00d, y0u s0 707411y ch3473d! CHEATER! CH3473R!!!"
              user-message "If you did not cheat, feel free to email me at icecreamranterx4@aim.com to rant about my paranoia..."]]]]]
  if count birds = 0
    [user-message "YOU CHEATED YOU CHEATED YOU CHEATED YOU CHEATED!!!"
    user-message "CHEATER! CHEATER! CHEATER!!!"
    loop
      [user-message "CHEATER! CHEATER! CHEATER!!!"]]
  if level = "very easy"
    [if count birds > 3
      [user-message "nice try, but no...I STILL KNOW YOU CHEATED!!"
      user-message "YOU CHEATED YOU CHEATED YOU CHEATED YOU CHEATED!!!"
      user-message "CHEATER! CHEATER! CHEATER!!"
      loop
        [user-message "CHEATER! CHEATER!!! CHEATER!!"]]]
  if level = "easy"
    [if count birds > 5
      [user-message "nice try, but no...I STILL KNOW YOU CHEATED!!"
      user-message "YOU CHEATED YOU CHEATED YOU CHEATED YOU CHEATED!!!"
      user-message "CHEATER! CHEATER! CHEATER!!"
      loop
        [user-message "CHEATER! CHEATER!!! CHEATER!!"]]]
  if level = "medium"
    [if count birds > 7
      [user-message "nice try, but no...I STILL KNOW YOU CHEATED!!"
      user-message "YOU CHEATED YOU CHEATED YOU CHEATED YOU CHEATED!!!"
      user-message "CHEATER! CHEATER! CHEATER!!"
      loop
        [user-message "CHEATER! CHEATER!!! CHEATER!!"]]]
  if level = "hard"
    [if count birds > 9
      [user-message "nice try, but no...I STILL KNOW YOU CHEATED!!"
      user-message "YOU CHEATED YOU CHEATED YOU CHEATED YOU CHEATED!!!"
      user-message "CHEATER! CHEATER! CHEATER!!"
      loop
        [user-message "CHEATER! CHEATER!!! CHEATER!!"]]]
  if level = "very hard"
    [if count birds > 11
      [user-message "nice try, but no...I STILL KNOW YOU CHEATED!!"
      user-message "YOU CHEATED YOU CHEATED YOU CHEATED YOU CHEATED!!!"
      user-message "CHEATER! CHEATER! CHEATER!!"
      loop
        [user-message "CHEATER! CHEATER!!! CHEATER!!"]]]
  if level = "iNsAnE"
    [if count birds > 15
      [user-message "nice try, but no...I STILL KNOW YOU CHEATED!!"
      user-message "YOU CHEATED YOU CHEATED YOU CHEATED YOU CHEATED!!!"
      user-message "CHEATER! CHEATER! CHEATER!!"
      loop
        [user-message "CHEATER! CHEATER!!! CHEATER!!"]]]
  ask turtles [die]
  ask patches [set pcolor yellow]
  crt 1
  loop
    [ask turtles
        [set size 20
        set shape "cow 1"
        wait .5
        set shape "cow 2"
        wait .5
        set shape "cow 3"
        wait .5
        set shape "cow 4"
        wait .5
        set shape "cow 5"
        wait .5
        set shape "cow 6"
        wait .5
        set shape "cow 7"
        wait 1]]
end
@#$#@#$#@
GRAPHICS-WINDOW
303
10
733
461
17
17
12.0
1
10
1
1
1
0

CC-WINDOW
5
475
742
570
Command Center

BUTTON
53
164
117
197
NIL
Setup\n
NIL
1
T
OBSERVER
T
S

CHOOSER
9
10
147
55
Balloon.Color
Balloon.Color
"red" "orange" "green" "lime" "cyan" "purple" "pink" "magenta" "white" "grey"
5

CHOOSER
11
77
149
122
Level
Level
"very easy" "easy" "medium" "hard" "very hard" "iNsAnE"
0

BUTTON
53
196
116
229
NIL
Go
T
1
T
OBSERVER
T
D

BUTTON
53
228
116
261
NIL
Flare
NIL
1
T
OBSERVER
T
F

BUTTON
199
103
276
136
Cleanup
ca
NIL
1
T
OBSERVER
T
NIL

@#$#@#$#@
WHAT IS IT?
-----------
This is a classic arcade game (sort of...okay, no, not really)...
Anyway, it was based off a game that we made in a CTD Summer Program class (Bits and Blocks). The point of the game is to land the balloon on the island/landing pad, while avoiding the birds, sun, and other obstacles, while trying not to land in the water...confusing, eh?


HOW IT WORKS
------------
There is a little bit of user input needed to play the game. First off, you have to chose the level at which you will play. Be warned, it's hard enough on level Very Easy (for me) and iNsAnE is not named for just any reason...Remember, I warned you first...
Also, here is a good enough time to input a rule: Please do not, I repeat, do NOT, cheat by removing the birds...That would ruin the point of the game. The only circumstance I can see removing the birds would be okay for would be if you are unable to win the game and wish to see the end of it...(it's okay, I've done it too.)
You can also change the color of the balloon...no, those are the ONLY colors available, please don't shoot me...no, really...don't.
The birds move randomly.


HOW TO USE IT
-------------
Gameplay is pretty simple. Once you are done picking colors and levels, press the Setup button. (this would be a good time to check if its too easy or too hard)...Once you're done making adjustments, then press the Go button.
The Flare button makes the balloon move up by a little bit...This is your only way to avoid crashing into birds, but it may make you crash into birds...or even into the sun...
If the balloon goes up off the screen, you will be in the ocean (through a quirk in physics, I know). Then you will lose, regardless...


THINGS TO NOTICE
----------------
Notice that the game is almost impossible to win on very easy with birds because the wraparound makes you stumble right into the birds.


THINGS TO TRY
-------------
Try to win...and then look at the spiffy animation that my friend and I made (it's based off one of my AIM(tm) icons that was designed by someone I don't remember...


EXTENDING THE MODEL
-------------------
I would try making it easier and harder, and then making more spiffy animations to play with.


NETLOGO FEATURES
----------------
Uh....The model uses the "if" command a lot, to work with the levels, to change the color of the balloon, to make the ending things different, and all that.
The animation was made by telling one turtle to change its shape...Unfortunately, it runs forever if you let it, so I would make it stop once you're sick of it...

RELATED MODELS
--------------
I know of no related models other than those created as a result of the CTD Summer Program class...That classd used Microworlds, so the wording will be different, but it is the same all-around concept.


CREDITS AND REFERENCES
----------------------
I would like to thank:
  Mr. DeCrane, who was my Bits and Blocks teacher, and who first introduced me to computer program...
  Mr. Novak, for continuing that education in our Integrated Geometry class, and helping me work out the bugs in this, and other programs...
                   and
  Annie Lee, my programming partner in Integrated Geometry, for helping me with bugs, drawing the shapes for the winning animation, writing music for other programs, and providing criticism, encouragement, and insults to get me to finish all my programs before the due date... -_-u...

If you would like to email me about this or other programs of mine, please email me at icecreamranterx4@aim.com
@#$#@#$#@
default
true
0
Polygon -7566196 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7566196 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7566196 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

balloon
false
0
Circle -7566196 true true 75 15 150
Polygon -256 true false 120 120 150 30 180 120 105 60 195 60 120 120
Rectangle -7566196 true true 105 210 195 270
Line -256 false 75 105 105 210
Line -256 false 223 105 195 210
Line -256 false 182 158 170 209
Line -256 false 118 158 130 209

bird side
false
0
Polygon -7566196 true true 0 120 45 90 75 90 105 120 150 120 240 135 285 120 285 135 300 150 240 150 195 165 255 195 210 195 150 210 90 195 60 180 45 135
Circle -16777216 true false 38 98 14

box
false
0
Polygon -7566196 true true 150 285 285 225 285 75 150 135
Polygon -7566196 true true 150 135 15 75 150 15 285 75
Polygon -7566196 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7566196 true true 96 182 108
Circle -7566196 true true 110 127 80
Circle -7566196 true true 110 75 80
Line -7566196 true 150 100 80 30
Line -7566196 true 150 100 220 30

butterfly
true
0
Polygon -7566196 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7566196 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7566196 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7566196 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7566196 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7566196 true true 47 195 58
Circle -7566196 true true 195 195 58

circle
false
0
Circle -7566196 true true 30 30 240

circle 2
false
0
Circle -7566196 true true 16 16 270
Circle -16777216 true false 46 46 210

cow
false
0
Polygon -7566196 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7566196 true true 73 210 86 251 62 249 48 208
Polygon -7566196 true true 25 114 16 195 9 204 23 213 25 200 39 123

cow 1
false
0
Circle -16777216 true false 0 0 300
Line -8716033 false 30 60 30 90
Line -8716033 false 30 90 45 90
Circle -65281 false false 60 60 30
Line -8716033 false 105 60 120 90
Line -65281 false 150 60 165 60
Line -65281 false 150 75 165 75
Line -65281 false 150 90 165 90
Line -8716033 false 210 60 210 90
Line -8716033 false 210 60 225 75
Line -8716033 false 225 75 240 60
Line -8716033 false 240 60 240 90
Line -65281 false 255 60 255 90
Line -65281 false 255 60 270 60
Line -65281 false 255 75 270 75
Line -65281 false 255 90 270 90
Line -16711936 false 120 90 135 60
Line -8716033 false 120 90 135 60
Line -65281 false 150 60 150 90

cow 2
false
0
Circle -16777216 true false 0 0 300
Line -65281 false 30 60 30 90
Line -65281 false 30 90 45 90
Circle -8716033 false false 60 60 30
Line -65281 false 105 60 120 90
Line -8716033 false 120 135 135 105
Line -65281 false 150 105 150 135
Line -8716033 false 150 60 165 60
Line -8716033 false 150 75 165 75
Line -8716033 false 150 90 165 90
Line -65281 false 210 60 210 90
Line -65281 false 210 60 225 75
Line -65281 false 225 75 240 60
Line -65281 false 240 60 240 90
Line -16776961 false 255 60 255 90
Line -8716033 false 255 60 270 60
Line -8716033 false 255 75 270 75
Line -8716033 false 255 90 270 90
Line -8716033 false 30 105 30 135
Line -8716033 false 30 135 45 135
Circle -65281 false false 60 105 30
Line -8716033 false 105 105 120 135
Line -16711936 false 120 90 135 60
Line -65281 false 120 90 135 60
Line -65281 false 150 120 165 120
Line -65281 false 150 135 165 135
Line -65281 false 150 105 165 105
Line -8716033 false 210 105 210 135
Line -8716033 false 240 105 240 135
Line -65281 false 262 120 262 135
Line -8716033 false 210 105 225 120
Line -8716033 false 240 105 225 120
Line -65281 false 262 119 247 104
Line -65281 false 277 105 262 120
Line -8716033 false 150 60 150 90

cow 3
false
0
Circle -16777216 true false 0 0 300
Line -8716033 false 30 60 30 90
Line -8716033 false 30 90 45 90
Circle -65281 false false 60 60 30
Line -8716033 false 105 60 120 90
Line -65281 false 120 135 135 105
Line -8716033 false 150 105 150 135
Line -65281 false 150 60 165 60
Line -65281 false 150 75 165 75
Line -65281 false 150 90 165 90
Line -8716033 false 210 60 210 90
Line -8716033 false 210 60 225 75
Line -8716033 false 225 75 240 60
Line -8716033 false 240 60 240 90
Line -65281 false 255 60 255 90
Line -65281 false 255 60 270 60
Line -65281 false 255 75 270 75
Line -65281 false 255 90 270 90
Line -65281 false 30 105 30 135
Line -65281 false 30 135 45 135
Circle -8716033 false false 60 105 30
Line -65281 false 105 105 120 135
Line -16711936 false 120 90 135 60
Line -8716033 false 120 90 135 60
Line -8716033 false 150 120 165 120
Line -8716033 false 150 135 165 135
Line -8716033 false 150 105 165 105
Line -65281 false 210 105 210 135
Line -65281 false 240 105 240 135
Line -8716033 false 255 120 255 135
Line -65281 false 210 105 225 120
Line -65281 false 240 105 225 120
Line -8716033 false 255 120 240 105
Line -8716033 false 270 105 255 120
Line -65281 false 150 60 150 90
Line -16711681 false 105 180 45 180
Line -16711681 false 60 255 60 165
Line -16711681 false 105 240 45 240

cow 4
false
0
Circle -16777216 true false 0 0 300
Line -65281 false 30 60 30 90
Line -65281 false 30 90 45 90
Circle -8716033 false false 60 60 30
Line -65281 false 105 60 120 90
Line -8716033 false 120 135 135 105
Line -65281 false 150 105 150 135
Line -8716033 false 150 60 165 60
Line -8716033 false 150 75 165 75
Line -8716033 false 150 90 165 90
Line -65281 false 210 60 210 90
Line -65281 false 210 60 225 75
Line -65281 false 225 75 240 60
Line -65281 false 240 60 240 90
Line -8716033 false 255 60 255 90
Line -8716033 false 255 60 270 60
Line -8716033 false 255 75 270 75
Line -8716033 false 255 90 270 90
Line -8716033 false 30 105 30 135
Line -8716033 false 30 135 45 135
Circle -65281 false false 60 105 30
Line -8716033 false 105 105 120 135
Line -16711936 false 120 90 135 60
Line -65281 false 120 90 135 60
Line -65281 false 150 120 165 120
Line -65281 false 150 135 165 135
Line -65281 false 150 105 165 105
Line -8716033 false 210 105 210 135
Line -8716033 false 240 105 240 135
Line -65281 false 255 120 255 135
Line -8716033 false 210 105 225 120
Line -8716033 false 240 105 225 120
Line -65281 false 255 120 240 105
Line -65281 false 270 105 255 120
Line -8716033 false 150 60 150 90
Line -16711681 false 105 180 45 180
Line -16711681 false 60 255 60 165
Line -16711681 false 105 240 45 240
Circle -16711681 false false 103 178 62

cow 5
false
0
Circle -16777216 true false 0 0 300
Line -8716033 false 30 60 30 90
Line -8716033 false 30 90 45 90
Circle -65281 false false 60 60 30
Line -8716033 false 105 60 120 90
Line -65281 false 120 135 135 105
Line -8716033 false 150 105 150 135
Line -65281 false 150 60 165 60
Line -65281 false 150 75 165 75
Line -65281 false 150 90 165 90
Line -8716033 false 210 60 210 90
Line -8716033 false 210 60 225 75
Line -8716033 false 225 75 240 60
Line -8716033 false 240 60 240 90
Line -65281 false 255 60 255 90
Line -65281 false 255 60 270 60
Line -65281 false 255 75 270 75
Line -65281 false 255 90 270 90
Line -65281 false 30 105 30 135
Line -8716033 false 30 135 45 135
Circle -8716033 false false 60 105 30
Line -65281 false 105 105 120 135
Line -16711936 false 120 90 135 60
Line -8716033 false 120 90 135 60
Line -8716033 false 150 120 165 120
Line -8716033 false 150 135 165 135
Line -8716033 false 150 105 165 105
Line -65281 false 210 105 210 135
Line -65281 false 240 105 240 135
Line -8716033 false 255 120 255 135
Line -65281 false 210 105 225 120
Line -65281 false 240 105 225 120
Line -8716033 false 255 120 240 105
Line -8716033 false 270 105 255 120
Line -65281 false 150 60 150 90
Line -16711681 false 105 180 45 180
Line -16711681 false 60 255 60 165
Line -16711681 false 105 240 45 240
Circle -16711681 false false 105 180 60
Line -16711681 false 165 180 195 240
Line -16711681 false 180 240 210 210
Line -16711681 false 240 240 210 210
Line -16711681 false 225 240 255 180

cow 6
false
3
Circle -16777216 true false 0 0 300
Circle -1 true false 114 76 104
Circle -1 true false 66 72 70
Circle -65281 true false 89 129 38
Circle -65281 true false 70 128 38
Circle -16777216 true false 83 143 8
Circle -16777216 true false 104 100 8
Circle -16777216 true false 86 100 8
Rectangle -1 true false 147 167 165 221
Circle -1 true false 172 69 104
Polygon -1 true false 215 70 149 78 183 97 214 70
Polygon -1 true false 172 179 238 171 204 152 173 179
Rectangle -1 true false 169 167 187 221
Rectangle -1 true false 221 161 239 215
Rectangle -1 true false 243 156 261 210
Circle -1 true false 63 78 18
Circle -1 true false 118 75 15
Polygon -1 true false 141 66 121 75 134 83 137 76
Polygon -1 true false 69 77 51 70 64 91 73 79
Polygon -7566196 true false 147 219 165 219 164 236 156 229 148 237 146 219
Polygon -7566196 true false 169 219 187 219 186 236 178 229 170 237 168 219
Polygon -7566196 true false 221 212 239 212 238 229 230 222 222 230 220 212
Polygon -7566196 true false 243 208 261 208 260 225 252 218 244 226 242 208
Circle -16777216 true false 161 104 23
Circle -16777216 true false 174 100 23
Circle -16777216 true false 169 112 23
Circle -16777216 true false 229 80 38
Circle -16777216 true false 223 74 22
Circle -16777216 true false 232 107 22
Circle -16777216 true false 148 190 10
Circle -16777216 true false 146 195 10
Circle -16777216 true false 146 186 10
Circle -16777216 true false 184 155 19
Circle -16777216 true false 198 152 19
Circle -16777216 true false 207 152 19
Circle -16777216 true false 193 144 19
Circle -16777216 true false 223 189 16
Circle -16777216 true false 224 180 14
Circle -16777216 true false 104 143 8
Polygon -1 true false 272 100 268 109 292 145 286 129
Polygon -7566196 true false 82 55 83 78 91 76 82 55
Polygon -7566196 true false 114 54 106 78 115 79 114 54
Circle -16777216 true false 111 108 19
Circle -16777216 true false 119 106 18

cow 7
false
3
Circle -16777216 true false 0 0 300
Circle -1 true false 114 76 104
Circle -1 true false 66 72 70
Circle -65281 true false 89 129 38
Circle -65281 true false 70 128 38
Circle -16777216 true false 83 143 8
Circle -16777216 true false 104 100 8
Circle -16777216 true false 86 100 8
Rectangle -1 true false 147 167 165 221
Circle -1 true false 172 69 104
Polygon -1 true false 215 70 149 78 183 97 214 70
Polygon -1 true false 172 179 238 171 204 152 173 179
Rectangle -1 true false 169 167 187 221
Rectangle -1 true false 221 161 239 215
Rectangle -1 true false 243 156 261 210
Circle -1 true false 63 78 18
Circle -1 true false 118 75 15
Polygon -1 true false 141 66 121 75 134 83 137 76
Polygon -1 true false 69 77 51 70 64 91 73 79
Polygon -7566196 true false 147 219 165 219 164 236 156 229 148 237 146 219
Polygon -7566196 true false 169 219 187 219 186 236 178 229 170 237 168 219
Polygon -7566196 true false 221 212 239 212 238 229 230 222 222 230 220 212
Polygon -7566196 true false 243 208 261 208 260 225 252 218 244 226 242 208
Circle -16777216 true false 161 104 23
Circle -16777216 true false 174 100 23
Circle -16777216 true false 169 112 23
Circle -16777216 true false 229 80 38
Circle -16777216 true false 223 74 22
Circle -16777216 true false 232 107 22
Circle -16777216 true false 148 190 10
Circle -16777216 true false 146 195 10
Circle -16777216 true false 146 186 10
Circle -16777216 true false 184 155 19
Circle -16777216 true false 198 152 19
Circle -16777216 true false 207 152 19
Circle -16777216 true false 193 144 19
Circle -16777216 true false 223 189 16
Circle -16777216 true false 224 180 14
Circle -16777216 true false 104 143 8
Polygon -1 true false 272 100 268 109 292 145 286 129
Polygon -7566196 true false 82 55 83 78 91 76 82 55
Polygon -7566196 true false 114 54 106 78 115 79 114 54
Circle -16777216 true false 111 108 19
Circle -16777216 true false 119 106 18
Circle -1 true false 5 201 76
Circle -1 true false 40 202 76
Polygon -1 true false 41 201 83 202 60 218 37 201
Polygon -1 true false 76 278 34 277 57 261 80 278
Polygon -1 true false 85 186 69 205 85 207 84 187
Line -8716033 false 17 226 14 248
Line -8716033 false 36 225 40 246
Line -8716033 false 17 225 26 236
Line -8716033 false 35 226 27 236
Circle -8716033 false false 43 224 25
Circle -8716033 false false 72 225 25
Line -8716033 false 104 225 104 243
Circle -8716033 true false 103 249 3

face happy
false
0
Circle -7566196 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7566196 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7566196 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7566196 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7566196 true true 60 15 75 300
Polygon -7566196 true true 90 150 270 90 90 30
Line -7566196 true 75 135 90 135
Line -7566196 true 75 45 90 45

flower
false
0
Polygon -11352576 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7566196 true true 85 132 38
Circle -7566196 true true 130 147 38
Circle -7566196 true true 192 85 38
Circle -7566196 true true 85 40 38
Circle -7566196 true true 177 40 38
Circle -7566196 true true 177 132 38
Circle -7566196 true true 70 85 38
Circle -7566196 true true 130 25 38
Circle -7566196 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -11352576 true false 189 233 219 188 249 173 279 188 234 218
Polygon -11352576 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7566196 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7566196 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

island
false
0
Rectangle -6524078 true false 105 195 210 240
Rectangle -256 true false 147 151 164 204
Rectangle -16711738 true false 101 95 210 154
Line -16777216 false 106 100 106 122
Line -16777216 false 107 123 116 123
Line -16777216 false 123 102 123 124
Line -16777216 false 133 102 133 124
Line -16777216 false 122 102 134 102
Line -16777216 false 122 115 134 115
Line -16777216 false 157 104 157 124
Line -16777216 false 143 104 143 124
Line -16777216 false 143 105 158 124
Line -16777216 false 170 100 170 122
Line -16777216 false 170 126 182 111
Line -16777216 false 171 99 183 114
Line -16777216 false 121 135 121 152
Line -16777216 false 132 135 132 152
Line -16777216 false 122 144 134 144
Line -16777216 false 137 130 137 152
Line -16777216 false 137 130 147 130
Line -16777216 false 137 150 147 150
Line -16777216 false 137 141 147 141
Line -16777216 false 155 127 155 150
Line -16777216 false 156 128 166 137
Line -16777216 false 155 142 170 137
Line -16777216 false 157 142 167 151
Line -16777216 false 179 133 179 152
Line -16777216 false 179 133 192 133
Line -16777216 false 179 152 192 152
Line -16777216 false 181 143 194 143

leaf
false
0
Polygon -7566196 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7566196 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7566196 true 150 0 150 300

pentagon
false
0
Polygon -7566196 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7566196 true true 110 5 80
Polygon -7566196 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7566196 true true 127 79 172 94
Polygon -7566196 true true 195 90 240 150 225 180 165 105
Polygon -7566196 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7566196 true true 135 90 165 300
Polygon -7566196 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7566196 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7566196 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7566196 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7566196 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7566196 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7566196 true true 135 90 120 45 150 15 180 45 165 90

square
false
0
Rectangle -7566196 true true 30 30 270 270

square 2
false
0
Rectangle -7566196 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7566196 true true 60 270 150 0 240 270 15 105 285 105
Polygon -7566196 true true 75 120 105 210 195 210 225 120 150 75

sun
false
0
Circle -7566196 true true 75 75 150
Polygon -7566196 true true 300 150 240 120 240 180
Polygon -7566196 true true 150 0 120 60 180 60
Polygon -7566196 true true 150 300 120 240 180 240
Polygon -7566196 true true 0 150 60 120 60 180
Polygon -7566196 true true 60 195 105 240 45 255
Polygon -7566196 true true 60 105 105 60 45 45
Polygon -7566196 true true 195 60 240 105 255 45
Polygon -7566196 true true 240 195 195 240 255 255

target
false
0
Circle -7566196 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7566196 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7566196 true true 120 120 60

tree
false
0
Circle -7566196 true true 118 3 94
Rectangle -6524078 true false 120 195 180 300
Circle -7566196 true true 65 21 108
Circle -7566196 true true 116 41 127
Circle -7566196 true true 45 90 120
Circle -7566196 true true 104 74 152

triangle
false
0
Polygon -7566196 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7566196 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7566196 true true 4 45 195 187
Polygon -7566196 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7566196 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7566196 false true 24 174 42
Circle -7566196 false true 144 174 42
Circle -7566196 false true 234 174 42

turtle
true
0
Polygon -11352576 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -11352576 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -11352576 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -11352576 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -11352576 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7566196 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7566196 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7566196 true 150 285 150 15
Line -7566196 true 15 150 285 150
Circle -7566196 true true 120 120 60
Line -7566196 true 216 40 79 269
Line -7566196 true 40 84 269 221
Line -7566196 true 40 216 269 79
Line -7566196 true 84 40 221 269

x
false
0
Polygon -7566196 true true 270 75 225 30 30 225 75 270
Polygon -7566196 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 2.1.0
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
