__extensions [ "sound.jar" ]

globals
[ old-selected
  selected
  dragged
  ticks
  K
  caption
]

breeds
[ levers
]

levers-own
[ cx cy
  x1 x2 y1 y2
  hook1
  hook2
  xv yv av
  fixed? -f
  spin?  -r
  armlen
  from-h1 to-h2
  h1x2 h1y2
  h2x1 h2y1
  h1cx h1cy
  h2cx h2cy
  ideal-dist
  ideal-angl
  ratio1
  ratio2
  inst

]

to setup
    ca
    clear-output
    set k 1
    set-default-shape levers "lever"
    set ticks 0
    ; set population screen-edge-x * .5
    create-levers population
    ask levers
    [ reset-lever
      set heading 180
      set cx 0
      set cy ( (who / population) * screen-size-y - screen-edge-y ) * -.8
      setxy cx cy
      set cx xcor
      set cy ycor
      ifelse who = 0
      [ set hook1 self
        set fixed? true
      ]
      [ set hook1 turtle ( who - 1 )
      ]
      ifelse who = population - 1
      [ set hook2 self
        set label "2"
        set fixed? false
      ]
      [ set hook2 turtle ( who + 1 )
      ]
      set x1 xcor - dx * scale * armlen
      set y1 ycor - dy * scale * armlen
      set x2 xcor + dx * scale * armlen
      set y2 ycor + dy * scale * armlen
      set inst item 0 instruments
    ]
    set selected turtle 0
    set caption patch (screen-edge-x * .9 ) (screen-edge-y * .9)
end

to-report mean-heading [ a b ]
      report atan (( sin a + sin b) * .5)
                  (( cos a + cos b) * .5)
end

to-report mean-heading-w [ a b c w]
      ; reports a weighted mean of the given headings
      ;
      let w/2 (1 - w) * .5
      let xx (( w/2 * sin a + w/2 * sin b + w * sin c ) )
      let yy (( w/2 * cos a + w/2 * cos b + w * cos c ) )
      ifelse xx = 0 and yy = 0
      [ report 0 ]
      [ report atan (( w/2 * sin a + w/2 * sin b + w * sin c ) )
                    (( w/2 * cos a + w/2 * cos b + w * cos c ) )
      ]
end

to reset-lever
    set-fixed==>off
    set-spin==>off
    set armlen .5
    set size scale
end

to go
  set ticks ticks + 1
  ask levers
  [ if mouse-on?
    [ monitor-mouse ]
    lever-display
  ]
  ask levers
  [ calc-arm-coords
    calc-hook-coords
  ]
  ask levers
  [ lever! ]
  if cycle?
  [ set plot-color ( plot-color + cycle-rate * .1 ) mod 140 ]
  if plot?
  [ ask selected [ set pcolor plot-color ] ]

  if fade?
  [ ifelse fade-to-black?
    [ ask patches with [ pcolor != black ]
      [ ifelse pcolor mod 10 >= fade-rate
        [ set pcolor pcolor - fade-rate ]
        [ set pcolor black ]
      ]
    ]
    [ ask patches with [ pcolor >= fade-rate ]
      [ set pcolor pcolor - fade-rate ]
    ]
  ]
  if diffuse? [ diffuse pcolor diffuse-rate  ]
  ;ask random-one-of levers [ without-interruption
  ;[ lever!2 ] ]
end

to-report sign [ a ]
    ifelse a = 0
    [ report 0 ]
    [  report a / abs a ]
end

to monitor-mouse
    locals [ mouse-here? ]
    set mouse-here? abs (mouse-xcor - xcor)  < scale / 2 and abs ( mouse-ycor - ycor) < scale / 2
    ifelse mouse-here?
    [ if color != white [ set color white ] ]
    [ if color = white [ set color (5 + (10 * (who mod 14 ))) ] ]
    ifelse mouse-down?
    [ if dragged = nobody and mouse-here?
      [ set dragged self
        set selected self
      ]
    ]
    [ set dragged nobody ]
end

to lever-display
    let shape-name ""
    let -s ""
    if size != armlen * 2 * scale
    [ set size scale * 2 * armlen ]
    ifelse selected = self
    [ set -s "-s"
      if selected != old-selected
      [ set plabel-of caption (word "Selected link: " who " - " armlen " ")
        set label (word who " - " armlen " "  " ---->     ")
      ]
    ]
    [ if label != no-label
      [ set label no-label ]
    ]
    set shape-name (word "lever" -f -r -s)
    if shape != shape-name
    [ set shape shape-name ]
end

to calc-arm-coords
    set x1 cx - dx * scale * armlen
    set y1 cy - dy * scale * armlen
    set x2 cx + dx * scale * armlen
    set y2 cy + dy * scale * armlen
end

to calc-hook-coords
    ifelse hook1 = self
    [ set h1x2 x1
      set h1y2 y1
      set h1cx cx - dx * scale * armlen
      set h1cy cy - dy * scale * armlen
    ]
    [ set h1x2 x2-of hook1
      set h1y2 y2-of hook1
      set h1cx cx-of hook1
      set h1cy cy-of hook1
    ]
    ifelse hook2 = self
    [ set h2x1 x2
      set h2y1 y2
      set h2cx cx + scale * dx * armlen
      set h2cy cy + scale * dy * armlen
    ]
    [ set h2x1 x1-of hook2
      set h2y1 y1-of hook2
      set h2cx cx-of hook2
      set h2cy cy-of hook2
    ]
    set ratio1 armlen / armlen-of hook1
    set ratio2 armlen / armlen-of hook2
end

to lever!
    ifelse dragged = self
    [ ; if being dragged, then go there the mouse tells you
      set cx mouse-xcor
      set cy mouse-ycor
    ]
    [
      if not fixed?
      [ set xv ( xv * f ) + ( ( h1x2 - x1 ) + ( h2x1 - x2 ) ) * .5 * k
        set yv ( yv * f ) + ( ( h1y2 - y1 ) + ( h2y1 - y2 ) ) * .5 * k - g * armlen

        set cx cx + xv
        set cy cy + yv

        if abs cx > screen-edge-x [ set xv xv * -.99 set cx screen-edge-x * sign cx + xv bonk! (y2note cx)  ]
        if abs cy > screen-edge-y [ set yv yv * -.99 set cy screen-edge-y * sign cy + yv bonk! (x2note cy)  ]
      ]
    ]
    ifelse stiff?
    [ new-heading-2 ]
    [ new-heading-1 ]
    if spin? != 0
    [ let spin-rate spin? * spin-speed
      if spin*arm? [ set spin-rate spin-rate * armlen ]
      set heading heading + spin-rate
    ]
    setxy cx cy
end

to new-heading-1
    ; calculate new heading of lever
    ; if node2 of hook1 is overlapping center, keep same heading
    ; other wise, find heading to node2 of hook1
    ifelse ( distancexy-nowrap h1x2 h1y2 = 0 )
    [ set from-h1 180 + heading ]
    [ set from-h1 180 + towardsxy-nowrap h1x2 h1y2 ]
    ; likewise node1 of hook2
    ifelse ( distancexy-nowrap h2x1 h2y1 = 0 )
    [ set to-h2 heading ]
    [ set to-h2 towardsxy-nowrap h2x1 h2y1 ]
    ; calc heading
    ;;; using "angular velocity"
    ;;set av av * f + k2 * (subtract-headings ( mean-heading from-h1 to-h2 ) heading )
    ;;set heading heading + av + dt
    set heading mean-heading from-h1 to-h2
end

to new-heading-2
    ; calculate new heading of lever
    ; if center of hook1 is overlapping center, keep same heading
    ; other wise, find heading to center of hook1
    ifelse ( distancexy-nowrap h1cx h1cy = 0 )
    [ set from-h1 180 + heading ]
    [ set from-h1 180 + towardsxy-nowrap h1cx h1cy ]
    ; likewise node1 of hook2
    ifelse ( distancexy-nowrap h2cx h2cy = 0 )
    [ set to-h2 heading ]
    [ set to-h2 towardsxy-nowrap h2cx h2cy ]
    ; calc heading
    set heading mean-heading from-h1 to-h2
end


to crazy-machine
  without-interruption
  [ ask levers
    [ ; choose random location, in the inner area of the screen
      set cx (random-float 1.6 - .8 ) * screen-edge-x
      set cy (random-float 1.6 - .8 ) * screen-edge-y
      set xv 0
      set yv 0
      setxy cx cy
      ifelse ( random 5 = 0 ) [ set-fixed==>on ] [ set-fixed==>off ]
      set spin? random 3 - 1
      ifelse spin? = 0    [ set-spin==>off ]
      [ ifelse spin? = 1  [ set-spin==>on-cw  ]
                          [ set-spin==>on-ws  ]
      ]
      set armlen precision ( .5 + .5 * random 4 ) 1
    ]
  ]
end


to default
  ask levers
  [ reset-lever
  ]
  ask first-lever
  [ set-fixed==>on
    set cx 0
    set cy (screen-edge-y * .8 )
    setxy cx cy
  ]
end

to set-fixed==>on
   set fixed? true
   set -f "-f"
end

to set-fixed==>off
   set fixed? false
   set -f ""
end

to set-fixed==>toggle
   set fixed? not fixed?
   set -f ifelse-value fixed? [ "-f" ] [ "" ]
end

to set-spin==>on-cw ; clockwise
   set spin? 1
   set -r "-cw"
end

to set-spin==>on-ws ; widdershins (counter-clockwise)
   set spin? -1
   set -r "-ws"
end

to set-spin==>off
   set spin? 0
   set -r ""
end

to counter-spin
  ; sets all levers spinning in opposite directions
  ; assumes who numbers are consecutive
  ; if not, some adjacent levers may spin in same direction
  ; not really a problem.
  if not any? levers [ stop ]
  without-interruption
  [ ask levers
    [ ifelse who mod 2 = 0
      [ set-spin==>on-cw  ]
      [ set-spin==>on-ws  ]
    ]
  ]
end

to chaos-tentacle
  if not any? levers [ stop ]
  without-interruption
  [ ask levers
    [ set armlen (population - who ) * .1
      set-fixed==>off
      ifelse who mod 2 = 0
      [ set-spin==>on-cw ]
      [ set-spin==>on-ws ]
    ]
    ask min-one-of levers [ who ]
    [ set cx 0
      set cy 0
      setxy cx cy
      set-fixed==>on
    ]
    select-last-lever
  ]
end

to rope-bridge
  if not any? levers [ stop ]
  ask levers [ reset-lever ]
  ask first-lever
  [ set-fixed==>on
    setxy (- screen-edge-x / 2) (screen-edge-y * .5)
    set cx xcor
    set cy ycor
  ]
  ask last-lever
  [ set-fixed==>on
    setxy (  screen-edge-x / 2) (screen-edge-y * .5)
    set cx xcor
    set cy ycor
  ]
end

to save-setup
    locals [ filename ]
    set filename user-choose-new-file
    if filename != false
    [ export-world filename ]
end

to load-setup
    locals [ filename ]
    set filename user-choose-file
    if filename != false
    [ import-world filename ]
end

to set-directory
    locals [ directory ]
    set directory user-choose-directory
    if directory != false
    [ set-current-directory directory ]
end


to select-lever [ which-lever ]
   ; which-lever is -1 (previous) or +1 (next)
   ; no error checking on that, assume caller uses correctly
   ; illegal value will default to next
   ifelse not any? levers
   [ set selected nobody
     set old-selected nobody
   ]
   [ ifelse which-lever = -1
     [ select-lever-prev ]
     [ select-lever-next ]
   ]
end

  ; NOTE: the following routines may seem needlessly complex,
  ; but this is to allow for the future extension of
  ; adding or removing levers at will while
  ; the simulation is running.
  ; So, instead of simply moving the selection
  ; from lever who to lever who - 1 or who + 1,
  ; we look for the lever with the next lower
  ; or next higher who number.
  ; if none (ie, this is the first or last lever),
  ; we look for the lever with the highest or lowest
  ; who number (not just lever 0 or lever (population - 1),
  ; as lever 0 or lever (population - 1) may have been removed
  ; or more levers added.


to select-lever-prev
      ; selects the previous lever
      ; use safety-wrapper "select-lever" to call this
      ; to make sure there are levers

      ; if nobody is currently selected, select the first lever
      ifelse not is-turtle? selected or selected = nobody
      [ ; no current selection, so...
          select-first-lever
      ]
      [ ; otherwise, remember prior selection
        set old-selected selected
        ; find next lowest numbered lever
        ; first find all lower-numbered levers
        let prev-levers levers with [ who < who-of selected ]
        ; are there any?
        ifelse any? prev-levers
        [ ; yes, so find the one with the largest who number
          ; (smaller than selected who number)
          set selected max-one-of prev-levers [ who ]
        ]
        [ ; no, so the selected lever must be the "first" lever, so...
          select-last-lever
        ]
      ]
end

to select-lever-next
      ; selects the next lever
      ; use safety-wrapper "select-lever" to call this
      ; to make sure there are levers

      ; if nobody is currently selected, select the last lever
      ifelse not is-turtle? selected or selected = nobody
      [ ; no current selection, so...
        select-last-lever
      ]
      [ ; otherwise, remember prior selection
        set old-selected selected
        ; find next highest numbered lever
        let next-levers levers with [ who > who-of selected ]
        ; are there any?
        ifelse any? next-levers
        [ ; yes, so, find the one with the smallest who number
          ; (larger than selected who number)
          set selected min-one-of next-levers [ who ]
        ]
        [ ; no, so the selected lever must be the "last" lever, so...
          select-first-lever
        ]
      ]
end

to-report first-lever
     report min-one-of levers [ who ]
end

to-report last-lever
      report max-one-of levers [ who ]
end

to select-first-lever
   set selected first-lever
   set old-selected nobody
end

to select-last-lever
   set selected last-lever
   set old-selected nobody
end

to bonk! [ note-value ]
   if sound? [ play-note item (who + instrument) instruments (note-value) velocity .05 ]
end

to-report x2note [ coord ]
   report (16 + int ( 96 * (xcor + screen-edge-x ) / screen-size-x) )
end

to-report y2note [ coord ]
   report (16 + int ( 96 * (ycor + screen-edge-y ) / screen-size-y) )
end
@#$#@#$#@
GRAPHICS-WINDOW
241
10
554
344
50
50
3.0
1
10
1
1
1
0
0
0
1

CC-WINDOW
5
482
817
577
Command Center
0

BUTTON
12
66
67
99
NIL
setup
NIL
1
T
OBSERVER
T
NIL

SLIDER
12
101
184
134
f
f
0.9
0.9999
0.9891
1.0E-4
1
NIL

BUTTON
69
66
124
99
NIL
go
T
1
T
OBSERVER
T
NIL

SWITCH
126
66
226
99
mouse-on?
mouse-on?
0
1
-1000

SLIDER
12
29
227
62
population
population
3
100
13
1
1
NIL

SLIDER
12
169
184
202
scale
scale
0.5
25
7.0
0.5
1
NIL

SLIDER
12
135
184
168
g
g
0
0.18
0.1445
1.0E-4
1
NIL

BUTTON
13
262
68
295
fix/free
ask selected [ set-fixed==>toggle ]
NIL
1
T
OBSERVER
T
NIL

BUTTON
69
296
124
329
arm +++
ask selected [ set armlen precision ( armlen + .1 ) 3 ]
NIL
1
T
OBSERVER
T
NIL

BUTTON
69
262
124
295
arm ---
ask selected [ if armlen > .1 [ set armlen precision ( armlen - .1 ) 3 ] ]
NIL
1
T
OBSERVER
T
NIL

BUTTON
693
268
767
301
reset-default
default
NIL
1
T
OBSERVER
T
NIL

BUTTON
13
296
68
329
arm reset
ask selected [ set armlen .5 ]
NIL
1
T
OBSERVER
T
NIL

BUTTON
182
296
237
329
next
select-lever-next
NIL
1
T
OBSERVER
T
NIL

SLIDER
13
330
236
363
spin-speed
spin-speed
-25
25
5.77
0.01
1
NIL

BUTTON
125
262
180
295
spin +1?
ask selected [ ifelse spin? != 1 [ set-spin==>on-cw ][set-spin==>off] ]
NIL
1
T
OBSERVER
NIL
NIL

MONITOR
362
386
443
435
NIL
ticks
0
1

BUTTON
566
189
690
222
build-crazy-machine
crazy-machine
NIL
1
T
OBSERVER
T
NIL

SWITCH
12
203
102
236
stiff?
stiff?
1
1
-1000

BUTTON
181
364
236
397
spd=0
set spin-speed 0
NIL
1
T
OBSERVER
T
NIL

TEXTBOX
13
244
149
262
Selected Lever Properties

BUTTON
69
364
124
397
+.5
set spin-speed precision ( ( precision ( spin-speed * 2 ) 0 ) / 2.0 + .5 ) 1
NIL
1
T
OBSERVER
T
NIL

BUTTON
13
364
68
397
-.5
set spin-speed precision ( ( precision ( spin-speed * 2 ) 0 ) / 2.0 - .5 ) 1
NIL
1
T
OBSERVER
T
NIL

BUTTON
125
296
180
329
spin -1?
ask selected [ ifelse spin? != -1 [ set-spin==>on-ws ][set-spin==>off] ]
NIL
1
T
OBSERVER
NIL
NIL

BUTTON
182
262
237
295
prev
set selected turtle ( ( (who-of selected) - 1 ) mod population )
NIL
1
T
OBSERVER
T
NIL

BUTTON
565
268
634
301
counter-spin
counter-spin
NIL
1
T
OBSERVER
T
NIL

SWITCH
566
10
656
43
plot?
plot?
1
1
-1000

SLIDER
657
10
808
43
plot-color
plot-color
0
139
73
1
1
NIL

BUTTON
566
223
649
256
NIL
chaos-tentacle
NIL
1
T
OBSERVER
T
NIL

SWITCH
566
44
656
77
fade?
fade?
1
1
-1000

SLIDER
657
44
808
77
fade-rate
fade-rate
0
1
0.1
0.01
1
NIL

SWITCH
13
399
109
432
spin*arm?
spin*arm?
1
1
-1000

SWITCH
566
78
656
111
diffuse?
diffuse?
1
1
-1000

SLIDER
657
78
808
111
diffuse-rate
diffuse-rate
0
1
0.1
0.1
1
NIL

TEXTBOX
113
401
204
432
(multiplies spin rate * arm length)

SWITCH
566
112
656
145
cycle?
cycle?
1
1
-1000

SLIDER
657
112
808
145
cycle-rate
cycle-rate
-70
70
-5.0
0.5
1
NIL

SWITCH
566
146
685
179
fade-to-black?
fade-to-black?
1
1
-1000

BUTTON
636
268
691
301
no-spin
ask levers [ set-spin==>off ]
NIL
1
T
OBSERVER
T
NIL

BUTTON
272
349
359
382
NIL
save-setup
NIL
1
T
OBSERVER
T
NIL

BUTTON
360
349
439
382
NIL
load-setup
NIL
1
T
OBSERVER
T
NIL

BUTTON
440
349
532
382
NIL
set-directory
NIL
1
T
OBSERVER
T
NIL

BUTTON
691
189
773
222
NIL
rope-bridge
NIL
1
T
OBSERVER
T
NIL

BUTTON
696
146
751
179
clear
clear-patches
NIL
1
T
OBSERVER
NIL
NIL

BUTTON
753
146
808
179
all-off
set plot? false\nset fade? false\nset diffuse? false\nset cycle? false\nset fade-to-black? false\nclear-patches\n\n
NIL
1
T
OBSERVER
T
NIL

TEXTBOX
11
10
204
28
(Population is set before running setup)

SWITCH
545
378
635
411
sound?
sound?
0
1
-1000

SLIDER
635
303
807
336
velocity
velocity
0
128
89.5
0.5
1
NIL

SLIDER
636
337
808
370
instrument
instrument
0
127
32
1
1
NIL

MONITOR
637
370
808
419
First Instrument
item instrument instruments
0
1

MONITOR
637
419
808
468
Last Inst.
item (instrument + population) instruments
3
1

@#$#@#$#@
WHAT IS IT?
-----------
This model is some kind of physics / machine / links simulation.
I don't know what it is. I started with an idea for a surveryors chain simulation, and it got out of hand. It could be the basis for a rag-doll physics simulation.

It has a nifty drag-n-drop interface for positioning the elements on the work surface. The "selected" element is circled, and can be changed with the property buttons.

When I told someone what I was doing, they asked me "what integrator are you using?" I said, "huh?" Then they started talking about integrals and derivitives and other calculus-y stuff. Well, there is no caculus in this. There is math, there is trigonometry. All very simple.

This model is a great example of "emergent" behavior. All of the cool things that the levers do emerged from the simple code that runs them. This code is mostly concerned with each lever trying rather simple-mindedly to keep its attachment points (hooks) attached to its neighbor's attachement points. Swinging, crumpling, pushing and pulling all emerged from that.

I'm not really sure why it works, but it does. Each element (lever) has two hooks. The levers want to be centered bewteen attached levers. Likewise, they want to point to both attached hooks.

There's to0 much sag. I'm not sure how to keep the levers from seperating. That may just be a limitation of this method.

I had some goals in mind when I started. I wanted the elements to exhibit these behaviors.

Design goals:

1. "fixed" nodes spin in response to movement of the chain.
2. the chain "dangles" relisticly.
3. the chain links respond to each other, bunching up or stretching out, as appropriate.
4. When stretched and plucked, the chain will vibrate, like a guitar string.
4a. Stretching can be turned off, ie, be a feature, rather than a bug.
5. Conservation of linear momentum.
6. Conservation of angular momemtum.
7. Pendulum behavior.

Other Stuff:
Levers can have different lengths
Levers can be fixed or free
Levers can be driven (spin? = true)
Spinning Levers are still affected by attached Levers
Bigger levers are heavier

Surprises:
Without trying to, all the behaviors emerged, more or less.

Gravity affects things a great deal.
Also, friction (thought only present in a very small range) can also cause significant behavior changes.

New: based on a modification sent to me by Seth Tisue, I added sound to this version.
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

ball
true
10
Circle -13345367 true true 15 15 270

lever
true
10
Circle -13345367 true true 120 -30 60
Circle -13345367 true true 121 270 58
Line -13345367 true 150 30 150 269
Polygon -13345367 true true 150 90 195 105 149 30 105 105

lever-cw
true
10
Circle -13345367 true true 120 -30 60
Circle -13345367 true true 121 270 58
Line -13345367 true 150 30 150 269
Polygon -13345367 true true 150 90 195 105 149 30 105 105
Line -13345367 true 61 30 240 30
Line -13345367 true 240 30 195 44
Line -13345367 true 238 29 193 15
Line -13345367 true 239 269 61 270
Line -13345367 true 61 270 106 255
Line -13345367 true 104 285 61 271

lever-cw-s
true
10
Circle -13345367 true true 120 -30 60
Circle -13345367 true true 121 270 58
Line -13345367 true 150 30 150 269
Polygon -13345367 true true 150 90 195 105 149 30 105 105
Line -13345367 true 61 30 240 30
Line -13345367 true 240 30 195 44
Line -13345367 true 238 29 193 15
Line -13345367 true 239 269 61 270
Line -13345367 true 61 270 106 255
Line -13345367 true 104 285 61 271
Circle -13345367 false true 29 29 242

lever-f
true
10
Circle -13345367 true true 120 -30 60
Circle -13345367 true true 121 270 58
Line -13345367 true 150 30 150 269
Polygon -13345367 true true 150 90 195 105 149 30 105 105
Rectangle -13345367 true true 135 135 166 166

lever-f-cw
true
10
Circle -13345367 true true 120 -30 60
Circle -13345367 true true 121 270 58
Line -13345367 true 150 30 150 269
Polygon -13345367 true true 150 90 195 105 149 30 105 105
Line -13345367 true 61 30 240 30
Line -13345367 true 240 30 195 44
Line -13345367 true 238 29 193 15
Line -13345367 true 239 269 61 270
Line -13345367 true 61 270 106 255
Line -13345367 true 104 285 61 271
Rectangle -13345367 true true 135 135 165 165

lever-f-cw-s
true
10
Circle -13345367 true true 120 -30 60
Circle -13345367 true true 121 270 58
Line -13345367 true 150 30 150 269
Polygon -13345367 true true 150 90 195 105 149 30 105 105
Line -13345367 true 61 30 240 30
Line -13345367 true 240 30 195 44
Line -13345367 true 238 29 193 15
Line -13345367 true 239 269 61 270
Line -13345367 true 61 270 106 255
Line -13345367 true 104 285 61 271
Rectangle -13345367 true true 135 135 165 165
Circle -13345367 false true 29 30 240

lever-f-s
true
10
Circle -13345367 true true 120 -30 60
Circle -13345367 true true 121 270 58
Line -13345367 true 150 30 150 269
Polygon -13345367 true true 150 90 195 105 149 30 105 105
Circle -13345367 false true 30 30 240
Rectangle -13345367 true true 135 135 165 165

lever-f-ws
true
10
Circle -13345367 true true 120 -30 60
Circle -13345367 true true 121 270 58
Line -13345367 true 150 30 150 269
Polygon -13345367 true true 150 90 195 105 149 30 105 105
Line -13345367 true 120 30 181 30
Line -13345367 true 181 30 233 54
Line -13345367 true 120 30 68 52
Line -13345367 true 68 52 91 15
Line -13345367 true 69 53 111 60
Line -13345367 true 120 270 180 270
Line -13345367 true 179 271 233 246
Line -13345367 true 233 246 210 285
Line -13345367 true 233 245 186 241
Line -13345367 true 120 270 68 247
Rectangle -13345367 true true 135 135 166 166

lever-f-ws-s
true
10
Circle -13345367 true true 120 -30 60
Circle -13345367 true true 121 270 58
Line -13345367 true 150 30 150 269
Polygon -13345367 true true 150 90 195 105 149 30 105 105
Line -13345367 true 120 30 181 30
Line -13345367 true 181 30 233 54
Line -13345367 true 120 30 68 52
Line -13345367 true 68 52 91 15
Line -13345367 true 69 53 111 60
Line -13345367 true 120 270 180 270
Line -13345367 true 179 271 233 246
Line -13345367 true 233 246 210 285
Line -13345367 true 233 245 186 241
Line -13345367 true 120 270 68 247
Circle -13345367 false true 30 30 240
Rectangle -13345367 true true 135 135 166 166

lever-s
true
10
Circle -13345367 true true 120 -30 60
Circle -13345367 true true 121 270 58
Line -13345367 true 150 30 150 269
Polygon -13345367 true true 150 90 195 105 149 30 105 105
Circle -13345367 false true 30 30 240

lever-ws
true
10
Circle -13345367 true true 120 -30 60
Circle -13345367 true true 121 270 58
Line -13345367 true 150 30 150 269
Polygon -13345367 true true 150 90 195 105 149 30 105 105
Line -13345367 true 120 30 181 30
Line -13345367 true 181 30 233 54
Line -13345367 true 120 30 68 52
Line -13345367 true 68 52 91 15
Line -13345367 true 69 53 111 60
Line -13345367 true 120 270 180 270
Line -13345367 true 179 271 233 246
Line -13345367 true 233 246 210 285
Line -13345367 true 233 245 186 241
Line -13345367 true 120 270 68 247

lever-ws-s
true
10
Circle -13345367 true true 120 -30 60
Circle -13345367 true true 121 270 58
Line -13345367 true 150 30 150 269
Polygon -13345367 true true 150 90 195 105 149 30 105 105
Line -13345367 true 120 30 181 30
Line -13345367 true 181 30 233 54
Line -13345367 true 120 30 68 52
Line -13345367 true 68 52 91 15
Line -13345367 true 69 53 111 60
Line -13345367 true 120 270 180 270
Line -13345367 true 179 271 233 246
Line -13345367 true 233 246 210 285
Line -13345367 true 233 245 186 241
Line -13345367 true 120 270 68 247
Circle -13345367 false true 30 30 240

@#$#@#$#@
NetLogo 3.0beta2
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
