globals [genes gcolors grates genecount gnat promotercount promoters xstartloc bindings pbound xcoords preg KB Kd knockout]
turtles-own [gtype age bound]
breeds [rna protein ]


to setup
  ca
  ; bindings determines which proteins bind to which promoters
;
; Problem 1
;
  if (problem = 1) [
  set bindings ["E" "C"
                "C" "D"
                "A" "D"
                "E" "B"
                "C" "A"]
; gnat is the natural tendency of the gene to be transcribed
  set gnat [1 0 0 0 0]
; preg is the promoter regulatory function
  set preg [ 1 -2
            -1  2
             1 -2
             1 -1
             1 -1 ]
 ]
 ;
 ; Problem 2
 ;
   if (problem = 2) [
  set bindings ["D" "E"
                "A" "C"
                "B" "E"
                "B" "E"
                "E" "D"]
; gnat is the natural tendency of the gene to be transcribed
  set gnat [1 0 -1 0 0]
; preg is the promoter regulatory function
  set preg [ -1 -1
             1   -1
             1   1
             1  1
             1  1 ]
 ]
 ;
 ; Problem 3
 ;
   if (problem = 3) [
  set bindings ["D" "E"
                "D" "E"
                "D" "B"
                "A" "B"
                "A" "B"]
; gnat is the natural tendency of the gene to be transcribed
  set gnat [1 1 0 1 1]
; preg is the promoter regulatory function
  set preg [ -1 -1
             -1 -1
             1 1
             -1 -1
             -1 -1 ]
 ]
   if (problem = 4) [
  set bindings ["B" "C"
                "C" "D"
                "B" "D"
                "C" "E"
                "C" "A"]
; gnat is the natural tendency of the gene to be transcribed
  set gnat [0 1 0 0 0]
; preg is the promoter regulatory function
  set preg [ 1 -2
             -1 1
             1 -2
             1 -1
             -1 2 ]
 ]
   if (problem = 5) [
  set bindings ["E" "C"
                "C" "D"
                "A" "D"
                "E" "B"
                "C" "A"]
; gnat is the natural tendency of the gene to be transcribed
  set gnat [1 -2 0 0 0]
; preg is the promoter regulatory function
  set preg [ 1 -2
             1 1
             1 -2
             1 -1
             1 -1 ]
 ]
   if (problem = 6) [
  set bindings ["E" "C"
                "C" "D"
                "A" "D"
                "E" "B"
                "C" "A"]
; gnat is the natural tendency of the gene to be transcribed
  set gnat [1 -2 0 0 0]
; preg is the promoter regulatory function
  set preg [ 1 -2
             1 1
             1 -2
             1 -1
             1 -1 ]
 ]
   if (problem = 7) [
  set bindings ["E" "C"
                "C" "D"
                "A" "D"
                "E" "B"
                "C" "A"]
; gnat is the natural tendency of the gene to be transcribed
  set gnat [1 -2 0 0 0]
; preg is the promoter regulatory function
  set preg [ 1 -2
             1 1
             1 -2
             1 -1
             1 -1 ]
 ]
   if (problem = 8) [
  set bindings ["E" "C"
                "C" "D"
                "A" "D"
                "E" "B"
                "C" "A"]
; gnat is the natural tendency of the gene to be transcribed
  set gnat [1 -2 0 0 0]
; preg is the promoter regulatory function
  set preg [ 1 -2
             1 1
             1 -2
             1 -1
             1 -1 ]
 ]

; normally you won't change anything down here

  set KB 100 ; binding coefficient
  set Kd 4 ; dissociation coefficient
  set genes ["A" "B" "C" "D" "E" ]
  set promoters 2
  set knockout [0 1 1 1 1 1]
  set gcolors [red blue green magenta yellow ]
  set grates [ 10 10 10 10 10 ]
  set promoters 2
  set pbound [0 0 0 0 0 0 0 0 0 0]
  set xcoords [0 0 0 0 0 0 0 0 0 0]

  set xstartloc (screen-edge-x * -1) + 1
  set promotercount 0
  (foreach genes gcolors [
  ; create promoters
    repeat promoters [
      set promotercount promotercount + 1
      ask patches with [(pxcor = (xstartloc)) and (pycor = 0)] [ set pcolor gray set plabel promotercount ]
      set xcoords replace-item (promotercount - 1) xcoords xstartloc
      set xstartloc xstartloc + 1
    ]
    ; create gene
    ask patches with [(pxcor = xstartloc) and (pycor = 0)] [ set pcolor ?2 set plabel ?1 ]
    set xstartloc xstartloc + 1
    ; create white region
    repeat 4 [
      ask patches with [(pxcor = xstartloc) and (pycor = 0)] [ set pcolor white ]
      set xstartloc xstartloc + 1
    ]
    set genecount genecount + 1
  ])
  ; create ribosomes
  ask patches with [ ((pycor < -3) or (pycor > 3))] [ if random-int-or-float 10 = 1 [set pcolor cyan] ]

; create initial population of turtles
;  cct 5 [
;        set breed protein
;        set shape "repressor"
;        set bound false
;        set color red
;        set gtype "A"
;        set age random 25
;        set heading random 360
;        fd random 50
;      ]

end

to go
 locals[cnt]
  ;set time time + 1
; set knockouts
ifelse (GENE-A) [set knockout replace-item 1 knockout 1] [set knockout replace-item 1 knockout 0]
ifelse (GENE-B) [set knockout replace-item 2 knockout 1] [set knockout replace-item 2 knockout 0]
ifelse (GENE-C) [set knockout replace-item 3 knockout 1] [set knockout replace-item 3 knockout 0]
ifelse (GENE-D) [set knockout replace-item 4 knockout 1] [set knockout replace-item 4 knockout 0]
ifelse (GENE-E) [set knockout replace-item 5 knockout 1] [set knockout replace-item 5 knockout 0]
; do gene transcription
ask patches [
 without-interruption [
  set cnt 0
  (foreach genes gcolors [
  set cnt cnt + 1
  if (plabel = ?1 and item cnt knockout = 1) [
    if ( random-int-or-float 100 <  item (cnt - 1) grates) [
      if ( ((item ((promoters * cnt) - 1) preg) * (item ((promoters * cnt) - 1) pbound)  + (item ((promoters * cnt) - 2) preg) * (item ((promoters * cnt) - 2) pbound) + item (cnt - 1) gnat) > 0) [
      sprout 1 [
       set breed rna
       set shape "rna"
       set gtype ?1
       set color ?2
       set bound false
       set age random-int-or-float 30
       set heading random-int-or-float 360
       fd 2
      ] ]
    ]
  ]
])
]
]
;; this determines which gate the system emulates
; if (plabel = "C" ) [
;   if (gate = "NAND" ) [if (not (rbound-A = true and rbound-B = true) ) [ express-c] ]
;   if (gate = "NOR" ) [if (rbound-A = false and rbound-B = false) [ express-c]]
;   if (gate = "AND" ) [if (rbound-A = true and rbound-B = true) [ express-c]]
;   if (gate = "OR" ) [if (rbound-A = true or rbound-B = true) [ express-c]]
;   if (gate = "XOR" ) [if ((rbound-A = true or rbound-B = true) and not (rbound-A = true and rbound-B = true)) [ express-c]]
; ]
;]

; this was a bit tricky to get the order of events right
ask protein [
    without-interruption [bind-site]
    ]
ask turtles
    [wander ;; both rnas and proteins check to see if they bind and otherwise move around
     grow-old] ;; both also are recycled by the cell machinery after a while.
plot-history
plot-levels
end

to bind-site
  locals [cnt]
  if (bound = false) [
    if (random-int-or-float 100 < Kb and breed = protein) [
      set cnt 0
      (foreach bindings pbound [
        if (gtype = ?1 and ?2 = 0) [
          set bound cnt
          set pbound replace-item cnt pbound 1
          setxy item cnt xcoords 0
          set heading 180
          stop
        ]
        set cnt cnt + 1
      ])
    ]
  ]
end

to unbind-site
  if (random-int-or-float 100 < Kd and bound != false) [
    set pbound replace-item bound pbound 0
    set bound false
    setxy random-int-or-float screen-size-x random-int-or-float screen-size-y
]
end

to grow-old ;; cells break down rnas and proteins after a while.
   set age age + 1
   if (age > (50 + random-int-or-float 150))  [
     without-interruption[if (bound = false) [die] ]]
end

to wander
  if (pcolor = cyan and shape = "rna") [  ;; this is the ribosome translating
;    set breed protein
;    set shape "repressor"
;    set age 0
     hatch 1 [
         set breed protein
         set shape "repressor"
         set bound false
        set age 0
        set heading random-int-or-float 360
      ]
  ]
  ifelse (bound = false) [rt random-int-or-float 180 - random-int-or-float 180 fd 1 ] [without-interruption [unbind-site]]
end

to plot-levels ;; this creates creates the bar graph
  locals [cnt]
    set-current-plot "Protein Concentrations"
    clear-plot
    set cnt 0
    (foreach genes gcolors [
    set-current-plot-pen ?1
    ppd
    set cnt cnt + 1
    plotxy cnt count protein with [color = ?2]
    ])
end

to plot-history ;; this creates the line graph
  set-current-plot "Concentration History"
      (foreach genes  gcolors [
    set-current-plot-pen ?1
  plot ( count protein with [color = ?2]  )
])
end
@#$#@#$#@
GRAPHICS-WINDOW
321
10
776
245
18
8
12.03
1
10
1
1
1

CC-WINDOW
8
453
465
587
Command Center

BUTTON
40
63
106
96
NIL
setup
NIL
1
T
OBSERVER
T

BUTTON
43
137
149
213
NIL
go
T
1
T
OBSERVER
T

SWITCH
207
43
312
76
GENE-A
GENE-A
0
1
-1000

SWITCH
207
79
313
112
GENE-B
GENE-B
0
1
-1000

SWITCH
207
115
312
148
GENE-C
GENE-C
0
1
-1000

SWITCH
207
151
312
184
GENE-D
GENE-D
0
1
-1000

SWITCH
207
186
312
219
GENE-E
GENE-E
0
1
-1000

PLOT
7
250
312
447
Protein Concentrations
Gene
Concentration
0.0
7.0
0.0
50.0
false
true
PENS
"A" 1.0 1 -65536 true
"B" 1.0 1 -16776961 true
"C" 1.0 1 -11352576 true
"D" 1.0 1 -65281 true
"E" 1.0 1 -256 true

PLOT
321
250
625
447
Concentration History
Time
Concentration
0.0
500.0
0.0
50.0
true
true
PENS
"A" 1.0 0 -65536 true
"B" 1.0 0 -16776961 true
"C" 1.0 0 -11352576 true
"D" 1.0 0 -65281 true
"E" 1.0 0 -256 true

CHOICE
7
10
145
55
problem
problem
1 2 3 4 5 6 7 8
3

@#$#@#$#@
WHAT IS IT?
-----------
This is a model that offers a series of "unknown" problems for students to explore
in learning about gene expression systems.

Genes are represented by colored patches labeled A, B, C, and D.  Transcription-factor binding sites are numbered 1-10.  Genes are transcribed to produce RNAs (represented as lines) which are translated by ribosomes (cyan patches) to produce proteins (irregular polygons).

HOW IT WORKS
------------
In this simulation, there are 5 genes: A-E.  Each gene has two promoters and can
be knocked out (turned-off) using a switch.

HOW TO USE IT
-------------
A pop-up menu allows the user to select a problem.

Click "setup" to create the genes and ribosomes.

Click "go" to start the model.

Switches allow the user to turn genes A-E on and off.

Two plots show current and historical concentrations of proteins.


THINGS TO NOTICE
----------------
You can tell which proteins bind to which sites.  Notice under what conditions genes turn on and off.  Does the system become fixed at some point, or does it oscillate?

THINGS TO TRY
-------------
For each gene, determine what roles the binding sites are playing in the system (enhancer or silencer).

How does the behavior of the system change when genes are knocked out?  Can you predict
these changes based on what you know by observing the system?

EXTENDING THE MODEL
-------------------
To simplify this model, a number of factors have been de-paramaterized, including the rates of each gene and the coefficients of binding and dissociation (KB and Kd).  By adding sliders, you could extend this model and explore the behavior of the system with different values.  By changing these values you can try to decrease the leakiness of the system and increase the speed of the system turning on or off.

CREDITS AND REFERENCES
----------------------
This model is based on work completed during the 2004 BioQUEST Curriculum Consortium
Summer Workshop.

Copyright 2004 by Steven Brewer.  All rights reserved.

This model was inspired by many of the sample Netlogo models and parts were based on functions from the Enzyme Kinetics model.  (Wilensky, U. (2001).  NetLogo Enzyme Kinetics model. http://ccl.northwestern.edu/netlogo/models/EnzymeKinetics. Center for Connected Learning and Computer-Based Modeling, Northwestern University, Evanston, IL.)
Permission to use, modify or redistribute this model is hereby granted,
provided that both of the following requirements are followed:
a) this copyright notice is included.
b) this model will not be redistributed for profit without permission
   from the authors.
Contact the authors for appropriate licenses for redistribution for
profit.

To refer to this model in academic publications, please use:
Brewer, S.D. (2004).  Unknown Gene Expression: Problems for Students.  http://bcrc.bio.umass.edu/netlogo/models/Unknown
Biology Computer Resource Center

In other publications, please use:
Copyright 2004 by Steven Brewer.  All rights reserved.  See
http://bcrc.bio.umass.edu/netlogo/models/Unknown
@#$#@#$#@
default
true
0
Polygon -7566196 true true 150 5 40 250 150 205 260 250

b-complex
true
0
Polygon -11352576 true false 79 46 198 148 78 254
Polygon -16776961 true false 77 48 197 149 77 255 257 254 256 49

box
true
0
Polygon -7566196 true true 45 255 255 255 255 45 45 45

circle
false
0
Circle -7566196 true true 35 35 230

inducer
true
0
Polygon -11352576 true false 76 47 197 151 75 256

r-complex
true
0
Polygon -65536 true false 76 47 197 150 76 254 257 255 257 47
Polygon -11352576 true false 79 46 198 148 78 254

repressor
true
0
Polygon -7566196 true true 76 47 197 150 76 254 257 255 257 47

rna
true
0
Rectangle -7566196 true true 7 126 294 170

@#$#@#$#@
NetLogo 2.0.1
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
